unit I_Choice;

interface
uses
// KERNEL
  Elements,
// INTERPET
  I_Basic,
// TOPOL
  C_TLDBF,
// 0TEMP
  T_EdiPro;

type


TChoicedElementInterpret = class(TInterpret)
private
  FDontViewProps: boolean;
  FDontViewDBF  : boolean;
  FLeft: integer;
  FTop: integer;
public
  procedure DoIt; override;
published
  property DontViewProps: boolean read FDontViewProps write FDontViewProps;
  property DontViewDBF: boolean read FDontViewDBF write FDontViewDBF;
  property Left: integer read FLeft write FLeft;
  property Top: integer read FTop write FTop;
end;


implementation
uses
  SysUtils, Forms, Dialogs, Controls,
// SPACE
  E_Space,
  E_TplPrp,
// EDITGRAP
  F_DbFRec;

// MAIN
//  F_Main



procedure TChoicedElementInterpret.DoIt;
var
  FDBRec: TF_dbfrecForm;
  aBlockDir: string;
  aTyp: char;
  aDruh: smallInt;
  aCislo: longInt;

  AC: TCursor;
  I: longInt;
  Editor:  TObjectPropertyEditor;

  MaxWidth: integer;
  Item: string;
  PocetRadku: integer;
  aTP: TTopolProps;
begin
  if not DontViewProps then
  begin
    Editor:= TObjectPropertyEditor.Create;
    Editor.Input:= Input;
    Editor.Left:= Left;
    Editor.Top:= Top;
    Editor.DoIt;
  end;

  if not (Input is TSpaceEntity) then exit;

  aTP:= TTopolProps(TSpaceEntity(Input).Properties);
  if not (TElement(aTP) is TTopolProps) then exit;

  if not DontViewDBF then
  begin
    AC:= Screen.Cursor;
    Screen.Cursor:= crHourGlass;
    FDBRec:= TF_DBFRecForm.Create(Application);

    aBlockDir:= aTP.BlockName;
    aTyp:= aTP.ObjectType;
    aDruh:= aTP.Druh;
    aCislo:= aTP.Cislo;

    if FDBRec.TopolDBFTable1.SetForTopolObject(aBlockDir, aTyp, aDruh, aCislo) then
    if FDBRec.TopolDBFTable1.SetForTopolEntity(TSPaceEntity(Input)) then
    begin
      PocetRadku:= FDBRec.TopolDBFTable1.FieldDefs.Count;
      FDBRec.StringGrid1.RowCount:= PocetRadku;
      MaxWidth:= 0;
      for I:= 0 to FDBRec.StringGrid1.RowCount-1 do
      begin
        FDBRec.StringGrid1.Cells[0,I]:= FDBRec.TopolDBFTable1.FieldDefs[I].Name;
        Item:= FDBRec.TopolDBFTable1.Fields[I].AsString;
        if length(Item) > MaxWidth then MaxWidth:= length(Item);
        FDBRec.StringGrid1.Cells[1,I]:= Item;
      end;

      FDBRec.StringGrid1.ColWidths[0]:= 100;
      if MaxWidth > 400 then MaxWidth:= 400;
      FDBRec.StringGrid1.ColWidths[1]:= MaxWidth*10;
      FDBRec.Width:= 120 + MaxWidth*10;

      if PocetRadku < 20 then
         FDBRec.Height:= (PocetRadku)*(FDBRec.StringGrid1.DefaultRowHeight+1) + 28
      else
         FDBRec.Height:= 20*(FDBRec.StringGrid1.DefaultRowHeight) + 28;
      FDBRec.Left:= Left;
      FDBRec.Left:= Top;
      FDBRec.Show;
    end;

    FDBRec.TopolDBFTable1.Active:= false;
    Screen.Cursor:= AC;
  end;
end;







end.

