{--------------------------------------------------------------------------------------------------}
{ Produkt: ORBIS                                                                                   }
{ Verze:   1.00                                                                                    }
{ Modul:   E_dclass                                                                                }
{ Autor:   (c) Michal Valk, 1996                                                                 }
{ Posledni revize: 4.12.1996                                                                       }
{                                                                                                  }
{ Popis modulu:                                                                                    }
{ Definice uivatelskho databzovho objektu TDatabaseClass pro pipojen zdroje dat (Tabulka,    }
{ SQL definice v textovm tvaru, SQL definice v defininm souboru, QBE, napojen textu pes ODBC) }
{ a pro standardn operace se zznami pipojenho datovho zdroje (zobrazen, pidn, smazn,    }
{ zmna) k emu slou druh objekt TVirtualElement.                                              }
{                                                                                                  }
{                                                                                                  }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
{ Seznam funkc definovanch v modulu                                                              }
{                                                                                                  }
{ TDatabaseClass                                                                                   }
{                                                                                                  }
{ function  GetDataSourcePath: string; Vrac cestu ke zdroji dat.                                  }
{ procedure SetDataSourcePath(aValue: string); Do globln promnn FDataSourcePath zape cestu   }
{           ke zdroji dat.                                                                         }
{ function  GetDataSource: string; Vrac nzev zdroje dat. (nap. jmno tabulky)                   }
{ procedure SetDataSource(aValue: string); Do globln promnn FDataSource zape nzev           }
{           zdroje dat.                                                                            }
{ function  GetAdressField: string; Vrac adresov pole DS v etzci oddlen stednkem.          }
{ procedure SetAdressField(aValue: string); Do globln promnn FAdressField zape zvolen       }
{           adresov pole (oddlen stednkem)                                                    }
{ function  GetNameField: string; Vrac pole DS pro pojmenovn TVirtualElement.                   }
{ procedure SetNameField(aValue: string); Do globln promnn FNameField zape zvolen           }
{           pole pro pojmenovn TVirtualElement.                                                  }
{ function  GetPropertyCount: LongInt; Vrt poet sloupc zdroje dat.                             }
{ function  GetPropertyName(aIndex: longInt): string; Vrt jmno fieldu datovho zdroje dle       }
{           zadanho indexu.                                                                       }
{ function  GetPropertyTypeI(aIndex: longInt): TFieldType; Vrt typ pole datovho zdroje dle      }
{           danho indexu.                                                                         }
{ function  GetPropertySizeI(aIndex: longInt) : Integer; Vrt velikost pole datovho zdroje dle   }
{           danho indexu.                                                                         }
{ function  GetPropertyRequiredI(aIndex: longInt) : Boolean; Vrt logickou hodnotu zda je nebo    }
{           nen nutn pole DS vyplnit (dle danho indexu ).                                       }
{ function  GetPropertyValueI(aIndex: longInt; aKey : string): string; Vrt hodnotu pole datovho }
{           zdroje dle danho indexu.                                                              }
{ procedure SetPropertyValueI(aIndex: longInt; aKey : string; aValue: string);                     }
{           Umouje zmnit hodnotu pole DS. Zznam se hled dle adresovch pol (hodnota v aKey)  }
{           a sloupec dle indexu (aIndex).                                                         }
{           V ppad tabulky se zznam hled pomoc metody FindKey                                }
{           (pokud existuje index), v ostatnch ppadech se zznam hled sekvenn.               }
{                                                                                                  }
{           Promnn:                                                                              }
{            i,j         - pomocn promnn pro zen cyklu                                       }
{            chyba       - detekuje, zda hodnota aKey se shoduje s aktulnmi hodnotami adresovch }
{                          pol DS                                                                 }
{            indexExists - detekuje, zda tabulka obsahuje alespo jeden index                      }
{                                                                                                  }
{ function  GetPropertyValueN(aName: string; aKey : string): string; Vrt hodnotu pole datovho   }
{           zdroje dle danho jmna pole.                                                          }
{ procedure SetPropertyValueN(aName: string; aKey : string; aValue: string);                       }
{           Umouje zmnit hodnotu pole DS. Zznam se hled dle adresovch pol (hodnota v aKey)  }
{           a sloupec dle jmna pole (aName).                                                      }
{           V ppad tabulky se zznam hled pomoc metody FindKey (pokud existuje index),        }
{           v ostatnch ppadech se zznam hled sekvenn.                                       }
{                                                                                                  }
{           Promnn:                                                                              }
{            i,j         - pomocn promnn pro zen cyklu                                       }
{            chyba       - detekuje, zda hodnota aKey se shoduje s aktulnmi hodnotami adresovch }
{                          pol DS                                                                 }
{            indexExists - detekuje, zda tabulka obsahuje alespo jeden index                      }
{                                                                                                  }
{ function  GetPropertyIndex(aValue : string) : LongInt; Dle jmna pole vrt index pole DS        }
{           (resp. poadov slo pole) - pokud nenajde nic vrt -1.                              }
{                                                                                                  }
{ function  GetDSData: TDataSource; Vrt data obsaen ve zdroji dat (v TDatasource)              }
{                                                                                                  }
{ function  GetDSIndexName : String; Vrt jmno aktulnho indexu                                 }
{           (pouvat pouze pro typ DS - dstTable)                                                 }
{ procedure SetDSIndexName(aValue : String);  Do globln promnn FDSIndexName zape jmno       }
{           danho indexu (pouze pro typ DS - dstTable).                                           }
{ function  GetSQL : TStrings; Vrt SQL dotaz v textovm tvaru.                                   }
{ procedure SetSQL(aValue : TStrings); Do property DSSql ulo SQL dotaz v textovm tvaru.         }
{ function  CreateMyTable: boolean; Pokus se otevt datov zdroj.                                }
{           V ppad, e se to nepoda vrac False.                                              }
{           Promnn:                                                                              }
{              MyDatabaseName  - pomocn promnn pro zen cyklu                                 }
{                                                                                                  }
{ function  GetMyIndexNames : TStringList;  Pouze v ppad tabulky.                               }
{           Vrac seznam index.                                                                   }
{                                                                                                  }
{ procedure SetNewDS; Zatm nedl nic                                                             }
{ function  FieldExists(aValue : string) : Boolean; V ppad, e field se jmnem aValue v datovm }
{           zdroji existuje, vrac True.                                                           }
{           Promnn:                                                                              }
{               i         - pomocn  promnn pro zen cyklu                                     }
{                                                                                                  }
{ function  GetRecordSize : longInt; Vrac velikost zznamu.                                       }
{           Promnn:                                                                              }
{               i         - pomocn promnn pro zen cyklu                                      }
{                                                                                                  }
{ function  AdressFieldCount : LongInt; Vrac poet pol v adrese elementu.                        }
{           Promnn:                                                                              }
{               i                - pomocn promnn pro zen cyklu                               }
{               znak             - etzec pro naten jednoho znaku z PomAdressField              }
{               PomAdressField   - pomocn promnn pro AdressField                                }
{                                                                                                  }
{ protected declaration                                                                            }
{                                                                                                  }
{ function  ElementsCount: longInt; override; Vrac poet zznam v datovm zdroji.                }
{ function  GetWholeSize : longInt; override; Vrac velikost dat v datovm zdroji.                 }
{                                                                                                  }
{ public declaration                                                                               }
{                                                                                                  }
{ constructor Create; override;  Vytvo pomocn promnn FSQL a FMyDataSource.                    }
{ function _Create : TElement; Vrt TElement pro prv vytvoenou vtu. (pouze pro tabulky)       }
{ function Free_(Element : TElement) : Boolean;                                                    }
{ function Get(Index: longint): TElement; override;                                                }
{ function NoElements : Boolean; override; Vrac True jestlie datov zdroj neobsahuje dn       }
{          zznam.                                                                                 }
{ function FindElementName(aName: string): TElement; override;                                     }
{ function IndexOf(aElement: TElement): longInt; override;                                         }
{                                                                                                  }
{                                                                                                  }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}

unit E_dclass;

interface

uses
   DB,
   DBTables,
   // PPKQBE
//   Wwqbe,
   SysUtils,
   winprocs,
   Dialogs,

   Classes,
   Elements,

   T_MyTool;

const

MyDriverName = 'ODBC_Text';

type

TDSType = (dstTable, dstSQL, dstSQLdef, dstQBE, dstText);  {Pehled vech typ zdroj dat}

TDatabaseClass = class(TOwnerEntity)

private
   MyTable: TTable;              {TTable - pro naten zdroje dat typu tabulka}
   MyQuery: TQuery;              {TQuery - pro naten zdroje dat SQL text nebo SQL definice}
   // PPKQBE
//   MyQBE  : TwwQBE;              { TQBE - pro naten zdroje dat typu QBE text }
   MyDatabase: TDatabase;        {TDatabase - pro oteven pouitch databz}

   FMyDataSource : TDataSource;  {TDataSource pro zobrazen dat datovho zdroje vech typ}

   FDataSourcePath: String;     {Cesta ke zdroji dat}
   FDataSource: String;         {Nzev zdroje dat}
   FAdresField: String;         {Adresov pole. Mezi sebou jsou oddlen stednkem}
   FDSIndexName: String;        {Jmno indexu. (v ppad tabulky)}
   FDSType: TDSType;             {Typ zdroje dat. (vtov typ)}
   FSQL: TStrings;               {Zobrazen popisu datovho zdroje (SQL a QBE pedpis)}

   FVirtualElement: TElement;
   FNameField: String;          {Jmno pole datovho zdroje pro property Name objektu TVirtualElement}
   LastIndex: longInt;           {Posledn dotazovan index zznamu tabulky}

   function  GetDataSourcePath: string;
   procedure SetDataSourcePath(aValue: string);
   function  GetDataSource: string;
   procedure SetDataSource(aValue: string);

   function  GetAdressField: string;
   procedure SetAdressField(aValue: string);

   function  GetNameField: string;
   procedure SetNameField(aValue: string);

   function  GetPropertyCount: LongInt;
   function  GetPropertyName(aIndex: longInt): string;
   function  GetPropertyTypeI(aIndex: longInt): TFieldType;
   function  GetPropertySizeI(aIndex: longInt) : Integer;
   function  GetPropertyRequiredI(aIndex: longInt) : Boolean;
   function  GetPropertyValueI(aIndex: longInt; aKey : string): string;
   procedure SetPropertyValueI(aIndex: longInt; aKey : string; aValue: string);
   function  GetPropertyValueN(aName: string; aKey : string): string;
   procedure SetPropertyValueN(aName: string; aKey : string; aValue: string);
   function  GetPropertyIndex(aValue : string) : LongInt;

   function  GetDSData: TDataSource;

   function  GetDSIndexName : String;
   procedure SetDSIndexName(aValue : String);

   function  GetSQL : TStrings;
   procedure SetSQL(aValue : TStrings);

   function  CreateMyTable: boolean;
   function  GetMyIndexNames : TStringList;
   procedure SetNewDS;
   function  FieldExists(aValue : string) : Boolean;
   function  GetRecordSize : longInt;  {Zruit a pout promnnou - plnit pi create}
   function  AdressFieldCount : LongInt;  {Poet pol v adrese elementu}
protected
   function  ElementsCount: longInt; override; {properta TEntity.Count - Poet zznam}
   property  VirtualElement: TElement read FVirtualElement write FVirtualElement;
   function  GetWholeSize : longInt; override;
public
   constructor Create; override;
   procedure  FreeAll; override;
   function _Create : TElement;
   function _Destroy(Element : TElement) : Boolean;
   function Get(Index: longint): TElement; override;
   function NoElements : Boolean; override;
   function FindElementName(aName: string): TElement; override;
   function IndexOf(aElement: TElement): longInt; override;

   property PropertyName[aIndex: longInt]: string read GetPropertyName;
   property PropertyTypeI[aIndex: longInt]: TFieldType read GetPropertyTypeI;
   property PropertySizeI[aIndex: longInt]: Integer read GetPropertySizeI;
   property PropertyRequiredI[aIndex: longInt]: Boolean read GetPropertyRequiredI;
   property PropertyValueI[aIndex: longInt; aKey : string]: string
             read GetPropertyValueI write SetPropertyValueI;

   property PropertyIndex[aName: string]: LongInt read GetPropertyIndex;
{   property PropertyTypeN[aName: string]: TFieldType read GetPropertyTypeN;
   property PropertySizeN[aName: string]: TWord read GetPropertySizeN;
   property PropertyRequiredN[aName: string]: Boolean read GetPropertyRequiredN;}
   property PropertyValueN[aName: string; aKey : string]: string
            read GetPropertyValueN write SetPropertyValueN;

   property DSIndexNames : TStringList read GetMyIndexNames;

   property DSSQL: TStrings read FSQL write SetSql;

   property DSIndexName: string read GetDSIndexName write SetDSIndexName;

   property DSData: TDataSource read FMyDataSource;

published
   property DataSourcePath: string read GetDataSourcePath write SetDataSourcePath;
   property DataSourceType: TDSType read FDSType write FDSType;
   property DataSource: string read GetDataSource write SetDataSource;

   property AdressField: string read GetAdressField write SetAdressField;
   property NameField: string read GetNameField write SetNameField;

   property PropertyCount: longInt read GetPropertyCount;  {Poet fieldu - sloupc}

   property RecordSize: LongInt read GetRecordSize; {Velikost zznamu zdroje dat}
end;

TVirtualElement = class(TOwnerElement)
private
   FElementClass: TDatabaseClass;
   FElementAdress: String;
   function  GetAdress: string;
   procedure SetAdress(aValue: string);
   function  GetClassName: string;
   function  GetPropertyCount: longInt;
   function  GetPropertyName(aIndex: longInt): string;
   function  GetPropertyTypeI(aIndex: longInt): TFieldType;
protected
   function  GetInstanceSize: longInt; override;
public
   property  ElementClass: TDatabaseClass read FElementClass write FElementClass;
   function  GetPropertyStringByName(AName: string): string; override;
   function  GetPropertyStringByIndex(aIndex: LongInt): string;
   property  ClassName: string read GetClassName ;
   property  PropertyName[aIndex: longInt]: string read GetPropertyName;
   property  PropertyTypeI[aIndex: longInt]: TFieldType read GetPropertyTypeI;
published
   property  ElementAdress: string read GetAdress write SetAdress;
   property  PropertyCount: longInt read GetPropertyCount;
end;

implementation

uses
   {!t_Main,}

   e_Class,
   u_String;

{ TDatabaseClass }

{--------------------------------------------------------------------------------------------------}
{ Create                                                                                           }
{                                                                                                  }
{ Vytvo pomocn promnn FSQL a FMyDataSource.                                                   }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
constructor TDatabaseClass.Create;
begin
  inherited Create;
  FSQL := TStringList.Create;
  FMyDataSource := TDataSource.Create(nil);
end;

procedure  TDatabaseClass.FreeAll;
begin
   // nedl nic ha ha
end;

{--------------------------------------------------------------------------------------------------}
{ NoElements                                                                                       }
{                                                                                                  }
{ Vrac True jestlie datov zdroj neobsahuje dn zznam.                                        }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function  TDatabaseClass.NoElements: boolean;
begin
   Result := (ElementsCount <= 0);
end;

function TDatabaseClass.FindElementName(aName: string): TElement;
var  Adress,PomAdressField : string;
     i,j : Integer;
begin
  if not NoElements then
    begin
      if CreateMyTable then
        begin
            begin
              FMyDataSource.DataSet.DisableControls;
              for i := 1 to ElementsCount do
                begin
                  if UpperCase(FMyDataSource.DataSet.FieldByName(AdressField).AsString) = UpperCase(aName) then
                    begin
  {Vytvoen adresy elementu z aktulnho zznamu}
                      Adress := '';
                      PomAdressField := AdressField + ';';
                      for j:=1 to AdressFieldCount do
                        begin
                          Adress  := Adress + FMyDataSource.DataSet.FieldByName(GetKeyValue(PomAdressField,j)).AsString + ';';
                        end;
  {Vytvoen Elementu}
                      if (FVirtualElement = nil) or (FVirtualElement.OwnersCount > 0) then
                        begin
                          FVirtualElement := TVirtualElement.Create;
                          FVirtualElement.Name := FMyDataSource.DataSet.FieldByName(NameField).AsString;
                          (FVirtualElement as TVirtualElement).ElementAdress := Adress;
                          (FVirtualElement as TVirtualElement).ElementClass := Self;
                          Result := FVirtualElement;
                        end
                        else
                          begin
                            FVirtualElement.Name := FMyDataSource.DataSet.FieldByName(NameField).AsString;
                            (FVirtualElement as TVirtualElement).ElementAdress := Adress;
                            Result := (FVirtualElement as TVirtualElement);
                          end;

                      break;
                    end else FMyDataSource.DataSet.Next;
                end;
              FMyDataSource.DataSet.EnableControls;
            end;
        end;
    end;
end;

{
Dle zadanho elementu vrt slo dku - index elementu
Pokud element nenajde vrt -1
}
function TDatabaseClass.IndexOf(aElement: TElement): longInt;
var  i,j : LongInt;
     Chyba : Boolean;
     PomAdressField, PomElementAdress : String;
begin
  result := -1;
  FMyDataSource.DataSet.DisableControls;
  for i:=1 to ElementsCount do
    begin
      Chyba := false;
      for j := 1 to AdressFieldCount do
        begin
          PomAdressField := GetKeyValue(AdressField,i);
          PomElementAdress := GetKeyValue((aElement as TVirtualElement).ElementAdress,i);
          if UpperCase(FMyDataSource.DataSet.FieldByName(pomAdressField).AsString) <>
             UpperCase(PomElementAdress) then Chyba := true;
          if (not Chyba) and (j = AdressFieldCount) then
            begin
              result := i;
              break;
            end;
        end;
      if not Chyba then break;
      FMyDataSource.DataSet.Next;
    end;
  FMyDataSource.DataSet.EnableControls;
end;

{--------------------------------------------------------------------------------------------------}
{ AdressFieldCount                                                                                 }
{                                                                                                  }
{ Vrac poet pol v adrese elementu.                                                              }
{                                                                                                  }
{ Promnn:                                                                                        }
{     i                - pomocn promnn pro zen cyklu                                         }
{     znak             - etzec pro naten jednoho znaku z PomAdressField                        }
{     PomAdressField   - pomocn promnn pro AdressField                                          }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function  TDatabaseClass.AdressFieldCount : LongInt;
var  i : Integer;
     Znak : string[1];
     PomAdressField : string;
begin
  result := 0;
  PomAdressField := AdressField;
  if (Length(PomAdressField) > 0) and (copy(PomAdressField,Length(PomAdressField),1) <> ';') then
    PomAdressField := PomAdressField + ';';

  for i := 1 to length(PomAdressField) do
    begin
      znak := copy(PomAdressField,i,1);
      if (znak = ';') then inc(result)
    end;
end;

{
Vrt TVirtualElement s adresou dku tabulky dle indexu (poad dku tabulky)
}
function TDatabaseClass.Get(Index: longInt): TElement;
var  Adress,PomAdressField : string;
     i,di : Integer;
begin
 {Pidat property, kter uruje, jakm adresovacm polem tabulky se bude pojmenovvat TVirtualElement}

 if CreateMyTable then
  begin
      begin
        FMyDataSource.DataSet.DisableControls;

        //*  Nastaven LastIndexu a jeho pouit
        di := Index - LastIndex;
        if Index = 0 then FMyDataSource.DataSet.First
        else
        if di = 1 then FMyDataSource.DataSet.Next
                  else FMyDataSource.DataSet.MoveBy(di);
        LastIndex := Index;
        //*

        //FMyDataSource.DataSet.First;
        //FMyDataSource.DataSet.MoveBy(Index);

        FMyDataSource.DataSet.EnableControls;
        Adress := '';
        PomAdressField := AdressField + ';';
        for i:=1 to AdressFieldCount do
          begin
            Adress  := Adress + FMyDataSource.DataSet.FieldByName(GetKeyValue(PomAdressField,i)).AsString + ';';
          end;

        if (FVirtualElement = nil) or (FVirtualElement.OwnersCount > 0) then
          begin
            FVirtualElement := TVirtualElement.Create;
            FVirtualElement.Name := FMyDataSource.DataSet.FieldByName(NameField).AsString;
            (FVirtualElement as TVirtualElement).ElementAdress := Adress;
            (FVirtualElement as TVirtualElement).ElementClass := Self;
            Result := FVirtualElement;
          end
        else
          begin
            FVirtualElement.Name := FMyDataSource.DataSet.FieldByName(NameField).AsString;
            (FVirtualElement as TVirtualElement).ElementAdress := Adress;
            Result := (FVirtualElement as TVirtualElement);
          end;
      end;
  end else Result := nil;
end;

{--------------------------------------------------------------------------------------------------}
{ ElementsCount                                                                                    }
{                                                                                                  }
{ Vrac poet zznam v datovm zdroji.                                                            }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function TDatabaseClass.ElementsCount: LongInt;
begin
  Result := 0;
    if CreateMyTable then result := FMyDataSource.DataSet.RecordCount;
end;

{--------------------------------------------------------------------------------------------------}
{ GetWholeSize                                                                                     }
{                                                                                                  }
{ Vrac velikost dat v datovm zdroji.                                                             }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function  TDatabaseClass.GetWholeSize : longInt;
begin
  result := 0;
  result := RecordSize * ElementsCount;
end;


{--------------------------------------------------------------------------------------------------}
{ GetRecordSize                                                                                    }
{                                                                                                  }
{ Vrac velikost zznamu.                                                                          }
{                                                                                                  }
{ Promnn:                                                                                        }
{     i         - pomocn promnn pro zen cyklu                                              }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function  TDatabaseClass.GetRecordSize : longInt;
var  i : Integer;
begin
  result := 0;
  if CreateMyTable then
    begin
        begin
          for i := 0 to FMyDataSource.DataSet.FieldCount - 1 do
            begin
              result := result + FMyDataSource.DataSet.Fields[i].DataSize;
            end;
        end;
    end;
end;


{--------------------------------------------------------------------------------------------------}
{ CreateMyTable                                                                                    }
{                                                                                                  }
{ Pokus se otevt datov zdroj.                                                                  }
{ V ppad, e se to nepoda vrac False.                                                        }
{                                                                                                  }
{ Promnn:                                                                                        }
{     MyDatabaseName  - pomocn promnn pro zen cyklu                                          }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function TDatabaseClass.CreateMyTable: boolean;
var MyDatabaseName : TFileName;
begin
  result := false;
  try
{Vytvo tabulku a oteve ji}
{    Screen.Cursor := crSQLWait;}
    if DatasourceType = dstTable then
      begin
        if MyTable = nil then
          begin
            MyTable := TTable.create(nil);
            MyTable.Name := Name+'_DB';
            MyTable.TableType := ttDefault;
          end;

        if not MyTable.active then
          begin
            MyTable.DatabaseName := DataSourcePath;
            MyTable.TableName := DataSource;
            MyTable.IndexName := DSIndexName;
            MyTable.TableType := ttDefault;
            MyTable.Active := true;
            FMyDataSource.DataSet := MyTable;
          end else if MyTable.IndexName <> DSIndexName then MyTable.IndexName := DSIndexName;
         Result := true;
      end;


{Text!!!}
    if DatasourceType = dstText then
      begin
                     
        if MyTable = nil then
          begin
            MyTable := TTable.create(nil);
            MyTable.Name := Name+'_DB';
            MyTable.TableType := ttASCII;
          end;

        if MyDatabase = nil then
          begin
            MyDatabase := TDatabase.create(nil);
            MyDatabase.Name := Name+'_ODBC';
            MyDatabase.DriverName := MyDriverName;
            MyDatabase.AliasName := '';
            MyTable.Active := False;
          end;

        if not MyTable.active then
          begin
            MyDatabase.Close;
            MyDatabase.LoginPrompt := False;
            MyDatabase.DriverName := MyDriverName;
            MyDatabaseName := copy(DataSource,1,79);
            MyDatabase.DatabaseName := MyDatabaseName; {DataSourcePath;}

            MyTable.DatabaseName := DataSourcePath;
            MyTable.TableName := DataSource;
            MyTable.TableType := ttASCII;

            MyDatabase.Open;
            MyTable.Active := true;
            FMyDataSource.DataSet := MyTable;
          end;
         Result := true;
      end;


{Nate QUERY z textovho souboru a oteve ho}
    if (DatasourceType = dstSQL) or (DatasourceType = dstSQLdef) then
      begin
        if MyQuery = nil then
          begin
            MyQuery := TQuery.create(nil);
            MyQuery.Name := Name+'_SQL';
          end;

        if not MyQuery.active then
          begin
            MyQuery.DatabaseName := DataSourcePath;
            MyQuery.SQL := DSSql;
            MyQuery.Active := true;
            FMyDataSource.DataSet := MyQuery;
          end;
         Result := true;
      end;

{Nate QBE a oteve ho}
    if DatasourceType = dstQBE then
      begin
    {  PPKQBE
        if MyQBE = nil then
          begin
            MyQBE := TwwQBE.create(nil);
            MyQBE.Name := Name+'_SQL';
          end;

        if not MyQBE.active then
          begin
            MyQBE.DatabaseName := DataSourcePath;
            MyQBE.QBE := DSSql;
            MyQBE.Active := true;
            FMyDataSource.DataSet := MyQBE;
          end;
         Result := true;
     }
      end;

  except
    messagebeep(0);
  end;
{  Screen.Cursor := crDefault;}
end;


{--------------------------------------------------------------------------------------------------}
{ FieldExists                                                                                      }
{                                                                                                  }
{ V ppad, e field se jmnem aValue v datovm zdroji existuje, vrac True.                      }
{ Promnn:                                                                                        }
{     i         - pomocn  promnn pro zen cyklu                                               }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function  TDatabaseClass.FieldExists(aValue : string) : Boolean;
var  i : Integer;
begin
  result := false;
  if CreateMyTable then
    begin
        begin
          for i := 0 to FMyDataSource.DataSet.FieldCount - 1 do
            begin
              if UpperCase(FMyDataSource.DataSet.Fields[i].FieldName) = UpperCase(aValue) then
                begin
                  result := true;
                  break;
                end;
            end;
        end;
    end;
end;


{
Po zmn klov property mus uzavt zdroje dat, aby se provedl
refresh v proc CreateMyTable
}
procedure TDatabaseClass.SetNewDS;
begin
{
   if FMyDataSource <> nil then
      if FMyDataSource.DataSet.Active then FMyDataSource.DataSet.Close;
 }
end;


{--------------------------------------------------------------------------------------------------}
{ GetMyIndexNames                                                                                  }
{                                                                                                  }
{ Pouze v ppad tabulky.                                                                         }
{ Vrac seznam index.                                                                             }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function TDatabaseClass.GetMyIndexNames : TStringList;
begin
  Result := TStringList.Create;
  if DataSourceType = dstTable then MyTable.GetIndexNames(Result)
    else Result := nil;
end;

{--------------------------------------------------------------------------------------------------}
{ GetDataSourcePath                                                                                }
{                                                                                                  }
{ Vrac cestu ke zdroji dat.                                                                       }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function  TDatabaseClass.GetDataSourcePath: string;
begin
   result := FDataSourcePath;
end;

{--------------------------------------------------------------------------------------------------}
{ SetDataSourcePath                                                                                }
{                                                                                                  }
{ Do globln promnn FDataSourcePath zape cestu ke zdroji dat.                                 }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
procedure TDatabaseClass.SetDataSourcePath(aValue: string);
begin
   FDataSourcePath :=  aValue;
   SetNewDS;
end;

{--------------------------------------------------------------------------------------------------}
{ GetDataSource                                                                                    }
{                                                                                                  }
{ Vrac nzev zdroje dat. (nap. jmno tabulky)                                                    }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function  TDatabaseClass.GetDataSource: string;
begin
   result := FDataSource;
end;

{--------------------------------------------------------------------------------------------------}
{ SetDataSource                                                                                    }
{                                                                                                  }
{ Do globln promnn FDataSource zape nzev zdroje dat.                                        }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
procedure TDatabaseClass.SetDataSource(aValue: string);
begin
   FDataSource := aValue;
   SetNewDS;
end;

{--------------------------------------------------------------------------------------------------}
{ GetAdressField                                                                                   }
{                                                                                                  }
{ Vrac adresov pole DS v etzci oddlen stednkem.                                            }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function  TDatabaseClass.GetAdressField: string;
begin
{
Zajitit aby byla property naplnna i v ppad
tabulky hodnotami pol aktulnho indexu
}
   result := FAdresField;
end;

{--------------------------------------------------------------------------------------------------}
{ SetAdressField                                                                                   }
{                                                                                                  }
{ Do globln promnn FAdressField zape zvolen adresov pole (oddlen stednkem)             }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
procedure TDatabaseClass.SetAdressField(aValue: string);
begin
   FAdresField := aValue;
end;

{--------------------------------------------------------------------------------------------------}
{ GetNameField                                                                                     }
{                                                                                                  }
{ Vrac pole DS pro pojmenovn TVirtualElement.                                                   }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function  TDatabaseClass.GetNameField: string;
begin
   result := FNameField;
end;

{--------------------------------------------------------------------------------------------------}
{ SetNameField                                                                                     }
{                                                                                                  }
{ Do globln promnn FNameField zape zvolen pole pro pojmenovn TVirtualElement.             }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
procedure TDatabaseClass.SetNameField(aValue: string);
begin
   FNameField := aValue;
end;

{--------------------------------------------------------------------------------------------------}
{ GetPropertyCount                                                                                 }
{                                                                                                  }
{ Vrt poet sloupc zdroje dat.                                                                  }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function TDatabaseClass.GetPropertyCount : LongInt;
begin
  result := 0;
  if CreateMyTable then result := FMyDataSource.DataSet.FieldDefs.Count;
end;

{--------------------------------------------------------------------------------------------------}
{ GetDSIndexName                                                                                   }
{                                                                                                  }
{ Vrt jmno aktulnho indexu (pouvat pouze pro typ DS - dstTable).                            }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function TDatabaseClass.GetDSIndexName : string;
begin
  result := FDSIndexName;
end;

{--------------------------------------------------------------------------------------------------}
{ SetDSIndexName                                                                                   }
{                                                                                                  }
{ Do globln promnn FDSIndexName zape jmno danho indexu (pouze pro typ DS - dstTable).      }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
procedure TDatabaseClass.SetDSIndexName(AValue : string);
var   i : Integer;
begin
  FDSIndexName := aValue;
end;

{--------------------------------------------------------------------------------------------------}
{ GetPropertyName                                                                                  }
{                                                                                                  }
{ Vrt jmno fieldu datovho zdroje dle zadanho indexu.                                          }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function TDatabaseClass.GetPropertyName(aIndex: longInt) : string;
begin
  result := '';
  if CreateMyTable then result := FMyDataSource.DataSet.FieldDefs.Items[aIndex].Name;
end;

{--------------------------------------------------------------------------------------------------}
{ GetPropertyIndex                                                                                 }
{                                                                                                  }
{ Dle jmna pole vrt index pole DS (resp. poadov slo pole). Pokud nenajde nic vrt -1.      }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function  TDatabaseClass.GetPropertyIndex(aValue : string) : LongInt;
begin
  result := -1;
  try
    if CreateMyTable then result := FMyDataSource.DataSet.FieldByName(aValue).Index;
  except
  end;
end;

{--------------------------------------------------------------------------------------------------}
{ GetPropertyTypeI                                                                                 }
{                                                                                                  }
{ Vrt typ pole datovho zdroje dle danho indexu.                                                }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function TDatabaseClass.GetPropertyTypeI(aIndex: longInt) : TFieldType;
begin
  if CreateMyTable then result := FMyDataSource.DataSet.FieldDefs.Items[aIndex].DataType;
end;

{--------------------------------------------------------------------------------------------------}
{ GetPropertySizeI                                                                                 }
{                                                                                                  }
{ Vrt velikost pole datovho zdroje dle danho indexu.                                           }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function TDatabaseClass.GetPropertySizeI(aIndex: longInt) : Integer;
begin
  if CreateMyTable then result := FMyDataSource.DataSet.FieldDefs.Items[aIndex].Size;
end;

{--------------------------------------------------------------------------------------------------}
{ GetPropertyRequiredI                                                                             }
{                                                                                                  }
{ Vrt logickou hodnotu zda je nebo nen nutn pole DS vyplnit (dle danho indexu ).              }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function TDatabaseClass.GetPropertyRequiredI(aIndex: longInt) : Boolean;
begin
  if CreateMyTable then result := FMyDataSource.DataSet.FieldDefs.Items[aIndex].Required;
end;

{--------------------------------------------------------------------------------------------------}
{ GetPropertyValueI                                                                                }
{                                                                                                  }
{ Vrt hodnotu pole datovho zdroje dle danho indexu.                                            }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function TDatabaseClass.GetPropertyValueI(aIndex: longInt; aKey : string) : string;
var i,j : Integer;
    Chyba,IndexExists : Boolean;
begin
  result := '';
  {Hledn zznamu v tabulce - dle indexu}

  if DataSourceType = dstTable then
    begin
      if not CreateMyTable then exit;
      MyTable.IndexDefs.Update;
      if MyTable.IndexDefs.Count > 0 then IndexExists := true else IndexExists := False;
    end;

  if (DataSourceType = dstTable) and IndexExists then
    begin
      if not CreateMyTable then exit;
      if MyTable.IndexName <> DSIndexName then MyTable.IndexName := DSIndexName;

      MyTable.SetKey;
      for i:=0 to MyTable.IndexFieldCount - 1 do
        begin
          MyTable.FieldByName(MyTable.IndexFields[i].FieldName).AsString := GetKeyValue(aKey,i+1);
        end;
      if MyTable.GotoKey then
        begin
          result := MyTable.Fields[aIndex].AsString
        end;
    end;

  {hledn zznamu v Query a QBE - sekvenn}

  if (DataSourceType <> dstTable) or ((DataSourceType = dstTable) and (not IndexExists))  then
    begin
      for i:=1 to ElementsCount do
        begin
          Chyba := false;
          for j := 1 to AdressFieldCount do
            begin
              if FMyDataSource.DataSet.FieldByName(GetKeyValue(AdressField,i)).AsString
                 <> GetKeyValue(aKey,i) then Chyba := true;
              if (not Chyba) and (j = AdressFieldCount) then
                begin
                  result := FMyDataSource.DataSet.Fields[aIndex].AsString;
                  break;
                end;
            end;
          if not Chyba then break;
          FMyDataSource.DataSet.Next;
        end;
    end;
end;

{--------------------------------------------------------------------------------------------------}
{ GetPropertyValueN                                                                                }
{                                                                                                  }
{ Vrt hodnotu pole datovho zdroje dle danho jmna pole.                                        }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function TDatabaseClass.GetPropertyValueN(aName: string; aKey : string) : string;
var  i,j : Integer;
     Chyba,IndexExists : Boolean;
begin
  result := '';
  {Hledn zznamu v tabulce - dle jmna fieldu}
  if DataSourceType = dstTable then
    begin
      if not CreateMyTable then exit;
      MyTable.IndexDefs.Update;
      if MyTable.IndexDefs.Count > 0 then IndexExists := true else IndexExists := False;
    end;

  if (DataSourceType = dstTable) and IndexExists then
    begin
      if not CreateMyTable then exit;
      if MyTable.IndexName <> DSIndexName then MyTable.IndexName := DSIndexName;

      MyTable.SetKey;
      for i:=0 to MyTable.IndexFieldCount - 1 do
        begin
          MyTable.FieldByName(MyTable.IndexFields[i].FieldName).AsString := GetKeyValue(aKey,i+1);
        end;
      if MyTable.GotoKey then
        begin
          result := MyTable.FieldByName(aName).AsString
        end;
    end;

  {hledn zznamu v Query a QBE - sekvenn}
  if (DataSourceType <> dstTable) or ((DataSourceType = dstTable) and (not IndexExists))  then
    begin
      //FMyDataSource.DataSet.First;
      for i:=1 to ElementsCount do
        begin
          Chyba := false;
          for j := 1 to AdressFieldCount do
            begin
              if FMyDataSource.DataSet.FieldByName(GetKeyValue(AdressField,j)).AsString
                 <> GetKeyValue(aKey,j) then Chyba := true;
              if (not Chyba) and (j = AdressFieldCount) then
                begin
                  result := FMyDataSource.DataSet.FieldByName(aName).AsString;
                  break;
                end;
            end;
          if not Chyba then break;
          FMyDataSource.DataSet.Next;
          if FMyDataSource.DataSet.EOF then FMyDataSource.DataSet.First;
        end;
    end;
end;


{--------------------------------------------------------------------------------------------------}
{ GetSQL                                                                                           }
{                                                                                                  }
{ Vrt SQL dotaz v textovm tvaru.                                                                }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function  TDatabaseClass.GetSQL : TStrings;
begin
  result.Assign(FSql);
end;

{--------------------------------------------------------------------------------------------------}
{ SetSQL                                                                                           }
{                                                                                                  }
{ Do property DSSql ulo SQL dotaz v textovm tvaru.                                              }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
procedure TDatabaseClass.SetSQL(aValue: TStrings);
begin
  DSSQL.Assign(aValue);
  SetNewDS;
end;

{--------------------------------------------------------------------------------------------------}
{ SetPropertyValueI                                                                                }
{                                                                                                  }
{ Umouje zmnit hodnotu pole DS. Zznam se hled dle adresovch pol (hodnota v aKey) a          }
{ sloupec dle indexu (aIndex).                                                                     }
{ V ppad tabulky se zznam hled pomoc metody FindKey (pokud existuje index), v ostatnch      }
{ ppadech se zznam hled sekvenn.                                                             }
{                                                                                                  }
{ Promnn:                                                                                        }
{     i,j         - pomocn promnn pro zen cyklu                                              }
{     chyba       - detekuje, zda hodnota aKey se shoduje s aktulnmi hodnotami adresovch pol DS}
{     indexExists - detekuje, zda tabulka obsahuje alespo jeden index                             }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
procedure TDatabaseClass.SetPropertyValueI(aIndex: longInt; aKey : string; aValue: string);
var i,j : Integer;
    Chyba,IndexExists : Boolean;
begin
  aValue := '';

  {Hledn zznamu v tabulce - dle indexu}
  IndexExists := false;
  if DataSourceType = dstTable then
    begin
      if not CreateMyTable then exit;
      MyTable.IndexDefs.Update;
      if MyTable.IndexDefs.Count > 0 then IndexExists := true else IndexExists := False;
    end;

  if IndexExists then
    begin
      if MyTable.IndexName <> DSIndexName then MyTable.IndexName := DSIndexName;

      MyTable.SetKey;
      for i:=0 to MyTable.IndexFieldCount - 1 do
        begin
          MyTable.FieldByName(MyTable.IndexFields[i].FieldName).AsString := GetKeyValue(aKey,i+1);
        end;
      if MyTable.GotoKey then
        begin
          try
            MyTable.Edit;
             MyTable.Fields[aIndex].AsString := aValue;
            MyTable.POst;
          except
          end;
        end;
    end;

  {hledn zznamu v TTable - sekvenn (tabulka neobsahuje index)}

  if (DataSourceType = dstTable) and (not IndexExists)  then
    begin
      for i:=1 to ElementsCount do
        begin
          Chyba := false;
          for j := 1 to AdressFieldCount do
            begin
              if FMyDataSource.DataSet.FieldByName(GetKeyValue(AdressField,i)).AsString
                 <> GetKeyValue(aKey,i) then Chyba := true;
              if (not Chyba) and (j = AdressFieldCount) then
                begin
                  try
                    MyTable.Edit;
                      MyTable.Fields[aIndex].AsString := aValue;
                    MyTable.POst;
                  except
                  end;

                  break;
                end;
            end;
          if not Chyba then break;
          FMyDataSource.DataSet.Next;
        end;
    end;
end;


{--------------------------------------------------------------------------------------------------}
{ SetPropertyValueN                                                                                }
{                                                                                                  }
{ Umouje zmnit hodnotu pole DS. Zznam se hled dle adresovch pol (hodnota v aKey) a          }
{ sloupec dle jmna pole (aName).                                                                  }
{ V ppad tabulky se zznam hled pomoc metody FindKey (pokud existuje index), v ostatnch      }
{ ppadech se zznam hled sekvenn.                                                             }
{                                                                                                  }
{ Promnn:                                                                                        }
{     i,j         - pomocn promnn pro zen cyklu                                              }
{     chyba       - detekuje, zda hodnota aKey se shoduje s aktulnmi hodnotami adresovch pol DS}
{     indexExists - detekuje, zda tabulka obsahuje alespo jeden index                             }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
procedure TDatabaseClass.SetPropertyValueN(aName: string; aKey : string; aValue: string);
var i,j : Integer;
    Chyba,IndexExists : Boolean;
begin
  aValue := '';

  {Hledn zznamu v tabulce - dle indexu}
  IndexExists := false;
  if DataSourceType = dstTable then
    begin
      if not CreateMyTable then exit;
      MyTable.IndexDefs.Update;
      if MyTable.IndexDefs.Count > 0 then IndexExists := true else IndexExists := False;
    end;

  if IndexExists then
    begin
      if MyTable.IndexName <> DSIndexName then MyTable.IndexName := DSIndexName;

      MyTable.SetKey;
      for i:=0 to MyTable.IndexFieldCount - 1 do
        begin
          MyTable.FieldByName(MyTable.IndexFields[i].FieldName).AsString := GetKeyValue(aKey,i+1);
        end;
      if MyTable.GotoKey then
        begin
          try
            MyTable.Edit;
             MyTable.FieldByName(aName).AsString := aValue;
            MyTable.POst;
          except
          end;
        end;
    end;

  {hledn zznamu v Ttable - sekvenn}

  if (DataSourceType = dstTable) and (not IndexExists)  then
    begin
      for i:=1 to ElementsCount do
        begin
          Chyba := false;
          for j := 1 to AdressFieldCount do
            begin
              if FMyDataSource.DataSet.FieldByName(GetKeyValue(AdressField,i)).AsString
                 <> GetKeyValue(aKey,i) then Chyba := true;
              if (not Chyba) and (j = AdressFieldCount) then
                begin
                  try
                    MyTable.Edit;
                      MyTable.FieldByName(aName).AsString := aValue;
                    MyTable.POst;
                  except
                  end;

                  break;
                end;
            end;
          if not Chyba then break;
          FMyDataSource.DataSet.Next;
        end;
    end;
end;


{--------------------------------------------------------------------------------------------------}
{ GetDSData                                                                                        }
{                                                                                                  }
{ Vrt data obsaen ve zdroji dat (v TDatasource).                                               }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function TDatabaseClass.GetDSData: TDataSource;
begin
  result := TDataSource.Create(nil);
  result := FMyDataSource;
end;

{ TVirtualElement }

function  TVirtualElement.GetInstanceSize: longInt;
begin
  if ElementClass <> nil then result := ElementClass.RecordSize;
end;

function  TVirtualElement.GetAdress: string;
begin
   result := FElementAdress;
end;

procedure TVirtualElement.SetAdress(aValue: string);
begin
   FElementAdress := aValue;
end;

function  TVirtualElement.GetClassName: string;
begin
   if ElementClass <> nil then result := ElementClass.Name;
end;

function  TVirtualElement.GetPropertyCount: longInt;
begin
   if ElementClass <> nil then result := ElementClass.PropertyCount;
end;

function  TVirtualElement.GetPropertyName(aIndex: longInt): string;
begin
   if ElementClass <> nil then result := ElementClass.PropertyName[aIndex];
end;

function  TVirtualElement.GetPropertyTypeI(aIndex: longInt): TFieldType;
begin
   if ElementClass <> nil then result := ElementClass.PropertyTypeI[aIndex];
end;


function TVirtualElement.GetPropertyStringByName(AName: string): string;
begin
{Rozhodnout, kdy vrtit jakou property - zda standardn nebo pole tabulky !!!! }
  if ElementClass <> nil then
    begin
      if ElementClass.FieldExists(aName) then
        result := ElementClass.PropertyValueN[aName,ElementAdress]
      else result := inherited GetPropertyStringByName(AName);
    end;
end;

function TVirtualElement.GetPropertyStringByIndex(aIndex: LongInt): string;
begin
  if ElementClass <> nil then
    begin
      result := ElementClass.PropertyValueI[aIndex,ElementAdress]
    end;
end;


{--------------------------------------------------------------------------------------------------}
{ _Create                                                                                          }
{                                                                                                  }
{ Vrt TElement pro prv vytvoenou vtu. (pouze pro tabulky)                                    }
{                                                                                                  }
{--------------------------------------------------------------------------------------------------}
function TDatabaseClass._Create : TElement;
begin
  if DataSourceType = dstTable then
    begin
      if not CreateMyTable then exit;
      MyTable.Append;
      MyTable.Post;
      if (FVirtualElement = nil) or (FVirtualElement.OwnersCount > 0) then
        begin
          FVirtualElement := TVirtualElement.Create;
          FVirtualElement.Name := '';
          (FVirtualElement as TVirtualElement).ElementAdress := '';
          (FVirtualElement as TVirtualElement).ElementClass := Self;
          Result := FVirtualElement;
        end
      else
        begin
          FVirtualElement.Name := '';
          (FVirtualElement as TVirtualElement).ElementAdress := '';
          Result := (FVirtualElement as TVirtualElement);
        end;

    end else result := nil;
end;

function TDatabaseClass._Destroy(Element : TElement) : Boolean;
var Index : LongInt;
begin
  Result := false;
  if DataSourceType <> dstTable then exit;

  Index := IndexOf(Element);
  if Index > 0 then
    begin
      MyTable.MoveBy(Index);
      try
        MyTable.delete;
        Result := true;
      except
      end;
    end;
end;


BEGIN
   RegisterOrbisClass(TDatabaseClass);
END.
