{$IMPORTEDDATA ON}
unit T_mytool;

interface

Uses
  DB,
  Classes,
  SysUtils;

function DataTypeToStr(aValue : TFieldType) : string;
function BoolToStr(aValue : Boolean) : string;
function GetKeyValue(aKey : string; aIndex : Integer) : String;
function GetAliasPath(Retezec : string; Lomitko : boolean) : string;
function AliasExists(aAlias : string) : Boolean;
function StrExists(Strings : TStrings; aStr : string) : Boolean;

implementation
uses
  DBTables;

function DataTypeToStr(aValue : TFieldType) : string;
begin
  result := '';
  case aValue of
    ftUnknown:  result := 'ftUnknown';
    ftString:   result := 'ftString';
    ftSmallint: result := 'ftSmallint';
    ftInteger:  result := 'ftInteger';
    ftWord:     result := 'ftWord';
    ftBoolean:  result := 'ftBoolean';
    ftFloat:    result := 'ftFloat';
    ftCurrency: result := 'ftCurrency';
    ftBCD:      result := 'ftBCD';
    ftDate:     result := 'ftDate';
    ftTime:     result := 'ftTime';
    ftDateTime: result := 'ftDateTime';
    ftBytes:    result := 'ftBytes';
    ftVarBytes: result := 'ftVarBytes';
    ftBlob:     result := 'ftBlob';
    ftMemo:     result := 'ftMemo';
    ftGraphic:  result := 'ftGraphic';
  end;
end;

function BoolToStr(aValue : Boolean) : string;
begin
  result := '';
  if aValue then result := 'True' else result := 'False'; 
end;

function  GetKeyValue(aKey : string; aIndex : Integer) : String;
var  i,Poradi : Integer;
     Znak,Slovo : string;
begin
  Result := '';
  Slovo := ''; Znak := ''; Poradi := 1;
  for i := 1 to Length(aKey) do
    begin
      Znak := copy(aKey,i,1);
      if Znak <> ';' then Slovo := Slovo + Znak
      else
        if Poradi = aIndex then
          begin
            inc(Poradi);
            Result := Slovo;
            break;
          end else Slovo := '';
    end;
    if (aIndex = 1) then result := Slovo;
end;

function GetAliasPath(Retezec : string; Lomitko : boolean): String;
var
  MyString : TStringList;
  fg       : word;
  S        : String;
begin
  Result := '';
  MyString := TStringList.Create;
  try
    Session.GetAliasParams(Retezec,MyString);
  except
    MyString.Free;
    Exit;
  end;
  S := MyString.Strings[0];
  If Length(S) > 5 then
    begin
      System.Delete(S,1,5);
      If (S[Length(S)] <> '\') and (Lomitko) then S := S + '\';
      Result := S;
    end;
  MyString.Free;
end;

function AliasExists(aAlias : string) : Boolean;
var  MyStringList : TStringList;
     Index : Integer;
begin
  MyStringList := TStringList.Create;
  Session.GetAliasNames(MyStringList);
  result := MyStringList.Find(aAlias,Index);
end;


function StrExists(Strings : TStrings; aStr : string) : Boolean;
var i : Integer;
begin
  result := false;
  for i := 0 to Strings.Count - 1 do
    begin
      if UpperCase(Strings[i]) = UpperCase(aStr) then
        begin
          result := true;
          break;
        end;
    end;
end;

end.
