unit t_ConvertLesniCelek;

interface
uses
   e_LesCel,
   Tools;

type

TConvertLesniCelek=class(TTool)
  private
    FTAXDirectory: string;
    FLesniCelek: TLesniCelek;
    FTAXOutputDirectory: string;
    procedure SetLesniCelek(const Value: TLesniCelek);
    procedure SetTAXDirectory(const Value: string);
    procedure SetTAXOutputDirectory(const Value: string);
public
   procedure DoIt; override;
   function  NumberToPropertyName(aNumber: longInt): string;override;
   function  CreateLesniCelek: boolean;
   procedure DestroyLesniCelek;
   property  LesniCelek: TLesniCelek read FLesniCelek write SetLesniCelek;
published
   property  TAXDirectory: string read FTAXDirectory write SetTAXDirectory;
   property  TAXOutputDirectory: string read FTAXOutputDirectory write SetTAXOutputDirectory;
end;

implementation
uses
   FOrms,
   Dialogs,
   SysUtils,
   dtbles98,
   eLesObec,
   LesCisel,
   e_Class,
   Worlds;

{ TConvertLesniCelek }

function TConvertLesniCelek.CreateLesniCelek: boolean;
begin
   result := true;
   LesniCelek := TLesniCelek.create;
   World.objectmodel.AddElement(LesniCelek);
   LesniCelek.NajdiTypDatLHP(false,TAXOutputDirectory,false,false,true); // nalezen dat TAXu
   LesniCelek.NajdiTypDatLHP(false,TAXDirectory,false,true,true); // nalezen dat TAXu
   if LesniCelek.TypDatLHP=NeniLHP then
   begin
      showmessage('V adresi "" nejsou data LHP');
      LesniCelek.Free;
      LesniCelek := nil;
      result := false;
      exit;
   end;
   LesniCelek.nactiPrvniOddeleni;
end;

procedure TConvertLesniCelek.DestroyLesniCelek;
begin
   LesniCelek.Free;
end;

procedure TConvertLesniCelek.DoIt;
var
   i: integer;
   ODD: integer;
begin
   if not CreateLesniCelek then exit;
   StartProgress('Konverze TAXu',0,LesniCelek.SeznamOddeleni.Count -1);
   LesniCelek.LOvr98.SmazVse(false);
   UlozPolozkyLHC_DB98(LesniCelek.LHC,LesniCelek.LOvr98);
   for i := 0 to LesniCelek.SeznamOddeleni.Count - 1 do
   begin
      progress := i;
      ODD := LesniCelek.LHC.Oddeleni.ODD;
      ProgressText := 'ODD: '+IntToStr(LesniCelek.LHC.Oddeleni.ODD);
      Application.ProcessMessages;
      UlozOddeleni_DB98(LesniCelek.LHC.Oddeleni,LesniCelek.LOvr98,BezBarvy1);
      //ProcessOddeleni(LesniCelek.LHC.Oddeleni);
      if i < (LesniCelek.SeznamOddeleni.Count -1) then
         LesniCelek.nactiOddeleni(true);
   end;
   DestroyLesniCelek;
end;

function TConvertLesniCelek.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0: result := 'TAXDirectory';
      1: result := 'TAXOutputDirectory'
   end;
end;

procedure TConvertLesniCelek.SetLesniCelek(const Value: TLesniCelek);
begin
  FLesniCelek := Value;
end;

procedure TConvertLesniCelek.SetTAXDirectory(const Value: string);
begin
  FTAXDirectory := Value;
end;

procedure TConvertLesniCelek.SetTAXOutputDirectory(const Value: string);
begin
  FTAXOutputDirectory := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TConvertLesniCelek);
END.
