unit t_Free_;

interface
uses
   Classes,
   Elements,
   t_CmdLn,
   Tools;

type

TFree_ = class(TTool)
public
   procedure DoIt(); override;
end;

TFree_Thread = class(TThread)
  private
    FElement: TElement;
    procedure SetElement(const Value: TElement);
public
   procedure Execute; override;
   property Element: TElement read FElement write SetElement;
end;

TTool_Thread = class(TThread)
private
    FTool: TTool;
    FFileName: string;
    procedure SetTool(const Value: TTool);
    procedure SetFileName(const Value: string);
public
   procedure Execute; override;
   property  Tool: TTool read FTool write SetTool;
   property  FileName: string read FFileName write SetFileName;
end;

TOIL_ = class(TTool)
  private
    FFileName: string;
    FTh: TTool_Thread;
    FCmd: TCommandLine;
    procedure SetFileName(const Value: string);
    procedure SetTh(const Value: TTool_Thread);
    procedure SetCmd(const Value: TCommandLine);
public
   procedure DoIt; override;
   function  NumberToPropertyName(aNumber: longInt): string; override;
   procedure onThreadTerminate(Sender:TObject);
   property  Cmd: TCommandLine read FCmd write SetCmd;
   property  Th: TTool_Thread read FTh write SetTh;
published
   property FileName: string read FFileName write SetFileName;
end;

implementation
uses
   Dialogs,
   t_Main,
   e_Class,
   u_String,
   Worlds, T_maintl;

{ TFree_ }

procedure TFree_.DoIt;
var
   FT: TFree_Thread;
begin
   FT := TFree_Thread.Create(true);
   FT.FreeOnTerminate := true;
   FT.OnTerminate := TMainTool(World.MainTool).onThreadTerminate;
   FT.Element := Input;
   FT.Resume;
end;

{ TFree_Thread }

procedure TFree_Thread.Execute;
begin
   try
   if Element <> nil then
      Element.Free;
   except
   end;
   //ShowMessage('free_ end');
end;

procedure TFree_Thread.SetElement(const Value: TElement);
begin
  FElement := Value;
end;

{ TOIL_ }

procedure TOIL_.DoIt;
begin
   Th := TTool_Thread.Create(true);
   //Cmd := TCommandLine.Create;
   //Cmd.FileName := GetAbsolutePath(FileName);
   //Th.Tool := Cmd;
   Th.FileName := FileName;
   Th.OnTerminate := TMainTool(World.MainTool).onThreadTerminate;
   Th.FreeOnTerminate := true;
   Th.Resume;
end;

function TOIL_.NumberToPropertyName(aNumber: Integer): string;
begin
   result := 'FileName';
end;

procedure TOIL_.onThreadTerminate(Sender: TObject);
begin
   //Th.Free;
   //ShowMessage('Hotovo');
   //Free;
end;

procedure TOIL_.SetCmd(const Value: TCommandLine);
begin
  FCmd := Value;
  AddElement(Value);
end;

procedure TOIL_.SetFileName(const Value: string);
begin
  FFileName := Value;
end;

procedure TOIL_.SetTh(const Value: TTool_Thread);
begin
  FTh := Value;
end;

{ TTool_Thread }

procedure TTool_Thread.Execute;
var
   cmd: TCommandLine;
begin
   try
   //MainThreadID
   Cmd := TCommandLine.Create;
   Cmd.FileName := GetAbsolutePath(FileName);
   Cmd.DoIt;
   Cmd.Free;
   except
   end;
end;

procedure TTool_Thread.SetFileName(const Value: string);
begin
  FFileName := Value;
end;

procedure TTool_Thread.SetTool(const Value: TTool);
begin
  FTool := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TFree_);
   RegisterOrbisClass(TOIL_);
END.
