unit t_RasTest;

interface
uses
   e_Device,
   e_Raster,
   i_Uni,
   RasData_TLB,
   Tools;
type

TRasTest = class(TTool)
  private
    FFileName: string;
    FDevice: TBitmapDevice;
    FAlign: integer;
    FRows: integer;
    FInterpret: TUniversalInterpret;
    FPixelSizeH: double;
    FPixelSizeV: double;
    FByModel: boolean;
    FMaxSize: double;
    FUseMaxSize: boolean;
    FRastyp: integer;
    FCompress: integer;
    FMaxBlack: byte;
    FMaxBlackForAll: boolean;
    FExactSize: boolean;
    procedure SetFileName(const Value: string);
    procedure SetDevice(const Value: TBitmapDevice);
    procedure SetAlign(const Value: integer);
    procedure SetRows(const Value: integer);
    procedure SetInterpret(const Value: TUniversalInterpret);
    procedure SetPixelSizeH(const Value: double);
    procedure SetPixelSizeV(const Value: double);
    function GetByDevice: boolean;
    procedure SetByDevice(const Value: boolean);
    procedure SetByModel(const Value: boolean);
    procedure SetMaxSize(const Value: double);
    procedure SetUseMaxSize(const Value: boolean);
    procedure SetRastyp(const Value: integer);
    procedure SetCompress(const Value: integer);
    procedure SetMaxBlack(const Value: byte);
    procedure SetMaxBlackForAll(const Value: boolean);
    procedure SetExactSize(const Value: boolean);
public
   procedure DoIt; override;
published
   property FileName: string read FFileName write SetFileName;
   property Interpret: TUniversalInterpret read FInterpret write SetInterpret;
   property Device: TBitmapDevice read FDevice write SetDevice;
   property Align: integer read FAlign write SetAlign;
   property Rows: integer read FRows write SetRows;
   property PixelSizeH: double read FPixelSizeH write SetPixelSizeH;
   property PixelSizeV: double read FPixelSizeV write SetPixelSizeV;
   property ByModel: boolean read FByModel write SetByModel;
   property ByDevice: boolean read GetByDevice write SetByDevice;
   property MaxSize: double read FMaxSize write SetMaxSize;
   property UseMaxSize: boolean read FUseMaxSize write SetUseMaxSize;
   property Rastyp: integer read FRastyp write SetRastyp;
   property Compress: integer read FCompress write SetCompress;
   property MaxBlack: byte read FMaxBlack write SetMaxBlack;
   property MaxBlackForAll: boolean read FMaxBlackForAll write SetMaxBlackForAll;
   property ExactSize: boolean read FExactSize write SetExactSize;
end;

TExportToBitmap = class(TTool)
  private
    FExactSize: boolean;
    FByModel: boolean;
    FCompressionQuality: integer;
    FBMFormat: string;
    FFileName: string;
    FDevice: TBitmapDevice;
    FInterpret: TUniversalInterpret;
    FBMWidth: integer;
    FBMHeight: integer;
    procedure SetFileName(const Value: string);
    procedure SetDevice(const Value: TBitmapDevice);
    procedure SetInterpret(const Value: TUniversalInterpret);
    function GetByDevice: boolean;
    procedure SetByDevice(const Value: boolean);
    procedure SetByModel(const Value: boolean);
    procedure SetExactSize(const Value: boolean);
    procedure SetBMFormat(const Value: string);
    procedure SetCompressionQuality(const Value: integer);
    procedure SetBMHeight(const Value: integer);
    procedure SetBMWidth(const Value: integer);
public
   procedure DoIt; override;
published
   property FileName: string read FFileName write SetFileName;
   property Interpret: TUniversalInterpret read FInterpret write SetInterpret;
   property Device: TBitmapDevice read FDevice write SetDevice;
   property ByModel: boolean read FByModel write SetByModel;
   property ByDevice: boolean read GetByDevice write SetByDevice;
   property ExactSize: boolean read FExactSize write SetExactSize;
   property CompressionQuality: integer read FCompressionQuality write SetCompressionQuality;
   property BMFormat: string read FBMFormat write SetBMFormat;
   property BMWidth: integer read FBMWidth write SetBMWidth;
   property BMHeight: integer read FBMHeight write SetBMHeight;
end;

implementation
uses
   Forms,
   Dialogs,
   m_Orbis,
   G_Elems,
   Graphics,
   JPEG,
   Vcl.Imaging.pngimage,
   SysUtils,
   d_Raster,
   e_Class;

{ TRasTest }
(*
procedure TRasTest.DoIt;
var
   RAS: e_Raster.TRaster;
   ITR: ITopRaster;
   Len: integer;
   AlignLen: integer;
   _Align: integer;
   B: TBitmap;
   P: PByteArray;
   BA: TByteArray;
   PutLin: integer;
   i,j,jj: integer;
   res: HResult;
   Er: boolean;
   Ar: Array of byte;
begin
   if Align < 1 then
      Align := 1;
   if Rows < 1 then
      Rows := 1;
   Ras := e_Raster.TRaster.Create;
   if Device <> nil then
   begin
      B := Device.Bitmap;
      Ras.SrvRas.Width := B.Width;
   end
   else
      Ras.SrvRas.Width := 500;
   Ras.SrvRas.Height := 400;
   Ras.SrvRas.BitPix := 24;
   Ras.SrvRas.RasTyp := 5;
   Ras.SrvRas.DefCol := 255;

   Ras.SrvRas.CreateRas(FileName,2,255);
   Ras.SrvRas.X1 := 1089929.792;
   Ras.SrvRas.Y1 := 669761.449;
   Ras.SrvRas.Dx := Ras.SrvRas.Height*10;
   Ras.SrvRas.Dy := Ras.SrvRas.Width*10;
   //Ras.SrvRas.Dx := 4000;
   //Ras.SrvRas.Dy := 5000;
   {
   Ras.SrvRas.CloseRas(0);
   Application.ProcessMessages;
   Ras.SrvRas.OpenRas(FileName,0,2);
   }
   ITR := RAS.SrvRas as ITopRaster;
   res := ITR.SetAlignment(Align);
   res := ITR.GetParamLine(Len,AlignLen,_Align);
   //ShowMessage('Len:'+IntToStr(Len)+' AlLen:'+IntToStr(AlignLen)+' Align:'+IntToStr(Align));
   if Device <> nil then
   begin
      B := Device.Bitmap;
      Er := false;
      StartProgress(FileName,0,399);
      SetLength(Ar,B.Width*3);
      for i := 0 to 399 do
      begin
         P := B.ScanLine[i];
         j := 0;
         jj := (B.Width * 3) - 1;
         while j < jj do
         begin
            Ar[j]   := P[j+2];
            Ar[j+1] := P[j+1];
            Ar[j+2] := P[j];
            Inc(j,3);
         end;
         try
         res := ITR.WriteLines(i,1,Ar[0],PutLin);
         except
            Er := true;
            //ShowMessage('Err');
         end;
         Progress := i;
         Application.ProcessMessages;
      end;
      EndProgress;
      if Er then
         ShowMessage('Err')
      else
         ShowMessage('Hotovo');
      //ShowMessage(IntToStr(PutLin));
      {
      FillChar(BA,1500,$50);
      for i := 0 to 399 do
      begin
         P := B.ScanLine[i];
         //P := @BA;
         //ITR.WriteLines(0,400,P[0],PutLin);
         res := ITR.WritePixLine(i,0,400,P^[0]);
         //ITR.ReadPixLine(i,0,400,P^[0]);
         Application.ProcessMessages;
      end;
      }
   end
   else
      ShowMessage('No Device');
   //Ras.SrvRas.
   ITR := nil;
   Ras.Free;
end;
*)

procedure TRasTest.DoIt;
var
   D: TTopRaster_Device;
   R: TRectEntity;
   MView: TDoubleRect;
   BDevice: TDevice;
begin
   D := nil;
   R := nil;
   if Interpret = nil then exit;
   Interpret.Printing := true;
   BDevice := Interpret.Device;
   StartProgress('Export rastru '+FileName,0,0);
   Application.ProcessMessages;
   if ByModel then
   begin
      if (Input = nil) or not (Input is TRectEntity) then
         ByModel := false
      else
         R := TRectEntity(Input);
   end;
   if ByModel then
   begin
      if ExactSize then
         MView := R.Rect.DoubleRect
      else
         MView := R.Rect.AsDoubleRect;
   end
   else
      MView := Interpret.Device.Projection.CLipModelView;
   try
   D := TTopRaster_Device.Create;
   D.RAS_FileName := FileName;
   D.RAS_X1 := -MView.MaxY;
   D.RAS_Y1 := -MView.MaxX;
   D.RAS_dX := MView.MaxY - MVIew.MinY;
   D.RAS_dY := MVIew.MaxX - MView.MinX;
   D.RAS_PixelSizeX := PixelSizeV;
   D.RAS_PixelSizeY := PixelSizeH;
   D.RAS_TYP := Rastyp;
   if MaxBlack = 0 then
      MaxBlack := $EF;
   D.MaxBlack := MaxBlack;
   D.MaxBlackForAll := MaxBlackForAll;
   D.RAS_Compress := Compress;
   D.OldProjection := BDevice.Projection;
   D.ModelView := MView;
    { TODO -cZkontrolovat -oPPK : OTESTOVAT sakra.... !!!!!!!!! }
   D.Projection.VirtualScale := D.OldProjection.VirtualScale;
   D.Reset;
   Interpret.Device := D;
   Interpret.Tile := true;
   Interpret.DoIt;
   D.Close;
   except
      on E: Exception do
         PostTextMsg(tm_AddToProtocol,'Err BMP: ' + E.Message,nil);
//         ShowMessage('Err BMP: ' + E.Message);
   end;
   Interpret.Tile := false;
   Interpret.Device := BDevice;
   D.Free();
   Interpret.Printing := false;
end;

function TRasTest.GetByDevice: boolean;
begin
   result := not ByModel;
end;

procedure TRasTest.SetAlign(const Value: integer);
begin
  FAlign := Value;
end;

procedure TRasTest.SetByDevice(const Value: boolean);
begin
   ByModel := not Value;
end;

procedure TRasTest.SetByModel(const Value: boolean);
begin
  FByModel := Value;
end;

procedure TRasTest.SetCompress(const Value: integer);
begin
  FCompress := Value;
end;

procedure TRasTest.SetDevice(const Value: TBitmapDevice);
begin
  FDevice := Value;
end;

procedure TRasTest.SetExactSize(const Value: boolean);
begin
  FExactSize := Value;
end;

procedure TRasTest.SetFileName(const Value: string);
begin
  FFileName := Value;
end;

procedure TRasTest.SetInterpret(const Value: TUniversalInterpret);
begin
  FInterpret := Value;
end;

procedure TRasTest.SetMaxBlack(const Value: byte);
begin
  FMaxBlack := Value;
end;

procedure TRasTest.SetMaxBlackForAll(const Value: boolean);
begin
  FMaxBlackForAll := Value;
end;

procedure TRasTest.SetMaxSize(const Value: double);
begin
  FMaxSize := Value;
end;

procedure TRasTest.SetPixelSizeH(const Value: double);
begin
  FPixelSizeH := Value;
end;

procedure TRasTest.SetPixelSizeV(const Value: double);
begin
  FPixelSizeV := Value;
end;

procedure TRasTest.SetRastyp(const Value: integer);
begin
  FRastyp := Value;
end;

procedure TRasTest.SetRows(const Value: integer);
begin
  FRows := Value;
end;

procedure TRasTest.SetUseMaxSize(const Value: boolean);
begin
  FUseMaxSize := Value;
end;



{ TExportToBitmap }

procedure TExportToBitmap.DoIt;
var
   D: TBitmapDevice;
   R: TRectEntity;
   MView: TDoubleRect;
   BDevice: TDevice;
   aJPG: TJPEGImage;
   aPNG: TPNGImage;
   BM: TBitmap;
begin
   D := nil;
   R := nil;
   if Interpret = nil then exit;
   Interpret.Printing := true;
   BDevice := Interpret.Device;
   StartProgress('Export obrzku '+FileName,0,0);
   Application.ProcessMessages;
   if ByModel then
   begin
      if (Input = nil) or not (Input is TRectEntity) then
         ByModel := false
      else
         R := TRectEntity(Input);
   end;
   if ByModel then
   begin
      if ExactSize then
         MView := R.Rect.DoubleRect
      else
         MView := R.Rect.AsDoubleRect;
   end
   else
      MView := Interpret.Device.Projection.CLipModelView;
   try
   D := TBitmapDevice.Create;
   BM := TBitmap.Create;
   BM.PixelFormat := pf24bit;
   BM.Width := BMWIdth;
   BM.Height := BMHeight;
   D.Bitmap := BM;
   D.KillBitmap := true;
   D.Projection.Page.Color := BDevice.Projection.Page.Color;
   //D.ModelView := MView;
    { TODO -cZkontrolovat -oPPK : OTESTOVAT sakra.... !!!!!!!!! }
   D.Projection.VirtualScale := BDevice.Projection.VirtualScale;
   D.Reset;
   Interpret.Device := D;
   D.Projection.ChangeProjectionByRect(MView,D.Page);
   //Interpret.Tile := true;
   Interpret.DoIt;
   D.Close;
   except
      on E: Exception do
         PostTextMsg(tm_AddToProtocol,'Err BMP: ' + E.Message,nil);
//         ShowMessage('Err BMP: ' + E.Message);
   end;
   //Interpret.Tile := false;
   Interpret.Device := BDevice;
   // export to file
   if LowerCase(BMFormat) = 'jpg' then
   begin
      aJPG:= TJPEGImage.Create;
      if CompressionQuality > 0 then
      begin
        if CompressionQuality > 100 then
           CompressionQuality:= 100;
        aJPG.CompressionQuality:= CompressionQuality;
      end;
      aJPG.GrayScale:= false;//JPGGrayscale;
      //if JPGPixelFormat > 1 then
      //   JPGPixelFormat:= 1;

      //aJPG.PixelFormat:= TJPEGPixelFormat(JPGPixelFormat);
      aJPG.PixelFormat := jf24Bit;
      aJPG.Assign(D.Bitmap);
      aJPG.SaveToFile(FileName);
      aJPG.Free
   end
   else
   if LowerCase(BMFormat) = 'png' then
   begin
      aPNG:= TPngImage.Create;
//      if CompressionQuality > 0 then
//      begin
//        if CompressionQuality > 100 then
//           CompressionQuality:= 100;
//        aJPG.CompressionQuality:= CompressionQuality;
//      end;
//      aJPG.GrayScale:= false;//JPGGrayscale;
      //if JPGPixelFormat > 1 then
      //   JPGPixelFormat:= 1;

      //aJPG.PixelFormat:= TJPEGPixelFormat(JPGPixelFormat);
//      aPNG.PixelFormat := jf24Bit;
      D.Bitmap.TransparentColor :=  D.Projection.Page.Color;
      D.Bitmap.Transparent := true;
      aPNG.Assign(D.Bitmap);
      aPNG.SaveToFile(FileName);
      aPNG.Free
   end
   else
       D.Bitmap.SaveToFile(FileName);
   D.Free();
   Interpret.Printing := false;
end;

function TExportToBitmap.GetByDevice: boolean;
begin
   result := not ByModel;
end;

procedure TExportToBitmap.SetBMFormat(const Value: string);
begin
   FBMFormat := Value;
end;

procedure TExportToBitmap.SetBMHeight(const Value: integer);
begin
  FBMHeight := Value;
end;

procedure TExportToBitmap.SetBMWidth(const Value: integer);
begin
  FBMWidth := Value;
end;

procedure TExportToBitmap.SetByDevice(const Value: boolean);
begin
   FByModel := not Value;
end;

procedure TExportToBitmap.SetByModel(const Value: boolean);
begin
   FByModel := true;
end;

procedure TExportToBitmap.SetCompressionQuality(const Value: integer);
begin
  FCompressionQuality := Value;
end;

procedure TExportToBitmap.SetDevice(const Value: TBitmapDevice);
begin
   FDevice := Value;
end;

procedure TExportToBitmap.SetExactSize(const Value: boolean);
begin
   FExactSize := true;
end;

procedure TExportToBitmap.SetFileName(const Value: string);
begin
   FFileName := value;
end;

procedure TExportToBitmap.SetInterpret(const Value: TUniversalInterpret);
begin
  FInterpret := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TRasTest);
   RegisterOrbisClass(TExportToBitmap);
END.
