unit r_OrbisFrame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Tools, Menus;

type
TOrbis_Frame = class(TFrame)
private
   FTool: TTool;
   FAcceptDropFiles: boolean;
protected
   procedure SetTool(const Value: TTool); virtual;
   procedure SetAcceptDropFiles(const Value: boolean);  virtual;
   procedure WMDropFiles(var Message: TMessage); message WM_DROPFILES;
public
   property Tool: TTool read FTool write SetTool;
   property AcceptDropFiles: boolean read FAcceptDropFiles write SetAcceptDropFiles;
end;

implementation
uses
   ShellApi,
   M_Orbis;

{$R *.DFM}

{ TOrbis_Frame }

procedure TOrbis_Frame.SetAcceptDropFiles(const Value: boolean);
begin
   FAcceptDropFiles := Value;
   DragAcceptFiles(Handle, Value);
end;


procedure TOrbis_Frame.SetTool(const Value: TTool);
begin
   FTool := Value;
end;

procedure TOrbis_Frame.WMDropFiles(var Message: TMessage);
var
   i: longInt;
   Count: longInt;
   H: THandle;
   cb: word;
   P: PChar;
   S: string;
   //CL: TCommandLine;
   Size: word;
begin
   H := Message.WParam;
   cb:= 0;
   Count := DragQueryFile(H, $FFFFFFFF, nil, cb);
   for i := 0 to Count - 1 do
   begin
      Size := DragQueryFile(H, i, nil, cb);
      inc(Size);
      P := StrAlloc(Size);
      DragQueryFile(H, i, P, Size);
      S := StrPas(P);
      StrDispose(P);
      if Tool <> nil then
         Tool.PostTextMsg(tm_DropFile, S, Tool);
      ShowMessage(S);
   end;
end;

end.
