unit T_OrbisDialog;

interface
uses
   f_OrbisDialog,
   t_FormTool;
type

TOrbisDialog = class(TFormTool)
private
    FResult: integer;
    FDontShowForm: boolean;
    FModified: boolean;
    FStatusScript: string;
    FHideStandardButtons: boolean;
    FAfterDoItScript: string;
    FNewObject: boolean;
   function GetDialogForm: TOrbisDialog_Form;
    procedure SetResult(const Value: integer);
    procedure SetDontShowForm(const Value: boolean);
    procedure SetModified(const Value: boolean);
    function GetOKText: string;
    function GetStornoText: string;
    procedure SetOKText(const Value: string);
    procedure SetStornoText(const Value: string);
    procedure SetStatusScript(const Value: string);
    procedure SetHideStandardButtons(const Value: boolean);
    procedure SetAfterDoItScript(const Value: string);
    procedure SetNewObject(const Value: boolean);
public
   procedure DoIt; override;
   procedure CreateForm; override;
   procedure SendStatus;
   property DialogForm: TOrbisDialog_Form read GetDialogForm;
published
   property Result: integer read FResult write SetResult;
   property DontShowForm: boolean read FDontShowForm write SetDontShowForm;
   property NewObject: boolean read FNewObject write SetNewObject;
   property Modified: boolean read FModified write SetModified;
   property OKText: string read GetOKText write SetOKText;
   property StornoText: string read GetStornoText write SetStornoText;
   property StatusScript: string read FStatusScript write SetStatusScript;
   property HideStandardButtons: boolean read FHideStandardButtons write SetHideStandardButtons;
   property AfterDoItScript: string read FAfterDoItScript write SetAfterDoItScript;
end;

implementation
uses
   Forms,
   m_Proj,
   e_Class, Elements;

{ TOrbisDialog }

procedure TOrbisDialog.CreateForm;
begin
   aForm := TOrbisDialog_Form.Create(Application);
   aForm.Tool := Self;
   aForm.IsPossibleToClose := false;
   aForm.OnShow := OnFormShow;
end;

procedure TOrbisDialog.DoIt;
begin
   result := 0;
   if not DontShowForm then
      Result := aForm.ShowModal
   else
      Result := 1;
   if AfterDoItScript <> '' then
   begin
      PostTextMsg(tm_Run,AfterDoItScript,nil);
      Application.ProcessMessages;
   end;
end;

function TOrbisDialog.GetDialogForm: TOrbisDialog_Form;
begin
   result := TOrbisDialog_Form(aForm);
end;


function TOrbisDialog.GetOKText: string;
begin
   result := '';
   if DialogForm = nil then exit;
   result := DialogForm.b_OK.Caption;
end;

function TOrbisDialog.GetStornoText: string;
begin
   result := '';
   if DialogForm = nil then exit;
   result := DialogForm.b_Storno.Caption;
end;

procedure TOrbisDialog.SendStatus;
begin
   if StatusScript <> '' then
      PostTextMsg(tm_Run,StatusScript,nil);
end;

procedure TOrbisDialog.SetAfterDoItScript(const Value: string);
begin
   FAfterDoItScript := Value;
end;

procedure TOrbisDialog.SetDontShowForm(const Value: boolean);
begin
   FDontShowForm := Value;
end;

procedure TOrbisDialog.SetHideStandardButtons(const Value: boolean);
begin
   if DialogForm <> nil then
      DialogForm.Panel1.Visible := not Value;
   FHideStandardButtons := Value;
end;

procedure TOrbisDialog.SetModified(const Value: boolean);
begin
  FModified := Value;
end;

procedure TOrbisDialog.SetNewObject(const Value: boolean);
begin
  FNewObject := Value;
end;

procedure TOrbisDialog.SetOKText(const Value: string);
begin
   if DialogForm = nil then exit;
   DialogForm.b_OK.Caption := Value;
end;

procedure TOrbisDialog.SetResult(const Value: integer);
begin
   FResult := Value;
end;

procedure TOrbisDialog.SetStatusScript(const Value: string);
begin
  FStatusScript := Value;
end;

procedure TOrbisDialog.SetStornoText(const Value: string);
begin
   if DialogForm = nil then exit;
   DialogForm.b_Storno.Caption := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TOrbisDialog);
END.
