unit t_Orbis_ColorDialog;

interface
uses
   Tools;

type

TOrbis_ColorDialog = Class(TBooleanTool)
  private
    FColor: integer;
    procedure SetColor(const Value: integer);
public
   procedure DoIt; override;
published
   property Color: integer read FColor write SetColor;
end;

implementation
uses
   Dialogs,
   Forms,
   e_Class;

{ TOrbis_ColorDialog }

procedure TOrbis_ColorDialog.DoIt;
var
   CD: TColorDialog;
begin
   Result := false;
   CD := TColorDialog.Create(Application);
   CD.Color := Color;
   if CD.Execute then
   begin
      Color := CD.Color;
      Result := true;
   end;
   CD.Free;
end;

procedure TOrbis_ColorDialog.SetColor(const Value: integer);
begin
  FColor := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TOrbis_ColorDialog);
END.
