(*----------------------------------------------------------------------+
|                                                                       |
|                         * DGNBLK *                                    |
|                                                                       |
|          Program pro prevod formatu MicroStation (DGN)                |
|                          do formatu TopoLu (BLK)                      |
|                                                                       |
|          (c) Petr Kunz 1993 Praha                                     |
|                                                                       |
+----------------------------------------------------------------------*)
program DGNBLK;


uses
   {ViceSoub,}
   DOS, Crt,
   PrevTab,
   Global, DataB,
   msElems, BlokType, MatProc, FilProc,
   TCB, Typky, _Music,
   DBStream,
   LiniProc,
   Ruzne, Objects;

const
   PLomBod: TLomBodPtr = nil;
   LomB:    TLomBodPtr = nil;
   Rastr      = '';

var
   OrigMode : Integer;
   DBW : TDBStream;
   JeDBW: boolean;
   FKYSDGN: Text;
   JeKYSDGN: Boolean;

{-------------------------------------------}

procedure SmazRadek;
  begin
     TextBackGround(Black);
     TextColor(White);
     GotoXY(5,28);
     writeln('                                                                                ');
  end;

procedure Hlaska(Co: String; Potvrz: Boolean);
  var
     Ch: Char;
  begin
     SmazRadek;
     GotoXY(2,28);
     writeln(Co);
     Ch := ' ';
     if Potvrz then
     repeat
       Ch := ReadKey;
     until Ch = #13;
  end;


procedure ZrusSeznam;
  var
    P,PP: TLomBodPtr;
  begin
    P := PLomBod;
    while P <> nil do
    begin
       PP := P^.Dalsi;
       Dispose(P);
       P := PP;
    end;
    PLomBod := nil;
    LomB    := nil;
  end;


procedure RadixToAscii(var Rad: TCellName; var Asc: string; Delka: byte);
  var
    Status: Integer;
    c, i, IRad: byte;
    n: word;
  begin;
     c      := 0;
     n      := 0;
     IRad   := 0;
     status := 0;
     Asc    := '';
     for  i := 0 to Delka - 1 do
     begin

       case (i mod 3) of
         0:
         begin
           n := Rad[IRad];
           Inc(IRad);
           c := n div 1600;
           n := n mod 1600;
         end;
         1:
         begin
           c := n div 40;
           n := n mod 40;
         end;
         2:
           c := n;
       end;
       if (c = 0) then
          c := 32
       else
       if (c >= 1) and (c <= 26) then
          c := c + 64
       else
       if (c = 27 ) then
          c := Ord('$')
       else
       if (c = 28 ) then
          c := Ord('.')
       else
       if (c >= 30) and (c <= 39 ) then
          c := c + 18
       else
       begin
         c := 32;
         status := -1;
       end;
       Asc := Asc + Chr(c);
     end;
     {
     return status;
     }
   end;


procedure VaxToIeee(var D: double); near;
begin
  asm
      push  di
      push  si
      push  ds
      lds   si,[bp+04]
      mov   ax,word ptr [si]
      mov   bx,word ptr [si+02]
      mov   cx,word ptr [si+04]
      mov   dx,word ptr [si+06]
      mov   di,ax
      and   di,8000H
      and   ax,7fffH
      shr   ax,1
      rcr   bx,1
      rcr   cx,1
      rcr   dx,1
      shr   ax,1
      rcr   bx,1
      rcr   cx,1
      rcr   dx,1
      shr   ax,1
      rcr   bx,1
      rcr   cx,1
      rcr   dx,1
      or    ax,ax
      je    @@Nula
      add   ax,37e0H
  @@Nula:
      or    ax,di
      mov   word ptr [si],dx
      mov   word ptr [si+02],cx
      mov   word ptr [si+04],bx
      mov   word ptr [si+06],ax
      pop   ds
      pop   si
      pop   di
  end;
end;




function SwapLong( L: longInt ): LongInt; assembler;
  asm
    mov   ax, word ptr L + 2
    mov   dx, word ptr L
  end;



function LL(L: LongInt): Real;
  var
     PomR: Real;
  begin
     PomR   := SwapLong(L);
     LL     := PomR/Prep;
  end;


procedure KontrolaSour(var S: Tsour);
  begin
     if (Abs(S.x) > 1E8) or
        (Abs(S.y) > 1E8) then
     begin
        Lup;
        Hlaska('Nalezena souradnice s hodnotou nepouzitelnou v TopoLu - Bude prevedena jako 0!',False);
        S.y := 0;
        S.x := 0;
     end;
  end;

procedure Bod2DnaSour(B: Point2D; var S: TSour);
  begin
     S.y := LL(B.x);
     S.x := LL(B.y);
     KontrolaSour(S);
  end;


procedure Bod3DnaSour(B: Point3D; var S: TSour);
  begin
     S.y := LL(B.x);
     S.x := LL(B.y);
     KontrolaSour(S);
  end;



procedure DBod2DnaSour(var B: DPoint2D; var S: TSour);
  begin
     VaxToIeee(B.x);
     S.y := B.x/Prep;
     VaxToIeee(B.y);
     S.x := B.y/Prep;
     KontrolaSour(S);
  end;


procedure DBod3DnaSour(var B: DPoint3D; var S: TSour);
  begin
     VaxToIeee(B.x);
     S.y := B.x/Prep;
     VaxToIeee(B.y);
     S.x := B.y/Prep;
     KontrolaSour(S);
  end;



procedure PosunSour(var ss: TSour);{ Posunuti vzhledem ke globalnimu pocatku }
  begin
     ss.y := ss.y - Pocatek.y;
     ss.x := ss.x - Pocatek.x;
     KontrolaSour(ss);
  end;

procedure TiskHlavicky;
  begin
    OrigMode := LastMode;
    TextMode (Co80 + Font8x8);
    TextBackground(LightGray);
    TextColor(Black);

 Writeln('ͻ');
 Writeln('                                                                      ');
 Writeln('                                                                      ');
 Writeln('                                                                      ');
 Writeln('   program pro prevod souboru ve formatu Microstation (*.DGN)         ');
 Writeln('                              do formatu TopoLu       (*.BLK)         ');
 Writeln('                                                                      ');
 Writeln('   [ Esc ... ukonceni prevodu ]                                       ');
 Writeln('                                                                      ');
 Writeln('                                       Ŀ                          ');
 Writeln('                          Celkem hotovo   %                         ');
 Writeln('                                                                 ');
 Writeln('                                                                      ');
 Writeln('                             ');
 Writeln('                              ');
 Writeln('                                                                      ');
 Writeln('                                                                      ');
 Writeln('                                                                      ');
 Writeln('                                                                      ');
 Writeln('                                                                      ');
 Writeln('                                                                      ');
 Writeln('   (c) Help Service Praha 1993,1995                                   ');
 Writeln('                                                                      ');
 Writeln('ͼ');

    TextColor(White);
    GoToXY(5,3);
    writeln('* DGNBLK * ');
  end;



procedure Help;
  begin
    TextBackGround(Black);
    GotoXY(1,28);
    writeln('pouziti: DGNBLK [/?] Soubor1 [Adresar] [/N] [/2] [/D]');
    writeln;
    writeln('         /? ........ pomocna informace o syntaxi');
    writeln('         Soubor1 ... cesta k souboru *.DGN (extenzi lze vynechat)');
    writeln('         Adresar ... adresar pro vystup ve formatu TopoLu (nepovinny)');
    writeln('         /N ........ neprovadet prevod sour. JTSK ze 3. kvadrantu');
    writeln('                     (napr. je-li pouzito zobrazeni v 1. kvadrantu)');
    writeln('         /2 ........ ignorovat Atribut 3D ... tento prepinac nastavte');
    writeln('                     u *.DGN souboru vyexportovanych z puvodniho 3D');
    writeln('                     do 2D (nebo v pripade, ze po prevodu ziskate');
    writeln('                     nesmyslna data, coz muze mit stejnou pricinu)');
    writeln('         /D ........ nevyhledavat pripojene databaze ');
    writeln('                     - pokud jste si jisti, ze databazove informace ');
    writeln('                       ve vykresovem souboru nejsou nebo se jimi ');
    writeln('                       nechcete zabyvat, lze timto prepinacem podstatne');
    writeln('                       urychlit dobu prevodu');
    writeln;
    TextColor(White);
    repeat until KeyPressed;
    TextMode(OrigMode);
    Halt(1);
  end;



function DirExists (Adresar: dirStr): boolean;
  var
    S: SearchRec;

  begin
    if Adresar = '' then DirExists:= true
    else
    begin
      if Adresar[length(Adresar)] = '\' then
         findFirst (Adresar + '*.*', AnyFile, S)
      else
         findFirst (Adresar + '\*.*', AnyFile, S);

      DirExists := (DosError <> 3) and
                   (DosError < 19)
    end
  end;



function JePrepinac(ftr: String): Boolean;
  begin
     JePrepinac := (ftr[1] = '/');
  end;


procedure RozeberPrepinace;
  var
     i: Byte;
     SSS: String;
  begin
     TretiQ  := True;
     Ignor3D := False;
     PripojitDatabaze := True;
     DBProBody := False;
     for i := 2 to ParamCount do
     begin
        SSS := ParamStr(i);
        if JePrepinac(SSS) then
        begin
           case Upcase(SSS[2]) of
              'N': TretiQ  := False;
              '2': Ignor3D := True;
              'D': PripojitDatabaze := False;
              'B': DBProBody := True;
           end;
        end;
     end;
  end;

procedure ZjistiJmenoSouboruDGN;
  begin
     ClrScr;
     TiskHlavicky;
     if (ParamCount < 1) or (ParamStr(1)='/?') or (ParamStr(1)='?') then Help;
     FSplit(ParamStr(1), D, Nm, E);
     AdresarDGN := D;
     CestaDGN := D+Nm+'.DGN';
     if (ParamCount = 1) or JePrepinac(ParamStr(2)) then
     begin
        CestaBlk := '';
        NazevBLK := Nm;
     end
     else begin
             FSplit(ParamStr(2),D,Nm,E);
             CestaBLK := D;
             NazevBlk := Nm;
             if Nm = '' then
             begin
                FSplit(CestaDGN,D,Nm,E);
                CestaBlk := '';
                NazevBLK := Nm;
             end;
          end;
     CestaBLK := CestaBLK + NazevBLK;
     RozeberPrepinace;
  end;



procedure PripravProstredi;
  var
     S,SS : DirStr;
  begin
     if not DirExists(CestaBLK) then MkDir(CestaBLK);
     Assign(F,CestaDGN);
  end;




procedure KontrolaIO;
  begin
    if IOResult <> 0 then
    begin
       TextBackGround(Black);
       GotoXY(5,28);
       TextColor(LightRed);
       writeln('Chyba pristupu na disk !');
       TextColor(White);
       TextMode(OrigMode);
       Halt(1);
    end;
  end;



Procedure ZavriVrstvu(Vr: Byte);
  begin
     with VV[Vr]^ do begin
        Close(FLin);
        Close(FCRD);
        Close(FPNT);
        Close(FTBX);
        Close(FTTX);
     end;
  end;




procedure KontrolaVrstvy(Vr: byte);
  var
    Vstr: String;
    Pstr: String;
  begin
     if not (Vr in Vrstvy) then
     begin
        if OtevrenaVrstva > 0 then ZavriVrstvu(OtevrenaVrstva);
        OtevrenaVrstva := Vr;
        Vrstvy := Vrstvy + [Vr];
        New(VV[Vr]);

        with VV[Vr]^ do begin
           Str(Vr,Vstr);
           Blok := CestaBLK+'\'+'VRSTVA'+Vstr+'.BLK';
           if not DirExists(Blok) then MkDir(Blok);

           Assign(FLIN,Blok+'\TN.LIN');
           Assign(FCRD,Blok+'\TN.CRD');
           Assign(FPNT,Blok+'\TN.PNT');
           Assign(FTBX,Blok+'\TN.TBX');
           Assign(FTTX,Blok+'\TN.TTX');

           DruhyLin := [];
           DruhyBod := [];
           ZalozLin := [];
           ZalozBod := [];

           AktivniDruh := 0;

           CLin  := 1;
           CSour := 1;
           CBod  := 1;
           CText := 1;
           {$I-}
           Rewrite(FLin);
           Linie.Atributy := [ZrusenaL];
           write(FLin,Linie);
           {$I+}
           KontrolaIO;

           {$I-}
           Rewrite(FCRD);
           write(FCRD,Sour);
           {$I+}
           KontrolaIO;

           {$I-}
           Rewrite(FPNT);
           Bod.Atributy := [ZrusenB];
           write(FPNT,Bod);
           {$I+}
           KontrolaIO;

           {$I-}
           Rewrite(FTBX);
           TBX.Atributy := [ZrusenT];
           write(FTBX,TBX);
           {$I+}
           KontrolaIO;

           TTX := 'Import z DGN do TopoLu ... Texty';
           {$I-}
           Rewrite(FTTX);
           writeln(FTTX,TTX);
           {$I+}
           KontrolaIO;
        end;
     end
     else begin
        if (Vr <> OtevrenaVrstva) then
        with VV[Vr]^ do begin
           AktivniDruh := 0;

           ZavriVrstvu(OtevrenaVrstva);
           OtevrenaVrstva := Vr;

           FileMode := 2;
           {$I-}
           Reset(FLin);
           Seek(FLin,FileSize(FLin));
           {$I+}
           KontrolaIO;

           {$I-}
           Reset(FCRD);
           Seek(FCRD,FileSize(FCRD));
           {$I+}
           KontrolaIO;

           {$I-}
           Reset(FPNT);
           Seek(FPNT,FileSize(FPNT));
           {$I+}
           KontrolaIO;

           {$I-}
           Reset(FTBX);
           Seek(FTBX,FileSize(FTBX));
           {$I+}
           KontrolaIO;

           {$I-}
           Append(FTTX);
           {$I+}
           KontrolaIO;
        end;
     end;
  end;




procedure OtevriSoubory;
  begin
     {$I-}
     Reset(F,1);
     {$I+}
     if ioResult <> 0 then
     begin
        TextBackGround(Black);
        GotoXY(5,28);
        TextColor(LightRed);
        TextBackGround(Black);
        writeln('Nelze otevrit soubor ' + CestaDGN);
        TextColor(White);
        Halt(1);
     end;
  end;



procedure ZavriSoubory;
  var
     i : byte;
  begin
     Close(F);
     {
     for i := 1 to 63 do
     begin
        if i in Vrstvy then
        with VV[i]^ do
        begin
           Close(FLin);
           Close(FCRD);
           Close(FPNT);
           Close(FTBX);
           Close(FTTX);
        end;
     end;
     }
    if JeDBW then DBW.Done;
  end;




procedure NastavBarvuAStylln(Symb: word; var Barva,Znacka: Integer);
  begin
    Barva := Barvy[(Symb and mskSymbColor)shr 8];
    if ((Symb and mskSymbWeight) shr 3) < 3 then
    begin
       case Symb and mskSymbStyle of
          0: Znacka := 0;
          1: Znacka := 1;
          2: Znacka := 2;
          3: Znacka := 3;
          4: Znacka := 24;
          5: Znacka := 23;
          6: Znacka := 26;
          7: Znacka := 25;
       else  Znacka := 9;
       end;
    end
    else begin
            case Symb and mskSymbStyle of
               0: Znacka := 4;
               1: Znacka := 5;
               2: Znacka := 6;
               3: Znacka := 7;
               4: Znacka := 34;
               5: Znacka := 33;
               6: Znacka := 36;
               7: Znacka := 35;
            else  Znacka := 4;
            end;
         end;
  end;



procedure KresliObnovatko;
  begin
    GotoXY(3,18);
    Writeln('Prevadim soubor '+ CestaDGN+' do adresare  '+CestaBlk );
  end;



procedure Hotovo;
  var
     Proc: LongInt;
  begin
     TextBackground(LightGray);
     Proc := (Pozice*100)div Felikost;
     TextColor(White);
     GotoXY(42,11);
     Write(Proc:3);
     GotoXY(28,14);
     Write (Copy(Rastr,1,round(Proc/2.5)));

  end;



procedure UpravObd1;
  begin
     EHDR.xlow  := ( SwapLong( EHDR.xlow ) - MaxLongInt ) - 1;
     EHDR.ylow  := ( SwapLong( EHDR.ylow ) - MaxLongInt ) - 1;
     EHDR.xhigh := ( SwapLong( EHDR.xhigh ) - MaxLongInt ) - 1;
     EHDR.yhigh := ( SwapLong( EHDR.yhigh ) - MaxLongInt ) - 1;
  end;



{----------- Uprava ops. obdelnika ---------}



procedure UpravObd;

  procedure UpravATak(var LLL: LongInt);
  begin
     LLL := SwapLong(LLL);
     if LLL > 0 then LLL := LLL - MaxLongInt - 1  else
     if LLL < 0 then LLL := LLL + MaxLongInt + 1;
  end;

  begin
     UpravATak(EHDR.xlow);
     UpravATak(EHDR.ylow);
     UpravATak(EHDR.xhigh);
     UpravATak(EHDR.yhigh);
  end;

procedure VratOpsanyObd(var OpsanyObdelnik: TObdelnik);
   var
      ss: TSour;
   begin
      UpravObd;
      OpsanyObdelnik.PH.y := EHDR.XHigh;
      OpsanyObdelnik.PH.y := OpsanyObdelnik.PH.y / Prep;
      OpsanyObdelnik.PH.x := EHDR.YHigh;
      OpsanyObdelnik.PH.x := OpsanyObdelnik.PH.x / Prep;

      OpsanyObdelnik.LD.y := EHDR.XLow;
      OpsanyObdelnik.LD.y := OpsanyObdelnik.LD.y / Prep;
      OpsanyObdelnik.LD.x := EHDR.YLow;
      OpsanyObdelnik.LD.x := OpsanyObdelnik.LD.x / Prep;

      PosunSour(OpsanyObdelnik.PH);
      PosunSour(OpsanyObdelnik.LD);

      { Pri prevodu z 1. kvadrantu jsou prehozene rohy }
      if not TretiQ then
      begin
         ss := OpsanyObdelnik.PH;
         OpsanyObdelnik.PH := OpsanyObdelnik.LD;
         OpsanyObdelnik.LD := ss;
      end;
   end;



function VratFont(Font: byte;var Sklon: real): byte;
  var
     Pomf: byte;
     Poms: real;
  begin
     Poms := 0;
     Pomf := 5;
     case Font of
        0: Pomf := 5;
        1: Pomf := 8;
        2: Pomf := 4;
        3: Pomf := 8;
       32: Pomf := 8;
        7: Pomf := 9;
       23: begin
              Pomf := 8;
              Poms := 8;
           end;
       30: begin
              Pomf := 5;
              Poms := -15;
           end;
       31: begin
              Pomf := 5;
              Poms := 15;
           end;
       42: Pomf := 1;
       43: Pomf := 6;
       50,
      127: Pomf := 5;
     end;
     VratFont := Pomf;
     Sklon    := DejRadZeStupnu(Poms);
  end;



function VratKoefVysky (hmult: longint; font: byte): real;
  var
     Pom: real;
  begin
     Pom   := 6;

     case font of
        8,4: Pom := 20{15}{28};
          9: Pom := 40{24};
          1: Pom := 53;
          6: Pom := 25;
     end;

     Pom := ((6/Pom)*(hmult/1000)/Prep);
     VratKoefVysky := Abs(Pom);
  end;



function VratKoefSirky (lngthmult: longInt; hmult: real; Font: byte): real;
  var
     Pom: real;
  begin
     Pom := (lngthmult/hmult);
     case font of
        3: Pom := Pom * 1.2;
       23: Pom := Pom * 0.8;
     end;
     VratKoefSirky := Pom;
  end;




{======================== UKLADANI =================================== }





procedure UlozLin;
  begin
     with VV[LVL]^ do
     begin
       Write(FLin,Linie);
       Inc(CLin);
     end;
  end;


procedure UlozBod;
  begin
     with VV[LVL]^ do
     begin
       Write(FPNT,Bod);
       Inc(CBod);
     end;
  end;




procedure UlozSour;
  begin
     with VV[LVL]^ do
     begin
        Write(FCRD,Sour);
        Inc(CSour);
     end;
  end;




procedure UlozDBLin;
  var
    DruhStr: String;
    { DBC : TCreatDBStrm; }
    DBC: TDBStream;

    i   : LongInt;
    OK  : Boolean;
    KYSD: DirStr;
    KYSN : NameStr;
    KYSE: ExtStr;
  begin
     with VV[LVL]^ do
     begin
        if DBOK and JeDB then
        begin
           if not(Linie.Druh in DruhyLin) and not(Linie.Druh in ZalozLin)then
           begin
              DruhyLin    := DruhyLin + [Linie.Druh];
              Str(Linie.Druh, DruhStr);
              with DD[Linie.Druh] do
              begin
                 CestaDGN := FExpand(CestaDGN);
                 FSplit(CestaDGN,D,Nm,E);
                 DruhStr := Blok+'\L000'+DruhStr;
                 FLinDB  := DruhStr+'.DBF';
                 Assign(FMDL,DruhStr+'.MDL');
                 Rewrite(FMDL);
                 Writeln(FMDL,'Info=Databaze k DGN');

                 OK:= OKVytvorDB(FLinDB, PStrucDB);
                 DBC.Init(FLinDB, nil, true);
                 DBC.PozadFMO:= moOpenRWNN;
                 OK:= DBC.OKInit and DBC.OKSetBuf(DBC.DejVelZazn);

                 OK := DBC.OKNastavZazn(1);
                 OK := DBC.OKNastavPol(1);
                 Str(Linie.Cislo,Sg);
                 DBC.VlozStavPolZeStr(Sg);
                 for i := 1 to PripojeneDB.Count do
                 begin
                    Str(i,Sg);
                    Writeln(FMDL,'SEC_DBF=' + D+PString(PripojeneDB.At(i-1))^);
                    Writeln(FMDL,'PRIM_KEY=MSL',Sg,':N:10');
                    Writeln(FMDL,'SEC_KEY=MSLINK:N:10');
                    writeln(FMDL,'[',Sg,']');

                    DBC.OKNastavPol(i + 1);
                    if AtribLink.CisloDatabaze = i then
                    begin
                       Str(AtribLink.MSLINK,Sg);
                       DBC.VlozStavPolZeStr(Sg);
                    end
                    else DBC.VlozStavPolZeStr('-1');
                 end;
                 JeKYSDGN := True;
                 DBC.Done;
                 Close(FMDL);
              end;

           end
           else if (Linie.Druh in DruhyLin) and
                not(Linie.Druh in ZalozLin)then
           begin
              if JeDBW then
              begin
                 DBW.Done;
                 JeDBW := False;
              end;
              ZalozLin := ZalozLin + [Linie.Druh];
              AktivniDruh := Linie.Druh;
              with DD[Linie.Druh] do
              begin
                 DBW.Init(FLinDB, nil, true);
                 DBW.PozadFMO:= moOpenRWNN;

                 OK := DBW.OKInit and DBW.OKSetBuf(DBW.DejVelZazn);
                 JeDBW := True;
                 OK := DBW.OKNastavZazn(DBW.DejPocPrvku + 1);
                 OK := DBW.OKNastavPol(1);
                 Str(Linie.Cislo,Sg);
                 DBW.VlozStavPolZeStr(Sg);
                 for i := 1 to PripojeneDB.Count do
                 begin
                    DBW.OKNastavPol(i + 1);
                    if AtribLink.CisloDatabaze = i then
                    begin
                       Str(AtribLink.MSLINK,Sg);
                       DBW.VlozStavPolZeStr(Sg);
                    end
                    else DBW.VlozStavPolZeStr('-1');
                 end;
              end;
           end
           else begin
              with DD[Linie.Druh] do
              begin
                 if JeDBW and (AktivniDruh <> Linie.Druh) then
                 begin
                    DBW.Done;
                    DBW.Init(FLinDB, nil, true);
                    DBW.PozadFMO:= moOpenRWNN;

                    OK := DBW.OKInit and DBW.OKSetBuf(DBW.DejVelZazn);
                    AktivniDruh := Linie.Druh;
                 end
                 else if not JeDBW then
                 begin
                    DBW.Init(FLinDB, nil, true);
                    DBW.PozadFMO:= moOpenRWNN;

                    JeDBW := True;
                    OK := DBW.OKInit and DBW.OKSetBuf(DBW.DejVelZazn);
                    AktivniDruh := Linie.Druh;
                 end;
                 OK := DBW.OKNastavZazn(DBW.DejPocPrvku + 1);
                 DBW.NastPlatnostZazn(True);
                 OK := DBW.OKNastavPol(1);
                 Str(Linie.Cislo,Sg);
                 DBW.VlozStavPolZeStr(Sg);
                 for i := 1 to PripojeneDB.Count do
                 begin
                    DBW.OKNastavPol(i + 1);
                    if AtribLink.CisloDatabaze = i then
                    begin
                       Str(AtribLink.MSLINK,Sg);
                       DBW.VlozStavPolZeStr(Sg);
                    end
                    else DBW.VlozStavPolZeStr('-1');
                 end;
              end
           end;
        end;
     end;
  end;




procedure UlozDBBod;
  var
    DruhStr: String;
    { DBC : TCreatDBStrm; }
    DBC: TDBStream;

    i   : LongInt;
    OK  : Boolean;
    KYSD: DirStr;
    KYSN : NameStr;
    KYSE: ExtStr;
  begin
     with VV[LVL]^ do
     begin
        if DBOK and JeDB then
        begin
           if not(Bod.Druh in DruhyBod) and not(Bod.Druh in ZalozBod)then
           begin
              DruhyBod    := DruhyBod + [Bod.Druh];
              Str(Bod.Druh, DruhStr);
              with DD[Bod.Druh] do
              begin
                 CestaDGN := FExpand(CestaDGN);
                 FSplit(CestaDGN,D,Nm,E);
                 DruhStr := Blok+'\B000'+DruhStr;
                 FBodDB  := DruhStr+'.DBF';
                 Assign(FMDL,DruhStr+'.MDL');
                 Rewrite(FMDL);
                 Writeln(FMDL,'Info=Databaze k DGN');

                 OK:= OKVytvorDB(FBodDB, PStrucDB);
                 DBC.Init(FBodDB, nil, true);
                 DBC.PozadFMO:= moOpenRWNN;
                 OK:= DBC.OKInit and DBC.OKSetBuf(DBC.DejVelZazn);

                 OK := DBC.OKNastavZazn(1);
                 OK := DBC.OKNastavPol(1);
                 Str(Bod.Cislo,Sg);
                 DBC.VlozStavPolZeStr(Sg);
                 for i := 1 to PripojeneDB.Count do
                 begin
                    Str(i,Sg);
                    Writeln(FMDL,'SEC_DBF=' + D+PString(PripojeneDB.At(i-1))^);
                    Writeln(FMDL,'PRIM_KEY=MSL',Sg,':N:10');
                    Writeln(FMDL,'SEC_KEY=MSLINK:N:10');
                    writeln(FMDL,'[',Sg,']');

                    DBC.OKNastavPol(i + 1);
                    if AtribLink.CisloDatabaze = i then
                    begin
                       Str(AtribLink.MSLINK,Sg);
                       DBC.VlozStavPolZeStr(Sg);
                    end
                    else DBC.VlozStavPolZeStr('-1');
                 end;
                 JeKYSDGN := True;
                 DBC.Done;
                 Close(FMDL);
              end;

           end
           else if (Bod.Druh in DruhyBod) and
                not(Bod.Druh in ZalozBod)then
           begin
              if JeDBW then
              begin
                 DBW.Done;
                 JeDBW := False;
              end;
              ZalozBod := ZalozBod + [Bod.Druh];
              AktivniDruh := Bod.Druh;
              with DD[Bod.Druh] do
              begin
                 DBW.Init(FBodDB, nil, true);
                 DBW.PozadFMO:= moOpenRWNN;

                 OK := DBW.OKInit and DBW.OKSetBuf(DBW.DejVelZazn);
                 JeDBW := True;
                 OK := DBW.OKNastavZazn(DBW.DejPocPrvku + 1);
                 OK := DBW.OKNastavPol(1);
                 Str(Bod.Cislo,Sg);
                 DBW.VlozStavPolZeStr(Sg);
                 for i := 1 to PripojeneDB.Count do
                 begin
                    DBW.OKNastavPol(i + 1);
                    if AtribLink.CisloDatabaze = i then
                    begin
                       Str(AtribLink.MSLINK,Sg);
                       DBW.VlozStavPolZeStr(Sg);
                    end
                    else DBW.VlozStavPolZeStr('-1');
                 end;
              end;
           end
           else begin
              with DD[Bod.Druh] do
              begin
                 if JeDBW and (AktivniDruh <> Bod.Druh) then
                 begin
                    DBW.Done;
                    DBW.Init(FBodDB, nil, true);
                    DBW.PozadFMO:= moOpenRWNN;

                    OK := DBW.OKInit and DBW.OKSetBuf(DBW.DejVelZazn);
                    AktivniDruh := Bod.Druh;
                 end
                 else if not JeDBW then
                 begin
                    DBW.Init(FBodDB, nil, true);
                    DBW.PozadFMO:= moOpenRWNN;

                    JeDBW := True;
                    OK := DBW.OKInit and DBW.OKSetBuf(DBW.DejVelZazn);
                    AktivniDruh := Bod.Druh;
                 end;
                 OK := DBW.OKNastavZazn(DBW.DejPocPrvku + 1);
                 DBW.NastPlatnostZazn(True);
                 OK := DBW.OKNastavPol(1);
                 Str(Bod.Cislo,Sg);
                 DBW.VlozStavPolZeStr(Sg);
                 for i := 1 to PripojeneDB.Count do
                 begin
                    DBW.OKNastavPol(i + 1);
                    if AtribLink.CisloDatabaze = i then
                    begin
                       Str(AtribLink.MSLINK,Sg);
                       DBW.VlozStavPolZeStr(Sg);
                    end
                    else DBW.VlozStavPolZeStr('-1');
                 end;
              end
           end;
        end;
     end;
  end;
{
procedure UlozDBBod;
  var
    DruhStr: String;
    DBC : TCreatDBStrm;
    i   : LongInt;
    OK  : Boolean;
    KYSD: DirStr;
    KYSN : NameStr;
    KYSE: ExtStr;
  begin
     with VV[LVL]^ do
     begin
        if DBOK and JeDB then
        begin
           if not(Bod.Druh in DruhyBod) and not(Bod.Druh in ZalozBod)then
           begin
              DruhyBod    := DruhyBod + [Bod.Druh];
              Str(Bod.Druh, DruhStr);
              with DD[Bod.Druh] do
              begin
                 CestaDGN := FExpand(CestaDGN);
                 FSplit(CestaDGN,D,Nm,E);
                 DruhStr := Blok+'\B000'+DruhStr;
                 FBodDB  := DruhStr+'.DBF';
                 Assign(FMDL,DruhStr+'.MDL');
                 Assign(FKYS,DruhStr+'.KYS');
                 Rewrite(FMDL);
                 Writeln(FMDL,'Databaze pripojene k DGN souboru');
                 Rewrite(FKYS);
                 Writeln(FKYS,'Klice vnejsich databazi');
                 DBC.Init(FBodDB,MaxAvail div 2,PStrucDB);
                 OK := DBC.OKInit;
                 OK := DBC.OKNastavZazn(1);
                 OK := DBC.OKNastavPol(1);
                 Str(Bod.Cislo,Sg);
                 DBC.VlozStavPolZeStr(Sg);
                 for i := 1 to PripojeneDB.Count do
                 begin
                    Str(i,Sg);
                    Writeln(FMDL,Sg+'. '+D+PString(PripojeneDB.At(i-1))^+' '+Sg+' 1');
                    Writeln(FKYS,Sg+'. '+' MSL'+Sg+':N:10');
                    if not JeKYSDGN then
                    begin
                       FSplit(PString(PripojeneDB.At(i-1))^,KYSD,KYSN,KYSE);
                       Assign(FKYSDGN,D+KYSN+'.KYS');
                       Rewrite(FKYSDGN);
                       Writeln(FKYSDGN,'Klic k pripojene databazi souboru DGN pro potreby TopoLu');
                       Writeln(FKYSDGN,'1. '+' MSBodK'+':N:10');
                       Close(FKYSDGN);
                    end;
                    DBC.OKNastavPol(i + 1);
                    if AtribBodk.CisloDatabaze = i then
                    begin
                       Str(AtribBodk.MSBodK,Sg);
                       DBC.VlozStavPolZeStr(Sg);
                    end
                    else DBC.VlozStavPolZeStr('-1');
                 end;
                 JeKYSDGN := True;
                 DBC.Done;
                 Close(FMDL);
                 Close(FKYS);
              end;

           end
           else if (Bod.Druh in DruhyBod) and
                not(Bod.Druh in ZalozBod)then
           begin
              if JeDBW then
              begin
                 DBW.Done;
                 JeDBW := False;
              end;
              ZalozBod := ZalozBod + [Bod.Druh];
              AktivniDruh := Bod.Druh;
              with DD[Bod.Druh] do
              begin
                 DBW.Init(FBodDB,MaxAvail div 2);
                 OK := DBW.OKInit;
                 JeDBW := True;
                 OK := DBW.OKNastavZazn(DBW.DejPocZazn + 1);
                 OK := DBW.OKNastavPol(1);
                 Str(Bod.Cislo,Sg);
                 DBW.VlozStavPolZeStr(Sg);
                 for i := 1 to PripojeneDB.Count do
                 begin
                    DBW.OKNastavPol(i + 1);
                    if AtribBodk.CisloDatabaze = i then
                    begin
                       Str(AtribBodk.MSBodK,Sg);
                       DBW.VlozStavPolZeStr(Sg);
                    end
                    else DBW.VlozStavPolZeStr('-1');
                 end;
              end;
           end
           else begin
              with DD[Bod.Druh] do
              begin
                 if JeDBW and (AktivniDruh <> Bod.Druh) then
                 begin
                    DBW.Done;
                    DBW.Init(FBodDB,MaxAvail div 2);
                    OK := DBW.OKInit;
                    AktivniDruh := Bod.Druh;
                 end
                 else if not JeDBW then
                 begin
                    DBW.Init(FBodDB,MaxAvail div 2);
                    JeDBW := True;
                    OK := DBW.OKInit;
                    AktivniDruh := Bod.Druh;
                 end;
                 OK := DBW.OKNastavZazn(DBW.DejPocZazn + 1);
                 DBW.NastavPlatnostZaznamu(True);
                 OK := DBW.OKNastavPol(1);
                 Str(Bod.Cislo,Sg);
                 DBW.VlozStavPolZeStr(Sg);
                 for i := 1 to PripojeneDB.Count do
                 begin
                    DBW.OKNastavPol(i + 1);
                    if AtribBodk.CisloDatabaze = i then
                    begin
                       Str(AtribBodk.MSBodK,Sg);
                       DBW.VlozStavPolZeStr(Sg);
                    end
                    else DBW.VlozStavPolZeStr('-1');
                 end;
              end
           end;
        end;
     end;
  end;


}

procedure OtocUhel(var Uh: real);
  begin
     if Uh < PI then Uh := Uh + PI
                else Uh := Uh - PI;
  end;

procedure NastavUhlyOblouku;
  var
    Start,
    Sweep: real;
    SweepL: LongInt;
    Kladny: boolean;
  begin
    if Je3D then
    begin
       Start := DejRadZeStupnu(SwapLong(Arc3D.StartAng)/360000);
       Arc3D.SweepAng := SwapLong(Arc3D.SweepAng);
       SweepL := (Arc3D.SweepAng and $7FFFFFFF);
       Kladny:= (Arc3D.SweepAng and $80000000) = 0;
       Sweep := DejRadZeStupnu(SweepL/360000);
    end
    else begin
            Start := DejRadZeStupnu(SwapLong(Arc2D.StartAng)/360000);
            Arc2D.SweepAng := SwapLong(Arc2D.SweepAng);
            SweepL := Arc2D.SweepAng and $7FFFFFFF;
            Kladny:= Arc2D.SweepAng and $80000000 = 0;
            Sweep := SweepL/360000;
            if Sweep = 360 then Sweep := 0 else
               Sweep := DejRadZeStupnu(SweepL/360000);
         end;
    if Kladny then
    begin
       Oblouk.Zacatek := Start;
       Oblouk.Konec   := Start + Sweep;
    end
    else begin
       Oblouk.Zacatek := Start - Sweep;
       Oblouk.Konec   := Start;
    end;
    {
    if not TretiQ and Ignor3D then
    begin
       OtocUhel(Oblouk.Zacatek);
       OtocUhel(Oblouk.Konec);
    end;
    }
  end;

procedure KontrolaUkonceni;
  var
    Ch: Char;
  begin
     if KeyPressed then
     begin
        Ch := ReadKey;
        if Ch = #27 then Hlaska('Konec',False);
        repeat until Keypressed;
        TextMode(OrigMode);
        Halt;
     end;
  end;


{============================== PREKLAD ===================================}


procedure Prekladej;
  var
    KontrolW: word;
    FTypu: text{*******};
  begin
    {******}
    (*
    Assign(FTypu,'c:\data\tl31\mstation\typy.txt');
    Rewrite(FTypu);
    Writeln(FTypu,CestaDGN);
    Writeln(FTypu);
    *)
    {******}
    if PripojitDatabaze then HledejRidiciDatabazi;

    KresliObnovatko;
    Felikost := FileSize(F);
    Pozice := 0;
    Bell  := Ascent;
    JeDBW := False;
    Je3D  := False;
    JeTCB := False;
    JeKYSDGN := False;
    Prvni := True;
    while (True) do
    begin
       KontrolaUkonceni;
       if Prvni then
       begin
          Seek(F,0);
          Prvni := False;
       end
       else begin
               Seek(F,Pozice + 4 + EHDR.Words shl 1);
               BlockRead(F,KontrolW,SizeOf(word));
               if KontrolW = EOD then
               begin
                  ZavriVrstvu(OtevrenaVrstva);
                  {**********************}
                  (*
                  Close(FTypu);
                  *)
                  {**********************}
                  exit;
               end;
               Seek(F,Pozice + 4 + EHDR.Words shl 1);
            end;
       Pozice := FilePos(F);
       BlockRead(F,EHDR,SizeOf(Elm_hdr));
       LVL  := Level;
       JeDB := False;
       JeLin:= False;
       Hotovo;
       {*****}
       (*
       if Deleted then Write(FTypu,'* ')
                  else Write(FTypu,'  ');
       Writeln(FTypu,Typ shr 8, '(', Level,') .... ',Pozice);
       *)
       {*****}
       if not Deleted then
       case  Typ of
         DGNFIL_HEADER_ELM:
         begin
            if not JeTCB then
            begin
               JeTCB := True;
               BlockRead(F,TCBB,SizeOf(TTCB));
               if (Design3D in TCBB.fbfdcn) and not Ignor3D then Je3D := True;
               Prep := (SwapLong(TCBB.uorpersub)*SwapLong(TCBB.subpermast));
               if TretiQ then Prep := 0 - Prep;
               DBod3DNaSour(TCBB.GlobOrg,Pocatek);
            end;
         end;
         CELL_LIB_ELM:
         begin
         end;
         SHAREDCELL_DEF_ELM:
         begin
         end;
         SHARED_CELL_ELM:
         begin
         end;
         CELL_HEADER_ELM:
         begin

            KontrolaVrstvy(LVL);
            if Je3D then  BlockRead(F,Cell3D,SizeOf(TCell_3D)) else
                          BlockRead(F,Cell2D,SizeOf(TCell_2D));

            if not Deleted then
            begin
               with Bod do
               begin
                  Cislo         := VV[LVL]^.CBod;
                  if Je3D then Druh := Class(Cell3D.DHdr) else
                               Druh := Class(Cell2D.DHdr);
                  Presnost      := 9;
                  Atributy      := [];
                  Vybran        := False;
                  if Je3D then
                     NastavBarvuAStylln(Cell3D.DHdr.Symb,Barva,Znacka) else
                     NastavBarvuAStylln(Cell2D.DHdr.Symb,Barva,Znacka);
                  Znacka        := 0;
                  Cas           := GetPackTime;
                  if Je3D then Bod3dnaSour(Cell3D.Origin,Sour)
                          else Bod2dnaSour(Cell2D.Origin,Sour);
                  PosunSour(Sour);
                  Uhel          := 0;

                  if Je3D then RadixToAscii(Cell3D.name,JmenoBunky,6)
                          else RadixToAscii(Cell2D.name,JmenoBunky,6);
                  Druh := PrevodniTabulka.VratKodDleBunky(JmenoBunky);

               end;
               UlozBod;
               if PripojitDatabaze and DBProBody and
                  ((Je3D and JsouAtributy(Cell3D.DHdr)) or
                  JsouAtributy(Cell2D.DHdr))  then
               begin
                  BlockRead(F,AtribLink,SizeOf(TAtribLink));
                  JeDB := True;
                  JeLin:= True;
                  UlozDBBod;
               end
            end;
         end;
         {
         TEXT_NODE_ELM:    Lip;
         CMPLX_STRING_ELM: Lip;
         CMPLX_SHAPE_ELM:  Lip;
         }
         LINE_ELM:
         begin
            KontrolaVrstvy(LVL);
            Linie := Linie00;
            if Je3D then BlockRead(F,Line3D,SizeOf(TLine_3D))
                    else BlockRead(F,Line2D,SizeOf(TLine_2D));
            {
            if (Je3D and (Class(Line3D.dhdr) = PATTERN_COMPONENT_CLASS)) or
                         (Class(Line2D.dhdr) = PATTERN_COMPONENT_CLASS) then
            }
            begin
               with Linie do
               begin
                  VratOpsanyObd(OpsanyObdelnik);
                  Cislo         := VV[LVL]^.CLin;
                  if Je3D then Druh := Class(Line3D.DHdr) else
                               Druh := Class(Line2D.DHdr);
                  Presnost      := 9;
                  Atributy      := [];
                  Vybrana       := false;
                  if Je3D then
                     NastavBarvuAStylln(Line3D.DHdr.Symb,Barva,Znacka) else
                     NastavBarvuAStylln(Line2D.DHdr.Symb,Barva,Znacka);
                  Symbol        := 0;
                  Cas           := GetPackTime;
                  PrvniSour     := VV[LVL]^.CSour;
                  PosledniSour  := VV[LVL]^.CSour + 1;
                  DrziSe        := NedrziSe;
                  Delka         := 0;
               end;


               if Je3D then Bod3dnaSour(Line3D.StartP,Sour)
                       else Bod2dnaSour(Line2D.StartP,Sour);

               PosunSour(Sour);
               UlozSour;
               New(PLomBod);
               PLomBod^.Sour := Sour;


               if Je3D then Bod3dnaSour(Line3D.EndP,Sour)
                       else Bod2dnaSour(Line2D.EndP,Sour);

               PosunSour(Sour);
               UlozSour;

               New(LomB);
               LomB^.Dalsi    := nil;
               LomB^.Sour     := Sour;
               PLomBod^.Dalsi := LomB;

               Linie.Delka := DelkaLinie(PLomBod);
               NastavSymbolDoStredu(Linie, PLomBod);

               ZrusSeznam;

               UlozLin;

               if PripojitDatabaze and
                  ((Je3D and JsouAtributy(Line3D.DHdr)) or
                  JsouAtributy(Line2D.DHdr))  then
               begin
                  JeDB := True;
                  JeLin:= True;
                  BlockRead(F,AtribLink,SizeOf(TAtribLink));
                  UlozDBLin;
               end
            end;
         end;
         ELLIPSE_ELM:
         begin
            KontrolaVrstvy(LVL);
            Linie := Linie00;
            if Je3D then BlockRead(F,Ellipse3D,SizeOf(TEllipse_3d))
                    else BlockRead(F,Ellipse2D,SizeOf(TEllipse_2d));

            begin
               with Linie do
               begin
                  VratOpsanyObd(OpsanyObdelnik);
                  Cislo         := VV[LVL]^.CLin;
                  if Je3D then Druh := Class(Ellipse3D.DHdr) else
                               Druh := Class(Ellipse2D.DHdr);
                  Presnost      := 9;
                  Atributy      := [lnKrivka,lnElipsa];
                  Vybrana       := false;
                  if Je3D then
                     NastavBarvuAStylln(Ellipse3D.DHdr.Symb,Barva,Znacka) else
                     NastavBarvuAStylln(Ellipse2D.DHdr.Symb,Barva,Znacka);
                  Symbol        := 0;
                  Cas           := GetPackTime;
                  PrvniSour     := VV[LVL]^.CSour;
                  PosledniSour  := VV[LVL]^.CSour + 2;
                  DrziSe        := Nedrzise;
                  Delka         := 0;
               end;


               if Je3D then
               begin
                  DBod3dnaSour(Ellipse3D.Origin,Elipsa.Orig);
                  VAXtoIEEE(Ellipse3D.Primary);
                  Elipsa.a    := Abs(Ellipse3D.Primary/Prep);
                  VAXtoIEEE(Ellipse3D.Secondary);
                  Elipsa.b    := Abs(Ellipse3D.Secondary/Prep);
                  Elipsa.Uhel := 0;{ ve 3D ?????????? }
               end
               else begin
                  DBod2DnaSour(Ellipse2D.Origin,Elipsa.Orig);
                  VAXtoIEEE(Ellipse2D.Primary);
                  Elipsa.a    := Abs(Ellipse2D.Primary/Prep);
                  VAXtoIEEE(Ellipse2D.Secondary);
                  Elipsa.b    := Abs(Ellipse2D.Secondary/Prep);
                  Elipsa.Uhel := DejRadZeStupnu
                                 (SwapLong(Ellipse2D.rotation)/360000);
                  if not TretiQ and Ignor3D then otocUhel(Elipsa.Uhel);
               end;

               if Elipsa.a = Elipsa.b then
                  Linie.Atributy := Linie.Atributy+[lnKruznice];

               UlozLin;

               Sour := Elipsa.Orig;
               PosunSour(Sour);
               UlozSour;
               Sour.y := Elipsa.a;
               Sour.x := Elipsa.b;
               UlozSour;
               Sour.y := Elipsa.Uhel;
               Sour.x := 0;
               UlozSour;
               if PripojitDatabaze and
                  ((Je3D and JsouAtributy(Ellipse3D.DHdr)) or
                  JsouAtributy(Ellipse2D.DHdr))  then
               begin
                  BlockRead(F,AtribLink,SizeOf(TAtribLink));
                  JeDB := True;
                  JeLin:= True;
                  UlozDBLin;
               end
            end;
         end;
         ARC_ELM:
         begin
            KontrolaVrstvy(LVL);
            Linie := Linie00;
            if Je3D then BlockRead(F,Arc3D,SizeOf(TArc_3d))
                    else BlockRead(F,Arc2D,SizeOf(TArc_2d));
            begin
               with Linie do
               begin
                  VratOpsanyObd(OpsanyObdelnik);
                  Cislo         := VV[LVL]^.CLin;
                  if Je3D then Druh := Class(Arc3D.DHdr) else
                               Druh := Class(Arc2D.DHdr);
                  Presnost      := 9;
                  Atributy      := [lnKrivka,lnOblouk];
                  Vybrana       := false;
                  if Je3D then
                     NastavBarvuAStylln(Arc3D.DHdr.Symb,Barva,Znacka) else
                     NastavBarvuAStylln(Arc2D.DHdr.Symb,Barva,Znacka);
                  Symbol        := 0;
                  Cas           := GetPackTime;
                  PrvniSour     := VV[LVL]^.CSour;
                  PosledniSour  := VV[LVL]^.CSour + 3;
                  DrziSe        := NedrziSe;
                  Delka         := 0;
               end;

               if Je3D then
               begin
                  DBod3dnaSour(Arc3D.Origin,Oblouk.Orig);
                  VAXtoIEEE(Arc3D.Primary);
                  Oblouk.a       := Abs(Arc3D.Primary/Prep);
                  VAXtoIEEE(Arc3D.Secondary);
                  Oblouk.b       := Abs(Arc3D.Secondary/Prep);
                  Oblouk.Uhel    := 0;{ ve 3D ?????????? }
               end
               else begin
                  DBod2DnaSour(Arc2D.Origin,Oblouk.Orig);
                  VAXtoIEEE(Arc2D.Primary);
                  Oblouk.a       := Abs(Arc2D.Primary/Prep);
                  VAXtoIEEE(Arc2D.Secondary);
                  Oblouk.b       := Abs(Arc2D.Secondary/Prep);
                  Oblouk.Uhel    := DejRadZeStupnu
                                    (SwapLong(Arc2D.rotation)/360000);
                  if not TretiQ and Ignor3D then otocUhel(Oblouk.Uhel);
               end;

               if Oblouk.a = Oblouk.b then
                  Linie.Atributy := Linie.Atributy+[lnKruznice];

               UlozLin;


               NastavUhlyOblouku;
               Sour := Oblouk.Orig;
               PosunSour(Sour);
               UlozSour;
               Sour.y := Oblouk.a;
               Sour.x := Oblouk.b;
               UlozSour;
               Sour.y := Oblouk.Uhel;
               Sour.x := Oblouk.Zacatek;
               UlozSour;
               Sour.y := Oblouk.Konec;
               Sour.x := 0;
               UlozSour;
               if PripojitDatabaze and
                  ((Je3D and JsouAtributy(Arc3D.DHdr)) or
                  JsouAtributy(Arc2D.DHdr))  then
               begin
                  JeDB := True;
                  JeLin:= True;
                  BlockRead(F,AtribLink,SizeOf(TAtribLink));
                  UlozDBLin;
               end
            end;
         end;
         LINE_STRING_ELM,
         CURVE_ELM,
         SHAPE_ELM:
         begin
            KontrolaVrstvy(LVL);
            Linie := Linie00;
            if Je3D then BlockRead(F,LineString3D,SizeOf(TLine_string_3d))
                    else BlockRead(F,LineString2D,SizeOf(TLine_string_2d));
            {
            if (Je3D and (Class(LineString3D.dhdr) = PATTERN_COMPONENT_CLASS)) or
                         (Class(LineString2D.dhdr) = PATTERN_COMPONENT_CLASS) then
            }
            begin
               with Linie do
               begin
                  VratOpsanyObd(OpsanyObdelnik);
                  Cislo      := VV[LVL]^.CLin;
                  if Je3D then Druh := Class(LineString3D.DHdr) else
                               Druh := Class(LineString2D.DHdr);
                  Presnost   := 9;
                  Atributy   := [];
                  case Typ of
                    CURVE_ELM :
                      begin
                         Atributy := Atributy+[lnKrivka,lnFerguson];
                      end;
                  end;
                  Vybrana       := false;
                  if Je3D then
                     NastavBarvuAStylln(LineString3D.DHdr.Symb,Barva,Znacka) else
                     NastavBarvuAStylln(LineString2D.DHdr.Symb,Barva,Znacka);
                  Symbol        := 0;
                  Cas           := GetPackTime;
                  PrvniSour     := VV[LVL]^.CSour;
                  if Je3d then PosledniSour  := VV[LVL]^.CSour + LineString3D.NumVerts -1
                          else PosledniSour  := VV[LVL]^.CSour + LineString2D.NumVerts -1;
                  Delka         := 0; {?????????????????????}
               end;

               if Je3D then Bod3dnaSour(LineString3D.Vertice,Sour)
                       else Bod2dnaSour(LineString2D.Vertice,Sour);
               PosunSour(Sour);
               UlozSour;
               New(PLomBod);
               PLomBod^.Dalsi := nil;
               PLomBod^.Sour  := Sour;
               LomB := PLomBod;

               if Je3D then
               begin
                  for i := 2 to LineString3D.NumVerts do
                  begin
                     BlockRead(F,P3D,SizeOf(Point3D));
                     Bod3dnaSour(P3D,Sour);
                     PosunSour(Sour);
                     UlozSour;
                     New(LomB^.Dalsi);
                     LomB := LomB^.Dalsi;
                     LomB^.Dalsi    := nil;
                     LomB^.Sour     := Sour;
                  end;
               end
               else begin
                       for i := 2 to LineString2D.NumVerts do
                       begin
                          BlockRead(F,P2D,SizeOf(Point2D));
                          Bod2dnaSour(P2D,Sour);
                          PosunSour(Sour);
                          UlozSour;
                          New(LomB^.Dalsi);
                          LomB := LomB^.Dalsi;
                          LomB^.Dalsi    := nil;
                          LomB^.Sour     := Sour;
                       end;
                    end;

               Linie.Delka := DelkaLinie(PLomBod);
               NastavSymbolDoStredu(Linie, PLomBod);

               UlozLin;

               ZrusSeznam;
               if PripojitDatabaze and
                  ((Je3D and JsouAtributy(LineString3D.DHdr)) or
                  JsouAtributy(LineString2D.DHdr))  then
               begin
                  JeDB := True;
                  JeLin:= True;
                  BlockRead(F,AtribLink,SizeOf(TAtribLink));
                  UlozDBLin;
               end
            end;
         end;
         TEXT_ELM:
         begin
            KontrolaVrstvy(LVL);
            with TBX do
            begin
               if Je3D then
               begin
                  BlockRead(F,Text3D,SizeOf(Ttext_3d));
                  Sg[1] := Text3D.Pis;
                  if Text3D.Numchars < 1 then Sg := ''
                  else begin
                     BlockRead(F,Sg[2],Text3D.numchars - 1);
                     Sg[0] := Chr(Text3D.numchars);
                  end;
                  font := VratFont(Text3D.Font,sklon);
                  Bod3DNaSour(Text3D.Origin,VychoziBod);
                  PosunSour(VychoziBod);

                  Text3D.hghtmult := SwapLong(Text3D.hghtmult);
                  Text3D.lngthmult:= SwapLong(Text3D.lngthmult);

                  KoefVysky := VratKoefVysky (Text3D.hghtmult,font);
                  KoefSirky := VratKoefSirky (Text3D.lngthmult,Text3D.hghtmult,Text3D.font);
                  Smer      := 0; { ve 3D ?????? }
                  NastavBarvuAStylln(Text3D.DHdr.Symb,Barva,DruhCary);
                  Druh := Class(Text3D.DHdr);
               end
               else begin
                       BlockRead(F,Text2D,SizeOf(Ttext_2d));
                       Sg[1] := Text2D.Pis;
                       if Text2D.Numchars < 1 then Sg := ''
                       else begin
                          BlockRead(F,Sg[2],Text2D.numchars - 1);
                          Sg[0] := Chr(Text2D.numchars);
                       end;
                       font := VratFont(Text2D.Font,sklon);
                       Bod2DNaSour(Text2D.Origin,VychoziBod);
                       PosunSour(VychoziBod);

                       Text2D.hghtmult := SwapLong(Text2D.hghtmult);
                       Text2D.lngthmult:= SwapLong(Text2D.lngthmult);

                       KoefVysky := VratKoefVysky (Text2D.hghtmult,font);
                       KoefSirky := VratKoefSirky (Text2D.lngthmult,Text2D.hghtmult,Text2D.font);
                       Smer      := DejRadZeStupnu(SwapLong(Text2D.rotation)/360000);
                      if not TretiQ and Ignor3D then otocUhel(Smer);
                       NastavBarvuAStylln(Text2D.DHdr.Symb,Barva,DruhCary);
                       Druh := Class(Text2D.DHdr);
               end;
               if DruhCary in [0..3,9,23..26] then DruhCary := 0
                                              else DruhCary := 4;
               VratOpsanyObd(OpsanyObdelnik);
               Cislo      := VV[LVL]^.CText;
               Druh       := 1;
               Vybran     := False;
               Cas        := GetPackTime;
               Atributy   := []; { !!! justifikation };
               RezimTextu := relativne;
               SmerNapevno:= False;
               Write(VV[LVL]^.FTBX,TBX);
               Writeln(VV[LVL]^.FTTX,Sg);
               Inc(VV[LVL]^.CText);
            end;
         end;
         MICROSTATION_ELM:
         begin
            if Level = 10 then
            begin
            {
               if PripojitDatabaze then
               begin
                  BlockRead(F,StartApp,SizeOf(TStartApp));
                  VratJmenoRidiciDatabaze;
               end;
            }
            end;
         end;
       end;{case}
    end;
  end;


{=============================== MAIN =================================}


begin
  ZjistiJmenoSouboruDGN;

  InicializacePrevodniTabulky;

  PripravProstredi;
  OtevriSoubory;
  Prekladej;
  ZavriSoubory;
  GotoXY(42,11);
  write('100');
  GotoXY(28,14);
  Write (Rastr);
  GotoXY(5,28);
  TextBackGround(Black);
  Writeln('Konec');
  Lup;
  repeat until Keypressed;
  TextMode(OrigMode);
end.
