unit i_Node;

interface
uses
   Elements,
   i_Basic;
type
TNodeInterpret = class(TRectInterpret)
protected
   function  IsItsClass(AObject: TObject): boolean; override;
   function  QGoInside(Element: TElement): boolean; override;
   function  QProcessBefore(Element: TElement): boolean; override;
   procedure Process(Element: TElement); override;
end;

TNodeInterpretEx = class(TNodeInterpret)
protected
   procedure Process(Element: TElement); override;
end;

implementation
uses
   Graphics,
   SysUtils,
   e_Class,
   e_Device,
   e_Node;


{ TNodeInterpret }

function TNodeInterpret.IsItsClass(AObject: TObject): boolean;
begin
   result := aObject is TNode;
end;

procedure TNodeInterpret.Process(Element: TElement);
var
   N: TNode;
   i: double;
begin
  N := TNode(Element);
  Device.Pen.Color := clRed;
  Device.Pen.Width := 3;
  Device.Pen.Style := psSolid;
  i := Device.Projection.GetModelLength(5);
  //Device.Rectangle(N.X-i,N.Y-i,N.X+i,N.Y+i);
  Device.MoveTo(N.X-i,N.Y-i);
  Device.LineTo(N.X,N.Y+i);
  Device.LineTo(N.X+i,N.Y-i);
  Device.LineTo(N.X-i,N.Y-i);
  Device.Font.Size := 8;
  Device.TextOut(N.X + i,N.Y + i,IntToStr(N.BranchCount));
end;

function TNodeInterpret.QGoInside(Element: TElement): boolean;
begin
   result := false;
end;

function TNodeInterpret.QProcessBefore(Element: TElement): boolean;
begin
   result := Element is TNode;
end;

{ TNodeInterpretEx }

procedure TNodeInterpretEx.Process(Element: TElement);
var
   N: TNode;
   i: double;
   ni: integer;
   S: string;
begin
  N := TNode(Element);
  ni := StrToIntDef(N.Name,0);
  case ni of
     0: Device.Pen.Color := clRed;
     3: Device.Pen.Color := $FF00FF;
  else
     Device.Pen.Color := clLime;
  end;
  Device.Pen.Width := 3;
  Device.Pen.Style := psSolid;
  i := Device.Projection.GetModelLength(5);
  //Device.Rectangle(N.X-i,N.Y-i,N.X+i,N.Y+i);
  Device.MoveTo(N.X-i,N.Y-i);
  Device.LineTo(N.X,N.Y+i);
  Device.LineTo(N.X+i,N.Y-i);
  Device.LineTo(N.X-i,N.Y-i);
  Device.Font.Size := 10;
  S :=' '+IntToStr(N.BranchCount);
  if ni = 2 then S := S + ' *'
  else
  if ni = 3 then S := S + ' !';
  Device.TextOut(N.X + i,N.Y + i,S);
end;

INITIALIZATION
   RegisterOrbisClass(TNodeInterpret);
   RegisterOrbisClass(TNodeInterpretEx);
END.
