unit F_layimp;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, FileCtrl, Buttons,
  Grids, Menus,
  // KERNEL
  Elements,
  Tools;

type
  TF_layimpForm = class(TForm)
    GroupBox1: TGroupBox;
    InDrive: TDriveComboBox;
    InDir: TDirectoryListBox;
    InFile: TFileListBox;
    InFilter: TFilterComboBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    SB_Up: TSpeedButton;
    SB_Down: TSpeedButton;
    OutLayers: TStringGrid;
    LayMenu: TPopupMenu;
    Vloitdek1: TMenuItem;
    Smazatdek1: TMenuItem;
    N1: TMenuItem;
    DRUH: TMenuItem;
    COLOR: TMenuItem;
    Zkrtitcestu1: TMenuItem;
    plus: TMenuItem;
    N3: TMenuItem;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn8: TBitBtn;
    BitBtn9: TBitBtn;
    BitBtn10: TBitBtn;
    BitBtn11: TBitBtn;
    BitBtn12: TBitBtn;
    aster: TMenuItem;
    Ex: TMenuItem;
    minus: TMenuItem;
    amper: TMenuItem;
    USECOLOR: TMenuItem;
    SYMBOL: TMenuItem;
    USESYMBOL: TMenuItem;
    CONDITION: TMenuItem;
    ColorDialog: TColorDialog;
    BitBtn7: TBitBtn;
    lbSize: TLabel;
    procedure InDriveChange(Sender: TObject);
    procedure InDirChange(Sender: TObject);
    procedure InFileDblClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SB_deleteClick(Sender: TObject);
    procedure SB_UpClick(Sender: TObject);
    procedure SB_DownClick(Sender: TObject);
    procedure SB_InsertClick(Sender: TObject);
    procedure Zkrtitcestu1Click(Sender: TObject);
    procedure plusClick(Sender: TObject);
    procedure DRUHClick(Sender: TObject);
    procedure COLORClick(Sender: TObject);
    procedure asterClick(Sender: TObject);
    procedure ExClick(Sender: TObject);
    procedure minusClick(Sender: TObject);
    procedure amperClick(Sender: TObject);
    procedure USECOLORClick(Sender: TObject);
    procedure SYMBOLClick(Sender: TObject);
    procedure USESYMBOLClick(Sender: TObject);
    procedure CONDITIONClick(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure InFileChange(Sender: TObject);
    procedure InFileClick(Sender: TObject);
  private
    { Private declarations }
    procedure SetLayer(aI: longInt; aString: string);
    function  GetLayer(aI: longInt): string;
    function  GetActualLayer: string;
    procedure SetActualLayer(aString: string);
    function  GetActualValue: string;
    function  GetActualParam: string;
    procedure  SetActualValue(aString: string);
    procedure  SetActualParam(aString: string);
    function  GetPlus: string;
    function  GetPath: string;
  public
    { Public declarations }
    property ActualLayer: string read GetActualLayer write SetActualLayer;
  end;




TLayerImportDialog = class(TTool)
private
   FInitialDir: string;
public
   procedure DoIt; override;
published
   property InitialDir: string read FInitialDir write FInitialDir;
end;

implementation

{$R *.DFM}
uses
  // KERNEL
  e_Class,
  e_Files,
  e_Type,
  U_String,
  Worlds,
// GISLAYER
  e_LayScr;
  // MAIN
  //HelpCtx;

procedure TLayerImportDialog.DoIt;
var
  LF: TF_layimpForm;
  SLE: TStringListElement;
  SL: TStringList;

begin
  LF:= TF_LayImpForm.Create(Application);
  if (InitialDir <> '') and DirectoryExists(InitialDir) then
  begin
    LF.InDrive.Drive := InitialDir[1];
    LF.InDir.Directory := InitialDir;
  end;
  SLE := TStringListElement(Input);
  if SLE <> nil then
  begin
     SL := SLE.CreateStringList;
     LF.Outlayers.Cols[0].Assign(SL);
     SL.Free;
  end;
  if (LF.ShowModal = mrOK) and (LF.OutLayers.Cols[0].Count > 0) then
  begin
    SLE.Free;
    //SLE:= nil;
    SL:= TStringList.Create;
    SL.AddStrings(LF.OutLayers.Cols[0]);
    SLE:= TStringListElement.CreateFromStringList(SL);
    SL.Free
  end
  else
  try
     if SLE <> nil then SLE.ParamToNames;
  except
  end;

  Output:= SLE
end;



procedure TF_layimpForm.InDriveChange(Sender: TObject);
begin
  try
    InDir.Drive:= InDrive.Drive
  except
      on EX: Exception  do
      begin
        try
          InDir.Directory:= InDrive.Drive + ':\';
        except
            on EX: Exception  do
            begin
              ShowMessage('Chyba pi zmn adrese: '+EX.Message);
              InDir.Directory:= InDrive.Drive + ':\';
            end;
        end;
      end;
  end;
end;

procedure TF_layimpForm.InDirChange(Sender: TObject);
begin
  InFile.Directory:= InDir.Directory
end;

procedure TF_LayImpForm.SetLayer(aI: longInt; aString: string);
begin
  with OutLayers do
  begin
    Cols[0].Strings[aI]:= aString
  end
end;

function  TF_layimpForm.GetLayer(aI: longInt): string;
begin
  with OutLayers do
  begin
    result:= Cols[0].Strings[aI]
  end
end;


function  TF_layimpForm.GetActualLayer: string;
begin
  with OutLayers do
  begin
    result:= Cols[0].Strings[Row]
  end
end;


procedure TF_LayImpForm.SetActualLayer(aString: string);
begin
  with OutLayers do
  begin
    Cols[0].Strings[Row]:= aString
  end
end;


function  TF_layimpForm.GetActualValue: string;
var
  Prom, Val: string;
begin
  StringAsParameter(ActualLayer, Prom, Val);
  result:= BezVnejsichMezer(Val)
end;


procedure  TF_layimpForm.SetActualValue(aString: string);
var
  Par, Val: string;
begin
  Par:= GetActualParam;
  Val:= GetActualValue;
  SetActualLayer(Par + '=' + aString)
end;



procedure  TF_layimpForm.SetActualParam(aString: string);
var
  Par, Val: string;
begin
  Par:= GetActualParam;
  Val:= GetActualValue;
  SetActualLayer(aString + '=' + Val)
end;



function  TF_layimpForm.GetActualParam: string;
var
  Prom, Val: string;
begin
  StringAsParameter(ActualLayer, Prom, Val);
  result:= Prom
end;


function  TF_layimpForm.GetPlus: string;
var
  Val: string;
begin
  Val:= GetActualValue;
  result:= '';
  if Val[1] = '+' then
     result:= '+'
end;


function  TF_layimpForm.GetPath: string;
begin
  result:= GetActualValue;
  if result[1] = '+' then
     result:= copy(result, 2, 255)
end;




procedure TF_layimpForm.InFileDblClick(Sender: TObject);
var
  aType, aLayType, aString: string;
  i: longInt;
begin
  aType:= InFile.FileName;
  aType:= upperCase(extractFileExt(aType));
  aLayType:= LayerTypeForExt(aType);

  if TopolLayer(aType)  then
     aString:= ExtractFilePath(InFile.FileName)
  else
     aString := InFile.FileName;

  RemoveBackSlash(aString);
  aString:= aLayType + '='+ aString;
  with OutLayers do
  begin
    if GetLayer(Row) = '' then
       SetLayer(Row, aString)
    else
    begin
      for i := Row to RowCount-1 do
      begin
         if GetLayer(i) = '' then
         begin
            SetLayer(i, aString);
            exit;
         end;
      end;
      if GetLayer(RowCount-1) <> '' then
         RowCount:= RowCount+1;
      SetLayer(RowCount-1, aString)
    end
  end
end;


procedure TF_layimpForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=   caFree
end;


procedure TF_layimpForm.SB_deleteClick(Sender: TObject);
var
  I, J: longInt;
begin
  with OutLayers do
  begin
    if RowCount < 1 then exit;
    I:= Row;
    if I < RowCount-1 then
      for J:= I to OutLayers.RowCount-2 do
      begin
        SetLayer(J, GetLayer(J+1));
      end;

    if RowCount = 1 then
       SetLayer(0, '')
    else
       OutLayers.RowCount:= OutLayers.RowCount-1;
  end
end;


procedure TF_layimpForm.SB_UpClick(Sender: TObject);
var
  I: longInt;
  aString: string;
begin
  with OutLayers do
  begin
    if Row > 0 then
    begin
      I:= Row;
      aString:= GetLayer(I-1);
      SetLayer(I-1, GetLayer(I));
      SetLayer(I, aString);
      Row:= I-1
    end
  end
end;




procedure TF_layimpForm.SB_DownClick(Sender: TObject);
var
  I: longInt;
  aString: string;
begin
  with OutLayers do
  begin
    if Row < RowCount-1 then
    begin
      I:= Row;
      aString:= GetLayer(I+1);
      SetLayer(I+1, GetLayer(I));
      SetLayer(I, aString);
      Row:= I+1
    end
  end
end;



procedure TF_layimpForm.SB_InsertClick(Sender: TObject);
var
  I,J: longInt;
begin
  with OutLayers do
  begin
    I:= Row;
    RowCount:= RowCount+1;
    if I < RowCount-1 then
    begin
      for J:= RowCount-2 downto I do
      begin
        SetLayer(J+1, GetLayer(J))
      end;
    end;
  end;
  SetLayer(I, '');
end;


procedure TF_layimpForm.Zkrtitcestu1Click(Sender: TObject);
var
  Par, Val, Plus: string;
begin
  Par:= GetActualParam;
  Val:= GetActualValue;
  Plus:= GetPlus;
  ActualLayer:= Par + '=' + Plus + ExtractFileName(Val)
end;

procedure TF_layimpForm.plusClick(Sender: TObject);
begin
  if GetPlus = '+' then
     SetActualValue(GetPath)
  else
     SetActualValue('+' + GetPath)
end;


procedure TF_layimpForm.DRUHClick(Sender: TObject);
begin
  SetActualParam('!DRUH')
end;

procedure TF_layimpForm.COLORClick(Sender: TObject);
var
   Val: string;
   i: longInt;
begin
   Val:= GetActualValue;
   try
      i := StrToInt(Val);
   except
      i := 0;
   end;
   ColorDialog.Color := i;
   if ColorDialog.Execute then i := ColorDialog.Color
                          else i := 0;
   Val := IntToStr(i);
   ActualLayer:= '@COLOR=' + Val;
end;


procedure TF_layimpForm.asterClick(Sender: TObject);
begin
    SetActualValue('*' + ExtractFileExt(GetPath));
end;


procedure TF_layimpForm.ExClick(Sender: TObject);
var
   par: string;
begin
   par := GetActualParam;
   if par = '' then par := '!'
   else
   begin
      if Par[1] = '!' then Par[1] := '-' else
      if Par[1] = '-' then Par[1] := '!' else exit;
   end;
   SetActualParam(Par);
end;


procedure TF_layimpForm.minusClick(Sender: TObject);
var
   par: string;
begin
   par := GetActualParam;
   if par = '' then par := '-'
   else
   begin
      if Par[1] = '!' then Par[1] := '-' else
      if Par[1] = '-' then Par[1] := '!' else exit;
   end;
   SetActualParam(Par);
end;

procedure TF_layimpForm.amperClick(Sender: TObject);
begin
   SetActualParam('@');
end;

procedure TF_layimpForm.USECOLORClick(Sender: TObject);
var
   S: string;
begin
   SetActualParam('@USECOLOR');
   S := GetActualValue;
   if UpperCase(S) <> 'TRUE' then S := 'TRUE'
                             else S := 'FALSE';
   SetActualValue(S);
end;

procedure TF_layimpForm.SYMBOLClick(Sender: TObject);
begin
   SetActualParam('@SYMBOL');
   SetActualValue('0');
end;

procedure TF_layimpForm.USESYMBOLClick(Sender: TObject);
var
   S: string;
begin
   SetActualParam('@USESYMBOL');
   S := GetActualValue;
   if UpperCase(S) <> 'TRUE' then S := 'TRUE'
                             else S := 'FALSE';
   SetActualValue(S);
end;

procedure TF_layimpForm.CONDITIONClick(Sender: TObject);
begin
   SetActualParam('@CONDITION')
end;

procedure TF_layimpForm.BitBtn7Click(Sender: TObject);
begin
   //ExpertJump('Layer_editing_Dialog');
end;

procedure TF_layimpForm.InFileChange(Sender: TObject);
begin
   if InFile.FileName = '' then
      LBSize.Caption:= '';
end;


procedure TF_layimpForm.InFileClick(Sender: TObject);
var
   F: TFileElement;
begin
   if InFile.FileName = '' then
      LBSize.Caption:= ''
   else
   begin
      F := TFileElement.Create;
      F.FileName := InFile.FileName;
      F.ReadInfo := true;
      LBSize.Caption:= IntToStr(F.FileSize);
      F.Free;
   end;
end;

INITIALIZATION
  RegisterOrbisClass(TLayerImportDialog);
END.

