unit AnalInt;

interface




uses WinTypes,
// KERNEL
   Elements,
// GLIB
   G_Elems;

const
  MaxPocetBoduPlochy = 10000;



type hranice     = (leva, prava, dolni, horni);
     kod_oblasti = set of hranice;


TXY = record X, Y: double end;

TCorns = array [1..4] of TXY;


procedure SwapInc(var XMin, XMax: double);

procedure RelRegionLine(const Region: TRect; const OX, OY, aX, aY: longInt;
                        var FullyInside, Clipped: boolean);


procedure ClipLine (const Region: TRect; const xi1, yi1, xi2, yi2: longInt;
                    var xi3, yi3, xi4, yi4: longInt; var Visible: boolean);

procedure Nearest2PointsLeftRight(Entita: TEntity; X, Y: double; var XL, XR: double;
                             var CrossCount: longInt);

procedure Nearest2PointsRight(Entita: TEntity; X, Y: double; var X1, X2: double;
                             var CrossCount: longInt);

function InsideTest(Entita: TEntity; Sour: TCoordinate): boolean;

procedure VratNormCtverec(Xmin, Ymin, Xmax, Ymax: double;
                          var QXmin, QYmin, Hrana: longInt);

procedure VratNormRozsireni2D(Qmin, Qwidth: longInt; Min, Max: double;
                              var QminVys, QWidthVys: longInt);
{ hledn hodnot obklopujcch vstup, kter jsou mocninnm nsobkem QWidth }

{ procedure SpustNormCtverec;}

function JeVlevoOdPrimky(X1,Y1,X2,Y2,X,Y: double): boolean;

function InsideCorns(X, Y: double; Corns: TCorns): boolean;

function Inside4XY(aX, aY, X1, Y1, X2, Y2, X3, Y3, X4, Y4: double): boolean;


implementation
uses
  WinProcs,
  Graphics,
  MathLib;



procedure SwapInc(var XMin, XMax: double);
var
  Pom: double;
begin
  if XMin > XMax then
  begin
    Pom:= XMax;
    XMax:= XMin;
    XMin:= Pom
  end
end;



procedure Zjisteni_kodu_oblasti
 (const Region:TRect; const x, y: longInt; var c: kod_oblasti);
begin
  with Region do
  begin
    c := [];
    if x < left
      then c := [leva]
      else if x > right then c := [prava];
    if y > bottom
      then c := c + [dolni]
      else if y < top then c := c + [horni]
  end
end;





procedure RelRegionLine(const Region:TRect; const OX, OY, aX, aY: longInt;
                        var FullyInside, Clipped: boolean);
var
  C1, C2: kod_Oblasti;
begin
  FullyInside:= true; {Nastaveni pro plne uvnitr}
  Clipped:= false;
  Zjisteni_Kodu_Oblasti(Region, OX, OY, C1);
  Zjisteni_Kodu_Oblasti(Region, aX, aY, C2);

  if C1 + C2 <> [] then
  begin { neni plne uvnitr }
    FullyInside:= false;
    if C1 * C2 = [] then
      Clipped:= true  { mozna je castecne uvnitr }
  end
end;


procedure Uprava_poradi_vrcholu (var x1, y1, x2, y2: double;
                                 var c1, c2: kod_oblasti);
  var
      p: double;
      c: kod_oblasti;
  begin
    if c1 = [] then
      begin  { prvni vrchol je uvnitr hranice ==> zamena s druhym }
        p:=x1; x1:=x2; x2:=p;
        p:=y1; y1:=y2; y2:=p;
        c:=c1; c1:=c2; c2:=c
      end
  end;



procedure ClipLine (const Region: TRect; const xi1, yi1, xi2, yi2: longInt;
                    var xi3, yi3, xi4, yi4: longInt; var Visible: boolean);
  var  kod1, kod2 : kod_oblasti;
       hotovo: boolean;
       x1, y1, x2, y2: double;
       m: double;
  begin
    x1:= xi1; x2:= xi2; y1:= yi1; y2:= yi2;
    hotovo := false;
    Visible := false;
    while not hotovo do

    begin
      zjisteni_kodu_oblasti (Region, round(x1), round(y1), kod1);
      zjisteni_kodu_oblasti (Region, round(x2), round(y2), kod2);
      if (kod1+kod2) = [] then { seka je zcela uvnit }
        begin
          hotovo := true;
          Visible := true;
        end
      else
      if (kod1*kod2) <> []
        then hotovo := true { seka je zcela mimo }
        else
          with Region do
          begin { hledani pruseciku }
            uprava_poradi_vrcholu (x1, y1, x2, y2, kod1, kod2);

            if x2-x1 <> 0 then { doplnil O.S. 13.3.96 }
            begin
              m := (y2 - y1) / (x2 - x1);
              if leva in kod1 then   { prusecik s levou hranici }
                begin y1 := y1 + (left - x1) * m;
                      x1 := left;
                end else
              if prava in kod1 then  { prusecik s pravou hranici }
                begin y1 := y1 + (right - x1) * m;
                      x1 := right
                end else
              if dolni in kod1 then  { prusecik s dolni hranici }
                begin x1 := x1 + (bottom - y1) / m;
                      y1 := bottom;
                end else
              if horni in kod1 then  { prusecik s horni hranici }
                begin x1 := x1 + (top - y1) / m;
                      y1 := top
                end
            end
            {svisla cara}
            else
            begin
              if dolni in kod1 then  { prusecik s dolni hranici }
                y1 := bottom
              else
              if horni in kod1 then  { prusecik s horni hranici }
                y1 := top
            end
          end {else hledani pruseciku}
    end; {while not hotovo}

    xi3:= round(x1);
    yi3:= round(y1);
    xi4:= round(x2);
    yi4:= round(y2);
  end;



procedure PrusecikParametrickychPrimek(
                                           K1, Q1, K2, Q2: double;
                                       var Yp, Xp        : double;
                                       var Rovnobezky    : boolean);
var
  Jmenovatel: double;

begin
  Jmenovatel:= K1 - K2;

  if abs(Jmenovatel) > 1E17 then
  begin
    Yp:= 0;
    Xp:= 0;
    Rovnobezky:= true
  end
  else
  if (abs(Jmenovatel * 1E20) <= abs(Q2 - Q1)) or
     (abs(Jmenovatel * 1E20) <= abs(K1*Q2 - K2*Q1)) then Rovnobezky:= true
  else
  begin
    Yp:= (K1*Q2 - K2*Q1) / Jmenovatel;
    Xp:= (Q2-Q1)/Jmenovatel;
    Rovnobezky:= false
  end
end;



(*
procedure PrusecikUsecek(
                             Ya1,Xa1,  Yb1,Xb1,   Ya2,Xa2,  Yb2,Xb2: double;
                         var Yp, Xp                                : double;
                         var Rovnobezky, Uvnitr1, Uvnitr2          : boolean);
var
  Svisla1, Svisla2: boolean;
  K1, Q1, K2, Q2, YR, XR: double;

begin
  Uvnitr1 := false;
  Uvnitr2 := false;
  K1 := 0;
  Q1 := 0;
  K2 := 0;
  Q2 := 0;

  YR := Ya1; Ya1 := 0;
  XR := Xa1; Xa1 := 0;

  Yb1 := Yb1 - YR;
  Ya2 := Ya2 - YR;
  Yb2 := Yb2 - YR;

  Xb1 := Xb1 - XR;
  Xa2 := Xa2 - XR;
  Xb2 := Xb2 - XR;

  Svisla1 := true;

  if abs(Xa1-Xb1) > 1E-20 then
  begin
    K1      := (Ya1 - Yb1)/(Xa1 - Xb1);
    Q1      := (Xa1*Yb1 - Xb1*Ya1) / (Xa1 - Xb1);
    Svisla1 := false
  end;

  Svisla2 := true;

  if abs(Xa2-Xb2) > 1E-20 then
  begin
    K2      := (Ya2 - Yb2)/(Xa2 - Xb2);
    Q2      := (Xa2*Yb2 - Xb2*Ya2) / (Xa2 - Xb2);
    Svisla2 := false
  end;

  if Svisla1 and Svisla2 then Rovnobezky:= true
  else
    if Svisla1 then
    begin
      Xp         := Xa1;
      Yp         := K2*Xp + Q2;
      Rovnobezky := false
    end
    else
      if Svisla2 then
      begin
        Xp         := Xa2;
        Yp         := K1*Xp + Q1;
        Rovnobezky := false
      end
      else
        PrusecikParametrickychPrimek(K1, Q1, K2, Q2, Yp, Xp, Rovnobezky);

  { Usecky se protinaji mezi krajnimi body ? }
  if not Rovnobezky then
  begin
    if Svisla1 then Uvnitr1 := (Yp <= Ya1) and (Yp >= Yb1) or
                               (Yp >= Ya1) and (Yp <= Yb1)
    else            Uvnitr1 := (XP <= Xa1) and (Xp >= Xb1) or
                               (Xp >= Xa1) and (Xp <= Xb1);

    if Svisla2 then Uvnitr2 := (Yp <= Ya2) and (Yp >= Yb2) or
                               (Yp >= Ya2) and (Yp <= Yb2)
    else            Uvnitr2 := (XP <= Xa2) and (Xp >= Xb2) or
                               (Xp >= Xa2) and (Xp <= Xb2);
  end;

  Yp := Yp + YR;
  Xp := Xp + XR
end;
*)



procedure Nearest2PointsLeftRight(Entita: TEntity; X, Y: double; var XL, XR: double;
                             var CrossCount: longInt);
{ pocita se pocet pruchodu vertexu plochy pres primku Sour.X.
  Specialne je osetrena moznost totoznosti X-ove souradnice vertexu s
  poloprimkou }

var
  Sour1, Sour2: TCoordinate;
  Rovnobezky, Uvnitr1, Uvnitr2: boolean;
  //BylTotoznyPocatek: boolean;
  Yp, Xp: double;
  I: longInt;

  procedure AddNearestLeft(aX: double);
  begin
    if abs(X - aX) < abs(X - XL) then
      XL:= aX;
  end;

  procedure AddNearestRight(aX: double);
  begin
    if abs(X - aX) < abs(X - XR) then
      XR:= aX;
  end;


begin
  XL:= 1E20;
  XR:= 1E20;
  CrossCount    := 0;

  with Entita do
  if Count > 2 then
  begin
    Sour1:= TCoordinate(Elements[0]);
    Sour2:= TCoordinate(Elements[1]);

    //BylTotoznyPocatek:= (Sour1.X = X) and (Sour1.Y <= Y);

    for I:= 2 to Count+1 do
    begin
      if (Sour1.Y>Y) and (Sour2.Y>Y) or  { vertex je nad poloprimkou }
         (Sour1.Y<Y) and (Sour2.Y<Y)     { vertex je pod poloprimkou }
         then Uvnitr1:= false

      else
      begin
      { vertex zhruba prochazi pres primku Sour.Y }

        PrusecikUsecek     { presne zjisteni vpravo }
           (X, Y, 1E20, Y, Sour1.X,Sour1.Y, Sour2.X,Sour2.Y,
            Xp, Yp, Rovnobezky, Uvnitr1, Uvnitr2);

        if Uvnitr1 and Uvnitr2 then
        begin
          inc(CrossCount);
          AddNearestRight(XP);
        end
        else
        begin
          PrusecikUsecek     { presne zjisteni vlevo }
             (X, Y, -1E20, Y, Sour1.X,Sour1.Y, Sour2.X,Sour2.Y,
              Xp, Yp, Rovnobezky, Uvnitr1, Uvnitr2);
          if Uvnitr1 and Uvnitr2 then
          begin
            inc(CrossCount);
            AddNearestLeft(XP);
          end
        end;
      end;

      Sour1:= Sour2;

      if I < Count then
         Sour2:= TCoordinate(Elements[I])
      else
      if I = Count then
      { navrat k prvni souradnici }
         Sour2:= TCoordinate(Elements[0])
    end;
  end; { if Count > 2 }
end;





procedure Nearest2PointsRight(Entita: TEntity; X, Y: double; var X1, X2: double;
                             var CrossCount: longInt);
{ pocita se pocet pruchodu vertexu plochy pres poloprimku Sour.X.
  Specialne je osetrena moznost totoznosti X-ove souradnice vertexu s
  poloprimkou }

var
  Sour1, Sour2: TCoordinate;
  Rovnobezky, Uvnitr1, Uvnitr2, Y1ByloVetsi: boolean;
  BylTotoznyPocatek, ByloPrvniNetotozneY, ByloBezneTotozneY: boolean;
  Yp, Xp: double;
  PrvniNetotozneY, PosledniNetotozneY: double;
  I: longInt;

  procedure AddIfNearest(aX: double);
  begin
    if abs(X - aX) < abs(X - X1) then
    begin
      X2:= X1;
      X1:= aX;
    end
    else
    if abs(X - aX) < abs(X - X2) then
    begin
      X2:= aX;
    end
  end;


begin
  X1:= 1E20;
  X2:= 1E20;
  PrvniNetotozneY := 0;
  PosledniNetotozneY := 0;
  CrossCount    := 0;
  Y1ByloVetsi := true;

  with Entita do
  if Count > 2 then
  begin
    Sour1:= TCoordinate(Elements[0]);
    Sour2:= TCoordinate(Elements[1]);

    BylTotoznyPocatek:= (Sour1.X = X) and (Sour1.Y <= Y);
    ByloPrvniNetotozneY:= false;
    ByloBezneTotozneY:= BylTotoznyPocatek;

    for I:= 2 to Count+1 do
    begin
      if (Sour1.X<X) and (Sour2.X<X) or  { vertex je vlevo od poloprimky }
         (Sour1.Y>Y) and (Sour2.Y>Y) or  { vertex je nad poloprimkou }
         (Sour1.Y<Y) and (Sour2.Y<Y)     { vertex je pod poloprimkou }
         then Uvnitr1:= false

      else
      begin
      { vertex zhruba prochazi pres poloprimku Sour.Y }

        PrusecikUsecek     { presne zjisteni }
           (X, Y, 1E20, Y, Sour1.X,Sour1.Y, Sour2.X,Sour2.Y,
            Xp, Yp, Rovnobezky, Uvnitr1, Uvnitr2);


        if (Sour2.Y = Y) then { druhy konec vertexu lezi na poloprimce }
        begin
          Uvnitr1:= false;

        { kdyz se narazi na sekvenci totoznych Y, tak se pruchody
          nezapocitavaji }

          if not ByloBezneTotozneY then   {1. bezne totozne Y }
          begin
            Y1ByloVetsi:= Sour1.Y > Y;
            ByloBezneTotozneY:= true
          end
        end

        else { Sour2.Y <> Y }
        begin
          if ByloBezneTotozneY then
          begin

          { konecne se narazilo na prvni hodnotu narusujici sekvenci totoznych
            Y. Nyni se rozhodne zda slo o pruchod nebo dotek }

            ByloBezneTotozneY:= false;

            if BylTotoznyPocatek and not ByloPrvniNetotozneY then
            begin
              ByloPrvniNetotozneY:= true;
              PrvniNetotozneY:= Sour2.Y;
              Uvnitr1:= false; { To, zda zde na zacatku se jednalo o pruchod
                                 se bude resit az po posledni souradnici }
            end;

            if ((Y1ByloVetsi and (Sour2.Y > Y)) or
                (not Y1ByloVetsi and (Sour2.Y < Y))) then
               { jednalo se o dotek, nebude se pruchod zapocitavat }
                 Uvnitr1:= false

          end; { naruseni BeznehoTotoznehoY }


        end; { if Sour2.Y = Y }

      end;

      if Uvnitr1 and Uvnitr2 then
      begin
        inc(CrossCount);
        AddIfNearest(XP);
      end;

      { Pro pripad prvniho bodu plochy, prochazejiciho poloprimkou, si
        pamatujeme posledni Sour2, ktere jeste nelezi na poloprimce }
      if BylTotoznyPocatek and (Sour2.Y <> Y) then
         PosledniNetotozneY:= Sour2.Y;

      Sour1:= Sour2;
      if I < Count then
         Sour2:= TCoordinate(Elements[I])
      else
      if I = Count then
      { navrat k prvni souradnici }
         Sour2:= TCoordinate(Elements[0])
    end;

  { ostreni pripadu kdy prvni bod plochy lezi na poloprimce Y }
    if BylTotoznyPocatek and
       ((PrvniNetotozneY > Y) and (PosledniNetotozneY < Y) or
        (PrvniNetotozneY < Y) and (PosledniNetotozneY > Y)) then
    begin
      inc(CrossCount);
      AddIfNearest(X);
    end;
  end; { if Count > 2 }
end;




function InsideTest(Entita: TEntity; Sour: TCoordinate): boolean;
{ pocita se pocet pruchodu vertexu plochy pres poloprimku Sour.X.
  Specialne je osetrena moznost totoznosti X-ove souradnice vertexu s
  poloprimkou }

var
  Sour1, Sour2: TCoordinate;
  Rovnobezky, Uvnitr1, Uvnitr2, Y1ByloVetsi: boolean;
  BylTotoznyPocatek, ByloPrvniNetotozneY, ByloBezneTotozneY: boolean;
  Pruchodu: integer;
  Yp, Xp: double;
  PrvniNetotozneY, PosledniNetotozneY: double;
  I: longInt;

begin
  //Result      := false;
  PrvniNetotozneY := 0;
  PosledniNetotozneY := 0;
  Pruchodu    := 0;
  Y1ByloVetsi := true;

  with Entita do
  if Count > 2 then
  begin
    Sour1:= TCoordinate(Elements[0]);
    Sour2:= TCoordinate(Elements[1]);

    //BylTotoznyPocatek:= (Sour1.X = Sour.X) and (Sour1.Y <= Sour.Y);
    BylTotoznyPocatek:= (Sour1.Y = Sour.Y) and (Sour1.X >= Sour.X);
    ByloPrvniNetotozneY:= false;
    ByloBezneTotozneY:= BylTotoznyPocatek;

    for I:= 2 to Count+1 do
    begin
      {
      if ((Sour1.X = Sour.X) and (Sour1.Y = Sour.Y)) or
         ((Sour2.X = Sour.X) and (Sour2.Y = Sour.Y)) then  // sour lezi na hranici
      }
      if BodLeziNaUsecce(Sour.X,Sour.Y,Sour1.X,Sour1.Y,Sour2.X,Sour2.Y) then
      begin
         result := false;
         exit;
      end;
      if (Sour1.X<Sour.X) and (Sour2.X<Sour.X) or  { vertex je vlevo od poloprimky }
         (Sour1.Y>Sour.Y) and (Sour2.Y>Sour.Y) or  { vertex je nad poloprimkou }
         (Sour1.Y<Sour.Y) and (Sour2.Y<Sour.Y)     { vertex je pod poloprimkou }
      then
      begin
         Uvnitr1:= false;
         ByloBezneTotozneY := false;
      end
      else
      begin
      { vertex zhruba prochazi pres poloprimku Sour.X }

        PrusecikUsecek     { presne zjisteni }
           (Sour.X, Sour.Y, 1E20, Sour.Y, Sour1.X,Sour1.Y, Sour2.X,Sour2.Y,
            Xp, Yp, Rovnobezky, Uvnitr1, Uvnitr2);


        if (Sour2.Y = Sour.Y) then { druhy konec vertexu lezi na poloprimce }
        begin
          Uvnitr1:= false;

        { kdyz se narazi na sekvenci totoznych Y, tak se pruchody
          nezapocitavaji }

          if not ByloBezneTotozneY then   {1. bezne totozne Y }
          begin
            Y1ByloVetsi:= Sour1.Y > Sour.Y;
            ByloBezneTotozneY:= true
          end
        end

        else { Sour2.Y <> Sour.Y }
        begin
          if ByloBezneTotozneY then
          begin

          { konecne se narazilo na prvni hodnotu narusujici sekvenci totoznych
            Y. Nyni se rozhodne zda slo o pruchod nebo dotek }

            ByloBezneTotozneY:= false;

            if BylTotoznyPocatek and not ByloPrvniNetotozneY then
            begin
              ByloPrvniNetotozneY:= true;
              PrvniNetotozneY:= Sour2.Y;
              Uvnitr1:= false; { To, zda zde na zacatku se jednalo o pruchod
                                 se bude resit az po posledni souradnici }
            end;

            if ((Y1ByloVetsi and (Sour2.Y > Sour.Y)) or
                (not Y1ByloVetsi and (Sour2.Y < Sour.Y))) then
               { jednalo se o dotek, nebude se pruchod zapocitavat }
                 Uvnitr1:= false

          end; { naruseni BeznehoTotoznehoY }


        end; { if Sour2.Y = Sour.Y }

      end;

      if Uvnitr1 and Uvnitr2 then
         inc(Pruchodu);

      { Pro pripad prvniho bodu plochy, prochazejiciho poloprimkou, si
        pamatujeme posledni Sour2, ktere jeste nelezi na poloprimce }
      if BylTotoznyPocatek and (Sour2.Y <> Sour.Y) then
         PosledniNetotozneY:= Sour2.Y;

      Sour1:= Sour2;
      if I < Count then
         Sour2:= TCoordinate(Elements[I])
      else
      if I = Count then
      { navrat k prvni souradnici }
         Sour2:= TCoordinate(Elements[0])
    end;

  { ostreni pripadu kdy prvni bod plochy lezi na poloprimce Sour.X }
    if BylTotoznyPocatek and
       ((PrvniNetotozneY > Sour.Y) and (PosledniNetotozneY < Sour.Y) or
        (PrvniNetotozneY < Sour.Y) and (PosledniNetotozneY > Sour.Y)) then
        inc(Pruchodu);
  end; { if Count > 2 }

  Result:= odd(Pruchodu)
end;


{ Binrn tverce }


{ normln trunc sniuje absolutn hodnotu. My vak nkdy potebujem mt
 zajitno pro celou selnou osu zaokrouhlen dol nebo nahoru ve smyslu
 minimln a maximln hodnoty }
function TruncDown(X: double): longInt;
begin
{i pro zporn slo sn hodnotu - ne absolutn }
  result:= trunc(X);
  if X < 0 then dec(result)
end;


function TruncUp(X: double): longInt;
begin
  result:= trunc(X);
  if X > 0 then inc(result)
end;


function DejNejblizsiVyssiMocninu(Cislo: longInt): longInt;
var
  Rad: integer;
begin
  Rad:= 0;
  while Cislo > 0 do
  begin
    Cislo:= Cislo shr 1;
    inc(Rad)
  end;
  Cislo:= 1;
  Cislo:= Cislo shl Rad;
  Result:= Cislo
end;


function DejNormMinHranu(Hodnota: double): longInt;
begin
  result:= DejNejblizsiVyssiMocninu(TruncUp(Hodnota))
end;


function DejNormMin(Hrana: longInt; X: double): longInt;
begin
  if Hrana > 0 then
  begin
    if X > 0 then
       result:= (TruncUp(X) div Hrana)*Hrana
    else
       result:= (TruncDown(X) div Hrana - 1)*Hrana
  end
  else result:= round(X)
end;


procedure VratNormHranuProUsecku(Xmin, Xmax: double; var QXmin, Hrana: longInt);
begin
  Hrana:= DejNormMinHranu(abs(Xmax - Xmin));
  QXmin:= DejNormMin(Hrana, Xmin);
  if (QXmin + Hrana) < Xmax then Hrana:= Hrana*2;
end;



procedure VratNormCtverec(Xmin, Ymin, Xmax, Ymax: double;
                          var QXmin, QYmin, Hrana: longInt);
var
  Hrana2: longInt;
begin
  SwapInc(XMin, XMax);
  SwapInc(YMin, YMax);

  VratNormHranuProUsecku(XMin, XMax, QXmin, Hrana);
  VratNormHranuProUsecku(YMin, YMax, QYmin, Hrana2);
  if Hrana <> Hrana2 then
  begin
    if Hrana < Hrana2 then Hrana:= Hrana2
  end;
end;




procedure VratNormRozsireni2D(Qmin, Qwidth: longInt; Min, Max: double;
                              var QminVys, QWidthVys: longInt);
var
  Inicializace: boolean;

begin
  if (QMin = 0) and (QWidth = 0) then
  { jet nenastaven QTRee }
  begin
    Qmin:= TruncDown(Min);
    QWidth:= TruncUp(abs(Max-Min));
    Inicializace:= true;
  end
  else
    Inicializace:= false;

  {1. nalezen minima }
  QminVys:= Qmin;
  QWidthVys:= QWidth;
  if (Min>=Qmin) and (Max <=Qmin+QWidth) and not Inicializace then
     exit;

  if Min < Qmin then
  begin
   { Odeten nsobku QWidth zaokrohlenho nahoru }
    QminVys:= Qmin - ((Qmin-TruncDown(Min)) div QWidth + 1) * QWidth
  end;
  if Qmin  + QWidth > Max then
     Max:= Qmin + QWidth;

  QWidthVys:= DejNejblizsiVyssiMocninu((TruncUp(Max)-QMinVys) div QWidth +1) * QWidth
end;



(*
procedure SpustNormCtverec;
var
  a,b,c: longInt;
begin
  VratNormCtverec(0,0,10,10,a,b,c)
end;

*)



function JeVlevoOdPrimky(X1,Y1,X2,Y2,X,Y: double): boolean;
{VZDALENOSTODPRIMKY JE KLADNA VLEVO OD PRIMKY ( Synek )}
var
  dY, dX, C:double;
begin
  dX:=X2-X1;
  dY:=Y1-Y2;
  C:= X1*Y2 - X2*Y1;
  result:=(dY*X + dX*Y + C) > 0 {/(sqrt(sqr(dY)+ sqr(dX))); pouze pro vzdalenost }
end;{VZDALENOSTODPRIMKY----------------------------------------------------}




function InsideCorns(X, Y: double; Corns: TCorns): boolean;
{ Synek }
var
   I: longInt;
   X2, Y2: double;

   function GetI(aI: longInt): longInt;
   begin
    result:= 0;
    case aI of
    1: result:= 1;
    2: result:= 2;
    3: result:= 4;
    4: result:= 3
    end;
   end;

begin
  result:= true;
  for I:= 1 to 4 do
  begin

    if I < 4 then
    begin
      X2:= Corns[GetI(I+1)].X;
      Y2:= Corns[GetI(I+1)].Y
    end
    else
    begin
      X2:= Corns[1].X;
      Y2:= Corns[1].Y
    end;
    if JeVlevoOdPrimky(Corns[GetI(I)].X, Corns[GetI(I)].Y ,X2, Y2, X, Y) then
    begin
     result:= false;
     continue
    end
  end
end;{UVNITRMAPY-----------------------------------------------------------}



function Inside4XY(aX, aY, X1, Y1, X2, Y2, X3, Y3, X4, Y4: double): boolean;
var
  aCorns: TCorns;

begin
  aCorns[1].X:= X1;
  aCorns[2].X:= X2;
  aCorns[3].X:= X3;
  aCorns[4].X:= X4;

  aCorns[1].y:= y1;
  aCorns[2].y:= y2;
  aCorns[3].y:= y3;
  aCorns[4].y:= y4;

  result:= InsideCorns(aX, aY, aCorns);
end;



end.

