unit T_InterA;
{
*********************************************************************
*                                                                   *
*  ORBIS ... Tdy interaktivnch nstroj                          *
*                                                                   *
*                       Topol Pro 1996                             *
*********************************************************************

[Unit_Description]
Description=Tdy interaktivnch nstroj
Admin=Petr
TechTopic=Interactive tools
Topic=Zobrazen dat
Version=1.0

[Edit]
 8.8.1997 18:00=Registrace
}


interface
uses
  Classes,
  Controls,
  Graphics,
  Menus,
  WinTypes,
// KERNEL
  Elements,
  Tools,
// DEVICE
  e_Proje,
  t_Device,
// INTERPRET
  e_IScrpt,
  i_Basic,
// GUI
// O.S. 12.7.98
  F_STDImg,
  M_InterA;


type

{ TInteractiveTool }
{ Postup pi tvorb novho interaktivnho nstroje:
  1. Vytvoen novho objetku class (TInteractiveTool)
  2. Do editanho formule vloit tlatko na sputn
     nstroje s vyvolnm udlosti
     Tool.PostMsg(tm_NewTool, Tool, nil, DontKill);
     Udlost tm_NewTool pidat do pslunho M_Proj
  3. Do potomka TFormToolManageru vloit
     a. CreateTools: instanci nstroje do property NextTool
        NextTool := TNewTool.Create;
     b. HandleMessage:
        obsluha udlosti tm_NewTool
     c. Nov procedura On_tm_NewTool
        FindMenuItemIn('Tools','TNewTool').OnClick(nil);
}




TFormToolManager = class;

TInteractiveTool = class(TDeviceTool)
 private
   FIcon: TIcon;
   FManager: TFormToolManager;
   FInterpret: TInterpret;
   function   GetIcon: TIcon;
   procedure  SetIcon(aIcon: TIcon);
   function   GetInterpret: TInterpret;
   procedure  SetInterpret(aInterpret: TInterpret); virtual;
 protected
   function   GetCursor: TCursor; virtual;
   procedure  SetInput(aInput: TElement); override;
 public
 { sprava udalosti }
   procedure PostMouseEvent(Msg: longInt; Receiver: TElement; Button: TMouseButton;
                            Shift: TShiftState; X, Y: Integer; Active: boolean); override;
   procedure PostKeyEvent(Msg: longInt; Receiver: TElement; Key: Word;
                          Shift: TShiftState); override;

   procedure On_tm_Keydown(var aMessage: TOrbisKeyEvent; var Handled: boolean); virtual;
   procedure On_tm_MouseDown(var aMessage: TOrbisMouseEvent; var Handled: boolean); virtual;
   procedure On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); virtual;
   procedure On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean); virtual;
   procedure On_tm_MouseWheelUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); virtual;
   procedure On_tm_MouseWheelDown(var aMessage: TOrbisMouseEvent; var Handled: boolean); virtual;

   procedure On_tm_StartDrag(var aMessage: TOrbisMouseEvent; var Handled: boolean); virtual;
   procedure On_tm_DragOver(var aMessage: TOrbisMouseEvent; var Handled: boolean); virtual;
   procedure On_tm_DragDrop(var aMessage: TOrbisMouseEvent; var Handled: boolean); virtual;
   procedure On_tm_DragEnd(var aMessage: TOrbisMouseEvent; var Handled: boolean); virtual;

   procedure On_tm_Review(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure On_tm_Resize(var Handled: boolean); virtual;
   procedure On_tm_BreakInterpret(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure On_tm_BreakAndReview(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure Select(Sender: TObject);
   procedure On_Activate  ; virtual;
   procedure On_DeActivate; virtual;
   procedure HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;

   property  Icon: TIcon read GetIcon write SetIcon;
   property  Cursor: TCursor read GetCursor;
   property  Interpret: TInterpret read GetInterpret write SetInterpret;
   property  Manager: TFormToolManager read FManager write FManager;
end;


{ TFormToolManager }

TFormToolManager = class(TInteractiveTool)
 private
   FNextToolIndex: longInt;
   FCloseAfterPrinting: boolean ;
    FQuickView: boolean;
    FPrintToFileName: string;
    FSilentMode: boolean;
    FOnPrinterChangedScript: string;
   function    GetActiveToolName: string;
   function    GetActiveToolClassName: string;
   procedure   SetActiveToolName(aValue: string);
   procedure   SetActiveToolClassName(aValue: string);
   function    GetPageColor: TColor;
   procedure   SetPageColor(aValue: TColor);
   function    GetProjection: TProjection;
   function    GetInterpretScript: TInterpretScript;
   procedure   SetInterpretScript(aValue: TInterpretScript);
    procedure SetQuickView(const Value: boolean);
    procedure SetSimpleMenu(const Value: boolean);
    procedure SetPrintToFileName(const Value: string);
    procedure SetPrintIt(const Value: boolean);
    procedure SetSilentMode(const Value: boolean);
    function GetTile: boolean;
    procedure SetTile(const Value: boolean);
    procedure SetOnPrinterChangedScript(const Value: string);
    procedure SetPrinterCHanged(const Value: boolean);
 protected
   FForm: TStandardImageForm;

   function    GetLeft: longInt; virtual;
   function    GetTop: longInt; virtual;
   function    GetWidth: longInt; virtual;
   function    GetHeight: longInt; virtual;
   procedure   SetLeft(aValue: longInt); virtual;
   procedure   SetTop(aValue: longInt); virtual;
   procedure   SetWidth(aValue: longInt); virtual;
   procedure   SetHeight(aValue: longInt); virtual;
   procedure   ShowScale(aVal: string); virtual;

   procedure   SetInput(aInput: TElement); override;
   procedure   CreateForm; virtual;
   procedure   CreateDevice; virtual;
   procedure   LinkDeviceToForm; virtual;
   procedure   CreateInterpret; virtual;
   procedure   LinkInterpretToDevice; virtual;
   procedure   CreateTools; virtual;
   procedure   SetActiveToolIndex(aIndex: longInt); override;
   procedure   SetNextTool(aTool: TInteractiveTool); virtual;
   function    GetVisible: boolean; virtual;
   procedure   SetVisible(aVisible: boolean);  virtual;
   function    FindMenuItem(const aText: string): TMenuItem;
   function    FindMenuItemIn(const aMenu, aItem: string): TMenuItem;
   procedure   CheckMenuItem(const aItem: string);
   function    GetMainMenu: TMainMenu; virtual;
   function    GetCaption: string; virtual;
   procedure   SetCaption(const aValue: string); virtual;
   function    GetFormCursor: TCursor; virtual;
   procedure   SetFormCursor(AValue: TCursor); virtual;
   procedure   SetBreakReView(aValue: boolean);
   procedure   SetElementForReView(aValue: TElement);
   procedure   SetElementForKillReView(aValue: TElement);
   procedure   SetFreeForm(aValue: boolean); virtual;
   procedure   DoLoadFromFile(aName: string); virtual;
   procedure   DoSaveToFile(aName: string); virtual;

   property    NextToolIndex: longInt read FNextToolIndex write FNextToolIndex;
   property    MainMenu: TMainMenu read GetmainMenu;
 public
   constructor Create; override;
   procedure   DoIt; override;

   function    AddTool(aTool: TTool): TTool; override;
   function    InsertTool(aIndex: longInt; aTool: TTool): TTool; override;
   procedure   RemoveTool(aTool: TTool); override;
   procedure   FreeTool(aTool: TTool); override;
   procedure   FreeTools;

   function    FindToolByIcon(aIcon: TIcon): TInteractiveTool;
   procedure   Show;
   procedure   ShowAll;
   procedure   on_tm_Open(var Handled: boolean); virtual;
   procedure   on_tm_SaveAs(var Handled: boolean); virtual;
   procedure   on_tm_QuitTask; override;
   procedure   on_tm_Done(var aMessage: TOrbisMessage; var Handled: boolean); override;
   procedure   on_tm_ToolSelected(var aMessage: TOrbisMessage; var Handled: boolean); virtual;
   procedure   on_tm_Print(var Handled: boolean); virtual;
   procedure   On_tm_Review(var aMessage: TOrbisMessage; var Handled: boolean); override;
   procedure   On_tm_QuickView(var Handled: boolean); virtual;
   procedure   On_tm_Resize(var Handled: boolean); override;
   procedure   On_tm_RePaint(var Handled: boolean); virtual;
   procedure   On_tm_NewScale(var Handled: boolean); virtual;
   procedure   on_tm_ShowAll(var Handled: boolean); virtual;
   procedure   On_tm_EndOfPrint(var Handled: boolean); virtual;
   procedure   On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure   On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure   On_tm_MouseWheelUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure   On_tm_MouseWheelDown(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure   On_tm_Keydown(var aMessage: TOrbisKeyEvent; var Handled: boolean); override;
   procedure   HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;

   property    FormCursor: TCursor read GetFormCursor write SetFormCursor;
   property    Visible: boolean read GetVisible write SetVisible;
published
   property    SimpleMenu: boolean write SetSimpleMenu;
   property    NextTool: TInteractiveTool write SetNextTool;
   property    Form: TStandardImageForm read FForm;
   property    ActiveToolName: string read GetActiveToolName write SetActiveToolName;
   property    ActiveToolClassName: string read GetActiveToolClassName write SetActiveToolClassName;
   property    PageColor: TColor read GetPageColor write SetPageColor;
   property    Projection: TProjection read GetProjection;
   property    InterpretScript: TInterpretScript read GetInterpretScript write SetInterpretScript;
   property    Left: longInt   read GetLeft   write SetLeft;
   property    Top: longInt    read GetTop    write SetTop;
   property    Width: longInt  read GetWidth  write SetWidth;
   property    Height: longInt read GetHeight write SetHeight;
   property    Caption: string read GetCaption write SetCaption;
   property    BreakReView: boolean write SetBreakReView stored false;
   property    ElementForReView: TElement write SetElementForReView;
   property    ElementForKillReView: TElement write SetElementForKillReView;
   property    FreeForm: boolean write SetFreeForm;
   property    LoadFromFile: string write DoLoadFromFile;
   property    SaveToFile: string write DoSaveToFile;
   property    QuickView: boolean read FQuickView write SetQuickView;
   property    PrintToFileName: string read FPrintToFileName write SetPrintToFileName;
   property    CloseAfterPrinting: boolean read FCloseAfterPrinting write FCloseAfterPrinting;
   property    PrintIt: boolean write SetPrintIt stored false;
   property    SilentMode: boolean read FSilentMode write SetSilentMode;
   property    Tile: boolean Read GetTile Write SetTile;
   property    OnPrinterChangedScript: string read FOnPrinterChangedScript write SetOnPrinterChangedScript;
   property    PrinterChanged: boolean write SetPrinterCHanged stored false;
end;


TEditor = class(TInteractiveTool)
end;


TViewer = class(TInteractiveTool)
 protected
   ShiftRect: TRect;
   function  GetCursor: TCursor; override;
   function  GetName: string; override;
 public
   procedure On_tm_Keydown(var aMessage: TOrbisKeyEvent; var Handled: boolean); override;
   procedure On_tm_MouseDown(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
   procedure On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean); override;
end;



implementation
uses
   Dialogs,
   Forms,
   SysUtils,
   //PrintToFile,
   // KERNEL
   e_Class,
   M_Orbis,
   u_String,
   // GLIB
   G_Elems,
   // DEVICE
   D_STDImg,
   e_Device,
   // INTERPRET
   i_Uni,
   // GUI
   F_SetScl,
//   t_Loader,
//   t_Saver,
{$IFNDEF NOTIS}
// SPACETOOL
   //t_SelAre,
//   t_SelMS,
//   t_TisCre,
{$ENDIF}
// MAPPER
   t_Print,
// MAIN
   m_Proj,
   u_Cursor;

{ TInteractiveTool }

function  TInteractiveTool.GetIcon: TIcon;
begin

end;

function  TInteractiveTool.GetCursor: TCursor;
begin
   result := crDefault;
end;

procedure TInteractiveTool.SetIcon(aIcon: TIcon);
begin
end;


function  TInteractiveTool.GetInterpret: TInterpret;
begin
   result := FInterpret;
end;

procedure TInteractiveTool.SetInterpret(aInterpret: TInterpret);
begin
   if Assigned(FInterpret) then
   begin
      try
         aInterpret.Device := FInterpret.Device;
         aInterpret.Input  := FInterpret.Input;
      finally
         FreeElement(FInterpret);
         FInterpret := nil;
      end;
   end
   else
   begin
      try
         aInterpret.Device := Device;
         aInterpret.Input  := Input;
      except
      end
   end;

   FInterpret := aInterpret;
   AddElement(FInterpret);
end;


procedure TInteractiveTool.SetInput(aInput: TElement);
begin
   inherited SetInput(aInput);
   try
      if Interpret = nil then exit;
      Interpret.Input := aInput;
   except
   end;
end;

procedure TInteractiveTool.PostMouseEvent(Msg: longInt; Receiver: TElement;
                           Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Active: boolean);
var
  OM: TOrbisMouseEvent;
begin
   OM := TOrbisMouseEvent.CreateAll(Msg, Self, Receiver, Shift, Button, X, Y, Active);
   OM.Post;
end;


procedure TInteractiveTool.PostKeyEvent(Msg: longInt; Receiver: TElement;
                                        Key: Word; Shift: TShiftState);
var
  OM: TOrbisKeyEvent;
begin
   OM := TOrbisKeyEvent.CreateAll(Msg, Self, Receiver, Shift, Key);
   OM.Post;
end;


procedure TInteractiveTool.On_tm_Keydown(var aMessage: TOrbisKeyEvent; var Handled: boolean);
begin
end;


procedure TInteractiveTool.On_tm_MouseDown(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
end;


procedure TInteractiveTool.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
end;


procedure TInteractiveTool.On_tm_MouseWheelDown(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin

end;

procedure TInteractiveTool.On_tm_MouseWheelUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin

end;

procedure TInteractiveTool.On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
end;



procedure TInteractiveTool.On_tm_StartDrag(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
end;

procedure TInteractiveTool.On_tm_DragOver(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
end;

procedure TInteractiveTool.On_tm_DragDrop(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
end;

procedure TInteractiveTool.On_tm_DragEnd(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
end;





procedure TInteractiveTool.Select(Sender: TObject);
begin
   PostMsgToOwners(tm_ToolSelected, Self, DontKill);
end;


procedure TInteractiveTool.On_tm_ReView(var aMessage: TOrbisMessage; var Handled: boolean);

begin
   if Input = nil then exit;
   if Interpret <> nil then Interpret.On_tm_ReView(aMessage, Handled);

   {
   try
      Interpret.On_tm_ReView(aMessage, Handled);
   except
   end;
   }
end;

procedure TInteractiveTool.On_tm_Resize(var Handled: boolean);
begin
   Handled := false;
end;





procedure TInteractiveTool.On_tm_BreakInterpret(var aMessage: TOrbisMessage; var Handled: boolean);
begin
  if Interpret = nil then exit;
   try
      if Interpret.Busy then Interpret.BreakWork := true;
      Handled := true;
   except
   end;
end;


procedure TInteractiveTool.On_tm_BreakAndReView(var aMessage: TOrbisMessage; var Handled: boolean);
begin
  if Interpret = nil then exit;
   try
      if Interpret.Busy then
      begin
         Interpret.Status := Status + [st_BREAK_AND_DOIT];
      end
      else
      begin
         PostMsg(tm_ReView, aMessage.Receiver, aMessage.Data, aMessage.KillData);
      end;
      Handled := true;
   except
      PostMsg(tm_ReView, aMessage.Receiver, aMessage.Data, aMessage.KillData);
      Handled := true;
   end;
end;

procedure TInteractiveTool.On_Activate  ;
begin
end;

procedure TInteractiveTool.On_DeActivate;
begin
end;




procedure TInteractiveTool.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   Handled := false;

   inherited HandleMessage(aMessage, Handled);
   if Handled then exit;
   case aMessage.Message of
      tm_MouseMove:      on_tm_MouseMove(TOrbisMouseEvent(aMessage ), Handled);
      tm_MouseDown:      on_tm_Mousedown(TOrbisMouseEvent(aMessage ), Handled);
      tm_MouseUp:        on_tm_MouseUp(TOrbisMouseEvent(aMessage ), Handled);
      tm_MouseWheelUp:   on_tm_MouseWheelUp(TOrbisMouseEvent(aMessage ), Handled);
      tm_MouseWheelDown: on_tm_MouseWheelDown(TOrbisMouseEvent(aMessage ), Handled);

      tm_StartDrag:      on_tm_StartDrag(TOrbisMouseEvent(aMessage ), Handled);
      tm_DragOver:       on_tm_DragOver(TOrbisMouseEvent(aMessage ), Handled);
      tm_DragDrop:       on_tm_DragDrop(TOrbisMouseEvent(aMessage ), Handled);
      tm_DragEnd:        on_tm_DragEnd(TOrbisMouseEvent(aMessage ), Handled);

      tm_ReView:         on_tm_ReView(aMessage, Handled);
      tm_ReSize:         on_tm_ReSize(Handled);
      tm_BreakInterpret: on_tm_BreakInterpret(aMessage, Handled);
      tm_BreakAndReView: on_tm_BreakAndReView(aMessage, Handled);
      tm_Keydown:        on_tm_Keydown(TOrbisKeyEvent(aMessage ), Handled);
   end;
end;

{ TFormToolManager }

constructor TFormToolManager.Create;
begin
   inherited Create;
   NextToolIndex := -1;
   CreateForm;
   CreateDevice;
   LinkDeviceToForm;
   CreateInterpret;
   LinkInterpretToDevice;
   CreateTools;
end;

function    TFormToolManager.GetLeft: longInt;
begin
  if Form = nil then exit;
   result := Form.Left;
end;

function    TFormToolManager.GetTop: longInt;
begin
  if Form = nil then exit;
   result := Form.Top;
end;

function    TFormToolManager.GetWidth: longInt;
begin
  if Form = nil then exit;
   result := Form.Width;
end;

function    TFormToolManager.GetHeight: longInt;
begin
  if Form = nil then exit;
   result := Form.Height;
end;

procedure   TFormToolManager.SetLeft(aValue: longInt);
begin
  if Form = nil then exit;
   Form.Left := aValue;
end;

procedure   TFormToolManager.SetTop(aValue: longInt);
begin
  if Form = nil then exit;
   Form.Top := aValue;
end;

procedure   TFormToolManager.SetWidth(aValue: longInt);
begin
  if Form = nil then exit;
   Form.Width := aValue;
end;

procedure   TFormToolManager.SetHeight(aValue: longInt);
begin
  if Form = nil then exit;
   Form.Height := aValue;
end;



procedure   TFormToolManager.SetBreakReView(aValue: boolean);
begin
   if Interpret.Busy then Interpret.BreakWork := true;
end;


procedure   TFormToolManager.SetElementForReView(aValue: TElement);
begin
   PostMsg(tm_ReView, Self, aValue, DontKill);
end;


procedure   TFormToolManager.SetElementForKillReView(aValue: TElement);
begin
   PostMsg(tm_ReView, Self, aValue, KillIt);
end;


procedure   TFormToolManager.SetFreeForm(aValue: boolean);
begin
  if Form = nil then exit;
   if aValue then Form.Free;
end;


procedure   TFormToolManager.DoLoadFromFile(aName: string);
begin
  if Form = nil then exit;
  try
  Form.Image.Picture.BitMap.LoadFromFile(aName);
  except
    ShowMessage('Do souboru ' + aName + ' nejde uloit bitmapa')
  end
end;



procedure   TFormToolManager.DoSaveToFile(aName: string);
begin
  if Form = nil then exit;
  try
  Form.Image.Picture.SaveToFile(aName);
  except
    ShowMessage('Do souboru ' + aName + ' nejde uloit bitmapa')
  end
end;


function    TFormToolManager.GetInterpretScript: TInterpretScript;
begin
{ TODO 0 -oO.. -cChyba : Nebyl pednastaven result }
  result:= nil;
  if Interpret is TUniversalInterpret then
     result := TUniversalInterpret(Interpret).Script;
end;


procedure   TFormToolManager.SetInterpretScript(aValue: TInterpretScript);
var
   //aTool: TUniversalTopolScriptCreator;
   aScript: TInterpretScript;
begin
   (*
   if aValue = nil then
   begin
   {$IFNDEF NOTIS}
      aTool := TUniversalTopolScriptCreator.Create;
      aTool.DoIt;
      aScript:= TInterpretScript(aTool.Output);
      TUniversalInterpret(FInterpret).Script := aScript;
      aTool.Free;
   {$ENDIF}
   end
   else
   *)
   begin
     if ((TElement(aValue) is TInterpretScript) and (Interpret is TUniversalInterpret))
        then TUniversalInterpret(Interpret).Script := aValue;
   end;
end;


function    TFormToolManager.GetPageColor: TColor;
begin
   try
      result := Device.Page.Color;
   except
      result := clBlack;
   end;
end;

procedure   TFormToolManager.SetPageColor(aValue: TColor);
begin
   try
      Device.Page.Color := aValue;
   except
   end;
end;

function    TFormToolManager.GetProjection: TProjection;
begin
   if Device <> nil then result := Device.Projection
                    else result := nil;
end;


function    TFormToolManager.GetActiveToolName: string;
begin
   result := ActiveTool.Name;
end;

function    TFormToolManager.GetActiveToolClassName: string;
begin
   result := ActiveTool.ClassName;
end;

procedure   TFormToolManager.SetActiveToolName(aValue: string);
var
   T: TTool;
begin
   T := TTool(Tools.FindElementName(aValue));
   if T = nil then exit;
   T.PostMsgToOwners(tm_ToolSelected, T, DontKill);
end;

procedure   TFormToolManager.SetActiveToolClassName(aValue: string);
var
   T: TTool;
begin
   T := nil;
   try
      T := TTool(Tools.FindElementClass(FindOrbisClass(aValue)));
   except
   end;
   if T = nil then exit;
   T.PostMsgToOwners(tm_ToolSelected, T, DontKill);
end;


procedure   TFormToolManager.DoIt;
begin
   Show;
   PostMsg(tm_ReView, Self, nil, DontKill);
end;

procedure   TFormToolManager.SetInput(aInput: TElement);
var
   Envelope: TRectEntity;
begin
   if FInput <> nil then
   begin
      FreeElement(FInput);
      FInput := nil;
   end;
   if aInput = nil then exit;
   Envelope := TRectEntity.Create;
   Envelope.Name := 'Oblka';      // p.k.17.1.99
   Envelope.AddAndUpdateRect(aInput{.CreateEnvelope});
   AddElement(Envelope);
   try
      if aInput is TRectEntity then
      begin
         Device.Projection.ChangeProjectionByRectangle(TRectEntity(aInput).Rect, Device.Page);
      end
      else
      if aInput is TCoordinate then
      begin
         Device.Projection.ChangeProjectionByRect(TCoordinate(aInput).GetRegion, Device.Page);
      end;
   except
   end;
   inherited SetInput(Envelope);
   PostTextMsg(tm_Run,'$SCRIPT\FormTool_CheckTransparency.oil',nil);
   Application.ProcessMessages;
end;


procedure   TFormToolManager.CreateForm;
begin
   Application.CreateForm(TStandardImageForm, FForm);
   Form.Tool := Self;
   Form.IsPossibleToClose := false;
end;

procedure   TFormToolManager.CreateDevice;
begin
//   Device := TCanvasBMPDoubleDevice.Create;
//   Device := TCanvasToBMPDevice.Create;
   Device := TImageCanvasDevice.Create;
end;

procedure   TFormToolManager.LinkDeviceToForm;
begin
  if Form = nil then exit;
   with TImageCanvasDevice(Device) do
   begin
      //Canvas := Form.Image.Canvas;
      Bitmap := Form.Image.Picture.Bitmap;
   end;
end;

procedure   TFormToolManager.CreateInterpret;
{$IFNDEF NOTIS}
var
   //aTool: TUniversalTopolScriptCreator;
   aScript: TInterpretScript;
{$ENDIF}
begin
   Interpret := TUniversalInterpret.Create;
{$IFNDEF NOTIS}
   (*
   aTool := TUniversalTopolScriptCreator.Create;
   aTool.DoIt;
   aScript:= TInterpretScript(aTool.Output);
   TUniversalInterpret(FInterpret).Script := aScript;
   aTool.Free;
   *)
{$ENDIF}
end;



procedure   TFormToolManager.LinkInterpretToDevice;
begin
   Interpret.Device := Device;
end;

procedure   TFormToolManager.CreateTools;
var
   T: TInteractiveTool;
begin
{$IFNDEF NOTIS}
   {
   NextTool := TSMO_10_Selector.Create;
   NextTool := TSMO_5_Selector.Create;
   }
   (*
   T := TPointSelector.Create;
   T.Name := 'Vybrn bod';
   NextTool := T;
   T := TLineSelector.Create;
   T.Name := 'Vybrn lini';
   NextTool := T;

   T := TAreaSelector.Create;
   T.Name := 'Vybrn ploch';
   NextTool := T;
*)
(*
   T := TPointCollector.Create;
   T.Name := 'Snmn bod';
   NextTool := T;
   *)
{$ENDIF}
   NextTool := TViewer.Create;
end;

procedure   TFormToolManager.SetActiveToolIndex(aIndex: longInt);
begin
   if aIndex = FActiveToolIndex then exit;
   inherited SetActiveToolIndex(aIndex);
end;

procedure   TFormToolManager.SetNextTool(aTool: TInteractiveTool);
begin
   aTool.Device := Device;
   aTool.Manager:= Self;
   AddTool(aTool);
   ActiveTool := aTool;
   CheckMenuItem(aTool.ClassName);
end;

function    TFormToolManager.GetVisible: boolean;
begin
  if Form = nil then exit;
   try
      result := Form.Visible;
   except
      result := false;
   end;
end;

procedure   TFormToolManager.SetVisible(aVisible: boolean);
begin
  if Form = nil then exit;
   try
      Form.Visible := aVisible;
      Device.SetupPage(nil);
   except
   end;
end;


function    TFormToolManager.GetMainMenu: TMainMenu;
begin
  result:= nil;
  if Form = nil then exit;
   result := Form.MainMenu;
end;

function    TFormToolManager.GetCaption: string;
begin
  result:= '';
  if Form = nil then exit;

   result := Form.Caption;
end;

procedure   TFormToolManager.SetCaption(const aValue: string);
begin
  if Form = nil then exit;
   Form.Caption := aValue;
end;


function    TFormToolManager.GetFormCursor: TCursor;
begin
  result:= 0;
  if Form = nil then exit;
//o.s.   result := Form.PaintBox.Cursor;
   result := Form.Image.Cursor;
end;


procedure   TFormToolManager.SetFormCursor(AValue: TCursor);
begin
  if Form = nil then exit;
//   Form.PaintBox.Cursor := aValue;
   Form.Image.Cursor := aValue;
end;



function    TFormToolManager.FindMenuItem(const aText: string): TMenuItem;
var
   i: longInt;
   Item: TMenuItem;
begin
   result := nil;
   for i := 0 to MainMenu.Items.Count -1 do
   begin
      Item := MainMenu.Items.Items[i];
      if UpperCase(Item.Name) = UpperCase(aText) then
      begin
         result := Item;
         exit;
      end;
   end;
end;


function    TFormToolManager.FindMenuItemIn(const aMenu, aItem: string): TMenuItem;
var
   ToolsIndex: longInt;
   i: longInt;
   Item: TMenuItem;
   SubItem: TMenuItem;
begin
   result := nil;
   Item := FindMenuItem(aMenu);
   for i := 0 to Item.Count -1 do
   begin
      SubItem := Item.Items[i];
      if UpperCase(SubItem.Name) = UpperCase(aItem) then
      begin
         result := SubItem;
         exit;
      end;
   end;
end;


procedure   TFormToolManager.CheckMenuItem(const aItem: string);
var
   ToolsIndex: longInt;
   i: longInt;
   Item: TMenuItem;
   SubItem: TMenuItem;
begin
   Item := FindMenuItem('TOOLS');
   for i := 0 to Item.Count -1 do
   begin
      SubItem := Item.Items[i];
      if UpperCase(SubItem.Name) = UpperCase(aItem) then SubItem.Checked := true
                                                    else SubItem.Checked := false;
   end;
end;


function    TFormToolManager.AddTool(aTool: TTool): TTool;
var
   ToolsIndex: longInt;
   i: longInt;
   aMenu, Item: TMenuItem;
begin
   inherited AddTool(aTool);
   result:= aTool;
   aMenu := FindMenuItem('Tools');
   Item  := TMenuItem.Create(aMenu);
   Item.Name := aTool.ClassName;
   Item.Caption := aTool.Name;
   Item.OnClick := TInterActiveTool(aTool).Select;
   aMenu.Add(Item);
end;


function    TFormToolManager.InsertTool(aIndex: longInt; aTool: TTool): TTool;
begin
   result :=  inherited InsertTool(aIndex, aTool);
end;

procedure   TFormToolManager.RemoveTool(aTool: TTool);
var
   MI: TMenuItem;
begin
   MI := FindMenuItemIn('TOOLS',aTool.ClassName);
   MI.Free;
   inherited RemoveTool(aTool);
end;

procedure   TFormToolManager.FreeTool(aTool: TTool);
var
   MI: TMenuItem;
begin
   MI := FindMenuItemIn('TOOLS',aTool.ClassName);
   MI.Free;
   inherited FreeTool(aTool);
end;

procedure   TFormToolManager.FreeTools;
var
   i: longInt;
begin
   for i := 0 to Tools.Count do
   begin
      FreeTool(TTool(Tools.Elements[i]));
   end;
end;

function    TFormToolManager.FindToolByIcon(aIcon: TIcon): TInteractiveTool;
begin
end;

procedure   TFormToolManager.Show;
begin
   Visible := true;
end;


procedure   TFormToolManager.ShowAll;
begin
  if FInput = nil then exit;
  try
     if FInput is TRectEntity then
     begin
        Device.Projection.ChangeProjectionByRectangle(TRectEntity(FInput).Rect, Device.Page);
     end
     else
     if FInput is TCoordinate then
     begin
        Device.Projection.ChangeProjectionByRect(TCoordinate(FInput).GetRegion, Device.Page);
     end;
  except
  end;
end;



procedure   TFormToolManager.on_tm_Open(var Handled: boolean);
begin
end;
(*
var
   Loader: TLoader;
   SelEl: TElement;
   SwapG: boolean;
begin
   if Form.OpenDialog.Execute then
   begin
      SwapG := true;
      Loader := TLoader.CreateAll(Form.OpenDialog.FileName);
      try
         Form.OpenDialog.InitialDir := ExtractFilePath(Form.OpenDialog.FileName);
         Loader.DoIt;
         Input := Loader.Output;
         Loader.Output.Free;
         PostMsg(tm_Review, Self, nil, DontKill);
      except
      end;
      Loader.Free;
   end
end;
*)

procedure   TFormToolManager.on_tm_SaveAs(var Handled: boolean);
begin
end;
(*
var
   Saver: TSaver;
begin
   Form.SaveDialog.InitialDir := Form.OpenDialog.InitialDir;
   Form.SaveDialog.FileName   := Form.OpenDialog.FileName;
   if Form.SaveDialog.Execute then
   begin
      Form.OpenDialog.InitialDir := ExtractFilePath(Form.SaveDialog.FileName);
      Form.OpenDialog.FileName := Form.SaveDialog.FileName;
      if Input = nil then exit;
      Input.ResetID;
      Saver := TSaver.CreateAll(Form.SaveDialog.FileName);
      Saver.Input := Input;
      Saver.DoIt;
      Saver.Free
   end;
end;
*)



procedure   TFormToolManager.On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   Coord: TDoubleCoord;

begin
  if Form = nil then exit;
    Handled := true;
    begin
       Coord := Device.Projection.GetModelPoint(aMessage.x, aMessage.y);
       Form.l_x.Caption := FloatToStrF(Coord.x, ffFixed, 12, 3);
       Form.l_y.Caption := FloatToStrF(Coord.y, ffFixed, 12, 3);
    end;
end;

procedure TFormToolManager.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   P: Wintypes.TPoint;
begin
  if Form = nil then exit;
   Handled := true;
   if aMessage.Button = mbRight then
   begin
      {
      if Interpret.Busy then
      begin
         PostMouseEvent(tm_MouseDown, Self, aMessage.Button,
                        aMessage.Shift, aMessage.X, aMessage.Y, aMessage.ActiveDevice);
         exit;
      end;
      }
      P := Point(aMessage.x, aMessage.y);
//      P := Form.PaintBox.ClientToScreen(P);
      P := Form.Image.ClientToScreen(P);
      Form.PopupMenu1.PopUp(P.x,P.y);
   end;
end;



procedure TFormToolManager.On_tm_MouseWheelDown(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   dx,dy: integer;
   _X,_Y: double;
begin
   if Handled then exit;
   Handled := true;
   dx := aMessage.X - (Device.Page.Width div 2);
   dy := aMessage.Y - (device.Page.Height div 2);
   _X := Device.Projection.GetModelX(aMessage.x);
   _Y := Device.Projection.GetModelY(aMessage.y);
   Scale:= Scale * 1.5;
   Device.Projection.Center_X := _X - Device.Projection.GetModelLengthHoriz(dX);
   Device.Projection.Center_Y := _Y + Device.Projection.GetModelLengthVert(dY);
   PostMsg(tm_BreakAndReView, Self, nil, DontKill);
//   PostMsg(tm_ProjectionChanged, Self, Device.Projection, false);
end;

procedure TFormToolManager.On_tm_MouseWheelUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   dx,dy: integer;
   _X,_Y: double;
begin
   if Handled then exit;
   Handled := true;
   dx := aMessage.X - (Device.Page.Width div 2);
   dy := aMessage.Y - (device.Page.Height div 2);
   _X := Device.Projection.GetModelX(aMessage.X);
   _Y := Device.Projection.GetModelY(aMessage.Y);
   Scale:= Scale * 0.75;
   Device.Projection.Center_X := _X - Device.Projection.GetModelLengthHoriz(dX);
   Device.Projection.Center_Y := _Y + Device.Projection.GetModelLengthVert(dY);
   PostMsg(tm_BreakAndReView, Self, nil, DontKill);
//   PostMsg(tm_ProjectionChanged, Self, Device.Projection, false);
end;

procedure   TFormToolManager.on_tm_QuitTask;
begin
   if Interpret.Busy then
   begin
      Status := Status + [st_DIE];
      Interpret.BreakWork := true;
   end
   else
   begin
     if Form <> nil then
        Form.Free;
      inherited on_tm_QuitTask;
   end;
end;

procedure   TFormToolManager.on_tm_Done(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   Handled := true;
   if aMessage.Sender is TUniversalInterpret then
   begin
      //ShowMessage('Done');
      if st_DIE in Status then
      begin
        if Form <> nil then
           Form.Free;
         inherited on_tm_QuitTask;
      end
      else
      if st_BREAK_AND_DOIT in Status then
      begin
         Status := Status - [st_BREAK_AND_DOIT];
         DoIt;
      end
      else
      if CLoseAfterPrinting then PostMsg(tm_Print, Self, nil, DontKill);
   end;
end;


procedure   TFormToolManager.on_tm_ToolSelected(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   if not (aMessage.Data is TInterActiveTool) then exit;

   if ActiveTool is TInterActiveTool then
      TInterActiveTool(ActiveTool).On_DeActivate;

   ActiveTool := TInterActiveTool(aMessage.Data);
   TInterActiveTool(ActiveTool).Device := Device;
   ActiveTool.Input  := Self.Input;
   TInterActiveTool(ActiveTool).On_Activate;
   Handled := true;
   CheckMenuItem(ActiveTool.ClassName);
   FormCursor := TInterActiveTool(ActiveTool).Cursor;
end;

procedure   TFormToolManager.on_tm_Print(var Handled: boolean);
var
   P: TPrint;
   Tiled: boolean;
   TileO: boolean;
begin
   //PrintToThisFile := PrintToFileName;
   Tiled := Form.Tile.Checked;
   if Interpret is TUniversalInterpret then
   begin
      TileO := TUniversalInterpret(Interpret).Tile;
      if TileO <> Tiled then
         TUniversalInterpret(Interpret).Tile := Tiled;
   end;
   P := TPrint.Create;
   P.Input := Interpret;
   if PrintToFileName <> '' then
      P.Title := AppString + ' ' + ExtractFileName(PrintToFileName)
   else
      P.Title := AppString + ' ' + Caption;
   P.FileName := PrintToFileName;
   P.SilentMode := SilentMode;
   P.DoIt;
   P.Free;
   if Interpret is TUniversalInterpret then
      TUniversalInterpret(Interpret).Tile := TileO;
end;


procedure TFormToolManager.ShowScale(aVal: string);
begin
   try
       if (Form <> nil) and (Form.l_m <> nil) then
          Form.l_M.Caption := aVal;
   except
   end;
end;



procedure   TFormToolManager.On_tm_ReView(var aMessage: TOrbisMessage; var Handled: boolean);
var
   s: string;
begin
   if Interpret.Busy then
   begin
      Status := Status + [st_BREAK_AND_DOIT];
      Interpret.BreakWork := true;
      exit;
   end;
   Device.Pen.Mode:= pmCopy; { novinka 10.6.97 }

   inherited On_tm_ReView(aMessage, Handled);

   if Scale < 10 then
   begin
      Str(Device.Projection.Scale:0:3,S);
   end
   else S := IntToStr(round(Device.Projection.Scale));

   ShowScale(S);
   //if CLoseAfterPrinting then PostMsg(tm_Print, Self, nil, DontKill);
   if ActiveTool <> nil then PostMsg(tm_Review,ActiveTool,nil,dontkill);
   Application.ProcessMessages;
   PostMsg(tm_Done, nil, self, dontKill);
end;


procedure TFormToolManager.On_tm_Resize(var Handled: boolean);
var
   i: longInt;
begin
   Handled := true;
   {
   PostMsg(tm_BreakInterpret, Self, nil, DontKill);
   }
   PostMsg(tm_BreakInterpret, Self, nil, DontKill);
   Application.ProcessMessages;
   Device.SetupPage(nil);
   PostMsg(tm_BreakAndReView, Self, nil, DontKill);
end;

procedure TFormToolManager.On_tm_RePaint(var Handled: boolean);
var
   i: longInt;
begin
   Handled := true;
   {
   PostMsg(tm_BreakInterpret, Self, nil, DontKill);
   }
   if assigned(Form) then
      Form.Image.Refresh;
end;



procedure TFormToolManager.On_tm_EndOfPrint(var Handled: boolean);
begin
   Handled := true;
   if CloseAfterPrinting then
   begin
      PostMsgToOwners(tm_EndOfPrint, nil, DontKill);
      on_tm_QuitTask;
   end;
end;



procedure TFormToolManager.On_tm_NewScale(var Handled: boolean);
var
   aForm: TF_SetScale;
   D: double;
begin
  try
    Application.CreateForm(Tf_SetScale, aForm);
    try
      aForm.Combo.Text := IntToStr(round(Scale));
      case aForm.ShowModal of
         mrOK:
         begin
            D:= StrToExtended(aForm.Combo.Text);
            if D > 0 then
            begin
              Scale := D;
              PostMsg(tm_BreakAndReView, self, nil, DontKill);
              Handled:= true
            end
            else
              ShowAll
         end;
      end;
    finally
      aForm.Free;
    end
  except
  end
end;


procedure   TFormToolManager.On_tm_ShowAll(var Handled: boolean);
begin
  ShowAll;
  PostMsg(tm_BreakAndReView, self, nil, DontKill);
  Handled:= true
end;



procedure TFormToolManager.On_tm_Keydown(var aMessage: TOrbisKeyEvent; var Handled: boolean);
begin
   case aMessage.Key of
      VK_F5:
      begin
         Scale:= Scale / 2;
         PostMsg(tm_BreakAndReView, Self, nil, DontKill);
      end;
      VK_F6:
      begin
         Scale:= Scale * 2;
         PostMsg(tm_BreakAndReView, Self, nil, DontKill);
      end;
      VK_ESCAPE:
      begin
         PostMsg(tm_BreakInterpret, Self, nil, DontKill);
      end;
   end;
end;



procedure TFormToolManager.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   Handled := false;
   try
     if (ActiveTool <> nil) and (aMessage.Message <> tm_Review) then
        ActiveTool.HandleMessage(aMessage, Handled);
   except
   end;
   if Handled then exit;
   inherited HandleMessage(aMessage, Handled);
   if Handled then exit;
   case aMessage.Message of
      tm_ToolSelected: on_tm_ToolSelected(aMessage, Handled);
      tm_Print:        on_tm_Print(Handled);
      tm_EndOfPrint:   on_tm_EndOfPrint(Handled);
      tm_Open:         on_tm_Open(Handled);
      tm_SaveAs:       on_tm_SaveAs(Handled);
      tm_NewScale:     on_tm_NewScale(Handled);
      tm_ShowAll:      on_tm_ShowAll(Handled);
      tm_RePaint:      on_tm_RePaint(Handled);
      tm_QuickView:    on_tm_QuickView(Handled);
   end;
end;



procedure TFormToolManager.SetQuickView(const Value: boolean);
begin
  if Form = nil then exit;
  FQuickView := Value;
  if Form.b_QuickView.Down <> Value then
     Form.b_QuickView.Down := Value;
end;

procedure TFormToolManager.On_tm_QuickView(var Handled: boolean);
begin
   QuickView := not QuickView;
end;

procedure TFormToolManager.SetSimpleMenu(const Value: boolean);
begin
   Form.Soubor1.Visible := not Value;
   Form.Struktura1.Visible := not Value;
   Form.ObjektyzExploreru.Visible := not Value;
   Form.Tools.Visible := not Value;
   Form.Storno2.Visible := not Value;
   Form.Model1.Visible := not Value;
   ActiveToolName := 'Prohle';
end;

procedure TFormToolManager.SetPrintToFileName(const Value: string);
begin
  FPrintToFileName := Value;
end;

procedure TFormToolManager.SetPrintIt(const Value: boolean);
var
   b: boolean;
begin
   on_tm_Print(b);
end;

procedure TFormToolManager.SetSilentMode(const Value: boolean);
begin
  FSilentMode := Value;
end;

function TFormToolManager.GetTile: boolean;
begin
   result := Form.Tile.Checked;
end;

procedure TFormToolManager.SetTile(const Value: boolean);
begin
   Form.Tile.Checked := Value;
   if (Interpret is TUniversalInterpret) then
   begin
      TUniversalInterpret(Interpret).Tile := Value;
      TUniversalInterpret(Interpret).TilePart := Value;
   end;
end;

procedure TFormToolManager.SetOnPrinterChangedScript(const Value: string);
begin
   FOnPrinterChangedScript := Value;
end;

procedure TFormToolManager.SetPrinterCHanged(const Value: boolean);
begin
   if not Value then exit;
   if OnPrinterChangedScript <> '' then
   begin
      PostTextMsg(tm_Run,OnPrinterChangedScript,nil);
      Application.ProcessMessages;
   end;
end;

{ TViewer }

function  TViewer.GetName: string;
begin
   result := 'Prohle';
end;


function  TViewer.GetCursor: TCursor;
begin
{$IFDEF Win32}
   result := cr_MoveCenter;
{$ELSE}
   result := cr_Lupa;
{$ENDIF}
end;


procedure TViewer.On_tm_Keydown(var aMessage: TOrbisKeyEvent; var Handled: boolean);
begin
   Handled := false;
   {
   if aMessage.Key = VK_ESCAPE then PostMsgToOwners(tm_BreakInterpret, nil, DontKill);
   }
   case aMessage.Key of
      VK_F5:
      begin
         Scale:= Scale / 2;
         PostMsg(tm_BreakAndReView, Self, nil, DontKill);
      end;
      VK_F6:
      begin
         Scale:= Scale * 2;
         PostMsg(tm_BreakAndReView, Self, nil, DontKill);
      end;
      VK_ESCAPE:
      begin
         PostMsg(tm_BreakInterpret, Self, nil, DontKill);
      end;
   end;

end;

procedure TViewer.On_tm_MouseDown(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
   {
   if isPickUpMode then
   begin
     if Button = mbLeft then
     begin
       TCanvasDevice(Tool.Device).CurX:= X;
       TCanvasDevice(Tool.Device).CurY:= Y;
       Tool.PostMsg(tm_PickUpObject, Tool, nil)
     end
     else
     if Button = mbRight then
     begin
     end
   end
   else
   }
   Application.ProcessMessages;
   PostMsgToOwners(tm_BreakInterpret, nil, DontKill);
   if aMessage.Button = mbLeft then
   begin
      Device.Pen.Mode  := pmXOR;
      Device.Pen.Color := clGreen;
      Device.Pen.Style := psSolid;
      ShiftRect := Rect(aMessage.x,aMessage.y,aMessage.x,aMessage.y);
      TCanvasDevice(Device).Canvas.Pen.Width := 3;
      with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
      Handled := true;
   end;
end;

procedure TViewer.On_tm_MouseUp(var aMessage: TOrbisMouseEvent; var Handled: boolean);
var
   R: TDoubleRect;
begin
    Handled := true;
    if aMessage.Button = mbLeft then
    begin
       if not aMessage.ActiveDevice then exit;
       with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
       TCanvasDevice(Device).Canvas.Pen.Mode  := pmCopy;
       TCanvasDevice(Device).Canvas.Pen.Color := clBlack;
       TCanvasDevice(Device).Canvas.Pen.Width := 1;
       with ShiftRect do
       begin
          if (Right-Left <= 2) and (Bottom - Top <= 2) then
          begin
             Device.Projection.CenterPoint := Device.Projection.GetModelPoint(aMessage.x,aMessage.y);
             PostMsgToOwners(tm_BreakAndReView, nil, DontKill);
             exit;
          end
          else
          begin
             R := Device.Projection.GetModelRect(Left, Top, Right, Bottom);
             TCanvasDevice(Device).Projection.ModelView := R;
             PostMsgToOwners(tm_BreakAndReView, nil, DontKill);
          end;
       end;
       {
       if ssCtrl in Shift then
       begin
         aTool:= TTechnology(World.MainTool).AddTool(TInterpretBloku.Create);
         if assigned(aTool) then
         begin
           aTool.Input:= TEntity(World.ObjectModel).FindElementClass(TTopoLPredmetZajmu);
           TInterpret(aTool).Device := TVMSDevice.Create;
           TInterpret(aTool).Device.Projection.ChangeProjectionByRect(R,
                                                      TInterpret(aTool).Device.Page);

           TInterpret(aTool).Device.Page.Color:= clWhite;
           TInterpret(aTool).Device.Reset;
           aTool.DoIt;
           TInterpret(aTool).Device.Close
         end;
       end
       else
       }
       {
       begin
          TCanvasDevice(Device).Projection.ModelView := R;
          PostMsgToOwners(tm_ReView, nil);
       end;
       }
    end
    else Handled := false;
end;

procedure TViewer.On_tm_MouseMove(var aMessage: TOrbisMouseEvent; var Handled: boolean);
begin
   Handled := false;
   if not aMessage.ActiveDevice then exit;
   if  ssLeft in aMessage.Shift then
   begin
      Device.Pen.Mode  := pmXOR;
      Device.Pen.Color := clGreen;
      Device.Pen.Style := psSolid;
      TCanvasDevice(Device).Canvas.Pen.Width := 3;
      with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
      ShiftRect.Right  := aMessage.x;
      ShiftRect.Bottom := aMessage.y;
      with ShiftRect do TCanvasDevice(Device).Canvas.Rectangle(Left, Top, Right, Bottom);
   end;
end;


BEGIN
   RegisterOrbisClass(TFormToolManager);
END.
