unit M_intera;
{
*********************************************************************
*                                                                   *
*  ORBIS ... Tdy udlost interaktivnch nstroj                 *
*                                                                   *
*                       Topol Pro 1996                             *
*********************************************************************
}

{
[Unit_Description]
Description=Zkladn tdy interaktivnch nstroj
Admin=Petr
TechTopic=Interactive Tool
Topic=Uivatelsk rozhran
Version=1.0

[Edit]
11.8.1997 11:32=Registrace
}


interface
uses
   Classes,
   Controls,
   Elements;

type

TOrbisCursorEvent = class(TOrbisMessage)
protected
   FCursor: integer;
public
   constructor CreateAll(aMessage: longInt; aSender, aReceiver: TElement;
                         aCursor: integer);
   property    Cursor: integer read FCursor write FCursor;
end;

TOrbisShiftEvent = class(TOrbisMessage)
 protected
   FShift: TShiftState;
 public
   constructor CreateAll(aMessage: longInt; aSender, aReceiver: TElement;
                         aShift: TShiftState);

   property Shift: TShiftState read FShift write FShift;
end;



 TOrbisMouseEvent = class(TOrbisShiftEvent)
 protected
   FButton: TMouseButton;
   FX, FY: Integer;
   FActiveDevice: boolean;
 public
   constructor CreateAll(aMessage: longInt; aSender, aReceiver: TElement;
                         aShift: TShiftState; aButton: TmouseButton; aX, aY: integer; Active: boolean);

   property Button: TMouseButton read FButton write FButton default mbLeft;
   property X: integer read FX write FX default 0;
   property Y: integer read FY write FY default 0;
   property ActiveDevice: boolean read FActiveDevice write FActiveDevice;
end;

TOrbisKeyEvent = class(TOrbisShiftEvent)
 protected
   FKey: word;
 public
   constructor CreateAll(aMessage: longInt; aSender, aReceiver: TElement;
                         aShift: TShiftState; aKey: word);

   property Key: word read FKey write FKey default 0;
end;

TOrbisExternalDeviceEvent = class(TOrbisMessage)
 protected
   FButton: integer;
   FX, FY: double;
 public
   constructor CreateAll(aMessage: longInt; aSender, aReceiver: TElement;
                         aButton: integer; aX, aY: double);

   property Button: integer read FButton write FButton default 0;
   property X: double read FX write FX;
   property Y: double read FY write FY;
end;


implementation


{ TOrbisShiftEvent }

constructor TOrbisShiftEvent.CreateAll(aMessage: longInt; aSender, aReceiver: TElement;
                                       aShift: TShiftState);
begin
   inherited CreateAll(aMessage, aSender, aReceiver, nil, DontKill);
   Shift := aShift;
end;


{ TOrbisMouseEvent }

constructor TOrbisMouseEvent.CreateAll(aMessage: longInt; aSender, aReceiver: TElement;
                         aShift: TShiftState; aButton: TmouseButton; aX, aY: integer; Active: boolean);
begin
   inherited CreateAll(aMessage, aSender, aReceiver, aShift);
   Button := aButton;
   X := aX;
   Y := aY;
   ActiveDevice := Active;
end;

{ TOrbisKeyEvent }

constructor TOrbisKeyEvent.CreateAll(aMessage: longInt; aSender, aReceiver: TElement;
                         aShift: TShiftState; aKey: word);
begin
   inherited CreateAll(aMessage, aSender, aReceiver, aShift);
   Key := aKey;
end;

{ TOrbisCursorEvent }

constructor TOrbisCursorEvent.CreateAll(aMessage: Integer; aSender,
  aReceiver: TElement; aCursor: integer);
begin
   inherited CreateAll(aMessage, aSender, aReceiver, nil, DontKill);
   Cursor := aCursor;
end;

{ TOrbisExternalDeviceEvent }

constructor TOrbisExternalDeviceEvent.CreateAll(aMessage: Integer; aSender,
  aReceiver: TElement; aButton: integer; aX, aY: double);
begin
   inherited CreateAll(aMessage, aSender, aReceiver, nil, DontKill);
   Button := aButton;
   X := aX;
   Y := aY;
end;

end.
