unit E_Index;

interface
uses
   Classes,
// KERNEL
   Elements,
   E_Class;

type

TOnAddElement = procedure (anElement: TElement; var aValue: string) of Object;

TElementIndex = class(TNameElement)
private
  FStringList : TStringList;
  FElementClass: TElementClass;
  FValue: string;
  FOnAddElement: TOnAddElement;

  function GetElement: TElement;
  procedure SetEntity(const Value: TEntity);
  procedure SetValue(const Value: string);
  procedure OnAddElement1(anElement: TElement; var aValue: string);
    function GetCount: integer;
    function GetElementIndex: integer;
    procedure SetElementIndex(const Value: integer);
    function GetSorted: Boolean;
    procedure SetSorted(const Value: Boolean);
    function GetStringList: TStringList;
public
  constructor Create; override;
  procedure AddElement(anElement: TElement);
  property StringList: TStringList read GetStringList;
published
  procedure Sort;
  property ElementClass: TElementClass read FElementClass write FElementClass;
  property Entity: TEntity write SetEntity;
  property Value: string read FValue write SetValue;
  property Element: TElement read GetElement;
  property Count: integer read GetCount;
  property ElementIndex: integer read GetElementIndex write SetElementIndex;
  property Sorted: Boolean read GetSorted write SetSorted;
  property OnAddElement: TOnAddElement read FOnAddElement write FOnAddElement;
end;





implementation

uses
  Forms,
  F_Gauge;


procedure TElementIndex.OnAddElement1(anElement: TElement; var aValue: string);
begin
  aValue:= anElement.Name + anElement.GetPropertyStringByName('SPACEID');
end;



{ TElementIndex }


constructor TElementIndex.Create;
begin
  OnAddElement:= OnAddElement1;
end;


procedure TElementIndex.AddElement(anElement: TElement);
var
  aVal: string;
begin
  if not Assigned(FOnAddElement) then
     Exit;

  FOnAddElement(anElement, aVal);

  StringList.AddObject(aVal, anElement);
end;



function TElementIndex.GetElement: TElement;
var
  I: integer;
begin
  Result:= nil;
  if StringList = nil then
     Exit;
  I:= StringList.IndexOf(FValue);

  if I>= 0 then
     Result:= TElement(StringList.Objects[I])
end;



procedure TElementIndex.SetEntity(const Value: TEntity);
var
  I: integer;
  anEl: TElement;
  FGauge: TF_gaugeForm;
begin
  FGauge:= TF_gaugeForm.Create(Application);
  FGauge.MaxValue:= Value.Count;
  FGauge.Show;
  for I:= 0 to Value.Count-1 do
  begin

    if I mod 100 = 0 then
       FGauge.Progress:= I;

    anEl:= Value.Elements[I];
    if ElementClass = nil then
       AddElement(anEl)
    else
    if (anEl is ElementClass) then
       AddElement(anEl)
  end;
  FGauge.Free
end;



procedure TElementIndex.SetValue(const Value: string);
begin
  FValue:= Value;
end;


function TElementIndex.GetCount: integer;
begin
  result:= 0;
  if StringList = nil then
     exit;
  result:= StringList.Count;
end;

function TElementIndex.GetElementIndex: integer;
begin
  result:= -1;
  if StringList = nil then
     exit;
  if FValue = '' then
     exit;
  result:= StringList.IndexOf(FValue)
end;


procedure TElementIndex.SetElementIndex(const Value: integer);
begin
  if StringList = nil then
     Exit;
  if Value < 0 then
     Exit;
  FValue:= stringList.Strings[Value];
end;




function TElementIndex.GetSorted: Boolean;
begin
  Result:= False;
  if StringList = nil then
     Exit;
  Result:= StringList.Sorted
end;

procedure TElementIndex.SetSorted(const Value: Boolean);
begin
  if StringList = nil then
     Exit;
  StringList.Sorted:= True;
end;

procedure TElementIndex.Sort;
begin
  if StringList = nil then
     Exit;
  StringList.Sort
end;

function TElementIndex.GetStringList: TStringList;
begin
  result:= nil;
  if not Assigned(FStringList) then
  begin
    FStringList:= TStringList.Create;
    FStringList.Sorted:= True;
  end;
  Result:= FStringList;
end;


begin
   RegisterOrbisClass(TElementIndex);
end.
