unit f_Synchronize_TABLE_ForestModel;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Gauges, ExtCtrls, DB,
{$IFNDEF WIN64}
  DBTables,
{$ELSE}
  DBF,
{$ENDIF}
  e_LHCModel,
  Tools, Spin;

type
  TSynchronize_TABLE_ForestModel_Form = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    ed_TableName: TEdit;
    p_Dioda: TPanel;
    Panel2: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ed_LHC: TComboBox;
    ed_ODD: TComboBox;
    ed_DIL: TComboBox;
    ed_POR: TComboBox;
    Panel3: TPanel;
    Label7: TLabel;
    ed_1: TComboBox;
    ed_2: TComboBox;
    ed_3: TComboBox;
    ed_4: TComboBox;
    ed_5: TComboBox;
    Panel4: TPanel;
    Gauge: TGauge;
    l_Err: TLabel;
    Panel5: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label13: TLabel;
    ed_PSK: TComboBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    OpenDialog: TOpenDialog;
{$IFNDEF WIN64}
    Table: TTable;
{$ELSE}
    Table: TDBF;
{$ENDIF}
    cb_Protocol: TCheckBox;
    cb_CHeck: TCheckBox;
    cb_BZL: TCheckBox;
    ed_BZL: TSpinEdit;
    procedure SpeedButton1Click(Sender: TObject);
    procedure ed_TableNameChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure cb_ProtocolClick(Sender: TObject);
  private
    FFieldList: TStringList;
    FForestModel: Tgis_ForestModel;
    FProtocol: boolean;
    FTool: TTool;
    procedure SetFieldList(const Value: TStringList);
    procedure SetForestModel(const Value: Tgis_ForestModel);
    procedure SetProtocol(const Value: boolean);
    procedure SetTool(const Value: TTool);
    { Private declarations }
  public
     procedure DoIt;
     function  Check: boolean;
     procedure FillFieldList;
     property FieldList: TStringList read FFieldList write SetFieldList;
     property ForestModel: Tgis_ForestModel read FForestModel write SetForestModel;
     property Protocol: boolean read FProtocol write SetProtocol;
     property Tool: TTool read FTool write SetTool;
  end;


implementation
uses
   e_Props,
   m_Orbis,
   Elements,
   t_Select,
   u_String;

{$R *.dfm}

{ TSynchronize_TABLE_ForestModel_Form }

procedure TSynchronize_TABLE_ForestModel_Form.DoIt;
var
   FindPSK: boolean;
   FindPor: boolean;
   UseLHC: boolean;
   Use1,Use2,Use3,Use4,Use5: boolean;
   LHC: integer;
   Oddeleni: integer;
   Dilec: string;
   Porost: string;
   Skupina: string;
   SS: string;
   F: TField;
   Errors,PErrors: integer;
   PSK: Tgis_PorostniSkupina;
   POR: Tgis_Porost;
   DIL: Tgis_Dilec;
   _LHC: Tgis_LHC;
   i: integer;
   EE: TElement;
   Sel: TAllSelector;
   SelE: TEntity;
   Solved: TEntity;
   NotSolved: TEntity;
   CheckOnly: boolean;
   bzl: boolean;
   bzlValue: integer;

   procedure PSKSet(aName, aValue: string);
   var
      S: string;
   begin
      if CheckOnly then
      begin
         S := PSK.GetPropertyStringByName(aName);
         if not AnsiSameText(S,aValue) then
         begin
            Tool.PostTextMsg(tm_AddToProtocol,' !CHK: '+IntToStr(LHC)+','+IntToStr(Oddeleni)+','+Dilec+','+Porost+','+Skupina+'  ::'+aName+':: L: '+S+' D: '+aValue,nil );
            Application.ProcessMessages;
         end;
      end
      else
      begin
         PSK.SetPropertyStringByName(aName,aValue);
      end;
   end;

   procedure ProcessSkupina;
   begin
      if PSK.Properties = nil then
         PSK.Properties := TDynamicProperties.Create;
      if Use1 then
      begin
         F := Table.FieldByName(ed_1.Text);
         if F <> nil then
         begin
            //PSK.SetPropertyStringByName(Edit1.Text,F.AsString);
            PSKSet(Edit1.Text,F.AsString);
         end;
      end;
      if Use2 then
      begin
         F := Table.FieldByName(ed_2.Text);
         if F <> nil then
         begin
            //PSK.SetPropertyStringByName(Edit2.Text,F.AsString);
            PSKSet(Edit2.Text,F.AsString);
         end;
      end;
      if Use3 then
      begin
         F := Table.FieldByName(ed_3.Text);
         if F <> nil then
         begin
            //PSK.SetPropertyStringByName(Edit3.Text,F.AsString);
            PSKSet(Edit3.Text,F.AsString);
         end;
      end;
      if Use4 then
      begin
         F := Table.FieldByName(ed_4.Text);
         if F <> nil then
         begin
            //PSK.SetPropertyStringByName(Edit4.Text,F.AsString);
            PSKSet(Edit4.Text,F.AsString);
         end;
      end;
      if Use5 then
      begin
         F := Table.FieldByName(ed_5.Text);
         if F <> nil then
         begin
            //PSK.SetPropertyStringByName(Edit5.Text,F.AsString);
            PSKSet(Edit5.Text,F.AsString);
         end;
      end;
   end;

begin
   LHC := -1;
   UseLHC := ed_LHC.Text <> '';
   if not UseLHC then
   begin
      _LHC := nil;
      if not ForestModel.NoElements then
         _LHC := Tgis_LHC(ForestModel.Elements[0]);
      if _LHC = nil then
      begin
         ShowMessage('Model LHC dn LHC neobsahuje!!!');
         exit;
      end;
      LHC := _LHC.Cislo;
      ForestModel.LHC_Cislo := LHC;
   end;
   CheckOnly := cb_CHeck.Checked;
   bzl := cb_BZL.Checked;
   bzlValue := ed_BZL.Value;
   Solved := TOwnerEntity.Create;
   Solved.Name := 'Solved';
   Tool.AddElement(Solved);
   NotSolved := TOwnerEntity.Create;
   NotSolved.Name := 'NotSolved';
   Tool.AddElement(NotSolved);
   FindPor := ed_POR.Text <> '';
   FindPSK := FindPor and (ed_PSK.Text <> '');
   if CheckOnly then
   begin
      if not FindPSK then
      begin
         ShowMessage('Kontrola funguje jen s adresac na rovni PSK!');
         exit;
      end;
   end;
   Use1 := (Edit1.Text <> '') and (ed_1.Text <> '');
   Use2 := (Edit2.Text <> '') and (ed_2.Text <> '');
   Use3 := (Edit3.Text <> '') and (ed_3.Text <> '');
   Use4 := (Edit4.Text <> '') and (ed_4.Text <> '');
   Use5 := (Edit5.Text <> '') and (ed_5.Text <> '');
   Table.First;
   Gauge.MaxValue := Table.RecordCount;
   Errors := 0;
   PErrors := 0;
   if Protocol then
   begin
      Tool.PostTextMsg(tm_AddToProtocol,'Synchronizace lesa s tabulkou: '+ed_TableName.Text,nil);
      Tool.PostTextMsg(tm_AddToProtocol,'START****',nil);
   end;
   //ForestModel.;
   while not Table.Eof do
   begin
      Gauge.Progress := Table.RecNo;
      if UseLHC then
      begin
         F := Table.FieldByName(ed_LHC.Text);
         if F = nil then exit;
         LHC := F.AsInteger;
      end;
      F := Table.FieldByName(ed_ODD.Text);
      if F = nil then exit;
      Oddeleni := F.AsInteger;
      F := Table.FieldByName(ed_DIL.Text);
      if F = nil then exit;
      Dilec := F.AsString;
      Porost := '';
      if FindPor then
      begin
         F := Table.FieldByName(ed_POR.Text);
         if F = nil then exit;
         Porost := F.AsString;
      end;
      Skupina := '';
      if FindPSK then
      begin
         F := Table.FieldByName(ed_PSK.Text);
         if F = nil then exit;
         SKupina := F.AsString;
         if bzl and (StringToInteger(Skupina) > bzlValue) then
         begin
            Table.Next;
            Continue;
         end;
      end;
      ForestModel.LHC_Cislo := LHC;
 { TODO -oPPK -cZkontrolovat : synchronizace DBF... zkontrolovat }
      ForestModel.ActualLS := nil;
      ForestModel.Oddeleni_Cislo := Oddeleni;
      ForestModel.Dilec_Name := Dilec;
      DIL := ForestModel.ActualDilec;
      if FindPor then
      begin
         ForestModel.Porost_Name := Porost;
         POR := ForestModel.ActualPorost;
         EE := POR;
      end
      else
         EE := DIL;

      if EE <> nil then
      begin
         if FindPSK then
         begin
            ForestModel.Skupina_Name := Skupina;
            PSK := ForestModel.ActualSkupina;
            if PSK = nil then
            begin
               inc(Errors);
               l_Err.Caption := 'Nenalezeno '+IntToStr(Errors)+' skupin';
               if Protocol then
               begin
                  Tool.PostTextMsg(tm_AddToProtocol,' -LED: '+IntToStr(LHC)+','+IntToStr(Oddeleni)+','+Dilec+','+Porost+','+Skupina,nil);
                  if Errors mod 50 = 0 then
                     Application.ProcessMessages;
               end;
            end
            else
            begin
               ProcessSkupina;
               Solved.AddElement(PSK);
            end;
         end
         else
         begin
            Solved.AddElement(EE);
            Sel := TAllSelector.Create;
            Sel.Input := EE;
            Sel.Condition := 'CLASS(Tgis_PorostniSkupina)';
            Sel.DoIt;
            if Sel.Output <> nil then
            begin
               SelE := TEntity(Sel.Output);
               for i := 0 to SelE.LastIndex do
               begin
                  PSK := Tgis_PorostniSkupina(SelE.Elements[i]);
                  ProcessSkupina;
               end;
               SelE.Free;
            end;
            Sel.Free;
         end;
      end
      else
      begin
         inc(PErrors);
         l_Err.Caption := 'Nenalezeno '+IntToStr(PErrors)+' porost';
         if Protocol then
         begin
            Tool.PostTextMsg(tm_AddToProtocol,' -LED: '+IntToStr(LHC)+','+IntToStr(Oddeleni)+','+Dilec+','+Porost,nil);
            if Errors mod 50 = 0 then
               Application.ProcessMessages;
         end;
      end;
      Table.Next;
   end;
   Sel := TAllSelector.Create;
   Sel.Input := ForestModel;
   if FindPSK then
      Sel.Condition := 'CLASS(Tgis_PorostniSkupina)'
   else
   if FindPor then
      Sel.Condition := 'CLASS(Tgis_Porost)'
   else
      Sel.Condition := 'CLASS(Tgis_Dilec)';
   Sel.DoIt;
   if Sel.Output <> nil then
   begin
      SelE := TEntity(Sel.Output);
      for i := 0 to SelE.LastIndex do
      begin
         EE := SelE.Elements[i];
         if not EE.IsMyOwner(Solved) then
         begin
            if FindPSK then
               if bzl and (StringToInteger(EE.Name) > bzlValue) then
                  Continue;
            NotSolved.AddElement(EE);
         end
      end;
      SelE.Free;
   end;
   Sel.Free;
   if Protocol then
   begin
      if NotSolved.Count > 0 then
      begin
         Tool.PostTextMsg(tm_AddToProtocol,' -----',nil);
         for i := 0 to NotSolved.LastIndex do
         begin
            EE := NotSolved.Elements[i];
            SS := EE.GetPropertyStringByName('LHC');
            SS := SS + ',' + EE.GetPropertyStringByName('Oddeleni');
            SS := SS + ',' + EE.GetPropertyStringByName('Dilec');
            if FindPor then
               SS := SS + ',' + EE.GetPropertyStringByName('Porost');
            if FindPSK then
               SS := SS + ',' + EE.GetPropertyStringByName('Skupina');
            Tool.PostTextMsg(tm_AddToProtocol,' -DB: '+SS,nil);
            Application.ProcessMessages;
         end;
      end;
      Tool.PostTextMsg(tm_AddToProtocol,'END ****',nil);
      Tool.PostTextMsg(tm_AddToProtocol,'konec Synchronizace lesa',nil);
      Application.ProcessMessages;
   end;
end;

procedure TSynchronize_TABLE_ForestModel_Form.FillFieldList;
var
   i: integer;
begin
   if not Table.Active then exit;
   FieldList.Clear;
   Table.First;
   for i := 0 to Table.FieldCount - 1 do
   begin
      FieldList.Add(Table.Fields.Fields[i].FieldName);
   end;
   ed_LHC.Items.Assign(FieldList);
   ed_ODD.Items.Assign(FieldList);
   ed_DIL.Items.Assign(FieldList);
   ed_POR.Items.Assign(FieldList);
   ed_PSK.Items.Assign(FieldList);
   ed_1.Items.Assign(FieldList);
   ed_2.Items.Assign(FieldList);
   ed_3.Items.Assign(FieldList);
   ed_4.Items.Assign(FieldList);
   ed_5.Items.Assign(FieldList);
end;

function TSynchronize_TABLE_ForestModel_Form.Check: boolean;
var
   S: string;
begin
   result := false;
   if not Table.Active then
   begin
      ShowMessage('DB Tabulka nen nastavena nebo nejde otevt ... Dal pokus !');
      ed_TableName.SetFocus;
      exit;
   end;
   S :=  ' je povinn(jako vechno co je erven)... znova!';
   if ed_ODD.Text = '' then
   begin
      ShowMessage('Poloka pro Oddlen'+S);
      ed_Odd.SetFocus;
      exit;
   end;
   if ed_DIL.Text = '' then
   begin
      ShowMessage('Poloka pro Dlec'+S);
      ed_DIL.SetFocus;
      exit;
   end;
   {
   if ed_POR.Text = '' then
   begin
      ShowMessage('Poloka pro Porost'+S);
      ed_POR.SetFocus;
      exit;
   end;
   }
   result := true;
end;

procedure TSynchronize_TABLE_ForestModel_Form.SetFieldList(
  const Value: TStringList);
begin
   if FFieldList <> nil then
      FFieldList.Free;
   FFieldList := Value;
end;

procedure TSynchronize_TABLE_ForestModel_Form.SetForestModel(
  const Value: Tgis_ForestModel);
begin
  FForestModel := Value;
end;

procedure TSynchronize_TABLE_ForestModel_Form.SpeedButton1Click(
  Sender: TObject);
begin
   if OpenDialog.Execute then
   begin
      ed_TableName.Text := OpenDialog.FileName;
   end;
end;

procedure TSynchronize_TABLE_ForestModel_Form.ed_TableNameChange(
  Sender: TObject);
begin
   p_Dioda.Color := clRed;
   if FileExists(ed_TableName.Text) then
   begin
      Table.Close;
      Table.TableName := ed_TableName.Text;
      Table.Open;
      if Table.Active then
         p_Dioda.Color := clLime;
      if not Table.Active then exit;
      FillFieldList;
   end;
end;

procedure TSynchronize_TABLE_ForestModel_Form.FormDestroy(Sender: TObject);
begin
   FieldList := nil;
end;

procedure TSynchronize_TABLE_ForestModel_Form.FormCreate(Sender: TObject);
begin
   FieldList := TStringList.Create;
end;

procedure TSynchronize_TABLE_ForestModel_Form.BitBtn1Click(
  Sender: TObject);
begin
   if not CHeck then exit;
   DoIt;
end;

procedure TSynchronize_TABLE_ForestModel_Form.cb_ProtocolClick(
  Sender: TObject);
begin
   Protocol := cb_Protocol.Checked;
end;

procedure TSynchronize_TABLE_ForestModel_Form.SetProtocol(
  const Value: boolean);
begin
  FProtocol := Value;
end;

procedure TSynchronize_TABLE_ForestModel_Form.SetTool(const Value: TTool);
begin
  FTool := Value;
end;

end.

