unit i_KatastrElements;

interface
uses
   Elements,
   i_AreaGeometryElement;

type

Tgis_KatastralElementInterpret = class(TGeometryAreaElementInterpret)
public
   function   GetElementClass: TElementClass; override;
   function   Get_Color(const Element: TElement): integer; override;
   function   Get_Symbol(const Element: TElement): integer; override;
end;

Tgis_KatastrInterpret = class(Tgis_KatastralElementInterpret)
public
   function   GetElementClass: TElementClass; override;
end;

Tgis_SkupinaParcelInterpret = class(Tgis_KatastralElementInterpret)
public
   function   GetElementClass: TElementClass; override;
end;

Tgis_ParcelaInterpret = class(Tgis_KatastralElementInterpret)
public
   function   GetElementClass: TElementClass; override;
end;

Tgis_ParcelaCastInterpret = class(Tgis_KatastralElementInterpret)
public
   function   GetElementClass: TElementClass; override;
end;

implementation
uses
   e_Class,
   e_KatastrModel;

{ Tgis_KatastralElementInterpret }

function Tgis_KatastralElementInterpret.GetElementClass: TElementClass;
begin
   result := Tgis_KatastralElement;
end;

function Tgis_KatastralElementInterpret.Get_Color(const Element: TElement): integer;
begin
   result := Tgis_KatastralElement(Element).Barva;
end;

function Tgis_KatastralElementInterpret.Get_Symbol(const Element: TElement): integer;
begin
   result := Tgis_KatastralElement(Element).Znacka;
end;



{ Tgis_SkupinaParcelInterpret }

function Tgis_SkupinaParcelInterpret.GetElementClass: TElementClass;
begin
   result := Tgis_SkupinaParcel;
end;

{ Tgis_ParcelaInterpret }

function Tgis_ParcelaInterpret.GetElementClass: TElementClass;
begin
   result := Tgis_Parcela;
end;

{ Tgis_ParcelaCastInterpret }

function Tgis_ParcelaCastInterpret.GetElementClass: TElementClass;
begin
   result := Tgis_ParcelaCast;
end;

{ Tgis_KatastrInterpret }

function Tgis_KatastrInterpret.GetElementClass: TElementClass;
begin
   result := Tgis_Katastr;
end;

INITIALIZATION
   RegisterOrbisClass(Tgis_KatastrInterpret);
   RegisterOrbisClass(Tgis_SkupinaParcelInterpret);
   RegisterOrbisClass(Tgis_ParcelaInterpret);
   RegisterOrbisClass(Tgis_ParcelaCastInterpret);
END.
