unit t_AnnotationDialog;

interface
uses
   f_TextAnnotationDialog,
   t_OrbisDialog;

type

TTextAnnotationDialog = class(TOrbisDialog)
  private
    FNoGeometry: boolean;
    FCanBeDeleted: boolean;
    FLink: boolean;
    FCanBeLinked: boolean;
    function GetForm: TTextAnnotationDialog_Form;
    function GetVisible: boolean;
    procedure SetVisible(const Value: boolean);
    procedure SetNoGeometry(const Value: boolean);
    procedure SetCanBeDeleted(const Value: boolean);
    procedure SetLink(const Value: boolean);
    procedure SetCanBeLinked(const Value: boolean);
    procedure SetFous(const Value: boolean);
    function GetFous: boolean;
    function GetZeroAngle: boolean;
    procedure SetZeroAngle(const Value: boolean);
public
   procedure DoIt; override;
   procedure CreateForm; override;
   property  Form: TTextAnnotationDialog_Form read GetForm;
published
   property IsVisible: boolean Read GetVisible write SetVisible;
   property NoGeometry: boolean read FNoGeometry write SetNoGeometry;
   property CanBeDeleted: boolean read FCanBeDeleted write SetCanBeDeleted;
   property Link: boolean read FLink write SetLink;
   property CanBeLinked: boolean read FCanBeLinked write SetCanBeLinked;
   property Fous: boolean read GetFous write SetFous;
   property ZeroAngle: boolean read GetZeroAngle write SetZeroAngle;
end;

implementation
uses
   Forms,
   e_Class;

{ TTextAnnotationDialog }

procedure TTextAnnotationDialog.CreateForm;
begin
   aForm := TTextAnnotationDialog_Form.Create(Application);
   aForm.Tool := Self;
   aForm.IsPossibleToClose := false;
end;

procedure TTextAnnotationDialog.DoIt;
begin
  inherited;

end;

function TTextAnnotationDialog.GetForm: TTextAnnotationDialog_Form;
begin
   result := TTextAnnotationDialog_Form(aForm);
end;

function TTextAnnotationDialog.GetFous: boolean;
begin
   result := Form.cb_Fous.Checked;
end;

function TTextAnnotationDialog.GetVisible: boolean;
begin
   result := Form.cb_Visible.Checked;
end;

function TTextAnnotationDialog.GetZeroAngle: boolean;
begin
   result := Form.cb_Angle.Checked;
end;

procedure TTextAnnotationDialog.SetCanBeDeleted(const Value: boolean);
begin
  FCanBeDeleted := Value;
  Form.b_Delete.Enabled := Value;
end;

procedure TTextAnnotationDialog.SetCanBeLinked(const Value: boolean);
begin
   FCanBeLinked := Value;
   Form.b_Link.Enabled := Value;
end;

procedure TTextAnnotationDialog.SetFous(const Value: boolean);
begin
  Form.cb_Fous.Checked := Value;
end;

procedure TTextAnnotationDialog.SetLink(const Value: boolean);
begin
   FLink := Value;
   if Value then
      Form.b_Link.Caption := 'Pipojit (text)'
   else
      Form.b_Link.Caption := 'Odpojit (text)';
end;

procedure TTextAnnotationDialog.SetNoGeometry(const Value: boolean);
begin
  FNoGeometry := Value;
  Form.b_Anchor.Enabled := not Value;
  Form.b_JoinNext.Enabled := not Value;
  Form.b_Link.Enabled := not Value;
end;

procedure TTextAnnotationDialog.SetVisible(const Value: boolean);
begin
   Form.cb_Visible.Checked := Value;
end;

procedure TTextAnnotationDialog.SetZeroAngle(const Value: boolean);
begin
   Form.cb_Angle.Checked := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TTextAnnotationDialog);
END.
