unit E_txtblk;

interface

uses
   Classes,
// KERNEL
   Elements,
// GLIB   
   g_Elems;


type

TTextBlock = class(TText)
private
   FLineHeight: double;
   FTextHeight: double;
   FLines: TStringList;
   FFileName: string;
   FDelimiter: string;
   FSorted: boolean;
   function  GetLineHeight: double;
   function  GetTextHeight: double;
   function  GetLines: TStringList;
   function  GetLinesCount: longInt;
   procedure SetLineHeight(aValue: double);
   procedure SetTextHeight(aValue: double);
   procedure SetLines(aValue: TStringList);
   procedure SetLinesPlus(aValue: TStringList);
   procedure SetSorted(aB: boolean);
   function  GetSorted: boolean;
   procedure SetFileName(aName: string);
public
   constructor Create; override;
   destructor  Destroy; override;
published
   property LineHeight: double read GetLineHeight write SetLineHeight;
   property TextHeight: double read GetTextHeight write SetTextHeight;
   property FileName: string read FFileName write SetFileName;
   property Lines: TStringList read GetLines write SetLines stored false;
   property LinesPlus: TStringList write SetLinesPlus stored false;
   property LinesCount: longInt read GetLinesCount stored false;
   property Delimiter: string read FDelimiter write FDelimiter;
   property Sorted: boolean read GetSorted write SetSorted stored false;
end;


implementation

uses
   SysUtils,
// KERNEL   
   e_Class;


{ TTextBlock }

constructor TTextBlock.Create;
begin
   LineHeight := 0.015;
   TextHeight := 0.01;
end;

destructor  TTextBlock.Destroy;
begin
   Lines := nil;
end;

function    TTextBlock.GetLineHeight: double;
begin
   result := FLineHeight;
end;

function    TTextBlock.GetTextHeight: double;
begin
   result := FTextHeight;
end;

function    TTextBlock.GetLines: TStringList;
begin
  if FLines = nil then
     FLines:= TStringList.Create;

  result := FLines;
end;

function    TTextBlock.GetLinesCount: longInt;
begin
   result := 0;
   if FLines = nil then exit;
   result := FLines.Count;
end;

procedure   TTextBlock.SetLineHeight(aValue: double);
begin
   FLineHeight := aValue;
end;

procedure   TTextBlock.SetTextHeight(aValue: double);
begin
   FTextHeight := aValue;
end;

procedure   TTextBlock.SetLines(aValue: TStringList);
begin
   if FLines <> nil then
   begin
      FLines.Free;
      FLines := nil;
   end;
   Flines := aValue;
   if FLines <> nil then
      FLines.Sorted:= FSorted
end;


procedure TTextBlock.SetFileName(aName: string);
begin
  FFileName:= aName;
  if aName = '' then exit;
  if not FileExists(aName) then exit;
  try
    Lines.Clear;
    Lines.LoadFromFile(aName)
  except
  end
end;




procedure   TTextBlock.SetLinesPlus(aValue: TStringList);
var
  I: longInt;
begin
   if FLines = nil then exit;

   if FLines.Count <> aValue.Count then exit;
   for I:= 0 to FLines.Count-1 do
   begin
     Flines.Strings[I] := FLines.Strings[I] + FDelimiter + aValue.Strings[I];
   end;
end;

procedure TTextBlock.SetSorted(aB: boolean);
begin
  FSorted:= aB;
  if FLines <> nil then
     FLines.Sorted:= aB
end;

function  TTextBlock.GetSorted: boolean;
begin
  if FLines <> nil then
  begin
    result:= FLines.Sorted;
    FSorted:= result
  end
  else
    result:= FSorted
end;


procedure MakeDialog(aB: boolean);
begin

end;


BEGIN
   RegisterOrbisClass(TTextBlock);
END.
