unit F_edtb;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Spin, Buttons,
// MAPPER  
  e_TxtBlk;

type
  TEditTextBlockDialog = class(TForm)
    SpeedButton1: TSpeedButton;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    FontPanel: TEdit;
    ed_FHeight: TEdit;
    SpinButton1: TSpinButton;
    Combo_Units: TComboBox;
    ColorPanel: TPanel;
    TestPanel: TPanel;
    FontDialog: TFontDialog;
    ColorDialog: TColorDialog;
    ed_Name: TEdit;
    Label7: TLabel;
    Label1: TLabel;
    ed_LHeight: TEdit;
    SpinButton2: TSpinButton;
    ed_File: TEdit;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel1: TBevel;
    Label3: TLabel;
    OpenDialog: TOpenDialog;
    BitBtn1: TBitBtn;
    Bevel4: TBevel;
    procedure ed_NameChange(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ColorPanelClick(Sender: TObject);
    procedure ed_FHeightChange(Sender: TObject);
    procedure ed_LHeightChange(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure ed_FileChange(Sender: TObject);
    procedure Combo_UnitsChange(Sender: TObject);
  private
    FTextBlockElement: TTextBlock;
    procedure SetTextBlockElement(aValue: TTextBlock);
    procedure SetFont;
  public
    property TextBlockElement: TTextBlock read FTextBlockElement write SetTextBlockElement;
    procedure SetColor(aValue: TColor);
    procedure SetTextHeight(aValue: double);
    procedure SetLineHeight(aValue: double);
    procedure SetStyle(aValue: TFontStyles);
    procedure SetCharSet(aValue: TFontCharSet);
  end;


implementation

{$R *.DFM}

procedure TEditTextBlockDialog.SetColor(aValue: TColor);
begin
   TextBlockElement.Color := aValue;
   ColorPanel.Color := aValue;
   TestPanel.Font.Color := aValue;
end;

procedure TEditTextBlockDialog.SetFont;
begin
   FontDialog.Font.Name:= TextBlockElement.FontName;
   FontDialog.Font.Color:= TextBlockElement.Color;
   FontDialog.Font.Style:= TextBlockElement.FontStyle;
   FontDialog.Font.CharSet:= TextBlockElement.CharSet;
   FontPanel.Text := TextBlockElement.FontName;
   TestPanel.Font := FontDialog.Font;
end;


procedure TEditTextBlockDialog.SetTextHeight(aValue: double);
var
   s: string;
begin
   TextblockElement.TextHeight := aValue;
   if Combo_Units.Text = 'mm' then s := FloatToStrF(aValue * 1000, ffFixed, 7, 0) else
   if Combo_Units.Text = 'cm' then s := FloatToStrF(aValue * 100, ffFixed, 5, 2)  else
      s := FloatToStrF(aValue , ffFixed, 2, 3);
   ed_FHeight.text := s;
end;


procedure TEditTextBlockDialog.SetLineHeight(aValue: double);
var
   s: string;
begin
   TextblockElement.LineHeight := aValue;
   if Combo_Units.Text = 'mm' then s := FloatToStrF(aValue * 1000, ffFixed, 7, 0) else
   if Combo_Units.Text = 'cm' then s := FloatToStrF(aValue * 100, ffFixed, 5, 2)  else
      s := FloatToStrF(aValue , ffFixed, 2, 3);
   ed_LHeight.text := s;
end;


procedure TEditTextBlockDialog.SetStyle(aValue: TFontStyles);
begin
  TextBlockElement.FontStyle:= aValue;
  FontDialog.Font.Style := TextBlockElement.FontStyle;
  TestPanel.Font.Style := aValue;
end;

procedure TEditTextBlockDialog.SetCharSet(aValue: TFontCharSet);
begin
  TextBlockElement.CharSet:= aValue;
  FontDialog.Font.CharSet := TextBlockElement.CharSet;
  TestPanel.Font.CharSet := aValue;
end;


procedure TEditTextBlockDialog.SetTextBLockElement(aValue: TTextBlock);
begin
   if FTextBlockElement <> nil then
   begin
      FTextBlockElement.Free;
      FTextBlockElement := nil;
   end;
   FTextBlockElement := aValue;
   if FTextBlockElement = nil then exit;
   ed_Name.Text := FTextBlockElement.Name;
   ed_File.Text := FTextBlockElement.FileName;
   SetFont;
   SetColor(FTextBlockElement.Color);
   SetTextHeight(FTextBlockElement.TextHeight);
   SetLineHeight(FTextBlockElement.LineHeight);
   SetStyle(FTextBlockElement.FontStyle);
   SetCharSet(FTextBlockElement.CharSet);
   FontDialog.Font.Height := 10;
end;




procedure TEditTextBlockDialog.ed_NameChange(Sender: TObject);
begin
   if TextBlockElement <> nil then TextBlockElement.Name := ed_Name.Text;
end;

procedure TEditTextBlockDialog.SpeedButton1Click(Sender: TObject);
begin
   FontDialog.Font.Color := TextBlockElement.Color;
   if FontDialog.execute then
   begin
      FontPanel.Text := FontDialog.Font.Name;
      TestPanel.Font := FontDialog.Font;
      SetColor(FontDialog.Font.Color);
      TextBlockElement.Font:= FontDialog.Font;
   end;
end;

procedure TEditTextBlockDialog.ColorPanelClick(Sender: TObject);
begin
   if ColorDialog.Execute then SetColor(ColorDialog.Color);
end;

procedure TEditTextBlockDialog.ed_FHeightChange(Sender: TObject);
var
   D: double;
begin
   try
      D := StrToFloat(ed_FHeight.Text);
      if Combo_Units.Text = 'mm' then D := D/1000 else
         if Combo_Units.Text = 'cm' then D := D/100;
      TextBlockElement.TextHeight := D;
   except
      SetTextHeight(TextBlockElement.TextHeight);
   end;
end;

procedure TEditTextBlockDialog.ed_LHeightChange(Sender: TObject);
var
   D: double;
begin
   try
      D := StrToFloat(ed_LHeight.Text);
      if Combo_Units.Text = 'mm' then D := D/1000 else
         if Combo_Units.Text = 'cm' then D := D/100;
      TextBlockElement.LineHeight := D;
   except
      SetLineHeight(TextBlockElement.LineHeight);
   end;
end;

procedure TEditTextBlockDialog.SpinButton1DownClick(Sender: TObject);
begin
   TextBlockElement.TextHeight := TextBlockElement.TextHeight - 0.001;
   SetTextHeight(TextBlockElement.TextHeight);
end;

procedure TEditTextBlockDialog.SpinButton1UpClick(Sender: TObject);
begin
   TextBlockElement.TextHeight := TextBlockElement.TextHeight + 0.001;
   SetTextHeight(TextBlockElement.TextHeight);
end;

procedure TEditTextBlockDialog.SpinButton2DownClick(Sender: TObject);
begin
   TextBlockElement.LineHeight := TextBlockElement.LineHeight - 0.001;
   SetLineHeight(TextBlockElement.LineHeight);
end;

procedure TEditTextBlockDialog.SpinButton2UpClick(Sender: TObject);
begin
   TextBlockElement.LineHeight := TextBlockElement.LineHeight + 0.001;
   SetLineHeight(TextBlockElement.LineHeight);
end;

procedure TEditTextBlockDialog.BitBtn1Click(Sender: TObject);
begin
   if OpenDialog.Execute then
   begin
      ed_File.Text := OpenDialog.FileName;
      OpenDialog.InitialDir := ExtractFilepath(OpenDialog.FileName);
   end;
end;

procedure TEditTextBlockDialog.ed_FileChange(Sender: TObject);
begin
   TextBlockElement.FileName := ed_File.Text;
end;

procedure TEditTextBlockDialog.Combo_UnitsChange(Sender: TObject);
begin
   SetTextHeight(TextBlockElement.TextHeight);
   SetLineHeight(TextBlockElement.LineHeight);
end;

end.
