unit f_MapperProjectDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  f_OrbisDialog, StdCtrls, Buttons, ExtCtrls;

type
  TMapperProjectDialog_Form = class(TOrbisDialog_Form)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    l_Directory30: TLabel;
    ed_Name: TEdit;
    ed_Author: TEdit;
    m_Comment: TMemo;
    ed_ProjectDirectory: TEdit;
    ed_Directory30: TEdit;
    b_ProjectDirectory: TSpeedButton;
    b_Directoy30: TSpeedButton;
    Timer1: TTimer;
    Label7: TLabel;
    Label8: TLabel;
    ed_SymbolDirectory: TEdit;
    ed_DataDirectory: TEdit;
    b_DataDirectory: TSpeedButton;
    b_SymbolDirectory: TSpeedButton;
    cb_Compatibility30: TCheckBox;
    l_Status30: TLabel;
    procedure b_ProjectDirectoryClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure b_Directoy30Click(Sender: TObject);
    procedure b_DataDirectoryClick(Sender: TObject);
    procedure b_SymbolDirectoryClick(Sender: TObject);
    procedure ed_Directory30Change(Sender: TObject);
    procedure cb_Compatibility30Click(Sender: TObject);
  private
    FLast30Directory: string;
    procedure SetLast30Directory(const Value: string);
  private
    FExportDataModified: boolean;
    FExportParcelModified: boolean;
    procedure SetExportDataModified(const Value: boolean);
    procedure SetExportParcelModified(const Value: boolean);
    { Private declarations }
  public
     property Last30Directory: string read FLast30Directory write SetLast30Directory;
     property ExportDataModified: boolean read FExportDataModified write SetExportDataModified;
     property ExportParcelModified: boolean read FExportParcelModified write SetExportParcelModified;
  end;


implementation
uses
   IniFiles,
   FileCtrl,
   u_String;

{$R *.DFM}

procedure TMapperProjectDialog_Form.b_ProjectDirectoryClick(Sender: TObject);
var
   S: string;
begin
   inherited;
   S := ed_ProjectDirectory.Text;
   if not DirectoryExists(S) then S := '';
   if SelectDirectory(S, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
   begin
      ed_ProjectDirectory.Text := S;
   end;
end;

procedure TMapperProjectDialog_Form.Timer1Timer(Sender: TObject);
begin
   inherited;
   if not Active then SetFocus;
end;

procedure TMapperProjectDialog_Form.FormHide(Sender: TObject);
begin
  inherited;
  Timer1.Enabled := false;
end;

procedure TMapperProjectDialog_Form.FormShow(Sender: TObject);
begin
  inherited;
  Timer1.Enabled := true;
end;

procedure TMapperProjectDialog_Form.b_Directoy30Click(Sender: TObject);
var
   S: string;
begin
   inherited;
   S := ed_Directory30.Text;
   if not DirectoryExists(S) then S := '';
   if SelectDirectory(S, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
   begin
      ed_Directory30.Text := S;
   end;
end;

procedure TMapperProjectDialog_Form.SetExportDataModified(
  const Value: boolean);
begin
end;

procedure TMapperProjectDialog_Form.SetExportParcelModified(
  const Value: boolean);
begin
end;

procedure TMapperProjectDialog_Form.b_DataDirectoryClick(Sender: TObject);
var
   S: string;
begin
   inherited;
   S := ed_DataDirectory.Text;
   if not DirectoryExists(S) then S := '';
   if SelectDirectory(S, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
   begin
      ed_DataDirectory.Text := S;
   end;
end;

procedure TMapperProjectDialog_Form.b_SymbolDirectoryClick(Sender: TObject);
var
   S: string;
begin
   inherited;
   S := ed_SymbolDirectory.Text;
   if not DirectoryExists(S) then S := '';
   if SelectDirectory(S, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
   begin
      ed_SymbolDirectory.Text := S;
   end;
end;

procedure TMapperProjectDialog_Form.ed_Directory30Change(Sender: TObject);
var
   S: string;
   Ini: TIniFile;
begin
   S := ed_Directory30.Text;
   if not DirectoryExists(S) then
   begin
      ed_Directory30.Font.Color := clRed;
      l_Status30.Font.Color := clRed;
      l_Status30.Caption := '...Sloka neexistuje!';
   end
   else
   begin
      ed_Directory30.Font.Color := clWindowText;
      l_Status30.Font.Color := clWindowText;
      l_Status30.Caption := '...OK';
      if S <> Last30Directory then
      begin
         Last30Directory := S;
         CheckBackSlash(S);
         S := S + 'Mapper32.ini';
         if FileExists(S) then
         begin
            Ini:= TIniFile.Create(S);
            ed_DataDirectory.Text := Ini.ReadString('Options', 'DataDirectory','');
            ed_SymbolDirectory.Text := Ini.ReadString('Options', 'ServiceDirectory','');
            Ini.Free;
         end
         else
         begin
            l_Status30.Font.Color := clRed;
            l_Status30.Caption := '...Sloka neobsahuje Mapper32!';
         end;
      end;
   end;

end;

procedure TMapperProjectDialog_Form.cb_Compatibility30Click(
  Sender: TObject);
var
   Chk: boolean;
begin
   Chk := cb_Compatibility30.Checked;
   l_Directory30.Enabled := Chk;
   ed_Directory30.Enabled := Chk;
   b_Directoy30.Enabled := Chk;
end;

procedure TMapperProjectDialog_Form.SetLast30Directory(const Value: string);
begin
  FLast30Directory := Value;
end;

end.
