unit I_Files;

interface

uses
  Elements,
  i_Basic;

type
TFileInterpret = class(TInterpret)
{
  function  QGoInside(Element: TElement): boolean; override;
  function  QProcessBefore(Element: TElement): boolean; override;
  procedure Process(Element: TElement); override;
  function  IsItsClass(AObject: TObject): boolean; override;
}
end;

TBMPFileInterpret = class(TFileInterpret)
  function  QGoInside(Element: TElement): boolean; override;
  function  QProcessBefore(Element: TElement): boolean; override;
  procedure Process(Element: TElement); override;
  function  IsItsClass(AObject: TObject): boolean; override;
end;

(*
TBMPFileInterpretToForm = class(TFileInterpret)
  procedure Process(Element: TElement); override;
end;



TTextFileInterpret = class(TFileInterpret)
  function  QGoInside(Element: TElement): boolean; override;
  function  QProcessBefore(Element: TElement): boolean; override;
  procedure Process(Element: TElement); override;
  function  IsItsClass(AObject: TObject): boolean; override;
end;
*)



implementation

uses
{   ITest, }

   {!T_Main,}
   SysUtils,
   Classes,
   ExtCtrls,
   WinProcs,
   Wintypes,
   Forms, Graphics,
   m_Orbis,
   E_Device, E_GFile{, F_Bmp, F_Text};


function  TBMPFileInterpret.QGoInside(Element: TElement): boolean;
begin
  Result:= false
end;

function  TBMPFileInterpret.QProcessBefore(Element: TElement): boolean;
begin
  Result:= (Element.ClassType = TGraphicFileElement) or (Element.ClassType = TBMPFileElement);
end;


procedure TBMPFileInterpret.Process(Element: TElement);
var
  BMPFile: TGraphicFileElement;
  Picture: TPicture;
  MFPicture: TPicture;
  Dev: TCanvasDevice;
  tmp: longInt;
  Bitmap: HBITMAP;
  BitmapInfo: ^TBitmapInfo;
  Bits: Pointer;
  InfoHeaderSize: Integer;
  ImageSize: Longint;
begin
  if (Element is TGraphicFileElement) then
  begin
    if Device is TCanvasDevice then
    begin
      Dev := TCanvasDevice(Device);
      BMPFile:= TGraphicFileElement(Element);
      if not FileExists(BMPFile.FileName) then
      begin
         PostTextMsg(tm_AddToProtocol,'Soubor nenalezen: '+BMPFile.FileName,nil);
         exit;
      end;
      Picture:= TPicture.Create;
      Picture.LoadFromFile(BMPFile.FileName);
      Application.ProcessMessages;

      {
      if (BMPFile.Height > 0) and (BMPFile.Width > 0) then
      }
         {
         SetStretchBltMode(Dev.Canvas.Handle, 3);
         }
         {
         StretchBlt(Dev.Canvas.Handle, Dev.Projection.GetPageX(BMPFile.X), Dev.Projection.GetPagey(BMPFile.y),
         Dev.Projection.GetPageLength(BMPFile.Width), Dev.Projection.GetPageLength(BMPFile.Height),
           BMP.Canvas.Handle, 0, 0, BMP.Width, BMP.Height, SRCCOPY);
         }
         {
        BitBlt(Dev.Canvas.Handle, Dev.Projection.GetPageX(BMPFile.X), Dev.Projection.GetPagey(BMPFile.y),
         Dev.Projection.GetPageLength(BMPFile.Width), Dev.Projection.GetPageLength(BMPFile.Height), BMP.Canvas.Handle,
          0, 0, Dev.Canvas.CopyMode);
         }
   {     Dev.Draw(BMPFile.X, BMPFile.Y, BMP); }


      if (BMPFile.Height > 0) and (BMPFile.Width > 0)
          {and not (Device is TPrintDevice)} { dokud se nevye tisk Stretch bitmapy } then
      begin
        (*
        if (Picture.Graphic is TBitmap) and (Device is TPrintDevice)then
        begin
           (*
           MFPicture := TPicture.Create;
           MFPicture.MetaFile := TMetafile.Create;
           MFPicture.MetaFile.Handle := CreateMetaFile('e:\0\ORBISTMP.wmf');
           MFPicture.MetaFile.Inch := 1000;
           MFPicture.MetaFile.Height := Picture.Bitmap.Height;
           MFPicture.MetaFile.Width := Picture.Bitmap.Width;
           SetMapMode(MFPicture.MetaFile.Handle, MM_ANISOTROPIC);
           SetWindowOrg(MFPicture.MetaFile.Handle, 0, 0);
           SetWindowExt(MFPicture.MetaFile.Handle, Picture.Bitmap.Width, Picture.Bitmap.Height);
           MoveTo(MFPicture.MetaFile.Handle, 0, 0);
           LineTo(MFPicture.MetaFile.Handle, 100, 100);

           GetDIBSizes(Picture.Bitmap.Handle, InfoHeaderSize, ImageSize);
           BitMapInfo := MemAlloc(InfoHeaderSize);
           Bits := MemAlloc(ImageSize);
           GetDIB(Picture.Bitmap.Handle, Picture.Bitmap.Palette ,BitmapInfo^, Bits^);

           StretchDIBits(MFPicture.MetaFile.Handle, 0, 0, MFPicture.MetaFile.Width, MFPicture.MetaFile.Height,
                         0, 0, Picture.Bitmap.Width, Picture.Bitmap.Height, Bits, BitmapInfo^, DIB_RGB_COLORS, SRCCOPY);
           {
           StretchBlt(MFPicture.MetaFile.Handle, 0, 0, MFPicture.MetaFile.Width, MFPicture.MetaFile.Height,
               Picture.Bitmap.Handle,0, 0, Picture.Bitmap.Width, Picture.Bitmap.Height, SRCCOPY);
           }
           RoundRect(MFPicture.MetaFile.Handle,15,15,150,150,20,30);
           MoveTo(MFPicture.MetaFile.Handle, 10, 10);
           LineTo(MFPicture.MetaFile.Handle, 200, 200);
           CloseMetaFile(MFPicture.MetaFile.Handle);
           {
           MFPicture.MetaFile.SaveToFile('e:\0\000.wmf');
           }
           {
           CopyMetaFile(MFPicture.MetaFile.Handle,'E:\0\ORBISTMP.wmf');
           }
           TCanvasDevice(Device).StretchDraw
             (BMPFile.MinX, BMPFile.MaxY, BMPFile.Width, BMPFile.Height,MFPicture.Graphic);
           DeleteMetaFile(MFPicture.MetaFile.Handle);
           MFPicture.Free;

           TCanvasDevice(Device).StretchDIB
             (BMPFile.MinX, BMPFile.MaxY, BMPFile.Width, BMPFile.Height,Picture.Bitmap);
        end
        *)
         TCanvasDevice(Device).StretchDraw
           (BMPFile.MinX, BMPFile.MaxY, BMPFile.Width, BMPFile.Height,0,0,0,0,Picture.Graphic);
      end
      else
         TCanvasDevice(Device).Draw(BMPFile.MinX, BMPFile.MaxY, Picture.Graphic);
      Picture.Free;
    end;
  end;
end;

(*
procedure TBMPFileInterpret.Process(Element: TElement);
var
  BMPFile: TBMPFileElement;
  BMP: TBitMap;
  Dev: TCanvasDevice;
begin
  if (Element is TBMPFileElement) then
  begin
    if Device is TCanvasDevice then
    begin
      Dev := TCanvasDevice(Device);
      BMPFile:= TBMPFileElement(Element);
      BMP:= TBitMap.Create;
      BMP.LoadFromFile(BMPFile.FileName);

      {
      if (BMPFile.Height > 0) and (BMPFile.Width > 0) then
      }
         {
         SetStretchBltMode(Dev.Canvas.Handle, 3);
         }
         {
         StretchBlt(Dev.Canvas.Handle, Dev.Projection.GetPageX(BMPFile.X), Dev.Projection.GetPagey(BMPFile.y),
         Dev.Projection.GetPageLength(BMPFile.Width), Dev.Projection.GetPageLength(BMPFile.Height),
           BMP.Canvas.Handle, 0, 0, BMP.Width, BMP.Height, SRCCOPY);
         }
         {
        BitBlt(Dev.Canvas.Handle, Dev.Projection.GetPageX(BMPFile.X), Dev.Projection.GetPagey(BMPFile.y),
         Dev.Projection.GetPageLength(BMPFile.Width), Dev.Projection.GetPageLength(BMPFile.Height), BMP.Canvas.Handle,
          0, 0, Dev.Canvas.CopyMode);
         }
   {     Dev.Draw(BMPFile.X, BMPFile.Y, BMP); }


      if (BMPFile.Height > 0) and (BMPFile.Width > 0)
          {and not (Device is TPrintDevice)} { dokud se nevye tisk Stretch bitmapy } then
      begin
        TCanvasDevice(Device).StretchDraw
          (BMPFile.MinX, BMPFile.MaxY, BMPFile.Width, BMPFile.Height,BMP);
      end
      else
        TCanvasDevice(Device).Draw(BMPFile.MinX, BMPFile.MaxY, BMP);
      BMP.Free;
    end;
  end;
end;
*)

function TBMPFileInterpret.IsItsClass(AObject: TObject): boolean;
begin
   result := (AObject.ClassType = TGraphicFileElement) or (AObject.ClassType = TBMPFileElement)
end;


(*
procedure TBMPFileInterpretToForm.Process(Element: TElement);
var
  FBmp: TF_bmpForm;
begin
  if (Element is TBMPFileElement) then
  begin
    Application.CreateForm(TF_BMPForm, FBmp);
    FBMP.Image1.Picture.LoadFromFile(TBMPFileElement(Element).FileName);
    FBMP.Show;
  end;
end;




function  TTextFileInterpret.QGoInside(Element: TElement): boolean;
begin
  Result:= false
end;


function  TTextFileInterpret.QProcessBefore(Element: TElement): boolean;
begin
  Result:= (Element is TTextFileElement);
end;


procedure TTextFileInterpret.Process(Element: TElement);
var
  FText: TF_TextForm;
begin
  if (Element is TTextFileElement) then
  begin
    Application.CreateForm(TF_TextForm, FText);
    FText.Memo1.Lines.LoadFromFile(TTextFileElement(Element).FileName);
    FText.Show;
  end;
end;



function TTextFileInterpret.IsItsClass(AObject: TObject): boolean;
begin
   result := AObject is TBMPFileElement
end;

*)

end.
