unit I_selr;
{****************************************************************************}
{                                                                            }
{          ORBIS ... Interpret Obdelniku                                     }
{                    (c) 1996                                                }
{                                                                            }
{****************************************************************************}

interface
uses
   Wintypes,
   Elements,
   g_Elems,
   i_Basic,
   t_Recurs;

type

  TSelectedElementInterpret = class(TRectInterpret)
  protected
    function  QGoInside(Element: TElement): boolean; override;
    function  QProcessBefore(Element: TElement): boolean; override;
  public
    procedure Process(Element: TElement); override;
    function  IsItsClass(AObject: TObject): boolean; override;
  end;


implementation
uses
   Graphics,
   M_Orbis,
   e_Device,
   Tools;


function  TSelectedElementInterpret.QGoInside(Element: TElement): boolean;
begin
  Result:= false
end;


function  TSelectedElementInterpret.QProcessBefore(Element: TElement): boolean;
begin
  Result:= (Element is TSelectedElement);
end;





function TSelectedElementInterpret.IsItsClass(AObject: TObject): boolean;
begin
   result := AObject is TSelectedElement;
end;




procedure TSelectedElementInterpret.Process(Element: TElement);
var
   R: TSelectedElement;
   DR: WinTypes.TRect;
   ix, iy, x2, y2: longInt;
begin
   if (Element is TSelectedElement) then
   begin
      R:= TSelectedElement(Element);

      {
      Device.Rectangle(R.MinX, R.MinY, R.MaxX, R.MaxY);
      }

      {
      Device.Pen.Width := 3;
      Device.Pen.Style := psDot;
      Device.Pen.Mode  := pmXOR;
      Device.Pen.Color := clLime;
      Device.Brush.Style := bsClear;
      Device.Rectangle(R.MinX, R.MinY, R.MaxX, R.MaxY);
      Device.Pen.Mode  := pmCopy;
      }
      Device.Pen.Width := 1;
      Device.Pen.Style := psSolid;
      Device.Pen.Mode  := pmCopy;
      Device.Pen.Color := clGray;
      Device.Brush.Style := bsSolid;
      Device.Brush.Color := clBlack;

      DR := Device.Projection.GetPageRect(R.MinX, R.MinY, R.MaxX, R.MaxY);
      ix := DR.Left;
      iy := DR.Top;
      TCanvasDevice(Device).Canvas.Rectangle(ix-5, iy-5, ix+5, iy+5);
      ix := DR.Right;
      iy := DR.Top;
      TCanvasDevice(Device).Canvas.Rectangle(ix-5, iy-5, ix+5, iy+5);
      ix := DR.Left;
      iy := DR.Bottom;
      TCanvasDevice(Device).Canvas.Rectangle(ix-5, iy-5, ix+5, iy+5);
      ix := DR.Right;
      iy := DR.Bottom;
      TCanvasDevice(Device).Canvas.Rectangle(ix-5, iy-5, ix+5, iy+5);

      x2 := (DR.Right - DR.Left) div 2;
      y2 := (DR.Bottom - DR.Top) div 2;

      ix := DR.Left + x2;
      iy := DR.Top;
      TCanvasDevice(Device).Canvas.Rectangle(ix-5, iy-5, ix+5, iy+5);
      ix := DR.Left + x2;
      iy := DR.Bottom;
      TCanvasDevice(Device).Canvas.Rectangle(ix-5, iy-5, ix+5, iy+5);
      ix := DR.Left;
      iy := DR.Top + y2;
      TCanvasDevice(Device).Canvas.Rectangle(ix-5, iy-5, ix+5, iy+5);
      ix := DR.Right;
      iy := DR.Top + y2;
      TCanvasDevice(Device).Canvas.Rectangle(ix-5, iy-5, ix+5, iy+5);
   end;
end;





END.