unit t_MapperProjectDialog;

interface
uses
   f_MapperProjectDialog,
   t_OrbisDialog;
type

TMapperProjectDialog = class(TOrbisDialog)
private
    FNewProject: boolean;
    FProjectDirectory: string;
    function GetForm: TMapperProjectDialog_Form;
    procedure SetNewProject(const Value: boolean);
    procedure SetProjectDirectory(const Value: string);
public
   procedure DoIt; override;
   procedure CreateForm; override;
   property  Form: TMapperProjectDialog_Form read GetForm;
   property  NewProject: boolean read FNewProject write SetNewProject;
published
   property  ProjectDirectory: string read FProjectDirectory write SetProjectDirectory;
end;

implementation
uses
   Forms,
   SysUtils,
   e_Class,
   e_MapperProject,
   u_String;

{ TMapperProjectDialog }

procedure TMapperProjectDialog.CreateForm;
begin
   aForm := TMapperProjectDialog_Form.Create(Application);
   aForm.Tool := Self;
   aForm.IsPossibleToClose := false;
end;

procedure TMapperProjectDialog.DoIt;
var
   P: TORBISMapperProject;
   S,S1,S3: string;
   i: integer;
begin
   P := TORBISMapperProject(Input);
   S := ProjectDirectory;
   Form.ed_ProjectDirectory.Text := S;
   if Input = nil then NewProject := true
   else
   begin
      Caption := 'Vlastnosti projektu: '+ P.Name;
      Form.ed_Name.Text := P.Name;
      Form.ed_Name.Enabled := false;
      Form.ed_Author.Text := P.Author;
      Form.m_Comment.Text := P.Comment;
      Form.cb_Compatibility30.Checked := false;
      Form.cb_Compatibility30.Enabled := false;
      Form.Last30Directory := P.Directory30;
      Form.ed_Directory30.Text := P.Directory30;
      Form.ed_DataDirectory.Text := P.DataDirectory;
      Form.ed_SymbolDirectory.Text := P.SymbolsDirectory;
   end;
   if NewProject then
   begin
      CheckBackSlash(S);
      S1 := 'Nov projekt';
      Caption := S1;
      S3 := '';
      if FileExists(S + S1 + '.MPR') then
      begin
         i := 1;
         S3 := IntToStr(i);
         while FileExists(S + S1 + S3 + '.MPR') do
         begin
            Inc(i);
            S3 := IntToStr(i);
         end;
      end;
      Form.ed_Name.Text := (S1 + S3);
   end;
   Form.cb_Compatibility30Click(nil);
   Inherited;
   case Result of
      1:
      begin
         if NewProject then P := TORBISMapperProject.Create;
         P.Name := Form.ed_Name.Text;
         P.Author := Form.ed_Author.Text;
         P.Comment := Form.m_Comment.Text;
         P.Compatibility30 := Form.cb_Compatibility30.Checked;
         P.DataDirectory := Form.ed_DataDirectory.Text;
         P.Directory30 := Form.ed_Directory30.Text;
         P.SymbolsDirectory := Form.ed_SymbolDirectory.Text;
         Output := P;
      end;
   end;
end;

function TMapperProjectDialog.GetForm: TMapperProjectDialog_Form;
begin
   result := TMapperProjectDialog_Form(aForm);
end;

procedure TMapperProjectDialog.SetNewProject(const Value: boolean);
begin
  FNewProject := Value;
end;


procedure TMapperProjectDialog.SetProjectDirectory(const Value: string);
begin
  FProjectDirectory := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TMapperProjectDialog);
END.
