unit T_vartxt;

interface

uses
   Elements,
   g_Elems,
   Tools;

type

TVarTextDialog = class(TTool)
private
   FTexts: TEntity;
   function GetTextCount: longInt;
   function GetText(aIndex: longInt): TText;
   function GetTextName(aIndex: longInt): string;
   function GetTextString(aIndex: longInt): string;
   Procedure SetTextString(aIndex: longInt; aValue: string);
   function GetTexts: Tentity;
public
   procedure DoIt; override;
   property  TextCount: longInt read GetTextCount;
   property  Texts: TEntity read GetTexts write FTexts;
   property  Text[aIndex: longInt]: TText read GetText;
   property  TextName[aIndex: longInt]: string read GetTextName;
   property  TextString[aIndex: longInt]: string read GetTextString write SetTextString;
end;

implementation

uses
   Controls,
   Forms,
   f_VarTxt;

function TVarTextDialog.GetTexts: Tentity;
begin
    result := TEntity(Input);
end;


function TVarTextDialog.GetTextCount: longInt;
begin
   result := 0;
   if Texts = nil then exit;
   result := Texts.Count;
end;

function TVarTextDialog.GetText(aIndex: longInt): TText;
begin
   result := TText(Texts.Elements[aIndex]);
end;

function TVarTextDialog.GetTextName(aIndex: longInt): string;
begin
   result := TText(Texts.Elements[aIndex]).Name;
end;

function TVarTextDialog.GetTextString(aIndex: longInt): string;
begin
   result := TText(Texts.Elements[aIndex]).Text;
end;

procedure TVarTextDialog.SetTextString(aIndex: longInt; aValue: string);
begin
   TText(Texts.Elements[aIndex]).Text := aValue;
end;

procedure TVarTextDialog.DoIt;
var
   VTD: Tf_AskForText;
   i: longInt;
begin
   if TextCount = 0 then exit;
   Application.CreateForm(Tf_AskForText, VTD);
   if TextCount  > 9 then VTD.Grid.RowCount := TextCount;
   for i := 0 to TextCount-1 do
   begin
      VTD.Grid.Cells[0, i] := TextName[i];
      VTD.Grid.Cells[1, i] := TextString[i];
   end;
   if VTD.ShowModal = mrOK then
   begin
      for i := 0 to TextCount-1 do
      begin
         TextString[i] := VTD.Grid.Cells[1, i];
      end;
   end;
   VTD.Free;
end;


end.
