{$A+,B-,D+,F-,G+,I+,K+,L+,N+,P+,Q+,R+,S+,T-,V+,W+,X+,Y+
$M 30000,8192}
unit T_Comp;

interface
uses Elements,
     Classes,
     Tools,
     language,
     T_Oper,
     E_Type;

const kw_if             =  'IF'             ;
      kw_then           =  'THEN'           ;
      kw_else           =  'ELSE'           ;
      kw_for            =  'FOR'            ;
      kw_to             =  'TO'             ;
      kw_downto         =  'DOWNTO'         ;
      kw_do             =  'DO'             ;
      kw_while          =  'WHILE'          ;
      kw_repeat         =  'REPEAT'         ;
      kw_until          =  'UNTIL'          ;
      kw_case           =  'CASE'           ;
      kw_of             =  'OF'           ;
      kw_element        =  'ELEMENT'        ;
      kw_end            =  'END'            ;
      kw_implementation =  'IMPLEMENTATION' ;
      kw_interface      =  'INTERFACE'      ;
      kw_int            =  'INTEGER'        ;
      kw_Fl             =  'FLOAT'          ;
      kw_Char           =  'CHAR'           ;
      kw_Bool           =  'BOOLEAN'        ;
      kw_Str            =  'STRING'         ;
      kw_Proc           =  'PROCEDURE'      ;
      kw_Func           =  'FUNCTION'       ;
      {stejne je poradi v stacku, jde od  nuly}
      kw_World          =  'WORLD'          ;
      kw_MTool          =  'MAINTOOL'       ;
      kw_ActivEl        =  'ACTIVEELEMENT'  ;



type


TBlockType=(t_If,t_For,t_While,t_Repeat,t_Case,t_Else,t_Do,t_Until,t_Procedure,
            t_Function,t_Then,t_CaseBlock,
            t_SingleThen,t_SingleDo,t_SingleElse,t_SingleRepeat,t_SingleCase,
            t_Done,t_DoneThen);

CallingStatus=(CS_Referenc,CS_Value);
TVarCompileInfo=record
         Typ:TType;
         Status:CallingStatus;
         end;

{predelat}
TShortProcInfo=class(TEntity)
 private
  FProcName:string;
  FProc:TOilProc;
  FCalledVars:array[1..MaxVariables] of TVarCompileInfo; {predelat}
  FCalls:integer;
  function GetProc:TOilProc;
  procedure SetProc(aProc:TOilProc);
  function GetCalledVar(index:integer):TVarCompileInfo;
  procedure SetCalledVar(index:integer;aInfo:TVarCompileInfo);
 public
  property Proc:TOilProc read  GetProc write SetProc;
  property ProcName:string read FProcName write FProcName;
  property Calls:integer read FCalls  write FCalls;
  property CalledVar[index:integer]:TVarCompileInfo read GetCalledVar write SetCalledVar;
           {index od 1 -jde o pole ne o entitu}
end;

{predelat}
TProcInfo=class(TEntity)
  private
   FMyShortInfo:TShortProcInfo;
   FVarNames:array[1..MaxVariables] of string[MaxVarLength];
   FCalls,FVarNum:integer;
   FProcsOnLevel:TEntity;
   function GetMyShortInfo:TShortProcInfo;
   procedure SetMyShortInfo(aInfo:TShortProcInfo);
   function GetVarName(index:integer):string;
   procedure SetVarName(index:integer;aName:string);
   function GetProcsOnLevel:TEntity;
   procedure SetProcsOnLevel(aProcs:TEntity);
   function GetAccsProc(index:integer):TShortProcInfo;
   procedure SetAccsProc(index:integer;aInfo:TShortProcInfo);
  public
   property MyShortInfo:TShortProcInfo read GetMyShortInfo write SetMyShortInfo;
   property VarName[index:integer]:string read GetVarName write SetVarName;
   property ProcsOnLevel:TEntity read GetProcsOnLevel write SetProcsOnLevel;
   property AccesibleProc[index:integer]:TShortProcInfo read GetAccsProc
                                                        write SetAccsProc;
   property Calls:integer read FCalls write FCalls;
   property VarNumber:integer read FVarNum write FvarNum;
  end;


TLineInfo=class(TOwnerEntity) {asi bude nutne vzmenit}
   private
    FBlockType:TBlockType;
    FLine:TPrgLine;
    FProcInfo:TProcInfo;
    function GetLine:TPrgLine;
    procedure SetLine(aLine:TprgLine);
    function GeTProcInfo:TProcInfo;
    procedure SetProcInfo(aVar:TProcInfo);
   public
    property BlockType:TBlockType read FBlockType write FBlockType;
    property Line:TPrgLine read GetLine write SetLine;
    property ProcInfo:TProcInfo read GetProcInfo write SetProcInfo;
   end;



{COMPILERY-forward deklarace}
{TSelectingCompiler=class;{bude postupne predavat rizeni}
{line compilery}
{A skupina}
TForCompiler=class;
TIfCompiler=class;
TWhileCompiler=class;
TRepeatCompiler=class;
TCaseCompiler=class;
{C-skupina}
TDeclarationCompiler=class;
TAssignCompiler=class;
{zvisl compilery}
{B-skupina}
TThenCompiler=class;
TDoCompiler=class;
TUntilCompiler=class;
TElseCompiler=class;
TCaseItemCompiler=class;
TEndCompiler=class;
{simple compilery}
TPathCompiler=class;
TExpressionCompiler=class;
TVariableCompiler=class;
{zatim nevim kam zaradit}
TLineExpCompiler=class;
TToolCompiler=class;
TFunctionCompiler=class;    {*}



TCompiler=class(TTechnology) {obecny predek}
   protected
    FCompString:string;
    FLineList:TOwnerEntity;
    FStartPos:longint;

    function AllowedToCompile:boolean;virtual;abstract;{existuje-li blok, do ktereho lze kompilovat}
    {line info}
    procedure SetLineList(aList:TOwnerEntity);virtual;
    function GetLineList:TOwnerEntity;virtual;
    function GetCurrentLine:TLineInfo;virtual;
    function GetLineInfo(index:longint):TLineInfo;virtual;
    procedure SetLineInfo(index:longint;aLine:TLineInfo);virtual;
    {compilery}
    function GetForCompiler:TForCompiler;virtual;abstract;
    procedure SetForCompiler(aComp:TForCompiler);virtual;abstract;
    function GetIfCompiler:TIfCompiler;virtual;abstract;
    procedure SetIfCompiler(aComp:TIfCompiler);virtual;abstract;
    function GetWhileCompiler:TWhileCompiler;virtual;abstract;
    procedure SetWhileCompiler(aComp:TWhileCompiler);virtual;abstract;
    function GetRepeatCompiler:TRepeatCompiler;virtual;abstract;
    procedure SetRepeatCompiler(aComp:TRepeatCompiler);virtual;abstract;
    function GetCaseCompiler:TCaseCompiler;virtual;abstract;
    procedure SetCaseCompiler(aComp:TCaseCompiler);virtual;abstract;
    function GetCaseItemCompiler:TCaseItemCompiler;virtual;abstract;
    procedure SetCaseItemCompiler(aComp:TCaseItemCompiler);virtual;abstract;
    function GetDeclarationCompiler:TDeclarationCompiler;virtual;abstract;
    procedure SetDeclarationCompiler(aComp:TDeclarationCompiler);virtual;abstract;
    function GetAssignCompiler:TAssignCompiler;virtual;abstract;
    procedure SetAssignCompiler(aComp:TAssignCompiler);virtual;abstract;
    function GetThenCompiler:TThenCompiler;virtual;abstract;
    procedure SetThenCompiler(aComp:TThenCompiler);virtual;abstract;
    function GetDoCompiler:TDoCompiler;virtual;abstract;
    procedure SetDoCompiler(aComp:TDoCompiler);virtual;abstract;
    function GetUntilCompiler:TUntilCompiler;virtual;abstract;
    procedure SetUntilCompiler(aComp:TUntilCompiler);virtual;abstract;
    function GetElseCompiler:TElseCompiler;virtual;abstract;
    procedure SetElseCompiler(aComp:TElseCompiler);virtual;abstract;
    function GetEndCompiler:TEndCompiler;virtual;abstract;
    procedure SetEndCompiler(aComp:TEndCompiler);virtual;abstract;
    function GetPathCompiler:TPathCompiler;virtual;abstract;
    procedure SetPathCompiler(aComp:TPathCompiler);virtual;abstract;
    function GetExpressionCompiler:TExpressionCompiler;virtual;abstract;
    procedure SetExpressionCompiler(aComp:TExpressionCompiler);virtual;abstract;
    function GetVariableCompiler:TVariableCompiler;virtual;abstract;
    procedure SetVariableCompiler(aComp:TVariableCompiler);virtual;abstract;
    function GetLineExpCompiler:TLineExpCompiler;virtual;abstract;
    procedure SetLineExpCompiler(aComp:TLineExpCompiler);virtual;abstract;
    function GetToolCompiler:TToolCompiler;virtual;abstract;
    procedure SetToolCompiler(aComp:TToolCompiler);virtual;abstract;
    function GetFunctionCompiler:TFunctionCompiler;virtual;abstract;
    procedure SetFunctionCompiler(aComp:TFunctionCompiler);virtual;abstract;
    function GetCompString:string;virtual;
    procedure SetCompString(aStr:string);virtual;
   protected
  {COMPILERY}
  {line compilery}
  {A skupina}
    property  ForCompiler:TForCompiler read GetForCompiler write SetForCompiler;
    property  IfCompiler:TIfCompiler read GetIfCompiler write SetIfCompiler;
    property  WhileCompiler:TWhileCompiler read GetWhileCompiler write SetWhileCompiler;
    property  RepeatCompiler:TRepeatCompiler read GetRepeatCompiler write SetRepeatCompiler;
    property  CaseCompiler:TCaseCompiler read GetCaseCompiler write SetCaseCompiler;
    property  CaseItemCompiler:TCaseItemCompiler read GetCaseItemCompiler write SetCaseItemCompiler;
  {C-skupina}
     property DeclarationCompiler:TDeclarationCompiler read GetDeclarationCompiler write SetDeclarationCompiler;
     {vyjimka-nonline compiler}
     property AssignCompiler:TAssignCompiler read GetAssignCompiler write SetAssignCompiler;
  {zvisl compilery}
  {B-skupina}
    property  ThenCompiler:TThenCompiler read GetThenCompiler write SetThenCompiler;
    property  DoCompiler:TDoCompiler read GetDoCompiler write SetDoCompiler;
    property  UntilCompiler:TUntilCompiler read GetUntilCompiler write SetUntilCompiler;
    property  ElseCompiler:TElseCompiler read GetElseCompiler write SetElseCompiler;
    property  EndCompiler:TEndCompiler read GetEndCompiler write SetEndCompiler;
  {simple compilery}
    property  PathCompiler:TPathCompiler read GetPathCompiler write SetPathCompiler;
    property  ExpressionCompiler:TExpressionCompiler read GetExpressionCompiler write SetExpressionCompiler;
    property  VariableCompiler:TVariableCompiler read GetVariableCompiler write SetVariableCompiler;
  {zatim nevimkam zaradit}
    property  ToolCompiler:TToolCompiler read GetToolCompiler write SetToolCompiler;
    property  FunctionCompiler:TFunctionCompiler read GetFunctionCompiler write SetFunctionCompiler;
    property  LineExpCompiler:TLineExpCompiler read GetLineExpCompiler write SetLineExpCompiler;
  {COMPILERY-end}
    procedure NewCurrentLineInfo(aLine:TLineInfo);
    procedure FreeCurrentLineInfo;virtual;
    public
    function SupposedToCompile:boolean;virtual;abstract; {hleda klicove slovo}
    property StartPos:longint read FStartPos write FStartPos;
    property CompLine:string read GetCompString write SetCompString;
    property LineList:TOwnerEntity read GetLineList write SetLinelist ;
    property LineInfo[Index:longint]:TLineInfo read GetLineInfo write SetLineInfo;
    property CurrentLineInfo:TLineInfo read GetCurrentLine;
   end;



TKeyWordCompiler=class(TCompiler)
   private
    function AllowedToCompile:boolean;override;
    function ReadFirstWord(var Pos:longint):string;
    function GetKeyWord:string;virtual;abstract;
   protected
    procedure SetInput(aInput: TElement); override;
    property KeyWord:string read GetKeyWord;
   private
    function SupposedToCompile:boolean;override;
   end;


TRepeatCompiler=class(TKeyWordCompiler)
   private
    function GetKeyWord:string;override;
   public
    procedure Doit;override;
   end;

TThenCompiler=class(TKeyWordCompiler)
   private
    function AllowedToCompile:boolean;override;
    function GetKeyWord:string;override;
   public
    procedure Doit;override;
   end;

TDoCompiler=class(TKeyWordCompiler)
   private
    function AllowedToCompile:boolean;override;
    function GetKeyWord:string;override;
   public
    procedure Doit;override;
   end;


TEndCompiler=class(TKeyWordCompiler)
   private
    function AllowedToCompile:boolean;override;
    function GetKeyWord:string;override;
   public
    procedure Doit;override;
   end;

TElseCompiler=class(TKeyWordCompiler)
   private
    function AllowedToCompile:boolean;override;
    {function SupposedToCompile:boolean;override;}
    function GetKeyWord:string;override;
   public
    procedure Doit;override;
   end;


TCaseItemCompiler=class(TKeyWordCompiler)
   private
    function AllowedToCompile:boolean;override;
    {function SupposedToCompile:boolean;override;}
    {function GetKeyWord:string;override;}
    function ReadCaseItem(var p:longint;var IsString:boolean):string;
   public
    procedure Doit;override;
   end;


TSimpleCompiler=class(TKeyWordCompiler)
   private
    FFunctionCompiler:TFunctionCompiler;
    FToolCompiler:TToolCompiler;
    FExprCompiler:TExpressionCompiler;
    FVarCompiler:TVariableCompiler;
    procedure SetLineList(aList:TOwnerEntity);override;
    function GetLineList:TOwnerEntity;override;
    function GetExpressionCompiler:TExpressionCompiler;override;
    procedure SetExpressionCompiler(aComp:TExpressionCompiler);override;
    function GetVariableCompiler:TVariableCompiler;override;
    procedure SetVariableCompiler(aComp:TVariableCompiler);override;
    function GetFunctionCompiler:TFunctionCompiler;override;
    procedure SetFunctionCompiler(aComp:TFunctionCompiler);override;
    function GetToolCompiler:TToolCompiler;override;
    procedure SetToolCompiler(aComp:TToolCompiler);override;
   end;

TLineExpCompiler=class(TSimpleCompiler)
   private
   function SupposedToCompile:boolean;override;
   public
   procedure DoIt;override;
   end;


TIfCompiler=class(TSimpleCompiler)
   private
    function GetKeyWord:string;override;
   public
    procedure DoIt;override;
   end;

TForCompiler=class(TSimpleCompiler)
   private
    function GetKeyWord:string;override;
   public
    procedure DoIt;override;
   end;

TWhileCompiler=class(TSimpleCompiler)
   private
    function GetKeyWord:string;override;
   public
    procedure Doit;override;
   end;

TUntilCompiler=class(TSimpleCompiler)
   private
    function AllowedToCompile:boolean;override;
    function GetKeyWord:string;override;
   public
    procedure Doit;override;
   end;


TCaseCompiler=class(TSimpleCompiler)
   private
    function GetKeyWord:string;override;
   public
    procedure Doit;override;
   end;

TDeclarationCompiler=class(TKeyWordCompiler){vyjimka}
 private
  FAssignCompiler:TAssignCompiler;
  procedure SetLineList(aList:TOwnerEntity);override;
  function GetLineList:TOwnerEntity;override;
  function GetAssignCompiler:TAssignCompiler;override;
  procedure SetAssignCompiler(aComp:TAssignCompiler);override;
  function AllowedToCompile:boolean;override;
  function SupposedToCompile:boolean;override;
 public
  procedure Doit;override;
 end;

TAssignCompiler=class(TSimpleCompiler)
   private
    function TypeCheck(Op1,Op2:TOperator):boolean;virtual;
    function SupposedToCompile:boolean;override;
   public
    procedure Doit;override;
   end;


TVariableCompiler=class(TSimpleCompiler)
   private
    FPathCompiler:TPathCompiler;
    procedure SetLineList(aList:TOwnerEntity);override;
    function GetLineList:TOwnerEntity;override;
    procedure SetPathCompiler(aComp:TPathCompiler);override;
    function GetPathCompiler:TPathCompiler;override;
   public
    procedure Doit;override;
   end;

TPathCompiler=class(TSimpleCompiler)
   public
    procedure DoIt;override;
   end;

TExpressionCompiler=class(TVariableCompiler)
   public
    procedure Doit;override;
   end;


TToolCompiler=class(TVariableCompiler)
   private
    function SupposedToCompile:boolean;override;
   public
    procedure DoIt;override;
end;

{****************************************************************}

TFunctionCompiler=class(TSimpleCompiler)
  private
   function SupposedToCompile:boolean;override;
   function AllowedToCompile:boolean;override;
  public
    procedure Doit;override;
  end;



  implementation


uses
        T_Errors,
        U_String,
        E_Class,
        SysUtils,
        worlds;

{zkontrolovat}

{HELPFUL PROCEDURES}

function CountSpaces(S:string):longint;{spocita mezery na zacatku}
   begin
   result:=0;
   while (result<length(s)) and (s[result+1]=' ') do inc(result);
   end;

function CountSpacesInside(S:string;Pos:longint):longint;
var i:longint;
   begin
   i:=pos;
   while (i<=length(s)) and(s[i]=' ') do inc(i);
   result:=i-Pos;
   end;



function ReadAnyString(S:string;FPos:longint;var TPos:longint):string;
var StringKind,ResChar:Char;
{pedpokld, e S zan na ' nebo "}
   begin
   StringKind:=S[FPos];
   inc(FPos);
   ReadToDelimiterWithoutWS(S,[StringKind],FPos,ResChar,TPos);
   if ResChar=#0 then
           begin
           Result:=Copy(S,FPos,TPos-FPos);
           TPos:=0;
           end
           else
           Result:=Copy(S,FPos,TPos-FPos-1);
   end;


function ReadBrackets(S:string;FPos:longint;var TPos:longint):string;
var Delimiters:TDelimiters;
    ResChar:char;
    Out:boolean;
    APos:longint;
    Brackets:integer;
{pedpokld, e S zan na '(' }
begin
Out:=false;
Brackets:=1;
inc(FPos);
APos:=FPos;
Delimiters:=['''','"','(',')'];
repeat
   ReadToDelimiterWithoutWS(S,Delimiters,APos,ResChar,TPos);
   case ResChar of
   #0:begin
      Out:=true;
      Result:=Copy(S,FPos,TPos-FPos);
      TPos:=0;
      end;
   '''','"':
      begin
      ReadAnystring(S,TPos-1,TPos);
      if TPos=0 then
         begin
         Out:=true;
         Result:=Copy(S,FPos,length(S)+1-FPos);
         end;
      end;
   '(':inc(Brackets);
   ')':
       begin
       dec(Brackets);
       if Brackets=0 then
          begin
          Out:=true;
          Result:=Copy(S,FPos,TPos-1-FPos);
          end;
       end;
    end;{case}
 APos:=TPos;
until Out;
end;


function ReadWord(S:string;FPos:longint;var TPos:longint):string;
var Delimiters:TDelimiters;
    ResChar:char;
{pokud slovo nen rozumn ukoneno je TPos=0}
begin
Result:='';
FPos:=FPos+CountSpacesInside(s,FPos);
Delimiters:=['''','"','(',' '];
if FPos>length(S) then TPos:=0
else
   begin
   ReadToDelimiterWithoutWS(S,Delimiters,FPos,ResChar,TPos);
   case ResChar of
      ' ':
         begin
         dec(TPos);
         Result:=Copy(s,FPos,Tpos-FPos);
         end;
      #0:begin
         dec(TPos);
         Result:=Copy(s,FPos,Tpos-FPos);
         end;
      '(':begin
          ReadBrackets(S,TPos-1,TPos);
          if TPos=0 then result:=Copy(S,FPos,length(s)+1-FPos)
          else result:=Copy(S,FPos,TPos-FPos);
          end;
      '"','''':
          begin
          if Tpos=Fpos+1 then
             begin
             ReadAnyString(S,TPos-1,TPos);
             if TPos=0 then result:=Copy(S,FPos,length(s)+1-FPos)
             else result:=Copy(S,FPos,TPos-FPos);
             end
           else
             result:=Copy(S,FPos,TPos-1-FPos);
          end;
    end;{case}
   end;
 end;


function FindAssigning(S:string;var pos:longint):boolean;
 var {Pos1,}Pos2,Brackets:longint;
     out:boolean;
     ResChar:char;
     Delimiters:TDelimiters;
     InString:boolean;
     StringKind:char;

   begin
   Brackets:=0;
   out:=false;
   InString:=false;
   Delimiters:=['(',')',':','=','''','"'];
   result:=false;
   Pos2:=1;
   repeat
   ReadToDelimiterWithoutWS(S,Delimiters,pos2,ResChar,Pos2);
   if not InString then
         begin
          case ResChar of
              '''','"':begin
                       InString:=true;
                       StringKind:=ResChar;
                       end;
              '(':inc(Brackets);
              ')':if Brackets>0 then dec(Brackets);
              '=':if Brackets=0 then
                   begin
                   result:=true;
                   Pos:=Pos2-1;
                   out:=true;
                   end;
              ':':if (Brackets=0) and (Pos2<=length(S)) then
                     if S[Pos2]='=' then
                     begin
                     result:=true;
                     Pos:=Pos2-1;
                     out:=true;
                     end;
              end{case}
         end
      else {if}
        if StringKind=ResChar then InString:=false;
   until (resChar=#0) or out;
end;{IsAssigning procedure}



function IsRegisteredTool(s:string;var aClass:TClass):boolean;
    begin
    result:=false;
    aClass := TElementClass(GetOrbisClass(CheckClassName(S)));
    if (aClass <> nil) and aClass.InheritsFrom(TTool) then result:=true;
    end;

function IsRegisteredClass(s:string):boolean;
var aClass:TClass;
    begin
    aClass := TElementClass(GetOrbisClass(CheckClassName(S)));
    result:=(aClass <> nil);
    end;

function ToType(S:string):TType;
 begin
 S:=AnsiUppercase(S);
      if s=kw_int then result:=_Integer
 else if s=kw_Fl then result:=_Float
 else if s=kw_Char then result:=_Char
 else if s=kw_Bool then result:=_Boolean
 else if s=kw_Str then result:=_String
 else if IsRegisteredclass(S) then result:=_Pointer
 else result:=_Other;
 end;
(*
function IsKeyWord(s:string):boolean;
   begin
   s:=AnsiUpperCase(BezVnejsichMezer(S));
   result:=(s=kw_if) or (s=kw_else) or (s=kw_for) or (s=kw_while) or (s=kw_repeat) or
          (s=kw_until) or (s=kw_case) or (s=kw_end) or (s=kw_Proc) or (s=kw_Func);
   end;
*)
function ReadFromLastDot(S:string;var Pos:longint):string;
var FPos,AbsPos:longint;
    Delimiters:TDelimiters;
    ResChar:char;
{predpoklada uzavreni vsech stringu a zavorek}
{pokud neni radna oddelujici tecka nalezena je pos=0}
begin
Pos:=0;
Result:='';
Delimiters:=['''','"','(','.'];
AbsPos:=CountSpaces(S);
S:=BezVnejsichMezer(S);
FPos:=1;
while S<>'' do
begin
ReadToDelimiterWithoutWS(S,Delimiters,FPos,ResChar,FPos);
case ResChar of
      #0:begin
         Result:=s;
         Pos:=AbsPos;
         s:='';
         end;
      '(':begin
          ReadBrackets(S,FPos-1,FPos);
          end;
      '"','''':
          begin
             ReadAnyString(S,FPos-1,FPos);
          end;
      '.':
          begin
          S:=Copy(S,FPos,length(S)-FPos+1);
          AbsPos:=AbsPos+Fpos-1;
          FPos:=1;
          end;
    end;{case}
   end;
 end;


function IsMainKeyWord(S:String):boolean;
         begin
         {leopsi by bylo mit pole}
         S:=AnsiUpperCase(BezVnejsichMezer(S));
         result:=(s=kw_if) or (s=kw_else) or (s=kw_for) or (s=kw_while) or (s=kw_repeat) or
          (s=kw_until) or (s=kw_case) or (s=kw_end) or (s=kw_Proc) or (s=kw_Func)
           or (s=kw_then) or (s=kw_to) or (s=kw_downto) or (s=kw_do)or (s=kw_until) or (s=kw_end);
         end;


function GetMainKeyWord(S:string;Pos:longint;var OpPos:longint):boolean;
var St:string;
begin
  result:=false;
  OpPos:=Pos;
  repeat
  St:=ReadWord(S,Pos,OpPos);
  if IsMainKeyWord(St) then
     begin
     result:=true;
     OpPos:=Pos;
     end;
     Pos:=OpPos;
  until result or (OpPos=0);
end;

{END OF HELPFUL PROCEDURES}


{TShortProcInfo}

function TShortProcInfo.GetProc:TOilProc;
   begin
   result:=FProc;
   end;

procedure TShortProcInfo.SetProc(aProc:TOilProc);
   begin
   if assigned(FProc) then FreeElement(FProc);
   AddElement(FProc);
   FProc:=aProc;
   end;

function TShortProcInfo.GetCalledVar(index:integer):TVarCompileInfo;
   begin
   result:=FCalledVars[index];
   end;

procedure TShortProcInfo.SetCalledVar(index:integer;aInfo:TVarCompileInfo);
   begin
   FCalledVars[index]:=aInfo;
   end;
{TProcInfo}
function TProcInfo.GetMyShortInfo:TShortProcInfo;
   begin
    if  not assigned(FMyShortInfo) then
        begin
        FMyShortInfo:=TShortProcInfo.Create;
        AddElement(FMyShortInfo);
        end;
    result:=MyShortInfo;
   end;

procedure TProcInfo.SetMyShortInfo(aInfo:TShortProcInfo);
   begin
    if  assigned(FMyShortInfo) then FreeElement(FMyShortInfo);
    FMyShortInfo:=aInfo;
    AddElement(FMyShortInfo);
   end;



function TProcInfo.GetAccsProc(index:integer):TShortProcInfo;
  begin
  result:=TShortProcInfo(ProcsOnLevel.Elements[index]);
  end;

procedure TProcInfo.SetAccsProc(index:integer;aInfo:TShortProcInfo);
var aEnt:TEntity;
    a:TElement;
  begin
  aEnt:=ProcsOnLevel;
  if aEnt.Elements[index]<>nil then aEnt.Elements[index].Free;
  aEnt.Elements[index]:=aInfo;
 end;

function TProcInfo.GetProcsOnLevel:TEntity;
  begin
  if not assigned(FProcsOnLevel) then
    begin
    FProcsOnLevel:=TEntity.Create;
    AddElement(FProcsOnLevel);
    end;
  result:=FProcsOnLevel;
  end;

procedure TProcInfo.SetProcsOnLevel(aProcs:TEntity);
   begin
   if assigned(FProcsOnLevel) then FreeElement(FProcsOnLevel);
   FProcsOnLevel:=TEntity.Create;
   AddElement(FProcsOnLevel);
   end;

function TprocInfo.GetVarName(index:integer):string;
   begin
   result:=FVarNames[index];
   end;

procedure TProcInfo.SetVarName(index:integer;aName:string);
   begin
   FVarNames[index]:=aName;
   end;

{TBlockInfo}
function TLineInfo.GetProcInfo:TProcInfo;
   begin
   if not assigned(FProcInfo) then
      begin
      FProcInfo:=TProcInfo.Create;
      AddElement(FProcInfo);
      end;
   result:=FProcInfo;
   end;

 procedure TLineInfo.SetProcInfo(aVar:TProcInfo);
   begin
   if assigned(FProcInfo) then FreeElement(FProcInfo);
   FProcInfo:=aVar;
   AddElement(FProcInfo);
   end;

function TLineInfo.GetLine:TPrgLine;
   begin
   result:=FLine;
   end;

procedure TLineInfo.SetLine(aLine:TprgLine);
   begin
   if assigned(FLine) then FreeElement(FLine);
   AddElement(aLine);
   FLine:=aLine;
   end;

{TCompiler}
function  TCompiler.GetLineInfo(index:longint):TLineInfo;
   begin
   result:=TLineInfo(LineList.Elements[index]);
   end;

procedure  TCompiler.SetLineInfo(index:longint;aLine:TLineInfo);
var aBlk:TOwnerEntity;
   begin
   aBlk:=LineList;
   if aBlk.Count>index then
     begin
     aBlk.Elements[index].Free;
     aBlk.Elements[index]:=aLine;
     end
     else aBlk.AddElement(aLine);
   end;

procedure TCompiler.NewCurrentLineInfo(aLine:TLineInfo);
   begin
   LineList.AddElement(aLine);
   end;

procedure TCompiler.FreeCurrentLineInfo;
var aLine:TOwnerEntity;
   begin
   aLine:=LineList;
   if aLine.Count>0 then aLine.FreeElement(aLine.Elements[aLine.count-1]);
   end;


function TCompiler.GetCurrentLine:TLineInfo;
    begin
    if LineList.Count=0 then result:=nil
    else
    result:=TLineInfo(LineList.Elements[LineList.Count-1]);
    end;

procedure TCompiler.SetLineList(aList:TOwnerEntity);
    begin
    if assigned(FLineList) then FreeElement(FLineList);
    AddElement(aList);
    FLineList:=aList;
    end;

function TCompiler.GetLineList:TOwnerEntity;
    begin
    if not assigned(FLineList) then
       begin
       FLineList:=TOwnerEntity.Create;
       AddElement(FLineList);
       end;
    result:=FLineList;
    end;



{TCompiler}
function TCompiler.GetCompString:string;
   begin
   result:=FCompString;
   end;

procedure TCompiler.SetCompString(aStr:string);
   begin
   FCompString:=aStr;
   end;

{TKeyWordCompiler}
function TKeyWordCompiler.AllowedToCompile:boolean;
   begin
   result:=CurrentlineInfo.Blocktype in[t_Repeat,t_Else,t_Do,
              t_Procedure,t_Function,t_Then,t_SingleThen,t_SingleDo,
              t_SingleElse,t_Singlerepeat];
   end;


procedure TKeyWordCompiler.SetInput(aInput: TElement);
   begin
   if (aInput is TStringElement) then CompLine:=TStringElement(aInput).Value;
   if aInput<>nil then aInput.free;
   end;

function TKeyWordCompiler.ReadFirstWord(var Pos:longint):string;
var St:string;
    AbsPos,Pos1:longint;
  begin
  result:='';
  St:=CompLine;
  St:=Copy(St,Pos,Length(St)-pos+1);
  AbsPos:=CountSpaces(St); {vsudepricist}
  St:=BezVnejsichMezer(St);
  if St='' then exit;
  result:=ReadWord(St,1,Pos1);
  Pos:=Pos+AbsPos+Pos1-1;
  end;



function TKeyWordCompiler.SupposedToCompile:boolean;
var St,St1:string;
    Pos:longint;
  begin
  Pos:=StartPos;
  result:=false;
  St:=CompLine;
  if AnsiUpperCase(ReadFirstWord(Pos))=KeyWord then result:=true;
  end;


{TSimpleCompiler}
procedure TSimpleCompiler.SetLineList(aList:TOwnerEntity);
    begin
    if assigned(FLineList) then FreeElement(FLineList);
    AddElement(aList);
    FLineList:=aList;
    if assigned(FExprCompiler) then ExpressionCompiler.Linelist:=aList;
    if assigned(FVarCompiler) then VariableCompiler.Linelist:=aList;
    end;

function TSimpleCompiler.GetLineList:TOwnerEntity;
    begin
    if not assigned(FLineList) then
       begin
       FLineList:=TOwnerEntity.Create;
       AddElement(FLineList);
       if assigned(FExprCompiler) then ExpressionCompiler.Linelist:=FLineList;
       if assigned(FVarCompiler) then VariableCompiler.Linelist:=FLineList;
       end;
    result:=FLineList;
    end;

function TSimpleCompiler.GetToolCompiler:TToolCompiler;
  begin
   if not assigned(FToolCompiler) then
       begin
       FToolCompiler:=TToolCompiler.Create;
       AddTool(FToolCompiler);
       FToolCompiler.LineList:=LineList;
       end;
   result:=FToolCompiler;
   end;



procedure TSimpleCompiler.SetToolCompiler(aComp:TToolCompiler);
   begin
   if assigned(FToolCompiler) then FreeTool(FToolCompiler);
   AddTool(aComp);
   FToolCompiler:=aComp;
   FToolCompiler.LineList:=LineList;
   end;




function TSimpleCompiler.GetFunctionCompiler:TFunctionCompiler;
  begin
   if not assigned(FFunctionCompiler) then
       begin
       FFunctionCompiler:=TFunctionCompiler.Create;
       AddTool(FFunctionCompiler);
       FFunctionCompiler.LineList:=LineList;
       end;
   result:=FFunctionCompiler;
   end;


procedure TSimpleCompiler.SetFunctionCompiler(aComp:TFunctionCompiler);
   begin
   if assigned(FFunctionCompiler) then FreeTool(FFunctionCompiler);
   AddTool(aComp);
   FFunctionCompiler:=aComp;
   FFunctionCompiler.LineList:=LineList;
   end;


function TSimpleCompiler.GetExpressionCompiler:TExpressionCompiler;
   begin
   if not assigned(FExprCompiler) then
       begin
       FExprCompiler:=TExpressionCompiler.Create;
       AddTool(FExprCompiler);
       FExprCompiler.LineList:=LineList;
       end;
   result:=FExprCompiler;
   end;


procedure TSimpleCompiler.SetExpressionCompiler(aComp:TExpressionCompiler);
   begin
   if assigned(FExprCompiler) then FreeTool(FExprCompiler);
   AddTool(aComp);
   FExprCompiler:=aComp;
   FExprCompiler.LineList:=LineList;
   end;

function TSimpleCompiler.GetVariableCompiler:TVariableCompiler;
   begin
   if not assigned(FVarCompiler) then
       begin
       FVarCompiler:=TVariableCompiler.Create;
       AddTool(FVarCompiler);
       FVarCompiler.LineList:=LineList;
       end;
   result:=FVarCompiler;
   end;


procedure TSimpleCompiler.SetVariableCompiler(aComp:TVariableCompiler);
   begin
   if assigned(FVarCompiler) then FreeTool(FVarCompiler);
   AddTool(aComp);
   FVarCompiler:=aComp;
   FVarCompiler.LineList:=LineList;
   end;

{LineExpCompiler}         

function TLineExpCompiler.SupposedToCompile:boolean;
 begin
 result:=true;
 end;

procedure TLineExpCompiler.DoIt;
 begin
 try
 Output:=TExpressionLine.Create;
 ExpressionCompiler.CompLine:=CompLine;
 ExpressionCompiler.StartPos:=StartPos;
 ExpressionCompiler.DoIt;
 TExpressionLine(Output).Expression:=TOperator(ExpressionCompiler.Output);
 StartPos:=ExpressionCompiler.StartPos;
 except
 Output.free;
 raise
 end;
 end;

{IfCompiler}
function TIfCompiler.GetKeyWord:string;
   begin
    result:=kw_IF;
   end;

procedure TIfCompiler.DoIt;
var St,St1,StA:string;
    APos,Pos,Pos1:longint;


    function IsBoolean:boolean;
      begin
      TIfLine(Output).Expression.GetTypeInfo;
      result:=TIfLine(Output).Expression.TypeItem[_boolean];
      TIfLine(Output).Expression.ClearTypeInfo;
      end;

   begin
   try
   St:=CompLine;
   Output:=TIfLine.Create;
   if not SupposedToCompile then
     raise TCompilerError.CreatePos(1,0,StartPos+CountSpacesInside(CompLine,StartPos),'IF');
   if not AllowedToCompile then
     raise TCompilerError.CreatePos(2,0,StartPos+CountSpacesInside(CompLine,StartPos),'IF');
   NewCurrentLineInfo(TLineInfo.Create);
   CurrentLineInfo.Line:=TPrgLine(Output);
   CurrentLineInfo.BlockType:=t_If;
   Pos:=StartPos;
   ReadFirstWord(Pos);
   if (Pos=0) or (BezVnejsichMezer(Copy(St,Pos,length(St)-pos+1))='')
      then raise TCompilerError.CreatePos(1,0,length(St)+1,'vraz');
   {## melo by hodit eror i pokud je tam jine klicove slovo nez THEN}

   APos:=Pos;
   repeat
   Pos1:=Pos;
   St1:=ReadWord(St,Pos1,Pos);
   until (Pos=0) or (AnsiUpperCase(BezVnejsichMezer(St1))=kw_then);
   if AnsiUpperCase(BezVnejsichMezer(St1))=kw_then then
    begin
    StA:=Copy(St,Apos,Pos1-APos);  {vyraz}
    StartPos:=Pos1;
    if BezVnejsichMezer(StA)='' then raise TCompilerError.CreatePos(1,0,APos,'vraz');
    {St1:=Copy(St,Pos1,length(St)-Pos1+1); {vcetne then}
    end
   else
    begin
    StartPos:=0;
    {St1:='';}
    StA:=Copy(St,APos,length(St)-APos+1);
    end;
   try
   ExpressionCompiler.Compline:=StA;
   ExpressionCompiler.Doit;
   except
      on E:TCompilerError do
      begin
      E.Position:=E.Position+Apos;
      raise;
      end;
   end;
   TIfLine(Output).Expression:=TOperator(ExpressionCompiler.Output);
   if ExpressionCompiler.StartPos>0 then
      raise TCompilerError.CreatePos(3,0,APos+ExpressionCompiler.StartPos,'');
   if not IsBoolean then {!raise musi byt boolean apos)};
 except
 TIfLine(Output).Free;
 Output:=nil;
 raise
 end;
 end;

{TForCompiler}
function TForCompiler.GetKeyWord:string;
   begin
    result:=kw_FOR;
   end;


procedure TForCompiler.DoIt;
var {TmpSt,}St,St1,St2,St3,StA,VarSt,ExprSt:string;
    APos,Pos,Pos1,DoPos,ForPos,ToPos,VarPos,Spaces:longint;
    {Delimiters:TDelimiters;
    ResChar:char;
    aVar:TNormalVariable;}

   function GetNormalVariable(s:string;VPos:integer):TNormalVariable;
    var i,m:longint;
         PInfo:TProcInfo;
    begin
    result:=nil;
    i:=LineList.Count-1;
    try
    while (i>=0) and (result=nil) do
       begin
        if LineInfo[i].BlockType in [t_Procedure,t_Function] then
           begin
           PInfo:=lineInfo[i].ProcInfo;;
           if PInfo.VarNumber>0 then for m:=1 to PInfo.VarNumber do
               if PInfo.VarName[m]=AnsiUppercase(S) then
                  if m<=PInfo.Calls then raise TCompilerError.CreatePos(4,0,Vpos,'')
                  else
                   begin
                    result:=TNormalVariable.Create;
                    result.Block:=TPrgBlock(lineInfo[i].Line);
                    result.VarIndex:=m-1;
                   end;
           end;
        dec(i);
       end;
    finally end;
    end;


   begin
   try
   St:=CompLine;
   Output:=TForLine.Create;
   if not SupposedToCompile then
     raise TCompilerError.CreatePos(1,0,StartPos+CountSpacesInside(CompLine,StartPos),'FOR');
   if not AllowedToCompile then
     raise TCompilerError.CreatePos(2,0,StartPos+CountSpacesInside(CompLine,StartPos),'FOR');
   NewCurrentLineInfo(TLineInfo.Create);
   CurrentLineInfo.Line:=TPrgLine(Output);
   CurrentLineInfo.BlockType:=t_For;
   Pos:=StartPos;
   ReadFirstWord(Pos);
   if (Pos=0) or (BezVnejsichMezer(Copy(St,Pos,length(St)-pos+1))='')
         then raise TCompilerError.CreatePos(1,0,length(St)+1,'piazen');
   APos:=Pos;
   repeat
   Pos1:=Pos;
   St1:=ReadWord(St,Pos1,Pos);
   until (Pos=0) or (AnsiUpperCase(BezVnejsichMezer(St1))=kw_Do);
   if AnsiUpperCase(BezVnejsichMezer(St1))=kw_Do then
    begin
    StA:=Copy(St,Apos,Pos1-APos+1);{vyraz}
    StartPos:=Pos1;
    {St1:=Copy(St,Pos1,length(St)-Pos1+1);{vcetne _do}
    DoPos:=Pos;
    end
    else
    begin
    StartPos:=0;
    StA:=Copy(St,Apos,length(St)-APos+1);{vyraz}
    end;
   VarPos:=Apos;
   Apos:=1;
   repeat
   Pos1:=APos;
   St2:=ReadWord(StA,Pos1,APos);
   until (APos=0) or (AnsiUpperCase(St2)=kw_To)or (AnsiUpperCase(St2)=kw_DownTo);
   if not((AnsiUpperCase(St2)=kw_To)or (AnsiUpperCase(St2)=kw_DownTo)) then
   raise TCompilerError.CreatePos(1,0,length(St),'TO');
   TForLine(Output).Increase:=AnsiUpperCase(St2)=kw_To;
   St2:=Copy(StA,1,Pos1);
   St3:=Copy(StA,APos,length(StA)-APos+1);
   ToPos:=VarPos+APos-1;
   ForPos:=VarPos+CountSpaces(St2);
   St2:=BezVnejsichMezer(St2);
   if St2='' then raise TCompilerError.CreatePos(1,0,Forpos,'piazen');
   ToPos:=ToPos+CountSpaces(St3);
   St3:=BezVnejsichMezer(St3);
   if St3='' then raise TCompilerError.CreatePos(1,0,Topos,'konenou hodnotu');
   {text rozdelen na tri casti}

   if not FindAssigning(St2,APos) then raise TCompilerError.CreatePos(1,0,Forpos,'piazen');
   VarSt:=Copy(St2,1,APos-1);
   if St2[APos]=':' then inc (APos);
   ExprSt:=Copy(St2,APos+1,length(St2)-APos);
   Spaces:=CountSpaces(VarSt);
   VarSt:=BezVnejsichMezer(VarSt);
   if VarSt='' then raise TCompilerError.CreatePos(1,0,ForPos+Spaces,'promnnou');
   ExprSt:=BezVnejsichMezer(ExprSt);
   if ExprSt='' then raise TCompilerError.CreatePos(1,0,Forpos+Apos,'vraz');
   TForLine(Output).Variable:=GetNormalVariable(VarSt,ForPos);
   if TForLine(Output).Variable=nil then raise TCompilerError.CreatePos(5,0,ForPos,'');
   {TADY nefunguje test typu}
   if not(TForLine(Output).Variable.Typ in [_integer,_char]) then raise TCompilerError.CreatePos(6,0,ForPos,'');
   try
      apos:=apos+CountSpaces(ExprSt);
      ExprSt:=BezvnejsichMezer(ExprSt);
      ExpressionCompiler.Compline:=ExprSt;
      ExpressionCompiler.Doit;
   except
     on A:TCompilerError do
     begin
     A.position:=A.Position+VarPos+Apos;
     raise
     end;
   end;
   if ExpressionCompiler.StartPos>0 then raise TCompilerError.CreatePos(3,0,VarPos+ExpressionCompiler.StartPos,'');
   TForLine(Output).Startvalue:=TOperator(ExpressionCompiler.Output);
   TForLine(Output).Startvalue.GetTypeInfo;
   if not TForLine(Output).StartValue.TypeItem[TForLine(Output).variable.Typ] then {!raise typova kolizeforpos+apos};
   TForLine(Output).Startvalue.ClearTypeInfo;
   try
      ExpressionCompiler.Compline:=St3;
      ExpressionCompiler.Doit;
   except
    on A:TCompilerError do
     begin
     A.position:=A.position+ToPos;
     raise;
     end;
   end;
   if ExpressionCompiler.StartPos>0 then raise TCompilerError.CreatePos(3,0,VarPos+Apos+ExpressionCompiler.StartPos,'');
   TForLine(Output).Endvalue:=TOperator(ExpressionCompiler.Output);
   TForLine(Output).Endvalue.GetTypeInfo;
   if not TForLine(Output).Endvalue.TypeItem[TForLine(Output).Variable.Typ] then {!raise typova kolize topos};
   TForLine(Output).Endvalue.ClearTypeinfo;
 except
 TForLine(Output).Free;
 Output:=nil;
 raise
 end;
 end;

{TWhileCompiler}
function TWhileCompiler.GetKeyWord:string;
   begin
    result:=kw_WHILE;
   end;


 procedure TWhileCompiler.DoIt;
 var St,St1,Sta:string;
     APos,Pos,Pos1:longint;

      function IsBoolean:boolean;
      begin
      TWhileLine(Output).Expression.GetTypeInfo;
      result:=TWhileLine(Output).Expression.TypeItem[_boolean];
      TWhileLine(Output).Expression.ClearTypeInfo;
      end;

   begin
   try
   St:=CompLine;
   Output:=TWhileLine.Create;
   if not SupposedToCompile then
     raise TCompilerError.CreatePos(1,0,StartPos+CountSpacesInside(CompLine,StartPos),'WHILE');
   if not AllowedToCompile then
     raise TCompilerError.CreatePos(2,0,StartPos+CountSpacesInside(CompLine,StartPos),'WHILE');
   NewCurrentLineInfo(TLineInfo.Create);
   CurrentLineInfo.Line:=TPrgLine(Output);
   CurrentLineInfo.BlockType:=t_While;
   Pos:=StartPos;
   ReadFirstWord(Pos);
   if (Pos=0) or (BezVnejsichMezer(Copy(St,Pos,length(St)-pos+1))='')
      then raise TCompilerError.CreatePos(1,0,length(St)+1,'vraz');
   APos:=Pos;
   repeat
   Pos1:=Pos;
   St1:=ReadWord(St,Pos1,Pos);
   until (Pos=0) or (AnsiUpperCase(BezVnejsichMezer(St1))=kw_do);
   if AnsiUpperCase(BezVnejsichMezer(St1))=kw_do then
   begin
    StA:=Copy(St,Apos,Pos1-APos+1);{vyraz}
    StartPos:=Pos1;
    end
    else
    begin
    {St1:='';}
    StartPos:=0;
    StA:=Copy(St,Apos,length(St)-APos+1);{vyraz}
    end;

   try
   ExpressionCompiler.Compline:=StA;
   ExpressionCompiler.Doit;
   except
     on A:TCompilerError do
     begin
     A.position:=A.Position+APos;
     raise;
     end;
   end;
   TWhileLine(Output).Expression:=TOperator(ExpressionCompiler.Output);
   if ExpressionCompiler.StartPos>0 then raise TCompilerError.CreatePos(3,0,APos+ExpressionCompiler.StartPos,'');
   if not IsBoolean then {!raise musi byt boolean apos)};
 except
 TWhileLine(Output).Free;
 Output:=nil;
 raise
 end;
 end;


{TUntilCompiler}
function TUntilCompiler.GetKeyWord:string;
   begin
    result:=kw_UNTIL;
   end;

function TUntilCompiler.AllowedToCompile:boolean;
   begin
   result:=CurrentlineInfo.Blocktype in[t_Repeat,t_SingleRepeat,t_Until];
   end;


procedure TUntilCompiler.DoIt;
var St,StA:string;
    Pos:longint;

    function IsBoolean:boolean;
      begin
      TOperator(Output).GetTypeInfo;
      result:=TOperator(Output).TypeItem[_boolean];
      TOperator(Output).ClearTypeInfo;
      end;

begin
  try
   Output:=nil;
   St:=CompLine;
   if not SupposedToCompile then
     raise TCompilerError.CreatePos(1,0,StartPos+CountSpacesInside(CompLine,StartPos),'UNTIL');
   if not AllowedToCompile then
     raise TCompilerError.CreatePos(2,0,StartPos+CountSpacesInside(CompLine,StartPos),'UNTIL');
   Pos:=StartPos;
   ReadFirstWord(Pos);
   if (Pos=0) or (BezVnejsichMezer(Copy(St,Pos,length(St)-pos+1))='')
      then raise TCompilerError.CreatePos(1,0,length(St)+1,'vraz');
   StA:=Copy(St,Pos,length(St)-Pos+1);
   try
   ExpressionCompiler.Compline:=StA;
   ExpressionCompiler.Doit;
   except
     on A:TCompilerError do
     begin
     A.position:=A.Position+Pos;
     raise;
     end;
   end;
   Output:=ExpressionCompiler.Output;
   if CurrentLineInfo.Line is TPrgBlock then FreeCurrentlineInfo;
   TRepeatLine(CurrentLineInfo.Line).Expression:=TOperator(Output);
   if ExpressionCompiler.StartPos>0 then raise TCompilerError.CreatePos(3,0,Pos+ExpressionCompiler.StartPos,'');
   if not IsBoolean then {!raise musi byt boolean apos)};
   FreeCurrentLineInfo;
   StartPos:=0;
    except
    if Output<>nil then
      begin
      Output.free;
      output:=nil;
      end;
    raise
    end;
end;


{TCaseCompiler}
function TCaseCompiler.GetKeyWord:string;
   begin
    result:=kw_CASE;
   end;

procedure TCaseCompiler.Doit;
var St,St1,StA:string;
    Pos,APos,Pos1:longint;

    function IsPossible:boolean;
    var Exp:TOperator;
      begin
      Exp:=TCaseLine(Output).Expression;
      Exp.GetTypeInfo;
      result:=(Exp.TypeItem[_char]) or (Exp.TypeItem[_integer])
              or(Exp.TypeItem[_boolean])or(Exp.TypeItem[_string])
              or(Exp.TypeItem[_float]);
      Exp.ClearTypeInfo;
      end;

begin
   try
   St:=CompLine;
   Output:=TCaseLine.Create;
   if not SupposedToCompile then
     raise TCompilerError.CreatePos(1,0,StartPos+CountSpacesInside(CompLine,StartPos),'CASE');
   if not AllowedToCompile then
     raise TCompilerError.CreatePos(2,0,StartPos+CountSpacesInside(CompLine,StartPos),'CASE');
   NewCurrentLineInfo(TLineInfo.Create);
   CurrentLineInfo.Line:=TPrgLine(Output);
   CurrentLineInfo.BlockType:=t_Case;
   Pos:=StartPos;
   ReadFirstWord(Pos);
   if (Pos=0) or (BezVnejsichMezer(Copy(St,Pos,length(St)-pos+1))='')
       then raise TCompilerError.CreatePos(1,0,length(St)+1,'vraz');
   APos:=Pos;
   repeat
   Pos1:=Pos;
   St1:=ReadWord(St,Pos1,Pos);
   until (Pos=0) or (AnsiUpperCase(BezVnejsichMezer(St1))=kw_OF);
   if Pos=0 then  raise TCompilerError.CreatePos(1,0,length(St)+1,'OF');
   StA:=Copy(St,Apos,Pos1-APos);{vyraz}
   St1:=Copy(St,Pos,length(St)-Pos+1); {za of}
   if BezVnejsichMezer(St1)<>'' then StartPos:=Pos else StartPos:=0;
   try
   ExpressionCompiler.Compline:=StA;
   ExpressionCompiler.Doit;
   except
    on A:TCompilerError do
     begin
     A.position:=A.Position+APos;
     raise;
     end;
   end;
   TCaseLine(Output).Expression:=TOperator(ExpressionCompiler.Output);
   if ExpressionCompiler.StartPos>0 then raise TCompilerError.CreatePos(3,0,APos+ExpressionCompiler.StartPos,'');
   if not IsPossible then raise TCompilerError.CreatePos(7,0,APos,'');
   except
    TCaseLine(Output).Free;
    Output:=nil;
    raise
    end;
 end;

{ThenCompiler}
function TThenCompiler.GetKeyWord:string;
   begin
    result:=kw_THEN;
   end;

function TThenCompiler.AllowedToCompile:boolean;
   begin
   result:=CurrentlineInfo.Blocktype=t_If;
   end;


procedure TThenCompiler.Doit;
var St:string;
    Pos:longint;
begin
  try
   Output:=nil;
   St:=CompLine;
   Pos:=StartPos;
   if not SupposedToCompile then
     raise TCompilerError.CreatePos(1,0,StartPos+CountSpacesInside(CompLine,StartPos),'THEN');
   if not AllowedToCompile then
     raise TCompilerError.CreatePos(2,0,StartPos+CountSpacesInside(CompLine,StartPos),'THEN');
   ReadFirstWord(Pos);
   if (Pos=0) or (BezVnejsichMezer(Copy(St,Pos,length(St)-pos+1))='')
      then
      begin
      Output:=TPrgBlock.Create;
      NewCurrentLineInfo(TLineInfo.Create);
      CurrentLineInfo.Line:=TPrgBlock(Output);
      CurrentLineInfo.BlockType:=t_Then;
      StartPos:=0;
      end
      else
      begin
      StartPos:=Pos;
      CurrentLineInfo.BlockType:=t_SingleThen;
      end;
 except
 if Output<>nil then TPrgBlock(Output).Free;
 Output:=nil;
 raise
 end;
end;


{RepeatCompiler}

function TRepeatCompiler.GetKeyWord:string;
   begin
    result:=kw_REPEAT;
   end;

procedure TRepeatCompiler.Doit;
var St,St1:string;
    Pos,Pos1:longint;


begin
  try
   Output:=TRepeatLine.Create;
   St:=CompLine;
   if not SupposedToCompile then
     raise TCompilerError.CreatePos(1,0,StartPos+CountSpacesInside(CompLine,StartPos),'REPEAT');
   if not AllowedToCompile then
     raise TCompilerError.CreatePos(2,0,StartPos+CountSpacesInside(CompLine,StartPos),'REPEAT');
   Pos:=StartPos;
   ReadFirstWord(Pos);
   NewCurrentLineInfo(TLineInfo.Create);
   CurrentLineInfo.Line:=TRepeatLine(Output);
   CurrentLineInfo.BlockType:=t_SingleRepeat;
   if (Pos=0) or (BezVnejsichMezer(Copy(St,Pos,length(St)-pos+1))='')
      then
      begin
      TRepeatLine(Output).Block:=TPrgBlock.Create;
      NewCurrentLineInfo(TLineInfo.Create);
      CurrentLineInfo.Line:=TRepeatLine(Output).Block;
      CurrentLineInfo.BlockType:=t_Repeat;
      StartPos:=0;
      end
      else StartPos:=Pos;
 except
 Output.Free;
 raise
 end;
end;

{TDoCompiler}
function TDoCompiler.GetKeyWord:string;
   begin
    result:=kw_DO;
   end;

function TDoCompiler.AllowedToCompile:boolean;
   begin
   result:=CurrentlineInfo.Blocktype in[t_For,t_While];
   end;


procedure TDoCompiler.Doit;
var St:string;
    Pos:longint;
begin
  try
   Output:=nil;
   St:=CompLine;
   if not SupposedToCompile then
     raise TCompilerError.CreatePos(1,0,StartPos+CountSpacesInside(CompLine,StartPos),'DO');
   if not AllowedToCompile then
     raise TCompilerError.CreatePos(2,0,StartPos+CountSpacesInside(CompLine,StartPos),'DO');
   Pos:=StartPos;
   ReadFirstWord(Pos);
   if (Pos=0) or (BezVnejsichMezer(Copy(St,Pos,length(St)-pos+1))='')
      then
      begin
      Output:=TPrgBlock.Create;
      NewCurrentLineInfo(TLineInfo.Create);
      CurrentLineInfo.Line:=TPrgBlock(Output);
      CurrentLineInfo.BlockType:=t_Do;
      StartPos:=0;
      end
      else
      begin
      StartPos:=Pos;
      CurrentLineInfo.BlockType:=t_SingleDo;
      end;
 except
 if Output<>nil then TPrgBlock(Output).Free;
 Output:=nil;
 raise
 end;
end;


{TElseCompiler}
function TElseCompiler.GetKeyWord:string;
   begin
    result:=kw_Else;
   end;

function TElseCompiler.AllowedToCompile:boolean;
   begin
   result:=CurrentlineInfo.Blocktype in[t_Then,t_DoneThen,t_Case]
   end;

procedure TElseCompiler.Doit;
var St:string;
    Pos:longint;
begin
  try
   Output:=nil;
   St:=CompLine;
   if not SupposedToCompile then
     raise TCompilerError.CreatePos(1,0,StartPos+CountSpacesInside(CompLine,StartPos),'ELSE');
   if not AllowedToCompile then
     raise TCompilerError.CreatePos(2,0,StartPos+CountSpacesInside(CompLine,StartPos),'ELSE');
   Pos:=StartPos;
   ReadFirstWord(Pos);
   if (Pos=0) or (BezVnejsichMezer(Copy(St,Pos,length(St)-pos+1))='')
      then
      begin
      Output:=TPrgBlock.Create;
      NewCurrentLineInfo(TLineInfo.Create);
      CurrentLineInfo.Line:=TPrgBlock(Output);
      CurrentLineInfo.BlockType:=t_Else;
      StartPos:=0;
      end
      else
      begin
      StartPos:=Pos;
      CurrentLineInfo.BlockType:=t_SingleElse;
      end;
 except
 if Output<>nil then TPrgBlock(Output).Free;
 Output:=nil;
 raise
 end;
end;

{TCaseItemCompiler}


function TCaseItemCompiler.AllowedToCompile:boolean;
   begin
   result:=CurrentlineInfo.Blocktype in[t_Case]
   end;

function TCaseItemCompiler.ReadCaseItem(var p:longint;var IsString:boolean):string;
   var p1,len:longint;
       St:string;
   begin
   len:=length(St);
   St:=CompLine;
   result:=St;
   IsString:=false;
   p1:=p+CountSpacesInside(St,P);
   case St[p] of '''','"':
                 begin
                 result:=ReadAnyString(St,p1,p);
                 IsString:=true;
                 end
              else
                 begin
                 while (p<=len) and (St[p] in ['a'..'z','A'..'Z','0'..'9','+','-'])do inc(p);
                 result:=Copy(St,p1,p-p1);
                 end;
              end;{case}
   if p>0 then p:=p+CountSpacesInside(St,p);
   if p>len then p:=0;
   end;

procedure TCaseItemCompiler.DoIt;
var St,St1,St3:string;
    Pos:longint;
    IsSt:boolean;
    Cons:TTypeElement;
    Cis:double;
    err:integer;
    Cline:TCaseLine;
begin
{jedina vyjimka: sam si zapisuje vytvoreny PrgBlock
 do nadrazeneho prikazu-melo by se predelat, ale jak?}
  try
   Output:=nil;
   St:=Compline;
   Pos:=StartPos;
   St1:=ReadCaseItem(Pos,IsSt);
   if (Pos=0) or (St[Pos]<>':')
     then raise TCompilerError.CreatePos(1,0,Pos,':');
   {totez co supposedtocompile}
   if not AllowedToCompile
     then raise TCompilerError.CreatePos(8,0,StartPos,'');
   inc(pos);
   if (Pos>length(St)) or (BezVnejsichMezer(Copy(St,Pos,length(St)-pos+1))='') then Pos:=0;
   {vyhodnoceni hodnoty itemu}
   if IsSt then
          begin {char nebo string}
          if length(St1)=1 then Cons:=TCharElement.CreateValue(St1[1])
             else Cons:=TStringElement.CreateValue(St1);
          end
         else
          begin {zbyle varianty-boolean, integer,float}
          St3:=AnsiUpperCase(St1);
          if St3='FALSE' then Cons:=TBooleanElement.CreateValue(false)
          else if St3='TRUE' then Cons:=TBooleanElement.CreateValue(true)
          else
              begin {cisla nebo chyba}
              if StringIsFloat(St1) then
                 begin
                 cis:=StrToExtended(St1);
                 if trunc(Cis)=Cis then Cons:=TIntegerElement.CreateValue(trunc(Cis))
                       else Cons:=TFloatElement.CreateValue(Cis);
                 end
                 else raise TCompilerError.CreatePos(5,0,Pos,'');
              (*
              val(St1,Cis,err);
              if err<>0 then raise TCompilerError.CreatePos(5,0,Pos,'') else
                   begin {jeto cislo}
                   if trunc(Cis)=Cis then Cons:=TIntegerElement.CreateValue(trunc(Cis))
                       else Cons:=TFloatElement.CreateValue(Cis);
                   end;*)
              end;
          end;
   {dodelat ulozeni itemu}
   Cline:=TCaseLine(CurrentlineInfo.Line);
   CLine.CaseItem[CLine.CaseList.Count]:=Cons;
   if (Pos=0) then
      begin
      Output:=TPrgBlock.Create;
      NewCurrentLineInfo(TLineInfo.Create);
      CurrentLineInfo.Line:=TPrgBlock(Output);
      CurrentLineInfo.BlockType:=t_CaseBlock;
      StartPos:=0;
      end
      else
      begin
      StartPos:=Pos;
      CurrentLineInfo.BlockType:=t_SingleCase;
      end;
 except
 if Output<>nil then TPrgBlock(Output).Free;
 Output:=nil;
 raise
 end;
end;


{TEndCompiler}
function TEndCompiler.GetKeyWord:string;
   begin
    result:=kw_End;
   end;

function TEndCompiler.AllowedToCompile:boolean;
   begin
   result:=CurrentlineInfo.Blocktype in
           [t_Do,t_Procedure,t_Function,t_Then,t_Else];
   end;


procedure TEndCompiler.Doit;
var St:string;
    Pos:longint;
begin
  {try}
   Output:=nil;
   St:=CompLine;
   if not SupposedToCompile then
     raise TCompilerError.CreatePos(1,0,StartPos+CountSpacesInside(CompLine,StartPos),'END');
   if not AllowedToCompile then
     raise TCompilerError.CreatePos(2,0,StartPos+CountSpacesInside(CompLine,StartPos),'END');
   Pos:=StartPos;
   ReadFirstWord(Pos);
   if not((Pos=0) or (BezVnejsichMezer(Copy(St,Pos,length(St)-pos+1))=''))
      then raise TCompilerError.CreatePos(1,0,Pos,'konec dku');
   StartPos:=0;
   FreeCurrentLineInfo;
   Output:=CurrentLineInfo.Line;
   {except end;}
end;

{DeclarationCompiler}
procedure TDeclarationCompiler.SetLineList(aList:TOwnerEntity);
    begin
    if assigned(FLineList) then FreeElement(FLineList);
    AddElement(aList);
    FLineList:=aList;
    if assigned(FAssignCompiler) then AssignCompiler.Linelist:=aList;
    end;

function TDeclarationCompiler.GetLineList:TOwnerEntity;
    begin
    if not assigned(FLineList) then
       begin
       FLineList:=TOwnerEntity.Create;
       AddElement(FLineList);
       if assigned(FAssignCompiler) then AssignCompiler.Linelist:=FLineList;
       end;
    result:=FLineList;
    end;

function TDeclarationCompiler.AllowedToCompile:boolean;
   begin
   result:=CurrentlineInfo.Blocktype in[t_Procedure,t_Function];
   end;

function TDeclarationCompiler.GetAssignCompiler:TAssignCompiler;
   begin
   if not assigned(FAssignCompiler) then
       begin
       FAssignCompiler:=TAssignCompiler.Create;
       AddTool(FAssignCompiler);
       FAssignCompiler.LineList:=LineList;
       end;
   result:=FAssignCompiler;
   end;


procedure TDeclarationCompiler.SetAssignCompiler(aComp:TAssignCompiler);
   begin
   if assigned(FAssignCompiler) then FreeTool(FAssignCompiler);
   AddTool(aComp);
   FAssignCompiler:=aComp;
   FAssignCompiler.LineList:=LineList;
   end;

function TDeclarationCompiler.SupposedToCompile:boolean;
var St:string;
    Delimiters:TDelimiters;
    ResChar:char;
    Pos:longint;
  begin
  St:=CompLine;
  Delimiters:=['(',':','.','=',' ','''','"',')','+','-','*','/'];
  ReadToDelimiterWithoutWS(St,Delimiters,StartPos,ResChar,Pos);
  result:=ResChar=':';
  if ((Pos<=length(St)) and (Pos<>0)) then result:=result and (St[Pos]<>'=');
  end;

procedure TDeclarationCompiler.Doit;
var Delimiters:TDelimiters;
    St,St1,VarSt:string;
    Pos,Pos1,AbsPos,varpos:longint;
    ResChar,ResChar1:char;
    GoAssign:boolean;
    VarType:TType;
    Pro:TOilProc;

   function CanCreateVariable(VName:string):boolean;
   var Inf:TLineInfo;
       i,j:longint;
       PInf:TprocInfo;
      begin
      result:=false;
      Inf:=CurrentLineInfo;
      if (Inf.BlockType<>t_Function) and (Inf.BlockType<>t_procedure) then
         raise TCompilerError.CreatePos(9,0,VarPos,'');
      i:=1;
      j:=(TOilProc(Inf.Line)).VarNumber;
      VName:=AnsiUpperCase(VName);
      PInf:=Inf.ProcInfo;
      while (i<=j)and (PInf.VarName[i]<>VName) do inc(i);
      if (i>j) then result:=true;
      end;

   begin
   try
   Output:=nil;
   St:=CompLine;
   if not SupposedToCompile then
     raise TCompilerError.CreatePos(1,0,StartPos+CountSpacesInside(CompLine,StartPos),'deklaraci promnn');
   if not AllowedToCompile then
     raise TCompilerError.CreatePos(9,0,StartPos,'');
   Delimiters:=['(',':','.','=',' ','''','"',')','+','-','*','/'];
   St1:=ReadToDelimiterWithoutWS(St,Delimiters,StartPos,ResChar,Pos);
   varpos:=Pos;
   VarSt:=BezVnejsichMezer(St1);
   Pos1:=Pos+CountSpacesInside(St,Pos);
   St1:=ReadToDelimiterWithoutWS(St,Delimiters,Pos1,ResChar1,Pos);
   if not (ResChar1 in[':','=',#0]) then  raise TCompilerError.CreatePos(3,0,Pos-1,''); 
   GoAssign:=not (ResChar1=#0);
   if ResChar1=':' then if (Pos>length(St)) or(St[Pos]<>'=') then raise TCompilerError.CreatePos(3,0,Pos,'');
   AbsPos:=CountSpaces(St1);
   St1:=BezVnejsichMezer(St1);
   VarType:=ToType(St1);
   if VarType=_Other then raise TCompilerError.CreatePos(10,0,abspos+pos1,'');
   if VarType=_Pointer then St1:=AnsiUpperCase(CheckClassName(St1));
   if not CanCreateVariable(VarSt) then raise TCompilerError.CreatePos(11,0,VarPos,'')
    else
      begin
       Pro:=TOilProc(CurrentLineInfo.Line);
       if Pro.VarNumber=Maxvariables then raise TCompilerError.CreatePos(12,0,VarPos,'');
       Pro.VarInfoList.AddElement(TVarInfo.Create);
       Pro.VarName[Pro.VarNumber]:=St1;
       Pro.VarType[Pro.VarNumber]:=VarType;
       Pro.VarNumber:=Pro.VarNumber+1;
       CurrentLineInfo.procInfo.VarNumber:=CurrentLineInfo.procInfo.VarNumber+1;
       CurrentLineInfo.procInfo.VarName[CurrentLineInfo.procInfo.VarNumber]:=AnsiUpperCase(VarSt);
      end;
   if GoAssign then
     begin
      try
      Delete(St,Pos1-1,Pos-Pos1);
      AssignCompiler.StartPos:=1;
      AssignCompiler.Compline:=St;
      AssignCompiler.DoIt;
      Output:=AssignCompiler.Output;
      except
        on A:TCompilerError do
        begin
        Pro.VarNumber:=Pro.VarNumber-1;
        CurrentLineInfo.procInfo.VarNumber:=CurrentLineInfo.procInfo.VarNumber-1;
        A.position:=A.position+pos-pos1;
        raise
        end;
      end;
     end;
   finally end;
   StartPos:=0;
 end;


{TAssignCompiler}
function TAssignCompiler.TypeCheck(Op1,Op2:TOperator):boolean;
var i:TType;
   begin
   Op1.GetTypeInfo;
   Op2.GetTypeInfo;
   result:=false;
   for i:=_Boolean to _Other do result:=(result or (Op1.TypeItem[i] and Op2.TypeItem[i]));
   result:=result or (Op1.TypeItem[_float] and Op2.TypeItem[_integer]);
   result:=result or (Op1.TypeItem[_float] and Op2.TypeItem[_byte]);
   result:=result or (Op1.TypeItem[_integer] and Op2.TypeItem[_byte]);
   result:=result or (Op1.TypeItem[_string] and Op2.TypeItem[_char]);
   Op1.CleartypeInfo;
   Op2.ClearTypeInfo;
   end;

function TAssignCompiler.SupposedToCompile:boolean;
var St,St1:string;
    Pos:longint;
  begin
  St:=CompLine;
  St1:=Copy(St,StartPos,length(St)-StartPos+1);
  result:=FindAssigning(St1,Pos)
  end;

procedure TAssignCompiler.DoIt;
var St,St1:string;
    AbsPos,Pos,OpPos:longint;
    aOper:TOperator;

 begin
 try
 St:=CompLine;
 Output:=TAssignLine.Create;
 if not SupposedToCompile then
     raise TCompilerError.CreatePos(1,0,StartPos+CountSpacesInside(CompLine,StartPos),'piazen');
 if not AllowedToCompile then
     raise TCompilerError.CreatePos(2,0,StartPos+CountSpacesInside(CompLine,StartPos),'END');
 St1:=Copy(St,StartPos,length(St)-StartPos+1);
 StartPos:=StartPos+CountSpaces(St);
 St1:=BezVnejsichMezer(St1);
 St:=St1;
 FindAssigning(St,Pos);
 if Pos=1 then raise TCompilerError.CreatePos(1,0,StartPos,'promnnou');
 if ((St[Pos]='=') and (length(St)=Pos)) or ((St[Pos]=':') and (length(St)=Pos+1))
     then raise TCompilerError.CreatePos(1,0,length(St)+StartPos,'vraz'); 
 St1:=Copy(St,1,Pos-1);{promenna}
 try
  VariableCompiler.Compline:=BezVnejsichMezer(St1);
  VariableCompiler.StartPos:=1;
  VariableCompiler.Doit;
 except
   on A:TCompilerError do
     begin
     A.position:=A.Position+startpos-1;
     raise;
     end;
 end;
 TAssignLine(Output).LeftVar:=TVariable(VariableCompiler.Output);
 if VariableCompiler.StartPos>0 then raise TCompilerError.CreatePos(3,0,StartPos+VariableCompiler.StartPos,'');
 if St[pos]=':' then inc(Pos);
 St:=Copy(St,Pos+1,length(St)-Pos);
 Pos:=Pos+countSpaces(St)+1;
 St:=BezVnejsichMezer(St);
 try
 ExpressionCompiler.Compline:=St;
 ExpressionCompiler.StartPos:=1;
 ExpressionCompiler.Doit;
 except
   on A:TCompilerError do
     begin
     A.position:=A.Position+startpos+Pos+1;
     raise;
     end;
 end;
 TAssignLine(Output).Expression:=TOperator(ExpressionCompiler.Output);
 if not TypeCheck(TAssignLine(Output).LeftVar,TAssignLine(Output).Expression)
  then {!raise(vyraz nenni kompatibilni s promennou)};
 if ExpressionCompiler.StartPos=0 then StartPos:=0
    else StartPos:=StartPos+ExpressionCompiler.StartPos+Pos-1;
 except
 Output.Free;
 Output:=nil;
 raise;
 end
 end;


{TVariableCompiler}
procedure TVariableCompiler.SetLineList(aList:TOwnerEntity);
    begin
    if assigned(FLineList) then FreeElement(FLineList);
    AddElement(aList);
    FLineList:=aList;
    if assigned(FPathCompiler) then PathCompiler.Linelist:=aList;
    end;

function TVariableCompiler.GetLineList:TOwnerEntity;
    begin
    if not assigned(FLineList) then
       begin
       FLineList:=TOwnerEntity.Create;
       AddElement(FLineList);
       if assigned(FPathCompiler) then PathCompiler.Linelist:=FLineList;
       end;
    result:=FLineList;
    end;

function TvariableCompiler.GetPathCompiler:TPathCompiler;
   begin
   if not assigned(FPathCompiler) then
       begin
       FPathCompiler:=TPathCompiler.Create;
       AddTool(FPathCompiler);
       FPathCompiler.LineList:=LineList;
       end;
   result:=FPathCompiler;
   end;

procedure TVariableCompiler.SetPathCompiler(aComp:TPathCompiler);
   begin
   if assigned(FPathCompiler) then FreeTool(FPathCompiler);
   AddTool(aComp);
   FPathCompiler:=aComp;
   FPathCompiler.LineList:=LineList;
   end;

procedure TVariableCompiler.DoIt;
var St,VarSt,PathSt:string;
    Len,Abspos,Pos,DotPos,i,m,OpPos:longint;
    ResChar:char;
    Delimiters:TDelimiters;
    PInfo:TProcInfo;
    aVar:TOperator;

   begin
   try
   St:=CompLine;
   Output:=nil;
   StartPos:=StartPos+CountSpaces(St);
   St:=BezVnejsichmezer(St);
   if GetMainKeyWord(St,Startpos,OpPos) then
        St:=Copy(St,StartPos,OpPos-StartPos+1)
   else
       begin
       St:=Copy(St,StartPos,length(St)-StartPos+1);
       OpPos:=-1;
       end;
   VarSt:=ReadFromLastDot(St,DotPos);
   if VarSt='' then raise TCompilerError.CreatePos(1,0,length(St)+StartPos-1,'nzev promnn');
   AbsPos:=0;
   {kontrola stringu}
   if VarSt[1] in ['''','"'] then
      begin
       if length(VarSt)<=2 then raise TCompilerError.CreatePos(3,0,length(St)+StartPos-1,'');
       Len:=length(VarSt);
       VarSt:=ReadAnyString(VarSt,1,Pos);
       if length(VarSt)<>Len+2 then raise TCompilerError.CreatePos(1,0,Dotpos+length(VarSt)+1,VarSt[1]);
       AbsPos:=1;
      end
   else
      begin
      Delimiters:=['''','"','('];
      ReadToDelimiterWithoutWS(VarSt,Delimiters,1,ResChar,Pos);
      if ResChar<>#0 then raise TCompilerError.CreatePos(3,0,StartPos,'');
      end;
   {kontrola stringu}
   if DotPos=0 then
      begin {Normalni promenna, nebo od ActiveElementu}
      i:=LineList.Count-1;
      while (i>=0) and (Output=nil) do
         begin
         if LineInfo[i].BlockType in [t_Procedure,t_Function] then
            begin
            PInfo:=LineInfo[i].ProcInfo;
            if PInfo.VarNumber>0 then for m:=1 to PInfo.VarNumber do
                if PInfo.VarName[m]=AnsiUppercase(varSt) then
                   begin
                   if m<=PInfo.Calls then Output:=TCalledVariable.Create
                       else
                         Output:=TNormalVariable.Create;
                   TNormalVariable(Output).Block:=TPrgBlock(LineInfo[i].Line);
                   {## zkontrovat zda se zapisuje na spravne misto}
                   TNormalVariable(Output).VarIndex:=m-1{-PInfo.References};
                   end;
            end;
         dec(i);
         end;
      if Output=nil then
            begin {od ActiveElementu}
            aVar:=TNormalVariable.Create;
            TNormalVariable(aVar).Block:=TPrgBlock(LineInfo[0].Line);
            TNormalVariable(aVar).VarIndex:=ActiveElIndex{poradi Activeelemetu ve stacku};
            Output:=TPropVariable.Create;
            TPropVariable(Output).InitialExp:=aVar;
            TPropVariable(Output).PropertyName:=VarSt;
            end;
      end;   {Normalni promenna, nebo od ActiveElementu}
      if DotPos=1 then
         begin {od ActiveElementu}
         aVar:=TNormalVariable.Create;
         TNormalVariable(aVar).Block:=TPrgBlock(LineInfo[0].Line);
         TNormalVariable(aVar).VarIndex:=ActiveElIndex{poradi Activeelemetu ve stacku};
         Output:=TPropVariable.Create;
         TPropVariable(Output).InitialExp:=aVar;
         TPropVariable(Output).PropertyName:=VarSt;
         end;  {od ActiveElementu}
      if DotPos>1 then
         begin {predchazi nejaka cesta}
         Output:=TPropVariable.Create;
         TPropVariable(Output).PropertyName:=VarSt;
         PathSt:=Copy(St,StartPos,DotPos-StartPos);
         PathCompiler.StartPos:=1;
         PathCompiler.CompLine:=PathSt;
         PathCompiler.DoIt;
         TPropVariable(Output).InitialExp:=TOperator(PathCompiler.Output);
         {typova kontrola}
         TOperator(PathCompiler.Output).GetTypeInfo;
         if not (TOperator(PathCompiler.Output).TypeItem[_pointer] or TOperator(PathCompiler.Output).TypeItem[_other])
               then
               begin
               TOperator(PathCompiler.Output).ClearTypeInfo;
               {!raise typove nemozne StartPos+dotpos}
               end;
         TOperator(PathCompiler.Output).ClearTypeInfo;
         end;  {predchazi nejaka cesta}
   If Oppos=-1 then Startpos:=0 else StartPos:=StartPos+OpPos-1; 
   except
   if Output<>nil then Output.Free;
   raise
   end;
   end;

{PathCompiler}
procedure TPathCompiler.DoIt;
   var St:string;
   begin
   try
   Output:=nil;
   St:=CompLine;
   {Veskere vnejsi mezery uz musi byt odstraneny predem}
   if St='' then raise TCompilerError.CreatePos(1,0,length(St)+1,'nzev promnn');
   FunctionCompiler.CompLine:=St;
   FunctionCompiler.StartPos:=StartPos;
   if FunctionCompiler.SupposedToCompile then
      begin   {FUNKCE}
      FunctionCompiler.DoIt;
      Output:=FunctionCompiler.Output;
      end     {FUNKCE}
   else
      begin
      ToolCompiler.CompLine:=St;
      ToolCompiler.StartPos:=StartPos;
      if ToolCompiler.SupposedToCompile then
         begin {TOOL, nebo FUNKCE}
         ToolCompiler.DoIt;
         Output:=ToolCompiler.Output;
         end {TOOL, nebo FUNKCE}
       else
         begin {PROPERTA, nebo PROMENNA}
          VariableCompiler.Compline:=St;
          VariableCompiler.StartPos:=StartPos;
          VariableCompiler.DoIt;
          Output:=VariableCompiler.Output;
         end;  {PROPERTA, nebo PROMENNA}
      end;
    except
    if Output<>nil then Output.Free;
    raise
    end;
    end;


{TExpressionCompiler}

procedure TExpressionCompiler.DoIt;
type
  TKeyWord=(_start,
       _NOT,_AND,_OR,_MOD,_DIV,_SMALLER,_GREATER,_EQUAL,_ADD,
      _SUBTRACT,_MULTIPL,_DIVIDE,
      _stop);

var OpPos:longint;
    St:string;
const  KeyWord:array[TKeyWord] of string=('',
       'NOT','AND','OR','MOD','DIV','<','>','=','+',
       '-','*','/',
       '');



       function GetKeyWord(S:string):TKeyWord;
       {pokud neni S klicove slovo vraci _start}
           var i:TKeyWord;
           begin
            result:=_start;
            S:=AnsiUpperCase(BezVnejsichMezer(S));
            for i:=succ(_start) to pred(_stop) do if KeyWord[i]=S then result:=i;
           end;

       function IsKeyWord(S:string;Pos:longint;var ResOp:TKeyWord;var TPos:longint):boolean;
           var Delimiters:TDelimiters;
               S1:string;
               Pos1:longint;
               ResChar:char;
           begin
           result:=false;
           Delimiters:=['''','"','(',' ','<','>','=','+',
                     '-','*','/'];
           TPos:=Pos+CountSpacesInside(S,Pos);
           if S[TPos] in ['<','>','=','+','-','*','/'] then
                begin
                result:=true;
                ResOp:=GetKeyWord(S[TPos]);
                end
           else
             begin
             S1:=ReadToDelimiterWithoutWS(S,Delimiters,Pos,ResChar,Pos1);
             ResOp:=GetKeyWord(S1);
             if ResOp<>_start then result:=true;
             end;
           end;


       function ReadWholeWord(S:string;Pos:longint;var TPos:longint):string;
           var Delimiters:TDelimiters;
               Pos1,TmpPos:longint;
               Op:TkeyWord;
               EndIt:boolean;
               ResChar:char;
           begin
           Delimiters:=['''','"','(',' ','.','<','>','=','+',
                        '-','*','/'];
           Pos:=Pos+CountSpacesInside(S,Pos);
           {S:=BezVnejsichMezer(S);}
           result:='';
           Pos1:=Pos;
           Endit:=false;
           repeat
             if S[Pos] in ['''','"'] then
                begin
                ReadAnyString(S,Pos,Pos);
                if (Pos>length(S)) or (S[pos]<>'.') then EndIt:=true;
                end
             else
             if S[Pos]='(' then
                begin
                ReadBrackets(S,Pos,Pos);
                if (Pos>length(S)) or (S[pos]<>'.') then EndIt:=true;
                end
             else
                begin
                ReadToDelimiterWithoutWS(S,Delimiters,pos,ResChar,Pos);
                {if Pos>=length(s) then EndIt:=true
                else}
                case ResChar of
                     '.':EndIt:=false;
                     ' ':
                         begin
                         EndIt:=false;
                         if GetKeyWord(Copy(S,Pos1,Pos-Pos1))<>_start then EndIt:=true
                         else
                         if IsKeyWord(S,Pos,Op,TmpPos) then EndIt:=true
                         else
                         if S[Pos+CountSpacesInside(S,Pos)-1] in ['''','"','('] then EndIt:=true;
                         end
                     else
                         begin
                         EndIt:=true;
                         if not IsKeyWord(S,Pos1,Op,TmpPos) then dec(Pos);
                         end;
                     end;{case}
                end;
           until EndIt;
           result:=Copy(S,Pos1,Pos-Pos1);
           TPos:=Pos;
           end;

      function FindBinaryOperator(S:string;var Pos:longint;var ResOp:TKeyWord):boolean;
          var FreeOp:boolean;
              St:string;
              Pos1:longint;
              Priority,Pr:byte;
              Op:TKeyWord;
          begin
          FreeOp:=false;
          result:=false;
          Pos1:=1;
          Priority:=1;
          ResOp:=_start;
          repeat
          St:=ReadWholeWord(S,Pos1,Pos1);
          Op:=GetKeyWord(St);
          if Op<>_start then
             begin
              case Op of
               _AND,_OR:Pr:=5;
               _SMALLER,_GREATER,_EQUAL:Pr:=4;
               _MOD,_DIV:Pr:=3;
               _ADD,_SUBTRACT:if FreeOp then Pr:=2 else Pr:=0;
               _MULTIPL,_DIVIDE:Pr:=1;
               else Pr:=0;
              end;{case}
             FreeOp:=False;
             if Pr>=Priority then
                begin
                 result:=true;
                 Priority:=Pr;
                 Pos:=Pos1-length(St);
                 ResOp:=Op;
                end;
             end
             else FreeOp:=true;
          until Pos1>length(S);
         end;

         function CompileExpString(S:string):TOperator;
            var LeftSt,RightSt:string;
                Pos,AbsPos:longint;
                Op:TKeyWord;
                Value:extended;
                Code:integer;
            begin
            result:=nil;
            try
            Pos:=1;
            if FindBinaryOperator(S,Pos,Op) then
                begin
                LeftSt:=Copy(S,1,Pos-1);
                RightSt:=Copy(S,Pos+length(KeyWord[Op]),length(S)-Pos-length(KeyWord[Op])+1);
                if BezVnejsichMezer(LeftSt)='' then raise TCompilerError.CreatePos(1,0,Pos+length(KeyWord[Op]),'vraz');
                if BezVnejsichMezer(RightSt)='' then raise TCompilerError.CreatePos(1,0,Pos,'vraz');
                case Op of
                 _AND:result:=TAndOperator.Create;
                 _OR:result:=TOrOperator.Create;
                 _SMALLER:result:=TMensiOperator.Create;
                 _GREATER:result:=TVetsiOperator.Create;
                 _EQUAL:result:=TRovnoOperator.Create;
                 _ADD:result:=TPlusOperator.Create;
                 _SUBTRACT:result:=TMinusOperator.Create;
                 _MULTIPL:result:=TKratOperator.Create;
                 _DIVIDE:result:=TDelenoOperator.Create;
                 _MOD:result:=TModOperator.Create;
                 _DIV:result:=TDivOperator.Create;
                 end;{CASE}
                (*
                result.ParamsIndex:=0; nejspise zbytecne
                *)
                try
                result.FirstOperator:=CompileExpString(LeftSt);
                result.SecondOperator:=CompileExpString(RightSt);
                except
                 on A:TCompilerError do
                   begin
                   A.position:=A.position+Pos+length(KeyWord[Op])-1;
                   raise
                   end;
                end;
                end{BINARNI OPERATOR}
           else
                begin {unarni operator, properta, promena nebo chyba}
                if IsKeyWord(S,1,Op,Pos) and (Op in [_ADD,_SUBTRACT,_NOT]) then
                     begin {UNARNI OPERATOR}
                     RightSt:=Copy(S,Pos+length(KeyWord[Op]),length(S)-Pos-length(KeyWord[Op])+1);
                     abspos:=abspos+CountSpaces(RightSt);
                     RightSt:= BezVnejsichMezer(RightSt);
                     if RightSt='' then raise TCompilerError.CreatePos(1,0,Pos+length(KeyWord[Op]),'vraz');
                     try
                     case Op of
                         _NOT:
                              begin
                              result:=TNotOperator.Create;
                              result.FirstOperator:=CompileExpString(RightSt);
                              end;
                         _SUBTRACT:
                              begin
                              result:=TUnMinusOperator.Create;
                              result.FirstOperator:=CompileExpString(RightSt);
                              end;
                         _ADD:
                              begin
                              result:=TUnMinusOperator.Create;
                              result.FirstOperator:=CompileExpString(RightSt);
                              end;
                         end;{case}
                      except
                      on A:TCompilerError do
                        begin
                        A.position:=A.position+Pos+length(KeyWord[Op])-1;
                        raise
                        end;
                      end;
                     end   {UNARNI OPERATOR}
                else
                     begin {ZADNY OPERATOR NENALEZEN}
                     AbsPos:=CountSpaces(S);
                     S:=BezVnejsichMezer(S);
                     case S[1] of
                            '(':
                                begin {ODSTRANENI UZAVORKOVANI}
                                LeftSt:=ReadBrackets(S,1,Pos);
                                RightSt:=Copy(S,Pos,length(S)-Pos+1);
                                if (BezVnejsichMezer(RightSt)<>'') and (RightSt[1]<>'.') then
                                    raise TCompilerError.CreatePos(3,0,Pos,'');
                                try
                                result:=CompileExpString(LeftSt);
                                except
                                 on A:TCompilerError do
                                      begin
                                      A.position:=A.position+AbsPos;
                                      raise
                                      end;
                                end;
                                end;  {ODSTRANENI UZAVORKOVANI}
                            '"','''':
                                begin
                                LeftSt:=ReadAnyString(S,1,Pos);
                                RightSt:=Copy(S,Pos,length(S)-Pos+1);
                                if (BezVnejsichMezer(RightSt)<>'') then
                                   begin
                                   if(RightSt[1]<>'.') then raise TCompilerError.CreatePos(3,0,Pos,'')
                                      else
                                      begin
                                      try
                                      PathCompiler.CompLine:=RightSt;
                                      result:=TOperator(PathCompiler.Output);
                                      except
                                       on A:TCompilerError do
                                       begin
                                       A.position:=A.position+Pos+AbsPos;
                                       raise
                                       end;
                                      end;
                                      end;
                                   end
                                else
                                   begin  {konstanta uvnitr stringu;}
                                   result:=TConstOperator.Create;
                                   if S[1]='"' then
                                            begin
                                            if (length(LeftSt)=1) then
                                             TConstOperator(result).Constant:=TCharElement.CreateValue(LeftSt[1])
                                            else  TConstOperator(result).Constant:=TStringElement.CreateValue(LeftSt);
                                            end
                                    else
                                    begin {stara konstanta}
                                        if StringIsFloat(LeftSt) then
                                           begin
                                           value:=StrToExtended(LeftSt);
                                           if trunc(value)=value then
                                              TConstOperator(result).Constant:=TIntegerElement.CreateValue(trunc(value))
                                              else TConstOperator(result).Constant:=TFloatElement.CreateValue(value);
                                           end
                                       (*
                                       Val(LeftSt,Value,Code);
                                       if Code=0 then
                                         begin {CISELNA KONSTANTA}
                                         if trunc(Value)=Value then
                                         TConstOperator(result).Constant:=TIntegerElement.CreateValue(trunc(Value))
                                         else TConstOperator(result).Constant:=TFloatElement.CreateValue(Value)
                                         end  {CISELNA KONSTANTA}
                                        *)
                                      else
                                     {BOOLEANY}
                                        if AnsiUpperCase(S)='FALSE' then
                                           TConstOperator(result).Constant:=TBooleanElement.CreateValue(false)
                                        else
                                        if AnsiUpperCase(S)='TRUE' then
                                           TConstOperator(result).Constant:=TBooleanElement.CreateValue(true)
                                   {BOOLEANY}
                                        else TConstOperator(result).Constant:=TStringElement.CreateValue(LeftSt);
                                    end;
                                   end;
                                end {konstanta uvnitr stringu;}
                            else
                                begin {FUNKCE,PROPERTY, NEUZAVRENE KONSTANTY, ATD...}
                                if StringIsFloat(S) then
                                           begin
                                           result:=TConstOperator.Create;
                                           value:=StrToExtended(S);
                                           if trunc(value)=value then
                                              TConstOperator(result).Constant:=TIntegerElement.CreateValue(trunc(value))
                                              else TConstOperator(result).Constant:=TFloatElement.CreateValue(value);
                                           end
                                (*
                                Val(S,Value,Code);
                                if Code=0 then
                                   begin {CISELNA KONSTANTA}
                                   result:=TConstOperator.Create;
                                   if trunc(Value)=Value then
                                      TConstOperator(result).Constant:=TIntegerElement.CreateValue(trunc(Value))
                                      else TConstOperator(result).Constant:=TFloatElement.CreateValue(Value)
                                   end  {CISELNA KONSTANTA}
                                   *)
                                  else
                                   {BOOLEANY}
                                   if AnsiUpperCase(S)='FALSE' then
                                       begin
                                       result:=TConstOperator.Create;
                                       TConstOperator(result).Constant:=TBooleanElement.CreateValue(false)
                                       end
                                  else
                                   if AnsiUpperCase(S)='TRUE' then
                                       begin
                                       result:=TConstOperator.Create;
                                       TConstOperator(result).Constant:=TBooleanElement.CreateValue(true)
                                       end
                                   {BOOLEANY}
                                  else
                                   begin {PROPERTA,FUNKCE,nebo CHYBA}
                                   PathCompiler.Compline:=S;
                                   PathCompiler.StartPos:=1;
                                   try
                                   PathCompiler.DoIt;
                                   result:=TOperator(PathCompiler.Output);
                                   except
                                      on A:TCompilerError do
                                      begin
                                      A.position:=A.position+AbsPos;
                                      raise
                                      end;
                                   end;
                                   end;{PROPERTA,FUNKCE,nebo CHYBA}
                                end;  {FUNKCE,PROPERTY, NEUZAVRENE KONSTANTY, ATD...}
                     end{case}
                     end; {ZADNY OPERATOR NENALEZEN}
                end;
           except
           on A:TCompilerError do
              begin
              if result<>nil then result.free;
              result:=nil;
              raise;
              end;
              end;
           end;{CompileExpString}

begin{TExpersionCompiler.Doit}
 try
 Output:=nil;
 if GetMainKeyWord(CompLine,StartPos,OpPos) then
    begin
    St:=Copy(St,StartPos,OpPos-StartPos+1);
    StartPos:=OpPos;
    end
 else
    begin
    St:=Copy(CompLine,StartPos,length(Compline)-StartPos+1);
    StartPos:=0;
    end;
 Output:=CompileExpString(St);
 except
   on A:TCompilerError do
      begin
      A.position:=A.position+StartPos;
      raise
      end;
 end;
end;


{ToolCompiler}
function TToolCompiler.SupposedToCompile:boolean;
var St,S,S1:string;
    Pos,Pos1:longint;
    Del:TDelimiters;
    resChar:char;
begin
result:=false;
St:=CompLine;
St:=Copy(St,StartPos,length(St)-StartPos+1);
S:=ReadFromLastDot(St,Pos);
Del:=['''','"','('];
Pos:=1;
repeat
case S[Pos] of
        '''','"':begin
                 ReadAnyString(S,Pos,Pos1);
                 Pos1:=Pos;
                 end;
             '(':begin
                 readbrackets(S,pos,Pos1);
                 if Pos1=length(s)+1 then result:=true;
                 end;
         else
          begin
          ReadToDelimiterWithoutWS(S,Del,Pos,ResChar,Pos1);
          if ResChar=#0 then Pos1:=0 else Dec(Pos1);
          Pos:=Pos1;
          end;
         end;{case}
until (Pos=0) or result;
end;

procedure TToolCompiler.DoIt;
var St,Err,ToolName,PathSt,SingleSt,ParamSt,PropName,ExprSt:string;
    Pos,Pos1,Pos2,Pos3,Dotpos,
    OpPos,PropNumber,PNumber:longint;
    Delimiters:TDelimiters;
    ResChar:char;
    aClass:TClass;
    aTool:TTool;

    function ReadSingleParametr(S:string;SPos:longint;var ResPos:longint):string;
    {Pri poslednim cteni vraci ResPos:=0}
    var Del:TDelimiters;
        out:boolean;
        CutPos:longint;
    begin
    Result:='';
    Del:=['''','"','(',','];
    out:=false;
    CutPos:=SPos;
    if SPos>length(S) then ResPos:=0
     else
     repeat
     ReadToDelimiterWithoutWS(S,Del,SPos,ResChar,ResPos);
     case ResChar of
        ',':
           begin
           Result:=Copy(s,CutPos,ResPos-CutPos-1);
           out:=true;
           end;
        #0:begin
           dec(ResPos);
           Result:=Copy(s,CutPos,ResPos-CutPos);
           out:=true;
           end;
        '(':begin
            ReadBrackets(S,ResPos-1,ResPos);
            if ResPos=0 then
             begin
             result:=Copy(S,CutPos,length(s)+1-CutPos);
             out:=true;
             end
            else SPos:=ResPos{result:=Copy(S,SPos,ResPos-SPos)};
            end;
        '"','''':
            begin
            ReadAnyString(S,ResPos-1,ResPos);
            if ResPos=0 then
             begin
             result:=Copy(S,CutPos,length(s)+1-CutPos);
             out:=true;
             end
            else SPos:=ResPos
            (*
            if ResPos=SPos+1 then
               begin
               ReadAnyString(S,ResPos-1,ResPos);
               if ResPos=0 then
                begin
                result:=Copy(S,CutPos,length(s)+1-CutPos)
                out:=true;
                end
               else result:=Copy(S,CutPos,ResPos-CutPos);
               end
             else
               result:=Copy(S,CutPos,ResPos-1-CutPos);
              *)
            end;
      end;{case}
     until  out;
  end;

  function IsProperty(Name:string;var ResPNumber:longint):boolean;
  var OrbClass:TOrbisclass;
      PCount,i:integer;
  begin
  result:=false;
  OrbClass:=TOrbisClass.Create;
  OrbClass.ElementClass:=TToolOperator(Output).ToolClass;
  PCount:=OrbClass.PropCount;
  i:=1;
  while (not result) and (i<=PCount) do
     begin
     result:=result or (AnsiUpperCase(Name)=AnsiUpperCase(OrbClass.PropertyName[i-1]));
     inc(i);
     end;
  ResPNumber:=i-1;
  OrbClass.Free;
  end;

  function SplitString(Str:string;var Position:longint):string;
  var Del:TDelimiters;
      out:boolean;
      Pos,Pos1:longint;
      ResChar:char;
  begin
  Pos:=1;
  out:=false;
  Del:=['''','"',':'];
  repeat
  ReadToDelimiterWithoutWs(Str,Del,Pos,ResChar,Pos1);
  case ResChar of
      ':':
          begin
          out:=true;
          result:=Copy(Str,1,Pos1-2);
          Position:=Pos1;
          end;
      '''','"':
          begin
          Pos:=Pos1;
          ReadAnyString(Str,Pos,pos1);
          if Pos1=0 then
           begin
           out:=true;
           result:=Str;
           Position:=0;
           end;
          end
       else
        begin
        out:=true;
        result:=Str;
        Position:=0;
        end;
      end;{case}
  until out;
  end;

{hlavni telo}
begin
aTool:=nil;
try
try
Output:=TToolOperator.Create;
if not SupposedToCompile then
     raise TCompilerError.CreatePos(1,0,StartPos+CountSpacesInside(CompLine,StartPos),'nstroj');
if not AllowedToCompile then
     raise TCompilerError.CreatePos(2,0,StartPos+CountSpacesInside(CompLine,StartPos),'voln nstroj');
if GetMainKeyWord(CompLine,StartPos,OpPos) then
    St:=Copy(CompLine,StartPos,OpPos-StartPos+1)
 else
 begin
 St:=Copy(CompLine,StartPos,length(Compline)-StartPos+1);
 OpPos:=0;
 end;
St:=ReadFromLastDot(St,DotPos);
PathSt:=Copy(Compline,StartPos,DotPos-StartPos);
Delimiters:=['('];
if St[1] in ['''','"'] then
   begin
   ToolName:=ReadAnyString(St,1,Pos);
   if St[Pos]<>St[1] then
        raise TCompilerError.CreatePos(1,0,Pos+StartPos,St[1]);
   end
 else ToolName:=ReadToDelimiterWithoutWs(St,Delimiters,1,ResChar,Pos);
ParamSt:=ReadBrackets(St,Pos-1,Pos2);

if not IsRegisteredTool(toolName,aClass) then
       raise TCompilerError.CreatePos(13,0,StartPos+DotPos+1,'');
TToolOperator(Output).ToolClass:=TToolClass(aClass);
aTool:=TToolClass(aClass).Create;
Pos1:=1;
Propnumber:=0;
repeat
SingleSt:=ReadSingleParametr(ParamSt,Pos1,Pos2);
if Pos2<>0 then
  begin
  if SingleSt='' then raise TCompilerError.CreatePos(1,0,StartPos+pos+pos1,'vstupn parametr');
  PropName:=SplitString(SingleSt,Pos3);
  if Pos3=1 then raise TCompilerError.CreatePos(1,0,Startpos+Pos+pos3,'nzev property');
  if Pos3=length(SingleSt) then raise TCompilerError.CreatePos(1,0,Startpos+Pos+pos3,'nzev property');
  if Pos3=0 then
     begin {pouze cislo poperty}
     pos3:=1;
     ExprSt:=SingleSt;
     {getit}
     PropName:=aTool.NumberToPropertyName(PropNumber);
     end;
  if not IsProperty(PropName,PNumber) then
      raise TCompilerError.CreatePos(14,0,Startpos+Pos+pos3,'');
  ExprSt:=Copy(SingleSt,Pos3,length(SingleSt)-Pos3+1);
  try
  ExpressionCompiler.CompLine:=ExprSt;
  ExpressionCompiler.StartPos:=1;
  ExpressionCompiler.DoIt;
  except
    on A:TCompilerError do
    begin
    A.Position:=A.Position+pos+pos3;
    raise
    end;
  end;
  TToolOperator(Output).PropInputList.AddElement(TToolInputInfo.Create);
  TToolOperator(Output).PropInputItem[TToolOperator(Output).PropInputList.Count-1].InputExpr:=
                                         TOperator(ExpressionCompiler.Output);
  TToolOperator(Output).PropInputItem[TToolOperator(Output).PropInputList.Count-1].PropIndex:=PNumber;
  if ExpressionCompiler.Startpos>0 then
     raise TCompilerError.CreatePos(3,0,Startpos+Pos+pos3+ExpressionCompiler.Startpos,'');
  end
  else if PropNumber<>0 then raise TCompilerError.CreatePos(15,0,Startpos+Pos,'');
  inc(PropNumber);
  Pos1:=Pos2;
until Pos2=0;
try
PathCompiler.Compline:=PathSt;
PathCompiler.Startpos:=1;
PathCompiler.DoIt;
except
  on A:TCompilerError do
  begin
  A.position:=A.Position+Startpos;
  raise;
  end;
end;
TToolOperator(Output).MainInput:=TOperator(PathCompiler.Output);
StartPos:=OpPos;
finally if atool<>nil then aTool.Free; end;
except
if Output<>nil then Output.Free;
raise
end;
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
{TFunctionCompiler}
function TFunctionCompiler.AllowedToCompile:boolean;
begin
result:=CurrentLineInfo.blocktype in [t_Procedure,t_Function];
end;


function TFunctionCompiler.SupposedToCompile:boolean;
var st:string;
    p:longint;
begin
p:=Startpos;
st:=ReadFirstWord(P);
result:=(st=kw_Proc)or(st=kw_Func);
end;

procedure TFunctionCompiler.DoIt;
begin

end;
end.
