unit T_fescr;
{ for each script }
interface
uses
  Elements, Tools, T_CmdLn;

type

TForEachDoScript = class(TCommandLine)
private
   procedure SetNextAutoVar(aValue: TElement);
protected
public
   procedure DoIt; override;
   function NumberToPropertyName(aNumber: longInt): string; override;
published
   property NextAutoVar: TElement write SetNextAutoVar;
end;

implementation
uses
   SysUtils,
  {!T_Main,}
   e_Type,
   e_Class;

{ TForEachDoScript }

procedure TForEachDoScript.SetNextAutoVar(aValue: TElement);
begin
   if aValue = nil then exit;
   SetNewVar(UpperCase(aValue.Name),_Pointer, TElement);
   TElementVar(ActualVar)._Element := aValue;
end;

function  TForEachDoScript.NumberToPropertyName(aNumber: longInt): string;
begin
  case aNumber of
     0: result := 'ActualDirectory';
     1: result := 'FileName';
  else
     result := 'NextAutoVar';
  end;
end;


procedure TForEachDoScript.DoIt;
var
   i: longInt;
   E: TEntity;
begin
   if (Input = nil) or not(Input is TEntity) then exit;
   E := TEntity(Input);
   for i := 0 to E.Count -1 do
   begin
      Input := E.Elements[i];
      inherited DoIt;
   end;
end;


BEGIN
   RegisterOrbisClass(TForEachDoScript);
end.
