unit T_Oper;

interface
uses Elements,
  E_type,
  TypInfo,
  SysUtils,
  Tools,{t_edit,}
  t_recurs,dialogs,classes
  {creacond;};

type
 TShortList=class(TOwnerElement)
private
  FList:TList;
  function GetItem(index:integer):pointer;
  procedure SetItem(index:integer;aItem:pointer);
public
  constructor create;override;
  destructor destroy;override;
  property Item[index:integer]:pointer read GetItem write SetItem;
end;

TTypeList=array[TType] of boolean;
PTypeList=^TTypeList;

TOperator=class(TTechnology)
private
 procedure SetFirstOperator(aOperator:TOperator);virtual;abstract;
 function GetFirstOperator:TOperator;virtual;abstract;
 procedure SetSecondOperator(aOperator:TOperator);virtual;abstract;
 function GetSecondOperator:TOperator;virtual;abstract;
 procedure SetFirstResult(aResult:TTypeElement);virtual;abstract;
 function GetFirstResult:TTypeElement;virtual;abstract;
 procedure SetSecondResult(aResult:TTypeElement);virtual;abstract;
 function GetSecondResult:TTypeElement;virtual;abstract;
 procedure SetIndex(aIndex:integer);virtual;abstract;
 function GetIndex:integer;virtual;abstract;
 procedure ClearResults;virtual;abstract;
 procedure SetParamsTable(aTable:TShortList);virtual;abstract;
 function GetParamsTable:TShortList;virtual;abstract;
 function GetTypeItem(index:TType):boolean;virtual;abstract;
 procedure SetTypeItem(index:TType;aValue:boolean);virtual;abstract;
 function GetTypeList:PTypeList;virtual;abstract;
 procedure SetTypeList(aList:PTypeList);virtual;abstract;
 procedure SetParamItem(index:integer;aItem:pointer);virtual;abstract;
 function GetParamItem(index:integer):pointer;virtual;abstract;
 property Typelist:PTypeList read GetTypeList write SetTypeList;
protected
 procedure ReadFirstResult;virtual;abstract;
 procedure ReadSecondResult;virtual;abstract;
public
 {procedure HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);override}
 procedure SpreadParameters;virtual;abstract;
 procedure CleanData;virtual;abstract;
 property FirstOperator:TOperator read GetFirstOperator write SetFirstOperator;
 property SecondOperator:TOperator read GetSecondOperator write SetSecondOperator;
 property FirstResult:TTypeElement read GetFirstResult write SetFirstResult;
 property SecondResult:TTypeElement read GetSecondResult write SetSecondResult;
 property ParamsIndex:integer read GetIndex write SetIndex;
 property ParamsTable:TShortList read GetParamsTable write SetParamsTable;
 property ParamItem[index:integer]:pointer read GetParamItem write SetParamItem;
 property TypeItem[index:TType]:boolean read GetTypeItem write SetTypeItem;
 function TypeCheck:boolean;virtual;abstract;
 procedure GetTypeInfo;virtual;abstract;
 procedure ClearTypeInfo;virtual;abstract;
end;

TNoPtrOperator=class(TOperator)
protected
 FTypeList:PTypeList;
private
 FParamsTable:TShortList;
 FIndex:integer;
 function GetTypeItem(index:TType):boolean;override;
 procedure SetTypeItem(index:TType;aValue:boolean);override;
 function GetTypeList:PTypeList;override;
 procedure SetTypeList(aList:PTypeList);override;
 procedure SetIndex(aIndex:integer);override;
 function GetIndex:integer;override;
 procedure SetParamsTable(aTable:TShortList);override;
 function GetParamsTable:TShortList;override;
 procedure SetParamItem(index:integer;aItem:pointer);override;
 function GetParamItem(index:integer):pointer;override;
public
 procedure ClearTypeInfo;override;
 function TypeCheck:boolean;override;
 procedure CleanData;override;
 {constructor create;override;}
end;

TOnePtrOperator=class(TNoPtrOperator)
private
 FFirstOperator:TOperator;
 FFirstResult:TTypeElement;
 procedure SetParamsTable(aTable: TShortList);override;
 procedure SetFirstOperator(aOperator:TOperator);override;
 function GetFirstOperator:TOperator;override;
 procedure SetFirstResult(aResult:TTypeElement);override;
 function GetFirstResult:TTypeElement;override;
protected
 procedure ClearResults;override;
 procedure ReadFirstResult;override;
public
 constructor create;override;
end;

TTwoPtrOperator=class(TOnePtrOperator)
private
 FSecondOperator:TOperator;
 FSecondResult:TTypeElement;
 procedure SetParamsTable(aTable: TShortList);override;
 procedure SetSecondOperator(aOperator:TOperator);override;
 function GetSecondOperator:TOperator;override;
 procedure SetSecondResult(aResult:TTypeElement);override;
 function GetSecondResult:TTypeElement;override;
protected
 procedure ClearResults;override;
 procedure ReadSecondResult;override;
public
 constructor create;override;
end;

{******konkretni operatory************}
 TConstOperator=class(TNoPtrOperator)
 private
  FConst:TTypeElement;
  procedure SetConst(aConst:TTypeElement);
 public
  procedure DoIt;override;
  constructor Create ;override;
  procedure CleanData; override;
  procedure GetTypeInfo;override;
  property Constant:TTypeElement read FConst write SetConst;
 end;

 TClassIsOperator=class(TOnePtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure Doit;override;
 end;

 TIsAncestorOperator=class(TOnePtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
 end;

 TPropExistsOperator=class(TOnePtrOperator)
  private
    FSimpleMode: boolean;
    FaPropName: string;
    FaElement: TElement;
    procedure SetaElement(const Value: TElement);
    procedure SetaPropName(const Value: string);
    procedure SetSimpleMode(const Value: boolean);
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
  procedure Set_SimpleMode(aValue: boolean; const aEl: TElement; const aPropN: string);
  property  SimpleMode: boolean read FSimpleMode write SetSimpleMode;
  property  aElement: TElement read FaElement write SetaElement;
  property  aPropName: string read FaPropName write SetaPropName;
 end;

TReadPropOperator=class(TOnePtrOperator)
private
   FComparedName:string;
    FVars: TEntity;
    FLocalVars: TEntity;
   procedure SetComparedName(aName:string);
    procedure SetVars(const Value: TEntity);
    procedure SetLocalVars(const Value: TEntity);
public
   constructor create;override;
   procedure GetTypeInfo;override;
   procedure DoIt;override;
   procedure FindElementAndProperty(const aPath: string; var aElement: TElement; var aPropName: string);
   property ComparedName:string read FComparedName write SetComparedName;
   property Vars: TEntity read FVars write SetVars;
   property LocalVars: TEntity read FLocalVars write SetLocalVars;
end;

 TAbsValOperator=class(TOnePtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
 end;

 TRoundOperator=class(TOnePtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
 end;

 TTruncOperator=class(TOnePtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
 end;

 TCosOperator=class(TOnePtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
 end;

 TSinOperator=class(TOnePtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
 end;

 TArcTanOperator=class(TOnePtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
 end;

 TExpOperator=class(TOnePtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
 end;

 TFracOperator=class(TOnePtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
 end;

 TLnOperator=class(TOnePtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
 end;

 TOddOperator=class(TOnePtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
 end;

 TSqrOperator=class(TOnePtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
 end;

 TSqrtOperator=class(TOnePtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
 end;

 TUnMinusOperator=class(TOnePtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
 end;

 TUnPlusOperator=class(TOnePtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
 end;

 TNotOperator=class(TOnePtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure Doit;override;
 end;

  TPlusOperator=class(TTwoPtrOperator)
  public
   procedure GetTypeInfo;override;
   procedure Doit;override;
  end;

 TMinusOperator=class(TTwoPtrOperator)
  public
   procedure GetTypeInfo;override;
   procedure Doit;override;
  end;

TKratOperator=class(TTwoPtrOperator)
  public
   procedure GetTypeInfo;override;
   procedure Doit;override;
  end;

TDelenoOperator=class(TTwoPtrOperator)
  public
   procedure GetTypeInfo;override;
   procedure Doit;override;
  end;

TModOperator=class(TTwoPtrOperator)
  public
   procedure GetTypeInfo;override;
   procedure Doit;override;
  end;

TDivOperator=class(TTwoPtrOperator)
  public
   procedure GetTypeInfo;override;
   procedure Doit;override;
  end;

TIsOperator=class(TTwoPtrOperator)
public
   procedure GetTypeInfo;override;
   procedure DoIt;override;
end;

TSubstrOperator=class(TTwoPtrOperator)
  private
    FFindStatus: integer;
public
   procedure GetTypeInfo;override;
   procedure DoIt;override;
   property  FindStatus: integer read FFindStatus write FFindStatus;
end;

TCompareOperator=class(TTwoPtrOperator)
	public
  procedure GetTypeInfo;override;
  end;

TVetsiOperator=class(TCompareOperator)
  public
   procedure Doit;override;
  end;

TMensiOperator=class(TCompareOperator)
  public
   procedure Doit;override;
  end;

TVetsiRovnoOperator=class(TCompareOperator)
  public
   procedure Doit;override;
  end;

TMensiRovnoOperator=class(TCompareOperator)
  public
   procedure Doit;override;
  end;

TRovnoOperator=class(TCompareOperator)
  public
   procedure Doit;override;
  end;

TRuzneOperator=class(TCompareOperator)
  public
   procedure Doit;override;
  end;


TAndOperator=class(TTwoPtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
 end;

TOrOperator=class(TTwoPtrOperator)
 public
  procedure GetTypeInfo;override;
  procedure DoIt;override;
 end;

TNaBooleanOperator=class(TOnePtrOperator)
public
 procedure GetTypeInfo;override;
 procedure DoIt;override;
end;

TNaCharOperator=class(TOnePtrOperator)
public
 procedure GetTypeInfo;override;
 procedure DoIt;override;
end;

TNaByteOperator=class(TOnePtrOperator)
public
 procedure GetTypeInfo;override;
 procedure DoIt;override;
end;

TNaFloatOperator=class(TOnePtrOperator)
public
 procedure GetTypeInfo;override;
 procedure DoIt;override;
end;

TNaStringOperator=class(TOnePtrOperator)
public
 procedure GetTypeInfo;override;
 procedure DoIt;override;
end;

TNaIntegerOperator=class(TOnePtrOperator)
public
 procedure GetTypeInfo;override;
 procedure DoIt;override;
end;

{+++++++++++++++++++++++}
TCondition=Class(TOnePtrOperator)
public
 function IsTrue:boolean;virtual;
 procedure GetTypeInfo;override;
 procedure DoIt;override;
end;


implementation
uses
   System.RegularExpressions,
   StrUtils,
   e_Class,
   u_Props,
   U_string,
   Worlds;

function TShortList.GetItem(index:integer):pointer;
  begin
   result:=FList.Items[index];
  end;

constructor TShortList.create;
begin
 inherited create;
 FList:=TList.create;
end;

destructor TShortList.destroy;
begin
 inherited destroy;
 FList.free;
end;


procedure TShortList.SetItem(index:integer;aItem:pointer);
 begin
  if index+1>FList.Count then
   repeat FList.add(aItem) until FList.Count=index+1;
  FList.Items[index]:=aItem;
 end;


{NoPtr}

 procedure TNoPtrOperator.SetParamsTable(aTable:TShortList);
 begin
   if assigned(FParamsTable) then
   begin
      FreeElement(FParamsTable);
      FParamsTable := nil;
   end;
   FParamsTable := aTable;
   AddElement(aTable);
 end;

 function TNoPtrOperator.GetParamsTable:TShortList;
  begin
   if not assigned(FParamsTable) then
   begin
      FParamsTable := TShortList.Create;
      AddElement(FParamsTable);
   end;
   result := FParamsTable;
 end;

 procedure TNoPtrOperator.SetParamItem(index:integer;aItem:pointer);
  begin
  ParamsTable.Item[index]:=aItem;
  end;

 function TNoPtrOperator.GetParamItem(index:integer):pointer;
  begin
  result:=ParamsTable.Item[index];
  end;


 procedure TNoPtrOperator.SetIndex(aIndex:integer);
  begin
   FIndex:=aIndex;
  end;

 function TNoPtrOperator.GetIndex:integer;
  begin
   result:=FIndex;
  end;

 procedure TNoPtrOperator.CleanData;
  {pokud je vymazani zakazano, pak je nutno tuto proc. predefinovat}
  begin
   if Output<>nil then if TTypeElement(Output).OwnersCount=0 then Output.free;
   Output:=nil;
  end;

 function TNoPtrOperator.GetTypeList:PTypeList;
 begin
  result:=FTypeList;
 end;

 procedure TNoPtrOperator.SetTypeList(aList:PTypeList);
 begin
  FTypeList:=aList;
 end;

 function TNoPtrOperator.GetTypeItem(index:TType):boolean;
 begin
  result:=TypeList^[index];
 end;

 procedure TNoPtrOperator.SetTypeItem(index:TType;aValue:boolean);
 begin
  TypeList^[index]:=aValue;
 end;

 procedure TNoPtrOperator.ClearTypeInfo;
 begin
  dispose(FTypeList);
  FTypeList:=nil;
 end;

 function TNoPtrOperator.TypeCheck:boolean;
 var i:TType;
 begin
  GetTypeInfo;
  result:=false;
  for i:=_Boolean to _Other do result:=result or TypeList^[i];
  ClearTypeInfo;
 end;


{OnePtr}
 procedure TOnePtrOperator.SetParamsTable(aTable:TShortList);
 begin
  inherited SetParamsTable(aTable);
  if FirstOperator<>nil then  FirstOperator.ParamsTable:=aTable;
   {MUSI BYT S UPRAVENYM INHERITED-ADDELEMENT}
 end;


 procedure TOnePtrOperator.SetFirstOperator(aOperator:TOperator);
  begin
   if assigned(FFirstOperator) then FreeTool(FFirstOperator);
   if aOperator<>nil then FFirstOperator:=TOperator(AddTool(aOperator))
    else FFirstOperator:=nil;
  end;

 function TOnePtrOperator.GetFirstOperator:TOperator;
  begin
   result:=FFirstOperator;
  end;

 procedure TOnePtrOperator.SetFirstResult(aResult:TTypeElement);
  begin
   FFirstResult:=aResult;
  end;

 function TOnePtrOperator.GetFirstResult:TTypeElement;
  begin
   result:=FFirstResult;
  end;

  constructor TOnePtrOperator.create;
   begin
    inherited create;
    FFirstOperator:=nil;
   end;

  procedure TOnePtrOperator.ReadFirstResult;
  begin
   if FirstOperator=nil then FirstResult:=nil
   else
    begin
    { FirstOperator.Input:=self;}
     FirstOperator.DoIt;
     FirstResult:=TTypeElement(FirstOperator.Output);
    end;
  end;

  procedure TOnePtrOperator.ClearResults;
   begin
    if FirstOperator<>nil then FirstOperator.CleanData;
   end;

 {TwoPtr}
 procedure TTwoPtrOperator.SetParamsTable(aTable:TShortList);
 begin
  inherited SetParamsTable(aTable);
  if SecondOperator<>nil then SecondOperator.ParamsTable:=aTable;
   {MUSI BYT S UPRAVENYM INHERITED-ADDELEMENT}
 end;

 procedure TTwoPtrOperator.SetSecondOperator(aOperator:TOperator);
  begin
   if assigned(FSecondOperator) then FreeTool(FSecondOperator);
   if aOperator<>nil then FSecondOperator:=TOperator(AddTool(aOperator))
    else FSecondOperator:=nil;
  end;

 function TTwoPtrOperator.GetSecondOperator:TOperator;
  begin
   result:=FSecondOperator;
  end;

procedure TTwoPtrOperator.SetSecondResult(aResult:TTypeElement);
  begin
   FSecondResult:=aResult;
  end;

 function TTwoPtrOperator.GetSecondResult:TTypeElement;
  begin
   result:=FSecondResult;
  end;

  constructor TTwoPtrOperator.create;
   begin
    inherited create;
    FSecondOperator:=nil;
   end;

  procedure TTwoPtrOperator.ReadSecondResult;
  begin
   if (SecondOperator=nil) or (FirstResult=nil) then SecondResult:=nil
   else
    begin
    {SecondOperator.Input:=self;}
     SecondOperator.DoIt;
     Secondresult:=TTypeElement(SecondOperator.Output);
    end;
  end;

  procedure TTwoPtrOperator.ClearResults;
   begin
    if FirstOperator<>nil then FirstOperator.CleanData;
    if SecondOperator<>nil then SecondOperator.CleanData;
   end;


  {Const}
  procedure TConstOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   For i:=_boolean to _other do TypeItem[i]:=false;
   TypeItem[TTypeElement(Constant).Typ]:=true;
  end;

  procedure TConstOperator.SetConst(aConst:TTypeElement);
   begin
    if assigned(FConst) then FreeElement(FConst);
    AddElement(aConst);
    FConst:=aConst;
   end;

  procedure TConstOperator.CleanData;
   begin
   end;

  procedure TConstOperator.DoIt;
   begin
    {asi by se mela konstanta prekopirovat}
    Output:=FConst;
   end;

  constructor TConstOperator.create;
   begin
    inherited create;
    FConst:=nil;
   end;

 {TClassIs}
 procedure TClassIsOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   For i:=_boolean to _other do TypeItem[i]:=false;
   TypeItem[_boolean]:=true;
  end;

 procedure TClassIsOperator.DoIt;
 var tmp:TBooleanElement;
   begin
     inherited DoIt;{asi zbytecne}
     Output:=nil;
     ReadfirstResult;
     {$B-}
     if (FirstResult=nil) or
      not (FirstResult.Typ= _string) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
    if ParamItem[ParamsIndex]=nil then
      begin
       {Kill}
        ClearResults;
        exit;
      end;
    Tmp:=TBooleanElement.create;
    Tmp.Value:=(UpperCase(FirstResult.AsString)=UpperCase(TObject(ParamItem[ParamsIndex]).classname));
    Output:=Tmp;
    ClearResults;
   end;

  {IsAncestor}
  procedure TIsAncestorOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   For i:=_boolean to _other do TypeItem[i]:=false;
   TypeItem[_boolean]:=true;
  end;

  procedure TIsAncestorOperator.DoIt;
   var CompClass:TClass;
       tmp:TBooleanElement;
   begin
   inherited DoIt;
     Output:=nil;
     ReadfirstResult;
     {$B-}
     if (FirstResult=nil) or
      not (FirstResult.Typ= _string) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
    if ParamItem[ParamsIndex]=nil then
      begin
       {Kill}
       ClearResults;
       exit;
      end;
    Tmp:=TBooleanElement.create;
    Tmp.Value:=false;
    CompClass:=TObject(ParamItem[ParamsIndex]).ClassType;
    repeat
     Tmp.Value:=(UpperCase(CompClass.ClassName) = Uppercase(FirstResult.AsString));
     CompClass:=CompClass.ClassParent;
    until (CompClass=nil) or (Tmp.Value=true);
    Output:=Tmp;
    ClearResults;
   end;

 {propexists}

 procedure TPropExistsOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   For i:=_boolean to _other do TypeItem[i]:=false;
   TypeItem[_boolean]:=true;
  end;

procedure TPropExistsOperator.SetaElement(const Value: TElement);
begin
  FaElement := Value;
end;

procedure TPropExistsOperator.SetaPropName(const Value: string);
begin
  FaPropName := Value;
end;

procedure TPropExistsOperator.Set_SimpleMode(aValue: boolean;
  const aEl: TElement; const aPropN: string);
begin
   SimpleMode := aValue;
   aElement := aEl;
   aPropName := aPropN;
end;

procedure TPropExistsOperator.SetSimpleMode(const Value: boolean);
begin
  FSimpleMode := Value;
end;

procedure TPropExistsOperator.DoIt;
var
   Tmp:TBooleanElement;
begin
   if SimpleMode then
   begin
      if (aElement=nil) or (aPropName = '') then
      begin
       {Kill}
        ClearResults;
        exit;
      end;
      Tmp:=TBooleanElement.create;
      Tmp.Value:=(GetPropInfo(aElement.ClassInfo,aPropName)<>nil);
   end
   else
   begin
      inherited DoIt;
      Output:=nil;
      ReadfirstResult;
      {$B-}
      if (FirstResult=nil) or not (FirstResult.Typ= _string) then
      begin
         {kill}
         ClearResults;
         exit;
      end;
      if FirstResult.AsString='' then
      begin
         Tmp:=TBooleanElement.create;
         Tmp.Value:=false
      end
      else
      begin
         if ParamItem[ParamsIndex]=nil then
         begin
          {Kill}
           ClearResults;
           exit;
         end;
         Tmp:=TBooleanElement.create;
         Tmp.Value:=(GetPropInfo(TElement(ParamItem[ParamsIndex]).ClassInfo,FirstResult.AsString)<>nil);
      end;
   end;
   Output:=Tmp;
   ClearResults;
end;

{ReadProp}
  procedure TReadPropOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   For i:=_boolean to _other do TypeItem[i]:=true;
  end;

    procedure TReadPropOperator.SetComparedName(aName:string);
     var ConstEl:TStringElement;
    begin
     FComparedName:=aName;
     if (FirstOperator is TPropExistsOperator) then
      begin
       ConstEl:=TStringElement.CreateValue(aname);
       TConstOperator(TPropExistsOperator(FirstOperator).FirstOperator).Constant:=ConstEl;
      end;
    end;


    constructor TReadPropOperator.create;
     begin
      inherited create;
      FirstOperator:=TPropExistsOperator.create;
      FirstOperator.FirstOperator:=TConstOperator.create;
      ComparedName:='';
     end;

procedure TReadPropOperator.SetVars(const Value: TEntity);
begin
  FVars := Value;
end;

procedure TReadPropOperator.FindElementAndProperty(const aPath: string;
          var aElement: TElement; var aPropName: string);
var
   Position: integer;
   Finish: boolean;
   Delimiters: TDelimiters;
   Delimiter: Char;
   SS,S: string;
   Word1: boolean;
   E: TElement;
   ActualVar: TTypeElement;
   i: NativeInt;
   function IsVar(aVar: string): boolean;
   begin
      ActualVar := nil;
      result := false;
      E := nil;
      if LocalVars <> nil then
         E := LocalVars.FindElementName(aVar);
      if E = nil then
      begin
         if Vars = nil then exit;
         if Vars.NoElements then exit;
         E := Vars.FindElementName(aVar);
      end;
      if E = nil then exit;
      result := true;
      ActualVar := TTypeElement(E);
   end;
begin
   S := aPath;
   Word1 := true;
   Position := 1;
   Finish := false;
   Delimiters := ['.','\'];
   while not Finish do
   begin
      if aElement = nil then exit;
      SS := ReadToDelimiterWithoutWS(S,  Delimiters, Position, Delimiter, Position);
      case Delimiter of
         #0: { properta - konec }
         begin
            {
            if UpperCase(SS)=cl_World then Info.Element := World
            else
            if UpperCase(SS)=cl_ActiveElement then Info.Element := ActiveElement
            else
            if UpperCase(SS)=cl_Var then exit
            else
            if IsVar(SS) then
            begin
               Info.Element := ActualVar.Element;
               Info.Variable := true;
               exit;
            end
            else
            }
            aPropName := SS;
            Finish := true;
            exit;
         end;
         '.': { properta - objekt }
         begin
            if Word1 and (UpperCase(SS) = 'WORLD') then aElement := World
            else
            if Word1 and IsVar(SS) then
            begin
               if ActualVar.Typ = _Pointer then
                  aElement := TElement(ActualVar.AsPointer)
               else
                  aElement := ActualVar;
            end
            else
            begin
               E := TElement(GetObjectPropByName(aElement,SS));
               if E = nil then
               begin
                 I:= StrToLongInt(aElement.GetPropertyStringByName(SS));
                 E:= TElement(I);
                 if (E<>nil) then
                 begin
                   if not (TObject(E) is TObject) then;
                      //Ex('Nemohu nalzt objekt '+ SS);
                 end
                 else
                 begin
                   if not (aElement is TEntity) then;
                      //Ex('Nemohu nalzt element '+ SS);

                   E := TEntity(aElement).FindElementName(SS);
                   if E = nil then
                      //Ex('Nemohu nalzt element '+ SS)
                 end
               end;
               aElement := E;
            end;
         end;
      end;
      Word1 := false;
   end;
end;


procedure TReadPropOperator.DoIt;
var
   tmp:TTypeElement;
   PropType:PTypeInfo;
   PropInfo:PPropInfo;
   StrVal:string;
   Num:extended;
   Numi: integer;
   aElement: TElement;
   aPropName: string;
begin
   inherited DoIt;
   Tmp:=nil;
   Output:=nil;
   aElement := TElement(ParamItem[ParamsIndex]);
   aPropName := '';
   FindElementAndProperty(ComparedName,aElement,aPropName);
   if FirstOperator is TPropExistsOperator then
      TPropExistsOperator(FirstOperator).Set_SimpleMode(true,aElement,aPropName);
   ReadFirstResult;
   {$B-}
   {po zavedeni podminek se toto zmeni}
   if aElement = nil then
   begin
      ClearResults;
      exit;
   end;
   if (FirstResult=nil) or (FirstResult.Typ<>_boolean)
       or ( not TBooleanElement(FirstResult).Value) then
   begin
      StrVal:=aElement.GetPropertyStringByName(aPropName);{UVOLNIT !!!}
      if StrVal='' then
      begin
         {kill}
         Tmp:=TStringElement.createVAlue(StrVal);
         //ClearResults;
         //exit;
      end
      else
      begin
         { Zmna PK 27.1.98 }
         if StringIsFloat(StrVal) then
         begin
            Num := StrToExtended(StrVal);
//            if round(Num)=Num then
            if TryStrToInt(StrVal, Numi) then
               Tmp:=TIntegerElement.createVAlue(Numi)
            else
               Tmp:=TFloatElement.createVAlue(Num);
         end
         else
            Tmp:=TStringElement.createVAlue(StrVal);
       {
       val(StrVal,Num,Code);
       if code<>0 then Tmp:=TStringElement.createVAlue(StrVal)
        else if round(Num)=Num then Tmp:=TIntegerElement.createVAlue(round(Num))
              else Tmp:=TFloatElement.createVAlue(Num);
       }
      end;
   end
   else
   begin
      PropInfo:=GetPropInfo(aElement.ClassInfo,aPropName);
      PropType:=PropInfo^.PropType^;
      case PropType^.kind of
      {_Float,_String,}
      tkInteger:
         if Uppercase(PropType^.name)='BYTE' then
         begin
            Tmp:=TByteElement.create;
            TByteElement(Tmp).Value:=GetOrdProp(aElement,PropInfo);
         end
         else
         begin
            Tmp:=TIntegerElement.create;
            TIntegerElement(Tmp).Value:=GetOrdProp(aElement,PropInfo);
         end;
     {$IFDEF UNICODE}
      tkWChar,
     {$ENDIF}
      tkChar:
         begin
            //Tmp:=TCharElement.create;
            //TCharElement(Tmp).Value:=char(GetOrdProp(TElement(ParamItem[ParamsIndex]),PropInfo));
            // PPK 12.03 kompatibilita char a string
            Tmp:=TStringElement.create;
            TStringElement(Tmp).Value:=char(GetOrdProp(aElement,PropInfo));
         end;
      tkEnumeration:
         if Uppercase(PropType^.name)='BOOLEAN' then
         begin
            Tmp:=TBooleanElement.create;
            TBooleanElement(Tmp).Value:=boolean(GetOrdProp(aElement,PropInfo));
         end
         else
         begin
            {other enumeretable types}
         end;
      tkFloat:
         begin
            Tmp:=TFloatElement.create;
            TFloatElement(Tmp).Value:=GetFloatProp(aElement,PropInfo);
         end;
      {}
     {$IFDEF UNICODE}
      tkUString,
     {$ENDIF}
      tkString,tkLString:
         begin
            Tmp:=TStringElement.create;
            TStringElement(Tmp).Value:=GetStrProp(aElement,PropInfo);
         end;
      tkClass:
         begin
            Tmp:=TPointerElement.create;
            TPointerElement(Tmp).Value:=Pointer(GetOrdProp(aElement,PropInfo));
         end;
      end;
   end;
   Output:=Tmp;
   ClearResults;
end;

  {AbsValue}
  procedure TAbsValOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if FirstOperator.TypeItem[_byte] then TypeItem[_byte]:=true;
   if FirstOperator.TypeItem[_integer] then TypeItem[_integer]:=true;
   if FirstOperator.TypeItem[_float] then TypeItem[_float]:=true;
   FirstOperator.ClearTypeInfo;
  end;

  procedure TAbsValOperator.Doit;
  var Tmp:TTypeElement;
   begin
     inherited DoIt;
     Tmp:=nil;
     Output:=nil;
     ReadFirstResult;
     if (FirstResult=nil) or
      not (FirstResult.Typ in [_Byte,_Float,_Integer]) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
     case FirstResult.Typ of
        _Byte:
          begin
           Tmp:=TByteElement.create;
           TByteElement(Tmp).Value:=abs(TByteElement(FirstResult).Value);
          end;
        _Float:
          begin
           Tmp:=TFloatElement.create;
           TFloatElement(Tmp).Value:=abs(TFloatElement(FirstResult).Value);
          end;
        _Integer:
          begin
           Tmp:=TIntegerElement.create;
           TIntegerElement(Tmp).Value:=abs(TIntegerElement(FirstResult).Value);
          end;
       end;
     Output:=Tmp;
     ClearResults;
   end;

{Round}
procedure TRoundOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if FirstOperator.TypeItem[_byte] then TypeItem[_byte]:=true;
   if FirstOperator.TypeItem[_integer] or
     FirstOperator.TypeItem[_float] then TypeItem[_integer]:=true;
   FirstOperator.ClearTypeInfo;
  end;

procedure TRoundOperator.DoIt;
var Tmp:TTypeElement;
 begin
     inherited DoIt;
     Tmp:=nil;
     Output:=nil;
     ReadFirstResult;
     if (FirstResult=nil) or
      not (FirstResult.Typ in [_Byte,_Float,_Integer]) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
     case FirstResult.Typ of
        _Byte:
          begin
           Tmp:=TByteElement.create;
           TByteElement(Tmp).Value:=round(TByteElement(FirstResult).Value);
          end;
        _Float:
          begin
           Tmp:=TIntegerElement.create;
           TIntegerElement(Tmp).Value:=round(TFloatElement(FirstResult).Value);
          end;
        _Integer:
          begin
           Tmp:=TIntegerElement.create;
           TIntegerElement(Tmp).Value:={round}(TIntegerElement(FirstResult).Value);
          end;
       end;
     Output:=Tmp;
     ClearResults;
 end;

{trunc}
procedure TTruncOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if FirstOperator.TypeItem[_byte] then TypeItem[_byte]:=true;
   if FirstOperator.TypeItem[_integer] or
     FirstOperator.TypeItem[_float] then TypeItem[_integer]:=true;
   FirstOperator.ClearTypeInfo;
  end;

 procedure TTruncOperator.DoIt;
 var Tmp:TTypeElement;
 begin
     inherited DoIt;
     Tmp:=nil;
     Output:=nil;
     ReadFirstResult;
     if (FirstResult=nil) or
      not (FirstResult.Typ in [_Byte,_Float,_Integer]) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
     case FirstResult.Typ of
        _Byte:
          begin
           Tmp:=TByteElement.create;
           TByteElement(Tmp).Value:=trunc(TByteElement(FirstResult).Value);
          end;
        _Float:
          begin
           Tmp:=TIntegerElement.create;
           TIntegerElement(Tmp).Value:=trunc(TFloatElement(FirstResult).Value);
          end;
        _Integer:
          begin
           Tmp:=TIntegerElement.create;
           TIntegerElement(Tmp).Value:={trunc}(TIntegerElement(FirstResult).Value);
          end;
       end;
     Output:=Tmp;
     ClearResults;
 end;

 {cos}
 procedure TCosOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if FirstOperator.TypeItem[_byte] or
     FirstOperator.TypeItem[_integer] or
     FirstOperator.TypeItem[_float] then TypeItem[_float]:=true;
   FirstOperator.ClearTypeInfo;
  end;

 procedure TCosOperator.DoIt;
 var Tmp:TFloatElement;
 begin
     inherited DoIt;
     Output:=nil;
     ReadFirstResult;
     if (FirstResult=nil) or
      not (FirstResult.Typ in [_Byte,_Float,_Integer]) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
     Tmp:=TFloatElement.create;
     Tmp.Value:=cos(TTypeElement(FirstResult).AsFloat);
     Output:=Tmp;
     ClearResults;
 end;

 {sin}
 procedure TSinOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if FirstOperator.TypeItem[_byte] or
     FirstOperator.TypeItem[_integer] or
     FirstOperator.TypeItem[_float] then TypeItem[_float]:=true;
   FirstOperator.ClearTypeInfo;
  end;


 procedure TSinOperator.DoIt;
 var Tmp:TFloatElement;
 begin
     inherited DoIt;
     Output:=nil;
     ReadFirstResult;
     if (FirstResult=nil) or
      not (FirstResult.Typ in [_Byte,_Float,_Integer]) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
     Tmp:=TFloatElement.create;
     Tmp.Value:=sin(TTypeElement(FirstResult).AsFloat);
     Output:=Tmp;
     ClearResults;
 end;

 {arctan}
 procedure TArcTanOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if FirstOperator.TypeItem[_byte] or
     FirstOperator.TypeItem[_integer] or
     FirstOperator.TypeItem[_float] then TypeItem[_float]:=true;
   FirstOperator.ClearTypeInfo;
  end;


 procedure TArcTanOperator.DoIt;
 var Tmp:TFloatElement;
 begin
     inherited DoIt;
     Output:=nil;
     ReadFirstResult;
     if (FirstResult=nil) or
      not (FirstResult.Typ in [_Byte,_Float,_Integer]) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
     Tmp:=TFloatElement.create;
     Tmp.Value:=arctan(TTypeElement(FirstResult).AsFloat);
     Output:=Tmp;
     ClearResults;
 end;

 {exp}
 procedure TExpOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if FirstOperator.TypeItem[_byte] or
     FirstOperator.TypeItem[_integer] or
     FirstOperator.TypeItem[_float] then TypeItem[_float]:=true;
   FirstOperator.ClearTypeInfo;
  end;


 procedure TExpOperator.DoIt;
 var Tmp:TFloatElement;
 begin
     inherited DoIt;
     Output:=nil;
     ReadFirstResult;
     if (FirstResult=nil) or
      not (FirstResult.Typ in [_Byte,_Float,_Integer]) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
     Tmp:=TFloatElement.create;
     Tmp.Value:=exp(TTypeElement(FirstResult).AsFloat);
     Output:=Tmp;
     ClearResults;
 end;

 {frac}
 procedure TFracOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if FirstOperator.TypeItem[_byte] or
     FirstOperator.TypeItem[_integer] or
     FirstOperator.TypeItem[_float] then TypeItem[_float]:=true;
   FirstOperator.ClearTypeInfo;
  end;


 procedure TFracOperator.DoIt;
 var Tmp:TFloatElement;
 begin
     inherited DoIt;
     Output:=nil;
     ReadFirstResult;
     if (FirstResult=nil) or
      not (FirstResult.Typ in [_Byte,_Float,_Integer]) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
     Tmp:=TFloatElement.create;
     Tmp.Value:=frac(TTypeElement(FirstResult).AsFloat);
     Output:=Tmp;
     ClearResults;
 end;

 {ln}
 procedure TLnOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if FirstOperator.TypeItem[_byte] or
     FirstOperator.TypeItem[_integer] or
     FirstOperator.TypeItem[_float] then TypeItem[_float]:=true;
   FirstOperator.ClearTypeInfo;
  end;

 procedure TLnOperator.DoIt;
  var Tmp:TFloatElement;
 begin
     inherited DoIt;
     Output:=nil;
     ReadFirstResult;
     if (FirstResult=nil) or
      (not (FirstResult.Typ in [_Byte,_Float,_Integer])) or
      (TTypeElement(FirstResult).AsFloat<=0) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
     Tmp:=TFloatElement.create;
     Tmp.Value:=ln(TTypeElement(FirstResult).AsFloat);
     Output:=Tmp;
     ClearResults;
 end;

 {odd}
 procedure TOddOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if FirstOperator.TypeItem[_byte] or
     FirstOperator.TypeItem[_integer] then TypeItem[_boolean]:=true;
   FirstOperator.ClearTypeInfo;
  end;

 procedure TOddOperator.DoIt;
  var Tmp:TBooleanElement;
 begin
     inherited DoIt;
     Output:=nil;
     ReadFirstResult;
     if (FirstResult=nil) or
      not (FirstResult.Typ in [_Byte,_Integer]) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
     Tmp:=TBooleanElement.create;
     Tmp.Value:=odd(TTypeElement(FirstResult).AsInteger);
     Output:=Tmp;
     ClearResults;
 end;

 {Sqr}
 procedure TSqrOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if FirstOperator.TypeItem[_byte] or
     FirstOperator.TypeItem[_integer] or
     FirstOperator.TypeItem[_float] then TypeItem[_float]:=true;
   FirstOperator.ClearTypeInfo;
  end;

  procedure TSqrOperator.Doit;
  var Tmp:TFloatElement;
   begin
     inherited DoIt;
     Output:=nil;
     ReadFirstResult;
     if (FirstResult=nil) or
      not (FirstResult.Typ in [_Byte,_Float,_Integer]) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
     Tmp:=TFloatElement.create;
     Tmp.Value:=sqr(TTypeElement(FirstResult).AsFloat);
     Output:=Tmp;
     ClearResults;
   end;

{Sqrt}
 procedure TSqrtOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if FirstOperator.TypeItem[_byte] or
     FirstOperator.TypeItem[_integer] or
     FirstOperator.TypeItem[_float] then TypeItem[_float]:=true;
   FirstOperator.ClearTypeInfo;
  end;

  procedure TSqrtOperator.Doit;
  var Tmp:TFloatElement;
   begin
     inherited DoIt;
     Output:=nil;
     ReadFirstResult;
     if (FirstResult=nil) or
      (not (FirstResult.Typ in [_Byte,_Float,_Integer]))
      or (TTypeElement(FirstResult).AsFloat<0) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
     Tmp:=TFloatElement.create;
     Tmp.Value:=sqrt(TTypeElement(FirstResult).AsFloat);
     Output:=Tmp;
     ClearResults;
   end;

{Unarni minus}
procedure TUnMinusOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if FirstOperator.TypeItem[_byte] or
     FirstOperator.TypeItem[_integer] then TypeItem[_integer]:=true;
   if FirstOperator.TypeItem[_float] then TypeItem[_float]:=true;
   FirstOperator.ClearTypeInfo;
  end;

procedure TUnMinusOperator.Doit;
  var Tmp:TTypeElement;
   begin
     inherited DoIt;
     Tmp:=nil;
     Output:=nil;
     ReadFirstResult;
     if (FirstResult=nil) or
      not (FirstResult.Typ in [_Byte,_Float,_Integer]) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
     case FirstResult.Typ of
        _Byte,_Integer:
          begin
           Tmp:=TIntegerElement.create;
           TIntegerElement(Tmp).Value:=-(TTypeElement(FirstResult).AsInteger);
          end;
        _Float:
          begin
           Tmp:=TFloatElement.create;
           TFloatElement(Tmp).Value:=-(TFloatElement(FirstResult).Value);
          end;
       end;
     Output:=Tmp;
     ClearResults;
   end;

 {Unarni plus}
procedure TUnPlusOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if FirstOperator.TypeItem[_byte] or
     FirstOperator.TypeItem[_integer] then TypeItem[_integer]:=true;
   if FirstOperator.TypeItem[_float] then TypeItem[_float]:=true;
   FirstOperator.ClearTypeInfo;
  end;

procedure TUnPlusOperator.Doit;
  var Tmp:TTypeElement;
   begin
     inherited DoIt;
     Tmp:=nil;
     Output:=nil;
     ReadFirstResult;
     if (FirstResult=nil) or
      not (FirstResult.Typ in [_Byte,_Float,_Integer]) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
     case FirstResult.Typ of
        _Byte,_Integer:
          begin
           Tmp:=TIntegerElement.create;
           TIntegerElement(Tmp).Value:=(TTypeElement(FirstResult).AsInteger);
          end;
        _Float:
          begin
           Tmp:=TFloatElement.create;
           TFloatElement(Tmp).Value:=(TFloatElement(FirstResult).Value);
          end;
       end;
     Output:=Tmp;
     ClearResults;
   end;


 {Not}
 procedure TNotOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if FirstOperator.TypeItem[_boolean] then TypeItem[_boolean]:=true;
   FirstOperator.ClearTypeInfo;
  end;

 procedure TNotOperator.Doit;
  var Tmp:TBooleanElement;
  begin
    inherited DoIt;
    Output:=nil;
    ReadFirstResult;
    if (FirstResult=nil) or (FirstResult.Typ<>_boolean) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
    Tmp:=TBooleanElement.create;
    Tmp.Value:=not TBooleanElement(FirstResult).Value;
    Output:=Tmp;
    ClearResults;
   end;

 {Plus}
  procedure TPlusOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   SecondOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;

   if (FirstOperator.TypeItem[_byte] or FirstOperator.TypeItem[_integer])
    and (SecondOperator.TypeItem[_byte] or SecondOperator.TypeItem[_integer])
      then TypeItem[_integer]:=true;

   if (FirstOperator.TypeItem[_Float]and(SecondOperator.TypeItem[_Byte] or
       SecondOperator.TypeItem[_Integer] or SecondOperator.TypeItem[_Float]))
    or((FirstOperator.TypeItem[_Byte] or FirstOperator.TypeItem[_Integer] or
      FirstOperator.TypeItem[_Float]) and(SecondOperator.TypeItem[_Float]))
     then TypeItem[_float]:=true;

   if (FirstOperator.TypeItem[_string] or FirstOperator.TypeItem[_char])
      and(SecondOperator.TypeItem[_string] or FirstOperator.TypeItem[_char])
     then TypeItem[_string]:=true;

   FirstOperator.ClearTypeInfo;
   SecondOperator.ClearTypeInfo;
  end;

  procedure TPlusOperator.Doit;
  var Tmp:TTypeElement;
  begin
    inherited DoIt;
    Output:=nil;
    ReadFirstResult;
    ReadSecondResult;
    if (FirstResult=nil) or (SecondResult=nil)then
        begin
         {kill}
         ClearResults;
         exit;
        end;
   if (FirstResult.Typ in[_Byte,_Integer])and(SecondResult.Typ in[_Byte,_Integer]) then
    begin
    Tmp:=TIntegerElement.create;
    TIntegerElement(Tmp).Value:=FirstResult.AsInteger+SecondResult.AsInteger;
    end
   else
   if ((FirstResult.Typ=_Float)and(SecondResult.Typ in[_Byte,_Integer,_Float]) or
       (FirstResult.Typ in[_Byte,_Integer,_Float])and(SecondResult.Typ=_Float)) then
   begin
    Tmp:=TFloatElement.create;
    TFloatElement(Tmp).Value:=FirstResult.AsFloat+SecondResult.AsFloat;
   end
   else
   if (FirstResult.Typ in [_String,_Char])and(SecondResult.Typ in [_String,_Char]) then
   begin
    Tmp:=TStringElement.create;
    TStringElement(Tmp).Value:=FirstResult.AsString+SecondResult.AsString;
   end
   else
    begin
     {kill}
     ClearResults;
     exit;
    end;
   Output:=Tmp;
   ClearResults;
  end;

{Minus}
  procedure TMinusOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   SecondOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;

   if (FirstOperator.TypeItem[_byte] or FirstOperator.TypeItem[_integer])
    and (SecondOperator.TypeItem[_byte] or SecondOperator.TypeItem[_integer])
      then TypeItem[_integer]:=true;

   if (FirstOperator.TypeItem[_Float]and(SecondOperator.TypeItem[_Byte] or
    SecondOperator.TypeItem[_Integer] or SecondOperator.TypeItem[_Float]))
    or((FirstOperator.TypeItem[_Byte] or FirstOperator.TypeItem[_Integer] or
     FirstOperator.TypeItem[_Float]) and(SecondOperator.TypeItem[_Float]))
     then TypeItem[_float]:=true;

   FirstOperator.ClearTypeInfo;
   SecondOperator.ClearTypeInfo;
  end;


  procedure TMinusOperator.Doit;
  var Tmp:TTypeElement;
  begin
    inherited DoIt;
    Output:=nil;
    ReadFirstResult;
    ReadSecondResult;
    if (FirstResult=nil) or (SecondResult=nil)then
        begin
         {kill}
         ClearResults;
         exit;
        end;
   if (FirstResult.Typ in[_Byte,_Integer])and(SecondResult.Typ in[_Byte,_Integer]) then
    begin
    Tmp:=TIntegerElement.create;
    TIntegerElement(Tmp).Value:=TTypeElement(FirstResult).AsInteger-
                                TTypeElement(SecondResult).AsInteger;
    end
   else
   if ((FirstResult.Typ=_Float)and(SecondResult.Typ in[_Byte,_Integer,_Float]) or
       (FirstResult.Typ in[_Byte,_Integer,_Float])and(SecondResult.Typ=_Float)) then
   begin
    Tmp:=TFloatElement.create;
    TFloatElement(Tmp).Value:=TTypeElement(FirstResult).AsFloat-TTypeElement(SecondResult).AsFloat;
   end
   else
    begin
     {kill}
     ClearResults;
     exit;
    end;
   Output:=Tmp;
   ClearResults;
  end;

{Krat}
  procedure TkratOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   SecondOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if (FirstOperator.TypeItem[_Byte] or FirstOperator.TypeItem[_Integer] or FirstOperator.TypeItem[_Float])
     and (SecondOperator.TypeItem[_Byte] or SecondOperator.TypeItem[_Integer] or SecondOperator.TypeItem[_Float])
     then
     begin
      TypeItem[_float]:=true;
      if (FirstOperator.TypeItem[_Byte] or FirstOperator.TypeItem[_Integer] )
       and (SecondOperator.TypeItem[_Byte] or SecondOperator.TypeItem[_Integer])
       then TypeItem[_integer]:=true;
     end;
   FirstOperator.ClearTypeInfo;
   SecondOperator.ClearTypeInfo;
  end;


  procedure TKratOperator.Doit;
  var Tmp:TTypeElement;
  begin
    inherited DoIt;
    Output:=nil;
    ReadFirstResult;
    ReadSecondResult;
    if (FirstResult=nil) or (SecondResult=nil) or not
       ((FirstResult.Typ in [_Byte,_Integer,_Float])
       and (SecondResult.Typ in [_Byte,_Integer,_Float]))then
        begin
         {kill}
         ClearResults;
         exit;
        end;
   if (FirstResult.Typ =_Float) or (SecondResult.Typ =_Float) then
   begin
   Tmp:=TFloatElement.create;
   TFloatElement(Tmp).Value:=TTypeElement(FirstResult).AsFloat*TTypeElement(SecondResult).AsFloat;
   end
   else
   begin
   if abs(TTypeElement(FirstResult).AsFloat*TTypeElement(SecondResult).AsFloat)>maxlongint then
   begin
   Tmp:=TFloatElement.create;
   TFloatElement(Tmp).Value:=TTypeElement(FirstResult).AsFloat*TTypeElement(SecondResult).AsFloat;
   end
   else
   begin
   Tmp:=TIntegerElement.create;
   TIntegerElement(Tmp).Value:=TTypeElement(FirstResult).AsInteger*TTypeElement(SecondResult).AsInteger;
   end;
   end;
   Output:=Tmp;
   ClearResults;
  end;

 {Deleno}
 procedure TDelenoOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   SecondOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if (FirstOperator.TypeItem[_Byte] or FirstOperator.TypeItem[_Integer] or FirstOperator.TypeItem[_Float])
     and (SecondOperator.TypeItem[_Byte] or SecondOperator.TypeItem[_Integer] or SecondOperator.TypeItem[_Float])
    then TypeItem[_float]:=true;
   FirstOperator.ClearTypeInfo;
   SecondOperator.ClearTypeInfo;
  end;

  procedure TDelenoOperator.Doit;
  var Tmp:TFloatElement;
  begin
    inherited DoIt;
    Output:=nil;
    ReadFirstResult;
    ReadSecondResult;
    if (FirstResult=nil) or (SecondResult=nil) or not
       ((FirstResult.Typ in [_Byte,_Integer,_Float])
       and (SecondResult.Typ in [_Byte,_Integer,_Float]))then
        begin
         {kill}
         ClearResults;
         exit;
        end;
   Tmp:=TFloatElement.create;
   Tmp.Value:=TTypeElement(FirstResult).AsFloat/TTypeElement(SecondResult).asFloat;
   Output:=Tmp;
   ClearResults;
  end;

 {Mod}
 procedure TModOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   SecondOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if (FirstOperator.TypeItem[_Byte] or FirstOperator.TypeItem[_Integer])
     and (SecondOperator.TypeItem[_Byte] or SecondOperator.TypeItem[_Integer])
    then TypeItem[_integer]:=true;
   FirstOperator.ClearTypeInfo;
   SecondOperator.ClearTypeInfo;
  end;


  procedure TModOperator.Doit;
  var Tmp:TIntegerElement;
  begin
    inherited DoIt;
    Output:=nil;
    ReadFirstResult;
    ReadSecondResult;
    if (FirstResult=nil) or (SecondResult=nil) or not
       ((FirstResult.Typ in [_Byte,_Integer])
       and (SecondResult.Typ in [_Byte,_Integer])) or
       (TTypeElement(Secondresult).AsInteger=0) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
   Tmp:=TIntegerElement.create;
   Tmp.Value:=TTypeElement(FirstResult).AsInteger mod TTypeElement(SecondResult).asInteger;
   Output:=Tmp;
   ClearResults;
  end;

 {Div}
procedure TDivOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   SecondOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if (FirstOperator.TypeItem[_Byte] or FirstOperator.TypeItem[_Integer])
     and (SecondOperator.TypeItem[_Byte] or SecondOperator.TypeItem[_Integer])
    then TypeItem[_integer]:=true;
   FirstOperator.ClearTypeInfo;
   SecondOperator.ClearTypeInfo;
  end;


  procedure TDivOperator.Doit;
  var Tmp:TIntegerElement;
  begin
    inherited DoIt;
    Output:=nil;
    ReadFirstResult;
    ReadSecondResult;
    if (FirstResult=nil) or (SecondResult=nil) or not
       ((FirstResult.Typ in [_Byte,_Integer])
       and (SecondResult.Typ in [_Byte,_Integer]))  or
       (TTypeElement(Secondresult).AsInteger=0)then
        begin
         {kill}
         ClearResults;
         exit;
        end;
   Tmp:=TIntegerElement.create;
   Tmp.Value:=TTypeElement(FirstResult).AsInteger div TTypeElement(SecondResult).asInteger;
   Output:=Tmp;
   ClearResults;
  end;


 {Compare}
 procedure TCompareOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   SecondOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
   if (FirstOperator.TypeItem[_Byte] or FirstOperator.TypeItem[_Integer] or FirstOperator.TypeItem[_Float])
     and (SecondOperator.TypeItem[_Byte] or SecondOperator.TypeItem[_Integer] or SecondOperator.TypeItem[_Float])
     then TypeItem[_boolean]:=true;
   if FirstOperator.TypeItem[_char] and SecondOperator.TypeItem[_char]
     then TypeItem[_boolean]:=true;
   if FirstOperator.TypeItem[_pointer] and SecondOperator.TypeItem[_pointer]
     then TypeItem[_boolean]:=true;
   if FirstOperator.TypeItem[_string] and SecondOperator.TypeItem[_string]
     then TypeItem[_boolean]:=true;
   FirstOperator.ClearTypeInfo;
   SecondOperator.ClearTypeInfo;
  end;

{vetsi}
 procedure TVetsiOperator.DoIt;
 var Tmp:TBooleanElement;
  begin
    inherited DoIt;
    Output:=nil;
    ReadFirstResult;
    ReadSecondResult;
    if (FirstResult=nil) or (SecondResult=nil) or
       ((FirstResult.typ<>SecondResult.typ) and not
        ((FirstResult.Typ in [_Byte,_Integer,_Float])
         and (SecondResult.Typ in [_Byte,_Integer,_Float]))) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
   Tmp:=TBooleanElement.create;
   case FirstResult.Typ of
      _Char:Tmp.Value:=TCharElement(FirstResult).Value>TCharElement(SecondResult).Value;
      _String:Tmp.Value:=TStringElement(FirstResult).Value>TStringElement(SecondResult).Value;
      _Byte,_Float,_Integer:Tmp.Value:=TTypeElement(FirstResult).AsFloat>TTypeElement(SecondResult).AsFloat;
      _Pointer:Tmp.Value:=TTypeElement(FirstResult).AsInteger>TTypeElement(SecondResult).AsInteger;
         else
           begin
           {kill}
           Tmp.free;
           ClearResults;
           exit;
          end;
       end;
   Output:=Tmp;
   ClearResults;
  end;

{vetsirovno}
 procedure TVetsiRovnoOperator.DoIt;
 var Tmp:TBooleanElement;
  begin
    inherited DoIt;
    Output:=nil;
    ReadFirstResult;
    ReadSecondResult;
    if (FirstResult=nil) or (SecondResult=nil) or
       ((FirstResult.typ<>SecondResult.typ) and not
        ((FirstResult.Typ in [_Byte,_Integer,_Float])
         and (SecondResult.Typ in [_Byte,_Integer,_Float]))) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
   Tmp:=TBooleanElement.create;
   case FirstResult.Typ of
      _Char:Tmp.Value:=TCharElement(FirstResult).Value>=TCharElement(SecondResult).Value;
      _String:Tmp.Value:=TStringElement(FirstResult).Value>=TStringElement(SecondResult).Value;
      _Byte,_Float,_Integer:Tmp.Value:=TTypeElement(FirstResult).AsFloat>=TTypeElement(SecondResult).AsFloat;
      _Pointer:Tmp.Value:=TTypeElement(FirstResult).AsInteger>=TTypeElement(SecondResult).AsInteger;
         else
           begin
           {kill}
           Tmp.free;
           ClearResults;
           exit;
          end;
       end;
   Output:=Tmp;
   ClearResults;
  end;

 {Mensi}
 procedure TMensiOperator.DoIt;
 var Tmp:TBooleanElement;
  begin
    inherited DoIt;
    Output:=nil;
    ReadFirstResult;
    ReadSecondResult;
   if (FirstResult=nil) or (SecondResult=nil) or
       ((FirstResult.typ<>SecondResult.typ) and not
        ((FirstResult.Typ in [_Byte,_Integer,_Float])
         and (SecondResult.Typ in [_Byte,_Integer,_Float]))) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
   Tmp:=TBooleanElement.create;
   case FirstResult.Typ of
      _Char:Tmp.Value:=TCharElement(FirstResult).Value<TCharElement(SecondResult).Value;
      _String:Tmp.Value:=TStringElement(FirstResult).Value<TStringElement(SecondResult).Value;
      _Byte,_Float,_Integer:Tmp.Value:=TTypeElement(FirstResult).AsFloat<TByteElement(SecondResult).AsFloat;
      _Pointer:Tmp.Value:=TTypeElement(FirstResult).AsInteger<TTypeElement(SecondResult).AsInteger;
         else
           begin
           {kill}
           Tmp.free;
           ClearResults;
           exit;
          end;
       end;
   Output:=Tmp;
   ClearResults;
  end;

 {MensiRovno}
 procedure TMensiRovnoOperator.DoIt;
 var Tmp:TBooleanElement;
  begin
    inherited DoIt;
    Output:=nil;
    ReadFirstResult;
    ReadSecondResult;
   if (FirstResult=nil) or (SecondResult=nil) or
       ((FirstResult.typ<>SecondResult.typ) and not
        ((FirstResult.Typ in [_Byte,_Integer,_Float])
         and (SecondResult.Typ in [_Byte,_Integer,_Float]))) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
   Tmp:=TBooleanElement.create;
   case FirstResult.Typ of
      _Char:Tmp.Value:=TCharElement(FirstResult).Value<=TCharElement(SecondResult).Value;
      _String:Tmp.Value:=TStringElement(FirstResult).Value<=TStringElement(SecondResult).Value;
      _Byte,_Float,_Integer:Tmp.Value:=TTypeElement(FirstResult).AsFloat<=TByteElement(SecondResult).AsFloat;
      _Pointer:Tmp.Value:=TTypeElement(FirstResult).AsInteger<=TTypeElement(SecondResult).AsInteger;
         else
           begin
           {kill}
           Tmp.free;
           ClearResults;
           exit;
          end;
       end;
   Output:=Tmp;
   ClearResults;
  end;


{Rovno}
 procedure TRovnoOperator.DoIt;
 var Tmp:TBooleanElement;
     dif:double;
  begin
    inherited DoIt;
    Output:=nil;
    ReadFirstResult;
    ReadSecondResult;
    if (FirstResult=nil) or (SecondResult=nil) or
       ((FirstResult.typ<>SecondResult.typ) and not
        ((FirstResult.Typ in [_Byte,_Integer,_Float])
         and (SecondResult.Typ in [_Byte,_Integer,_Float]))) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
   Tmp:=TBooleanElement.create;
   case FirstResult.Typ of
      _Boolean:Tmp.Value:=TBooleanElement(FirstResult).Value=TBooleanElement(SecondResult).Value;
      _Char:Tmp.Value:=TCharElement(FirstResult).Value=TCharElement(SecondResult).Value;
      _String:Tmp.Value:=TStringElement(FirstResult).Value=TStringElement(SecondResult).Value;
      _Pointer:Tmp.Value:=TTypeElement(FirstResult).AsInteger=TTypeElement(SecondResult).AsInteger;
      _Byte,_Float,_Integer:
             begin
             dif:=TTypeElement(FirstResult).AsFloat-TTypeElement(SecondResult).AsFloat;
             Tmp.Value := abs(dif) < 1e-13;
             {
             Tmp.Value:=(abs(dif/TTypeElement(FirstResult).AsFloat)<1e-13) and
              (abs(dif/TTypeElement(SecondResult).AsFloat)<1e-13);
             }
             end;
         else
           begin
           {kill}
           Tmp.free;
           ClearResults;
           exit;
          end;
       end;
   Output:=Tmp;
   ClearResults;
  end;
{Ruzne}
procedure TRuzneOperator.DoIt;
 var Tmp:TBooleanElement;
  begin
    inherited DoIt;
    Output:=nil;
    ReadFirstResult;
    ReadSecondResult;
    if (FirstResult=nil) or (SecondResult=nil) or
       ((FirstResult.typ<>SecondResult.typ) and not
        ((FirstResult.Typ in [_Byte,_Integer,_Float])
         and (SecondResult.Typ in [_Byte,_Integer,_Float]))) then
        begin
         {kill}
         ClearResults;
         exit;
        end;
   Tmp:=TBooleanElement.create;
   case FirstResult.Typ of
      _Boolean:Tmp.Value:=TBooleanElement(FirstResult).Value<>TBooleanElement(SecondResult).Value;
      _Char:Tmp.Value:=TCharElement(FirstResult).Value<>TCharElement(SecondResult).Value;
      _String:Tmp.Value:=TStringElement(FirstResult).Value<>TStringElement(SecondResult).Value;
      _Byte,_Float,_Integer:Tmp.Value :=TTypeElement(FirstResult).AsFloat<>TTypeElement(SecondResult).AsFloat;
      _Pointer:Tmp.Value:=TTypeElement(FirstResult).AsInteger<>TTypeElement(SecondResult).AsInteger;
      else
           begin
           {kill}
           Tmp.free;
           ClearResults;
           exit;
          end;
       end;
   Output:=Tmp;
   ClearResults;
  end;


{And}
 procedure TAndOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   SecondOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
    if FirstOperator.TypeItem[_boolean] and SecondOperator.TypeItem[_boolean]
     then TypeItem[_boolean]:=true;
   FirstOperator.ClearTypeInfo;
   SecondOperator.ClearTypeInfo;
  end;

procedure TAndOperator.DoIt;
var Tmp:TBooleanElement;
 begin
  inherited DoIt;
  Output:=nil;
  Tmp:=nil;
  ReadFirstResult;
  if (FirstResult<>nil) and (FirstResult.Typ=_boolean) then
   begin
     Tmp:=TBooleanElement.create;
     if TBooleanElement(FirstResult).Value then
       begin
        ReadSecondResult;
        if (SecondResult<>nil) and (FirstResult.Typ=_boolean) then
             begin
              if TBooleanElement(SecondResult).Value then Tmp.Value:=true
                                                     else Tmp.Value:=false;
             end
             else
             begin
              Tmp.free;
              {kill}
              exit;
             end;
       end
       else
       Tmp.Value:=false;
    end;
     {else
    begin
     {kill
      ClearResultst;
      exit;
    end;}
   Output:=Tmp;
   ClearResults;
 end;

{Or}
 procedure TOrOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   SecondOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
    if FirstOperator.TypeItem[_boolean] and SecondOperator.TypeItem[_boolean]
     then TypeItem[_boolean]:=true;
   FirstOperator.ClearTypeInfo;
   SecondOperator.ClearTypeInfo;
  end;

procedure TOrOperator.DoIt;
var Tmp:TBooleanElement;
 begin
  inherited DoIt;
  Output:=nil;
  Tmp:=nil;
  ReadFirstResult;
  if (FirstResult<>nil) and (FirstResult.Typ=_boolean) then
   begin
     Tmp:=TBooleanElement.create;
     if not TBooleanElement(FirstResult).Value then
       begin
        ReadSecondResult;
        if (SecondResult<>nil) and (FirstResult.Typ=_boolean) then
             begin
              if TBooleanElement(SecondResult).Value then Tmp.Value:=true
                                                     else Tmp.Value:=false;
             end
             else
             begin
              Tmp.free;
              ClearResults;
              {kill}
              exit;
             end;
       end
       else
       Tmp.Value:=true;
    end;
     {else
     begin
     {kill
      ClearResults;
      exit;
     end;}
    Output:=Tmp;
    ClearResults;
 end;

{na}
 procedure TNaBooleanOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
    if FirstOperator.TypeItem[_byte] or FirstOperator.TypeItem[_boolean] or FirstOperator.TypeItem[_integer]
     then TypeItem[_boolean]:=true;
   FirstOperator.ClearTypeInfo;
  end;

 procedure TNaBooleanOperator.DoIt;
  var Tmp:TBooleanElement;
   begin
     inherited DoIt;
     Output:=nil;
     ReadfirstResult;
     {$B-}
     if (FirstResult=nil) or
      not (FirstResult.Typ in [_Byte,_Boolean,_Integer]) then
          begin
          {kill}
          ClearResults;
          exit;
         end
        else
      begin
       Tmp:=TBooleanElement.create;
       case FirstResult.Typ of
        _Byte:Tmp.Value:=TByteElement(FirstResult).AsBoolean;
        _Boolean:Tmp.Value:=TBooleanElement(FirstResult).AsBoolean;
        _Integer:Tmp.Value:=TIntegerElement(FirstResult).AsBoolean;
       end;
      end;
     Output:=Tmp;
     ClearResults;
    end;

procedure TNaCharOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
    if FirstOperator.TypeItem[_byte] or FirstOperator.TypeItem[_char]
     then TypeItem[_char]:=true;
   FirstOperator.ClearTypeInfo;
  end;

 procedure TNaCharOperator.DoIt;
  var Tmp:TCharElement;
   begin
     inherited DoIt;
     Output:=nil;
     ReadfirstResult;
     {$B-}
     if (FirstResult=nil) or
      not (FirstResult.Typ in [_Byte,_Char]) then {kill}
         begin
         {kill}
         ClearResults;
         exit;
         end
      else
      begin
       Tmp:=TCharElement.create;
       case FirstResult.Typ of
        _Byte:Tmp.Value:=TByteElement(FirstResult).AsChar;
        _Char:Tmp.Value:=TCharElement(FirstResult).AsChar;
       end;
      end;
     Output:=Tmp;
     ClearResults;
    end;

 procedure TNaByteOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
    if FirstOperator.TypeItem[_byte] or FirstOperator.TypeItem[_boolean]
     or FirstOperator.TypeItem[_char] or FirstOperator.TypeItem[_integer]
     then TypeItem[_byte]:=true;
   FirstOperator.ClearTypeInfo;
  end;

 procedure TNaByteOperator.DoIt;
  var Tmp:TByteElement;
   begin
     inherited DoIt;
     Output:=nil;
     ReadfirstResult;
     {$B-}
     if (FirstResult=nil) or
      not (FirstResult.Typ in [_Byte,_Boolean,_Char,_Integer]) then {kill}
         begin
          {kill}
          ClearResults;
          exit;
         end
        else
      begin
       Tmp:=TByteElement.create;
       case FirstResult.Typ of
        _Byte:Tmp.Value:=TByteElement(FirstResult).AsByte;
        _Boolean:Tmp.Value:=TBooleanElement(FirstResult).AsByte;
        _Integer:Tmp.Value:=TIntegerElement(FirstResult).AsByte;
        _Char:Tmp.Value:=TCharElement(FirstResult).AsByte;
       end;
      end;
     Output:=Tmp;
     ClearResults;
    end;

procedure TNaIntegerOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
    if FirstOperator.TypeItem[_byte] or FirstOperator.TypeItem[_float]
     or FirstOperator.TypeItem[_char] or FirstOperator.TypeItem[_integer]
     then TypeItem[_byte]:=true;
   FirstOperator.ClearTypeInfo;
  end;

 procedure TNaIntegerOperator.DoIt;
  var Tmp:TIntegerElement;
   begin
     inherited DoIt;
     Output:=nil;
     ReadfirstResult;
     {$B-}
     if (FirstResult=nil) or
      not (FirstResult.Typ in [_Byte,_Float,_Char,_Integer,_String]) then {kill}
         begin
         {kill}
         ClearResults;
         exit;
         end
        else
      begin
       Tmp:=TIntegerElement.create;
       case FirstResult.Typ of
        _Byte   :Tmp.Value:= TByteElement(FirstResult).AsInteger;
        _Float  :Tmp.Value:= TFloatElement(FirstResult).AsInteger;
        _Integer:Tmp.Value:= TIntegerElement(FirstResult).AsInteger;
        _Char   :Tmp.Value:= TCharElement(FirstResult).AsInteger;
        _String :Tmp.Value:= TStringElement(FirstResult).AsInteger; { O.S. doplneno }
       end;
      end;
     Output:=Tmp;
     ClearResults;
    end;

procedure TNaFloatOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
    if FirstOperator.TypeItem[_byte] or FirstOperator.TypeItem[_float]
      or FirstOperator.TypeItem[_integer]
     then TypeItem[_float]:=true;
   FirstOperator.ClearTypeInfo;
  end;

 procedure TNaFloatOperator.DoIt;
  var Tmp:TFloatElement;
   begin
     inherited DoIt;
     Output:=nil;
     ReadfirstResult;
     {$B-}
      if (FirstResult=nil) or
      not (FirstResult.Typ in [_Byte,_Float,_Integer,_String]) then {kill}
          begin
          {kill}
          ClearResults;
          exit;
          end
        else
      begin
       Tmp:=TFloatElement.create;
       case FirstResult.Typ of
        _Byte:Tmp.Value:=TByteElement(FirstResult).AsFloat;
        _Float:Tmp.Value:=TFloatElement(FirstResult).AsFloat;
        _Integer:Tmp.Value:=TIntegerElement(FirstResult).AsFloat;
        _String:Tmp.Value := TStringElement(FirstResult).AsFloat;
       end;
      end;
     Output:=Tmp;
     ClearResults;
    end;

 procedure TNaStringOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   FirstOperator.GetTypeInfo;
   For i:=_boolean to _other do TypeItem[i]:=false;
    if FirstOperator.TypeItem[_byte] or FirstOperator.TypeItem[_float]
     or FirstOperator.TypeItem[_char] or FirstOperator.TypeItem[_integer]
     or FirstOperator.TypeItem[_boolean] or FirstOperator.TypeItem[_string]
     then TypeItem[_string]:=true;
   FirstOperator.ClearTypeInfo;
  end;


 procedure TNaStringOperator.DoIt;
  var Tmp:TStringElement;
   begin
     inherited DoIt;
     Output:=nil;
     ReadfirstResult;
     Tmp:=TStringElement.create;
     {$B-}
     if (FirstResult=nil) or
      not (FirstResult.Typ in [_Boolean,_Char,_Byte,_Float,_String,_Integer]) then {kill}
         begin
         {kill}
         //ClearResults;
         //exit;
         Tmp.Value := '';
        end
      else
      begin
       case FirstResult.Typ of
        _Byte:Tmp.Value:=TByteElement(FirstResult).AsString;
        _Float:Tmp.Value:=TFloatElement(FirstResult).AsString;
        _Integer:Tmp.Value:=TIntegerElement(FirstResult).AsString;
        _Char:Tmp.Value:=TCharElement(FirstResult).AsString;
        _Boolean:Tmp.Value:=TBooleanElement(FirstResult).AsString;
        _String:Tmp.Value:=TStringElement(FirstResult).AsString;
       end;
      end;
     Output:=Tmp;
     ClearResults;
    end;

{+++++++++++++++++++++++}

 function TCondition.IsTrue:boolean;
  begin
   ReadFirstResult;
   if (FirstResult=nil) or (FirstResult.Typ <>_boolean) then Result:=false
   else Result:=TBooleanElement(Firstresult).Value;
   ClearResults;
  end;

procedure TCondition.DoIt;
  begin
   Output:=TBooleanElement.createValue(IsTrue);
  end;

procedure TCondition.GetTypeInfo;
var
   i:TType;
begin
   new(FTypeList);
   For i:=_boolean to _other do TypeItem[i]:=false;
   TypeItem[_boolean]:=true;
end;



{ TIsOperator }

procedure TIsOperator.Doit;
var
   tmp: TBooleanElement;
   aClassName: string;
   CompClass: TClass;
begin
   Output:=nil;
   ReadFirstResult;
   if (FirstResult = nil) or (FirstResult.Typ <> _Pointer) or (TPointerElement(FirstResult)._Element = nil) then
   begin
      ClearResults;
      exit;
   end;

   ReadSecondResult;
   if (SecondResult = nil) or (SecondResult.Typ <> _string) then
   begin
      ClearResults;
      exit;
   end;
   aClassName := UpperCase(SecondResult.AsString);
   Tmp:=TBooleanElement.create;
   Output:=Tmp;
   Tmp.Value:=false;
   CompClass:=TPointerElement(FirstResult)._Element.ClassType;
   repeat
      Tmp.Value:=(UpperCase(CompClass.ClassName) = aClassName);
      CompClass:=CompClass.ClassParent;
   until (CompClass=nil) or (Tmp.Value=true);
   ClearResults;
end;

procedure TIsOperator.GetTypeInfo;
var
   i: TType;
begin
   new(FTypeList);
   For i:=_boolean to _other do TypeItem[i]:=false;
   TypeItem[_boolean]:=true;
end;

{ TSubstrOperator }

procedure TSubstrOperator.DoIt;
var
   tmp: TBooleanElement;
   S1,S2: string;
begin
   Output:=nil;
   ReadFirstResult;
   if (FirstResult = nil) or (FirstResult.Typ <> _String) then
   begin
      ClearResults;
      exit;
   end;

   ReadSecondResult;
   if (SecondResult = nil) or (SecondResult.Typ <> _string) then
   begin
      ClearResults;
      exit;
   end;
   if FindStatus <> 3 then
   begin
      S1 := UpperCase(FirstResult.AsString);
      S2 := UpperCase(SecondResult.AsString);
   end
   else
   begin
      S1 := FirstResult.AsString;
      S2 := SecondResult.AsString;
   end;
   Tmp:=TBooleanElement.create;
   Output:=Tmp;
   Tmp.Value:=false;
   case FindStatus of
      0: Tmp.Value := AnsiContainsText(S1,S2);
      1: Tmp.Value := AnsiStartsText(S2,S1);
      2: Tmp.Value := (Length(S2) <= Length(S1)) and AnsiEndsText(S2,S1);
      3: Tmp.Value := TRegEx.IsMatch(S1,S2,[roMultiLine]);
   end;
   ClearResults;
end;

procedure TSubstrOperator.GetTypeInfo;
var
   i: TType;
begin
   new(FTypeList);
   For i:=_boolean to _other do TypeItem[i]:=false;
   TypeItem[_boolean]:=true;
end;

procedure TReadPropOperator.SetLocalVars(const Value: TEntity);
begin
  FLocalVars := Value;
end;

end.