unit Ft_ine;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Grids, Outline, StdCtrls, Buttons, Menus,
  ImgList, ComCtrls, ToolWin, ActnList,
  e_HierTempl,
  e_INode,
  e_IModel,
  Elements,
  Tools;

type

TINESetupDialogForm = class(TForm)
   Panel1: TPanel;
   Panel2: TPanel;
    b_New: TBitBtn;
    o_1: TOutline;
    o_2: TOutline;
    o_3: TOutline;
    SG: TStringGrid;
   Header1: THeader;
    l_1: TLabel;
    l_2: TLabel;
    l_3: TLabel;
    l_IMProperties: TLabel;
    b_AddFromPalette: TBitBtn;
    BitBtn3: TBitBtn;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    BitBtn8: TBitBtn;
    b_DeleteNode: TBitBtn;
    ModelSetting: TBitBtn;
    b_Open: TBitBtn;
    b_Save: TBitBtn;
    b_SaveAs: TBitBtn;
    LB: TListBox;
    Bevel4: TBevel;
    ed_Name: TEdit;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    PopupMenu1: TPopupMenu;
    PopupMenu2: TPopupMenu;
    Prejmenovat: TMenuItem;
    Vyhodit1: TMenuItem;
    Nastavendatovhomodelu1: TMenuItem;
    cb_HDynamic: TCheckBox;
    cb_Dynamic: TCheckBox;
    PanelDH: TPanel;
    Panel: TPanel;
    BitBtn1: TBitBtn;
    TreeView: TTreeView;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton4: TToolButton;
    ToolButton8: TToolButton;
    ToolButton5: TToolButton;
    ActionList: TActionList;
    DeleteDir: TAction;
    NewDir: TAction;
    RenameDir: TAction;
    ClearDirs: TAction;
    CreateDirsByDisk: TAction;
    ToolButton6: TToolButton;
    ImageList1: TImageList;
    PopupMenu3: TPopupMenu;
    NewDir1: TMenuItem;
    DeleteDir1: TMenuItem;
    RenameDir1: TMenuItem;
    N1: TMenuItem;
    ClearDirs1: TMenuItem;
    CreateDirsByDisk1: TMenuItem;
    ImageList2: TImageList;
    SortTV: TCheckBox;
    cb_DontInterpretModels: TCheckBox;
    BitBtn2: TBitBtn;
    BitBtn4: TBitBtn;
    b_OpenAdd: TBitBtn;
    AddProperties: TMenuItem;
    PopupTAM: TPopupMenu;
    KontrolapodleTAMu1: TMenuItem;
    OpenTAM: TOpenDialog;
    BitBtn5: TBitBtn;
    procedure o_1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure b_AddFromPaletteClick(Sender: TObject);
    procedure o_2Click(Sender: TObject);
    procedure SGSetEditText(Sender: TObject; ACol, ARow: Longint;
      const Value: String);
    procedure b_DeleteNodeClick(Sender: TObject);
    procedure ModelSettingClick(Sender: TObject);
    procedure ed_NameChange(Sender: TObject);
    procedure b_NewClick(Sender: TObject);
    procedure b_OpenClick(Sender: TObject);
    procedure b_SaveAsClick(Sender: TObject);
    procedure b_SaveClick(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure PrejmenovatClick(Sender: TObject);
    procedure Vyhodit1Click(Sender: TObject);
    procedure Nastavendatovhomodelu1Click(Sender: TObject);
    procedure Header1Sizing(Sender: TObject; ASection, AWidth: Integer);
    procedure o_3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure o_3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SGDblClick(Sender: TObject);
    procedure cb_HDynamicClick(Sender: TObject);
    procedure cb_DynamicClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure ClearDirsExecute(Sender: TObject);
    procedure CreateDirsByDiskExecute(Sender: TObject);
    procedure DeleteDirExecute(Sender: TObject);
    procedure TreeViewChange(Sender: TObject; Node: TTreeNode);
    procedure NewDirExecute(Sender: TObject);
    procedure RenameDirExecute(Sender: TObject);
    procedure TreeViewEdited(Sender: TObject; Node: TTreeNode;
      var S: String);
    procedure SortTVClick(Sender: TObject);
    procedure cb_DontInterpretModelsClick(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure b_OpenAddClick(Sender: TObject);
    procedure AddPropertiesClick(Sender: TObject);
    procedure KontrolapodleTAMu1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
private
   FActive: boolean;
   FModified: boolean;
   FWork: TOwnerEntity;
   FFileName: string;
   FIniDir: string;
   DirTemplate: THierarchyTemplate;
   function GetIME: TInterpretModelEntity;
   function GetINE: TInterpretNodeEntity;
   function ConfirmSaving: word;
   procedure FillNodes;
   procedure FillIModel;
   procedure FillDModel;
   procedure FillIModelPalette;
   procedure FillProperties;
   procedure FillDirs;
   procedure FillTreeNode(Node: TTreeNode; Templ:THierarchyTemplate);
   procedure SetModified(aValue: boolean);
   procedure SaveINE;
   procedure NewINE;
   procedure LoadINE;
   procedure AddINE;
   procedure CHeckIME;
   procedure CHeckINE;
public
   Tool: TTool;
   property Work: TOwnerEntity read FWork write FWork;
   property IME: TInterpretModelEntity read GetIME;
   property INE: TInterpretNodeEntity read GetINE;
   property Modified: boolean read FModified write SetModified;
   property FileName: string read FFileName write FFileName;
   property InitialDir: string read FIniDir write FIniDir;
end;


TINESetupDialog = class(TTool)
private
   DLG: TINESetupDialogForm;
   FFileName: string;
   FIniDir: string;
public
   procedure DoIt; override;
   procedure HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean); override;
published
   property FileName: string read FFileName write FFileName;
   property initialDir: string read FIniDir write FIniDir;
end;


implementation
uses
   FileCtrl,
   e_Class,
   e_ElementModel,
   e_InterpretNameByPropertyModel,
   e_Files,
   e_Type,
   f_LayImp,
   f_Names,
   M_Orbis,
   t_ConfirmDialog,
   t_DirectoryHCheck,
   t_KontrolyByTAM,
   t_Loader,
   t_Main,
   t_Saver,
   u_String,
   Worlds;

{$R *.DFM}

{ TINESetupDialog }



procedure TINESetupDialog.DoIt;
begin
   Application.CreateForm(TINESetupDialogForm, DLG);
   DLG.FileName := FileName;
   DLG.InitialDir := InitialDir;
   DLG.Work := TOwnerEntity(Input);
   DLG.Tool := Self;
   DLG.ShowModal;
   FileName := DLG.FileName;
   DLG.Free;
   DLG := nil;
end;

procedure TINESetupDialog.HandleMessage(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   if aMessage.Message = tm_ShowTools then
   begin
      if DLG = nil then exit;
      DLG.CHeckIME;
      DLG.CHeckINE;
   end;
end;


{ TINESetupDialogForm }


procedure TINESetupDialogForm.SetModified(aValue: boolean);
begin
   if not FActive then exit;
   FModified := aValue;
   if aValue then ed_Name.Font.Color := clRed
             else ed_Name.Font.Color := clBlack;
end;

procedure TINESetupDialogForm.SaveINE;
var
   S: TSave;
begin
   if FileName = '' then
   begin
      if SaveDialog.Execute then FileName := ChangeFileExt(SaveDialog.FileName,'.ORB')
                            else exit;
   end;
   Modified := false;
   S := TSave.Create;
   S.Input := INE;
   S.FileName := FileName;
   Caption := FileName;
   S.DoIt;
   S.Free;
end;

procedure TINESetupDialogForm.NewINE;
begin
   Work.FreeElement(INE);
   FileName := '';
   Caption := 'NoName';
   FillNodes;
   Modified := false;
end;


procedure TINESetupDialogForm.LoadINE;
var
   L: TLoad;
begin
   OpenDialog.InitialDir := TMainTool(World.MainTool).Options.ScriptDirectory;
   if OpenDialog.Execute then
   begin
      Work.FreeElement(INE);
      L := TLoad.Create;
      L.FileName := OpenDialog.FileName;
      L.DoIt;
      Work.AddElement(L.Output);
      L.Free;
      FileName := OpenDialog.FileName;
      Caption := OpenDialog.FileName;
      FillNodes;
      Modified := false;
      CheckINE;
   end;
end;



procedure TINESetupDialogForm.FillNodes;
var
   E: TInterpretNodeEntity;
   El: TElement;
   i: longInt;
begin
   o_1.Clear;
   if Work = nil then exit;
   E := INE;
   if E = nil then
   begin
      E := TInterpretNodeEntity.Create;
      E.Name := 'Beze jmna';
      E.Version := IME.Version;
      Work.AddElement(E);
      Modified := false;
   end
   else
   begin
      for i := 0 to E.LastIndex do
      begin
         El := E.Elements[i];
         o_1.AddObject(0, El.Name, El);
      end;
      Modified := false;
   end;
   ed_Name.Text := E.Name;
   cb_HDynamic.Checked := E.DynamicModel;
   cb_DontInterpretModels.Checked := E.DontInterpretModels;
   FillIModel;
   FillDModel;
end;

procedure TINESetupDialogForm.FillIModel;
var
   IM: TInterpretModelEntity;
   i, j: longInt;
   aIndex: longInt;
   E, SE: TInterpretModel;
begin
   o_2.Clear;
   if o_1.SelectedItem = 0 then exit;
   if not (TElement(o_1.Items[o_1.SelectedItem].Data)is TInterpretNode) then exit;
   IM := TInterpretNode(o_1.Items[o_1.SelectedItem].Data).InterpretModel;
   if IM = nil then exit;
   for i := 0 to IM.LastIndex do
   begin
      E := TInterpretModel(IM.Elements[i]);
      aIndex := o_2.AddObject(0, E.Name, E);
      if not E.NoSubModels then
      for j := 0 to E.Submodels.LastIndex do
      begin
         SE := TInterpretModel(E.Submodels.Elements[j]);
         o_2.AddChildObject(aIndex, SE.Name, SE);
      end;
   end;
   o_2.FullExpand;
   FillProperties;
end;

procedure TINESetupDialogForm.FillDModel;
var
   IND: TInterpretNode;
   i: longInt;
begin
   LB.Items.Clear;
   if o_1.SelectedItem = 0 then exit;
   if not (TElement(o_1.Items[o_1.SelectedItem].Data)is TInterpretNode) then exit;
   IND := TInterpretNode(o_1.Items[o_1.SelectedItem].Data);
   cb_Dynamic.Checked := IND.DynamicModel;
   if IND.DataModel <> nil then
   begin
      for i := 0 to IND.DataModel.LastIndex do
      begin
         LB.Items.Add(IND.DataModel.StringElements[i].NameIsValue);
      end;
   end;
end;

procedure TINESetupDialogForm.FillIModelPalette;
var
   IM: TInterpretModelEntity;
   i, j: longInt;
   aIndex: longInt;
   E, SE: TInterpretModel;
begin
   IM := IME;
   if IM = nil then exit;
   for i := 0 to IM.LastIndex do
   begin
      E := TInterpretModel(IM.Elements[i]);
      aIndex := o_3.AddObject(0, E.Name, E);
      if not E.NoSubModels then
      for j := 0 to E.Submodels.LastIndex do
      begin
         SE := TInterpretModel(E.Submodels.Elements[j]);
         o_3.AddChildObject(aIndex, SE.Name, SE);
      end;
   end;
   o_3.FullExpand;
end;

procedure TINESetupDialogForm.FillProperties;
var
   IM: TInterpretModel;
   PM: TPropertyModel;
   i,Row: longInt;
begin
   SG.RowCount := 1;
   SG.Cells[0,0] := 'Docela ic';
   SG.Cells[1,0] := '';
   if o_2.SelectedItem = 0 then exit;
   IM := TInterpretModel(o_2.Items[o_2.SelectedItem].Data);
   if IM = nil then exit;
   if not IM.NoPropertyModels then
   begin
      SG.RowCount := IM.PropertyModels.Count;
      Row := 0;
      for i := 0 to IM.PropertyModels.LastIndex do
      begin
         PM := TPropertyModel(IM.PropertyModels.Elements[i]);
         if PM.Alias = 'HIDE PROPERTY' then
         begin
            SG.RowCount := SG.RowCount - 1;
            Continue;
         end;
         SG.Cells[0,Row] := PM.Alias;
         SG.Cells[1,Row] := PM.Value;
         SG.Objects[0,Row] := PM;
         Inc(Row);
      end;
      if Row = 0 then SG.Visible := false
                 else SG.Visible := true;
   end;
end;


function TINESetupDialogForm.GetIME: TInterpretModelEntity;
begin
   result := nil;
   if Work <> nil then
   begin
      result := TInterpretModelEntity(Work.FindElementClass(TInterpretModelEntity));
   end;
end;

function TINESetupDialogForm.GetINE: TInterpretNodeEntity;
begin
   result := nil;
   if Work <> nil then
   begin
      result := TInterpretNodeEntity(Work.FindElementClass(TInterpretNodeEntity));
   end;
end;

function TINESetupDialogForm.ConfirmSaving: word;
begin
   result := MessageDlg('Uloit zmny v '+ INE.Name + ' ?',mtConfirmation, [mbYes, mbNo, mbCancel], 0);
end;



procedure TINESetupDialogForm.o_1Click(Sender: TObject);
begin
   if o_1.SelectedItem = 0 then exit;
   if not (TElement(o_1.Items[o_1.SelectedItem].Data)is TInterpretNode) then
   begin
      if (TElement(o_1.Items[o_1.SelectedItem].Data)is TDirectoryHCheckNode) then
      begin
         DirTemplate := TDirectoryHCheckNode(o_1.Items[o_1.SelectedItem].Data).Template;
      end;
      PanelDH.Visible := true;
      Panel.Visible := true;
      FillDirs;
   end
   else
   begin
      DirTemplate := nil;
      PanelDH.Visible := false;
      Panel.Visible := false;
      FillIModel;
      FillDModel;
   end;
end;

procedure TINESetupDialogForm.FormShow(Sender: TObject);
begin
   FillIModelPalette;
   FillNodes;
   OpenDialog.InitialDir := InitialDir;
   SaveDialog.InitialDir := InitialDir;
   Caption := FileName;
   FActive := true;
   Tool.PostMsg(tm_ShowTools,Tool,nil,false);
   Modified := Work.FindElementName('Modified') <> nil;
end;

procedure TINESetupDialogForm.BitBtn8Click(Sender: TObject);
var
   FN: tf_Name;
   E: Telement;
   S: string;
begin
   Application.CreateForm(tf_Name,FN);
   FN.Left := Left + 20;
   FN.Top := Top + 100;
   FN.Caption := 'Nzev uzlu';
   FN.ed_Name.Text := 'Nov uzel';
   FN.ShowModal;
   if FN.ModalResult = mrOK then
   begin
      S := 'TInterpretNode';
      E := INE.CreateElement(S, FN.ed_Name.Text);
      TInterpretNode(E).DynamicModel := INE.DynamicModel;
      o_1.SelectedItem := o_1.AddObject(0, E.Name, E);
      Modified := true;
   end;
   FN.Free;
end;

procedure TINESetupDialogForm.b_AddFromPaletteClick(Sender: TObject);
var
   IM: TInterpretModel;
   IND: TInterpretNode;
begin
   if o_1.SelectedItem = 0 then exit;
   if o_3.SelectedItem = 0 then exit;
   if not (TElement(o_1.Items[o_1.SelectedItem].Data)is TInterpretNode) then exit;
   IND := TInterpretNode(o_1.Items[o_1.SelectedItem].Data);
   if IND.InterpretModel = nil then
   begin
      IND.InterpretModel := TInterpretModelEntity.Create;
   end;
   IM := TInterpretModel(o_3.Items[o_3.SelectedItem].Data);
   IND.InterpretModel.ModelToAdd := IM;
   Modified := true;
   FillIModel;
end;

procedure TINESetupDialogForm.o_2Click(Sender: TObject);
begin
   FillProperties;
end;

procedure TINESetupDialogForm.SGSetEditText(Sender: TObject; ACol,
  ARow: Longint; const Value: String);
var
   E: TElement;
begin
   try
      TPropertyModel(SG.Objects[0,aRow]).Value := Value;
      E := TElement(o_2.Items[o_2.SelectedItem].Data);
      if E is TInterpretNameByPropertyModel then
         o_2.Items[o_2.SelectedItem].Text := E.Name;
      Modified := true;
   except
   end;
end;


procedure TINESetupDialogForm.b_DeleteNodeClick(Sender: TObject);
var
   E: TElement;
begin
   if o_1.SelectedItem = 0 then exit;
   E := TElement(o_1.Items[o_1.SelectedItem].Data);
   if MessageDlg('Opravdu smazat uzel  "'+ E.Name + '" ?',mtConfirmation, [mbYes, mbNo], 0) = mrYes then
   begin
      INE.FreeElement(TElement(o_1.Items[o_1.SelectedItem].Data));
      FillNodes;
      Modified := true;
   end;
end;

procedure TINESetupDialogForm.ModelSettingClick(Sender: TObject);
var
   IND: TInterpretNode;
   DLG: TLayerImportDialog;
   i: longInt;
   SSS: TStringListElement;
begin
   if o_1.SelectedItem = 0 then exit;
   if not (TElement(o_1.Items[o_1.SelectedItem].Data)is TInterpretNode) then exit;
   IND := TInterpretNode(o_1.Items[o_1.SelectedItem].Data);
   DLG := TLayerImportDialog.Create;
   DLG.InitialDir := TMainTool(World.MainTool).Options.DataDirectory;
   SSS := nil;
   if IND.DataModel <> nil then
   begin
      SSS := TStringListElement.Create;
      for i := 0 to IND.DataModel.LastIndex do
      begin
         SSS.AddString(IND.DataModel.StringElements[i].NameIsValue);
      end;
   end;
   DLG.Input := SSS;
   DLG.DoIt;
   IND.DataModel := TStringListElement(DLG.Output);
   DLG.Free;
   Modified := true;
   FillDModel;
end;

procedure TINESetupDialogForm.ed_NameChange(Sender: TObject);
begin
   try
      INE.Name := ed_Name.Text;
      Modified := true;
   except
   end;
end;

procedure TINESetupDialogForm.b_NewClick(Sender: TObject);
begin
   PanelDH.Visible := false;
   Panel.Visible := false;
   if Modified then
   begin
      case ConfirmSaving of
         mrYes:
         begin
            SaveINE;
            NewINE;
         end;
         mrNo:
         begin
            NewINE;
         end;
      end;
   end
   else NewINE;
end;

procedure TINESetupDialogForm.b_OpenClick(Sender: TObject);
begin
   PanelDH.Visible := false;
   Panel.Visible := false;
   if Modified then
   begin
      case ConfirmSaving of
         mrYes:
         begin
            SaveINE;
            LoadINE;
         end;
         mrNo:
         begin
            LoadINE;
         end;
      end;
   end
   else LoadINE;
end;

procedure TINESetupDialogForm.b_SaveAsClick(Sender: TObject);
begin
   if SaveDialog.Execute then
   begin
      FileName := ChangeFileExt(Savedialog.FileName,'.ORB');
      SaveINE;
   end;
end;

procedure TINESetupDialogForm.b_SaveClick(Sender: TObject);
begin
   SaveINE;
end;

procedure TINESetupDialogForm.BitBtn3Click(Sender: TObject);
var
   IM: TInterpretModel;
   IND: TInterpretNode;
begin
   if o_1.SelectedItem = 0 then exit;
   if o_3.SelectedItem = 0 then exit;
   if not (TElement(o_1.Items[o_1.SelectedItem].Data)is TInterpretNode) then exit;
   IND := TInterpretNode(o_1.Items[o_1.SelectedItem].Data);
   if IND.InterpretModel = nil then exit;
   IM := TInterpretModel(o_2.Items[o_2.SelectedItem].Data);
   IND.InterpretModel.ModelToDelete := IM;
   Modified := true;
   FillIModel;
end;

procedure TINESetupDialogForm.PrejmenovatClick(Sender: TObject);
var
   FN: tf_Name;
   E: Telement;
begin
   if o_1.SelectedItem = 0 then exit;
   if not (TElement(o_1.Items[o_1.SelectedItem].Data)is TInterpretNode) then exit;
   Application.CreateForm(tf_Name,FN);
   FN.Left := Left + 20;
   FN.Top := Top + 100;
   FN.Caption := 'Nzev uzlu';
   FN.ed_Name.Text := TInterpretNode(o_1.Items[o_1.SelectedItem].Data).Name;
   FN.ShowModal;
   if FN.ModalResult = mrOK then
   begin
      TInterpretNode(o_1.Items[o_1.SelectedItem].Data).Name := FN.ed_Name.Text;
      o_1.Items[o_1.SelectedItem].Text := FN.ed_Name.Text;
      Modified := true;
   end;
   FN.Free;
end;

procedure TINESetupDialogForm.Vyhodit1Click(Sender: TObject);
begin
   b_DeleteNodeClick(nil);
end;

procedure TINESetupDialogForm.Nastavendatovhomodelu1Click(Sender: TObject);
begin
   ModelSettingClick(nil);
end;

procedure TINESetupDialogForm.Header1Sizing(Sender: TObject; ASection,
  AWidth: Integer);
begin
   SG.ColWidths[0] := Header1.SectionWidth[0];
   SG.ColWidths[1] := Header1.SectionWidth[1];
end;

procedure TINESetupDialogForm.o_3MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   if Button = mbRight then
   begin
      b_AddFromPaletteClick(nil);
   end;
end;

procedure TINESetupDialogForm.o_3MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   if Button = mbRight then
   begin
      o_3.SelectedItem := o_3.GetItem(x,y);
   end;
end;

procedure TINESetupDialogForm.SGDblClick(Sender: TObject);
var
   S: string;
   Y: longInt;
begin
   if SG.Selection.Left = 1 then
   begin
      Y := SG.Selection.Top;
      S := UpperCase(SG.Cells[1,Y]);
      S := BezVnejsichMezer(S);
      if S = 'TRUE' then
      begin
         S := 'FALSE'
      end
      else
      if S = 'FALSE' then
      begin
         S := 'TRUE'
      end
      else exit;
      SG.Cells[1,Y] := S;
      try
         TPropertyModel(SG.Objects[0,Y]).Value := S;
         Modified := true;
      except
      end;
   end;
end;

procedure TINESetupDialogForm.cb_HDynamicClick(Sender: TObject);
begin
   cb_Dynamic.Checked := cb_HDynamic.Checked;
   cb_Dynamic.enabled := not cb_HDynamic.Checked;
   INE.DynamicModel := cb_HDynamic.Checked;

end;

procedure TINESetupDialogForm.cb_DynamicClick(Sender: TObject);
var
   IND: TInterpretNode;
begin
   if o_1.SelectedItem = 0 then exit;
   if not (TElement((o_1.Items[o_1.SelectedItem].Data)) is TInterpretNode) then exit;
   IND := TInterpretNode(o_1.Items[o_1.SelectedItem].Data);
   IND.DynamicModel := cb_Dynamic.Checked;
end;

procedure TINESetupDialogForm.BitBtn1Click(Sender: TObject);
var
   E: Telement;
   S: string;
begin
   S := 'TDirectoryHCheckNode';
   E := INE.CreateElement(S, 'Adresov struktura');
   o_1.SelectedItem := o_1.AddObject(0, E.Name, E);
   Modified := true;
end;

procedure TINESetupDialogForm.FillDirs;
var
   N: TTreeNode;
begin
   TReeView.Items.Clear;
   N := TReeView.Items.AddObject(nil, DirTemplate.Name, DirTemplate);
   N.ImageIndex := 0;
   N.SelectedIndex := 1;
   FillTreeNode(N,DirTemplate);
   N.Expand(false);
   TreeView.Selected := N;
   if TreeView.SortType = stText then TreeView.AlphaSort;
end;

procedure TINESetupDialogForm.FillTreeNode(Node: TTreeNode;
  Templ: THierarchyTemplate);
var
   HT: THierarchyTemplate;
   N: TTreeNode;
   i: integer;
begin
   if Templ.NoElements then exit;
   for i := 0 to Templ.LastIndex do
   begin
      HT := THierarchyTemplate(Templ.Elements[i]);
      N := TreeView.Items.AddChildObject(Node, HT.Name, HT);
      N.ImageIndex := 0;
      N.SelectedIndex := 1;
      FillTreeNode(N,HT);
   end;
end;

procedure TINESetupDialogForm.ClearDirsExecute(Sender: TObject);
begin
   if DirTemplate = nil then exit;
   DirTemplate.FreeAll;
   FillDirs;
   Modified := true;
end;

procedure TINESetupDialogForm.CreateDirsByDiskExecute(Sender: TObject);
var
   S: string;
   D: TDirectoryElement;
begin
   if SelectDirectory('Vbr adrese pro ablonu', '', S) then
   begin
      D := TDirectoryElement.Create;
      D.DirOnly := true;
      D.FileName := S;
      DirTemplate.FreeAll;
      DirTemplate.TemplateElement := D;
      D.Free;
      FillDirs;
      Modified := true;
   end;
end;

procedure TINESetupDialogForm.DeleteDirExecute(Sender: TObject);
var
   N: TTreeNode;
   HT: THierarchyTemplate;
begin
   N := TreeView.Selected;
   HT := THierarchyTemplate(N.Data);
   if HT = DirTemplate then exit;
   HT.Free;
   N.Free;
   Modified := true;
end;

procedure TINESetupDialogForm.TreeViewChange(Sender: TObject;
  Node: TTreeNode);
begin
   DeleteDir.Enabled :=
      not (THierarchyTemplate(TreeView.Selected.Data)=DirTemplate);
end;

procedure TINESetupDialogForm.NewDirExecute(Sender: TObject);
var
   N,NN: TTreeNode;
   HT,HTN: THierarchyTemplate;
begin
   N := TreeView.Selected;
   HT := THierarchyTemplate(N.Data);
   HTN := THierarchyTemplate.Create;
   HTN.Name := 'Nov sloka';
   HT.AddElement(HTN);
   NN := TreeView.Items.AddChildObject(N,HTN.Name,HTN);
   NN.ImageIndex := 0;
   NN.SelectedIndex := 1;
   N.Expand(false);
   TreeView.Selected := NN;
   NN.EditText;
   Modified := true;
end;

procedure TINESetupDialogForm.RenameDirExecute(Sender: TObject);
var
   N: TTreeNode;
begin
   N := TreeView.Selected;
   N.EditText;
end;

procedure TINESetupDialogForm.TreeViewEdited(Sender: TObject;
  Node: TTreeNode; var S: String);
var
   N: TTreeNode;
   HT: THierarchyTemplate;
begin
   N := TreeView.Selected;
   HT := THierarchyTemplate(N.Data);
   HT.Name := S;
   Modified := true;
end;

procedure TINESetupDialogForm.SortTVClick(Sender: TObject);
begin
   if SortTV.Checked then TreeView.SortType := stText
                     else TreeView.SortType := stNone;
end;

procedure TINESetupDialogForm.cb_DontInterpretModelsClick(Sender: TObject);
begin
   if INE.DontInterpretModels = cb_DontInterpretModels.Checked then exit;
   INE.DontInterpretModels := cb_DontInterpretModels.Checked;
   Modified := true;
end;

procedure TINESetupDialogForm.BitBtn4Click(Sender: TObject);
var
   IND,IND1: TElement;
   i: integer;
begin
   i := o_1.SelectedItem;
   if i < 2 then exit;
   if not (TObject((o_1.Items[i].Data)) is TElement) then exit;
   IND := TElement(o_1.Items[i].Data);
   IND1 := TElement(o_1.Items[i-1].Data);
   INE.ExchangeElements(IND,IND1);
   o_1.Items[i].Text := IND1.Name;
   o_1.Items[i].Data := IND1;
   o_1.Items[i-1].Text := IND.Name;
   o_1.Items[i-1].Data := IND;
   o_1.SelectedItem := i-1;
   Modified := true;
end;

procedure TINESetupDialogForm.BitBtn2Click(Sender: TObject);
var
   IND,IND1: TElement;
   i: integer;
begin
   i := o_1.SelectedItem;
   if i > o_1.ItemCount - 1 then exit;
   if not (TObject((o_1.Items[i].Data)) is TElement) then exit;
   IND := TElement(o_1.Items[i].Data);
   IND1 := TElement(o_1.Items[i+1].Data);
   INE.ExchangeElements(IND,IND1);
   o_1.Items[i].Text := IND1.Name;
   o_1.Items[i].Data := IND1;
   o_1.Items[i+1].Text := IND.Name;
   o_1.Items[i+1].Data := IND;
   o_1.SelectedItem := i+1;
   Modified := true;
end;

procedure TINESetupDialogForm.b_OpenAddClick(Sender: TObject);
begin
   PanelDH.Visible := false;
   Panel.Visible := false;
   if INE = nil then LoadINE
                else AddINE;
end;

procedure TINESetupDialogForm.AddINE;
var
   L: TLoad;
   E: TEntity;
   i: integer;
begin
   OpenDialog.InitialDir := TMainTool(World.MainTool).Options.ScriptDirectory;
   if OpenDialog.Execute then
   begin
      L := TLoad.Create;
      L.FileName := OpenDialog.FileName;
      L.DoIt;
      E := TEntity(L.Output);
      for i := 0 to E.LastIndex do
      begin
         INE.AddElement(E.Elements[i]);
      end;
      E.Free;
      L.Free;
      FileName := OpenDialog.FileName;
      FillNodes;
      Modified := true;
   end;
end;

procedure TINESetupDialogForm.AddPropertiesClick(Sender: TObject);
var
   IM,IM1,SIM,SIM1: TInterpretModel;
   IND: TInterpretNode;
   NIME,PIME: TInterpretModelEntity;
   N: TInterpretNode;
   i,j,k: integer;
begin
   PIME := IME;
   if PIME = nil then exit;
   for i := 0 to INE.LastIndex do
   begin
      N := INE.InterpretNode[i];
      if TElement(N) is TDirectoryHCheckNode then Continue;
      NIME := N.InterpretModel;
      if not NIME.NoElements then
      for j := 0 to NIME.LastIndex do
      begin
         if not(NIME.Elements[j] is TInterpretModel) then continue;
         IM := TInterpretModel(NIME.Elements[j]);
         IM1 := TInterpretModel(PIME.FindElementName(IM.Name));
         if IM1 = nil then Continue;
         NIME.AddProperties(IM1,IM);
         if IM.SubModels.NoElements then Continue;
         for k := 0 to IM.SubModels.LastIndex do
         begin
            SIM := TInterpretModel(IM.SubModels.Elements[k]);
            SIM1 := TInterpretModel(IM1.SubModels.FindElementName(SIM.Name));
            if SIM1 = nil then Continue;
            NIME.AddProperties(SIM1,SIM);
         end;
      end;
   end;
   FillIModel;
   Modified := true;
end;

procedure TINESetupDialogForm.CHeckIME;
begin
   if IME = nil then
      ShowMessage('Neexistuje dn nabdka kontrol - to jsem zvdav, co budete dlat');
   if IME.Version < 4 then
      ShowMessage('Star nabdka kontrol - eknte nkomu, a Vm d aktuln soubor Start.oil');
end;

procedure TINESetupDialogForm.CHeckINE;
var
   IM,IM1,SIM,SIM1: TInterpretModel;
   PM,PM1: TPropertyModel;
   IND: TInterpretNode;
   NIME,PIME: TInterpretModelEntity;
   N: TInterpretNode;
   i,j,k: integer;
   E: TElement;
   S: string;
begin
   if INE = nil then exit;
   if INE.Version > 3 then exit;
   if not Confirm(INE.Name+#13+#10+'Star verze kontroly - budete si pt ji aktualizovat?') then exit;
   if IME.Version < 4 then
      if not Confirm('Jak u urit bylo eeno, nabdka kontrol je zastaral. Aktualizace tedy patrn nebude k niemu. Chcete v n pokraovat?') then exit
      else ShowMessage('Ach jo ... komu nen pomoci....');
   PIME := IME;
   if PIME = nil then exit;
   for i := 0 to INE.LastIndex do
   begin
      N := INE.InterpretNode[i];
      if TElement(N) is TDirectoryHCheckNode then Continue;
      NIME := N.InterpretModel;
      if (NIME <> nil) and not NIME.NoElements then
      for j := 0 to NIME.LastIndex do
      begin
         if not(NIME.Elements[j] is TInterpretModel) then continue;
         IM := TInterpretModel(NIME.Elements[j]);
         IM1 := TInterpretModel(PIME.FindElementName(IM.Name));
         if IM1 = nil then Continue;
         IM.ElementClassName := IM1.ElementClassName;
         if IM.Name = 'Kontrola zaplochovn' then
         begin
            E := IM.PropertyModels.FindElementName('DontSendErrors');
            if E <> nil then
               E.Free;
            E := IM.PropertyModels.FindElementName('OutputDir');
            if E <> nil then
               E.Free;
         end;
         NIME.AddProperties(IM1,IM);
         if IM.SubModels.NoElements then Continue;
         for k := 0 to IM.SubModels.LastIndex do
         begin
            SIM := TInterpretModel(IM.SubModels.Elements[k]);
            SIM1 := TInterpretModel(IM1.SubModels.FindElementName(SIM.Name));
            if SIM1 = nil then Continue;
            SIM.ElementClassName := SIM1.ElementClassName;
            if SIM.Name = 'Velikost plochy' then
            begin
               S := 'TestCondition';
               PM := TPropertyModel(SIM.PropertyModels.FindElementName(S));
               PM1:= TPropertyModel(SIM1.PropertyModels.FindElementName(S));
               PM.Value := PM1.Value;
               S := 'MsgProp';
               PM := TPropertyModel(SIM.PropertyModels.FindElementName(S));
               PM1:= TPropertyModel(SIM1.PropertyModels.FindElementName(S));
               PM.Value := PM1.Value;
            end
            else
            if SIM.Name = 'Zporn plocha-enklvy!?' then
            begin
               S := 'TestCondition';
               PM := TPropertyModel(SIM.PropertyModels.FindElementName(S));
               PM1:= TPropertyModel(SIM1.PropertyModels.FindElementName(S));
               PM.Value := PM1.Value;
            end;
            NIME.AddProperties(SIM1,SIM);
         end;
      end;
   end;
   INE.Version := PIME.Version;
   Modified := true;
   FillIModel;
end;


procedure TINESetupDialogForm.KontrolapodleTAMu1Click(Sender: TObject);
var
   T: TKontrolyByTam;
   S: string;
begin
   S := TMainTool(World.MainTool).Options.TAMDirectory;
   if not DirectoryExists(S) then S := '';
   OpenTAM.InitialDir := S;
   if OpenTAM.execute then
   begin
      PanelDH.Visible := false;
      Panel.Visible := false;
      if Modified then
      begin
         case ConfirmSaving of
            mrYes:
            begin
               SaveINE;
            end;
            mrNo:
            begin
            end;
            else
               exit;
         end;
      end;
      TMainTool(World.MainTool).Options.TAMDirectory := ExtractFilePath(OpenTAM.FileName);
      T := TKontrolyByTAM.Create;
      T.FileName := OpenTAM.FileName;
      T.PaletaKontrol := IME;
      T.DoIt;
      if T.Output = nil then exit;
      Work.FreeElement(INE);
      Work.AddElement(T.Output);
      FileName := '';
      Caption := 'NoName';

      T.Free;
      FillNodes;
      Modified := true;
   end;
end;

procedure TINESetupDialogForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
   S: string;
begin
   S := 'Modified';
   CanClose := true;
   if Modified then
   begin
      case ConfirmSaving of
         mrYes:
         begin
            SaveINE;
            Work.ElementToFree := Work.FindElementName(S);
         end;
         mrNo:
         begin
            if Work.FindElementName(S) = nil then
               Work.CreateElement('TOwnerElement',S);
         end;
         else
            CanClose := false;
      end;
   end
   else
      Work.ElementToFree := Work.FindElementName(S);
end;

INITIALIZATION
   RegisterOrbisClass(TINESetupDialog);
END.
