{$D-}
unit T_chktpl;

interface
uses
  Elements, Tools, T_Recurs, T_Chk, T_ChkSp;


const
  ch_LineConnection   = 10000; { + 1,2,3,4 - LR, LN, PR, PN bez napojeni,
                                 + 5, 6 - LR se drzi PR, LN se drzi PN }



type

TCheckLineConnection = class(TCheckSpaceEntity)
protected
  function GetError: longInt; override;
  function GetErrorMsg: string; override;
  function ElementCondition: boolean; override;
end;



TCheckTopolAreaInFather = class(TCheckSpaceEntity)
protected
  function GetError: longInt; override;
  function GetErrorMsg: string; override;
  function ElementCondition: boolean; override;
end;



implementation
uses
  SysUtils,
  E_Class,
  MathLib,
  G_Elems,
  //E_Space,
  e_Geometry,
  e_GeometryElement,
  E_Reg,
  e_TopolElements,
  //E_TplPrp,
  U_TopolT;



                     { TCheckLineConnection }

function TCheckLineConnection.GetError: longInt;
begin
  result:= ch_LineConnection + State;
end;



function TCheckLineConnection.GetErrorMsg: string;
begin
  result:= '';
  if Error > 0 then
     result:=  ' X: ' + FloatToStr(X) + ' Y: ' + FloatToStr(Y)
end;


{
  NedrziSe: TDrzise     = (

                           Levou : (
                                    Rukou: (
                                            Koho  : Nikoho;
                                            Zaruku: false
                                           );
                                    Nohou: (
                                            Koho  : Nikoho;
                                            ZaRuku: false
                                           )
                                   );
                           Pravou: (
                                    Rukou: (
                                            Koho  : Nikoho;
                                            Zaruku: false
                                           );
                                    Nohou: (
                                            Koho  : Nikoho;
                                            ZaRuku: false
                                           )
                                   )
                          );
}


function TCheckLineConnection.ElementCondition: boolean;
var
  PL: TPolyLineElement;
  TL: TTopolLineElement;
  DrziSe: TDrziSe;
begin
  result:= true;
  State:= 0;
  if not (Input is TTopolLineElement) then exit;
  TL:= TTopolLineElement(Input);
  X:= TL.X; Y:= TL.Y;
  DrziSe:= TL.DrziSe;
  if DrziSe.Levou.Rukou.Koho < 1 then
     State:= 1;
  if DrziSe.Levou.Nohou.Koho < 1 then
     State:= 2;
  if DrziSe.Pravou.Rukou.Koho < 1 then
     State:= 3;
  if DrziSe.Pravou.Nohou.Koho < 1 then
     State:= 4;

  if (DrziSe.Levou.Rukou.Koho = TL.Cislo) and
     (DrziSe.Levou.Rukou.ZaRuku) then
     State:= 5;

  if (DrziSe.Levou.Nohou.Koho = TL.Cislo) and
     (not DrziSe.Levou.Nohou.ZaRuku) then
     State:= 6;

  if State > 0 then
  begin
    result:= false;
    Error:= GetError;
  end;
end;




                     { TCheckTopolAreaInFather }

function TCheckTopolAreaInFather.GetError: longInt;
begin
  result:= ch_AreaInFather + State;
end;



function TCheckTopolAreaInFather.GetErrorMsg: string;
begin
  result:= '';
  if Error > 0 then
     result:=  ' X: ' + FloatToStr(FX) + ' Y: ' + FloatToStr(FY)
end;



function TCheckTopolAreaInFather.ElementCondition: boolean;
var
  Are: TAreaElement;
  TA: TTopolAreaElement;
  PaterNo: longInt;
  aPater: TGeometryElement;
  aBlockReg: TBlockRegister;
begin
  result:= true;
  State:= 0;
  if not (Input is TTopolAreaElement) then exit;
  TA:= TTopolAreaElement(Input);
  PaterNo:= TA.PaterNo;
  if PaterNo < 0 then exit;
  aBlockReg:= TA.BlockRegister;
  if aBlockReg = nil then exit;

  FX:= TA.X; FY:= TA.Y;

  aPater:= aBlockReg.GetObject('P', PaterNo);
  if not (aPater is TTopoLAreaElement) then
  begin
    result:= false;
    State:= 1;
    Error:= GetError;
    exit;
  end;

  result:= TAreaElement(aPater.Geometry).XYIsInsideNoHoles(TA.X, TA.Y);

  if not result then
  begin
    State:= 2;
    Error:= GetError;
  end;
end;





initialization
   RegisterOrbisClass(TCheckLineConnection);
   RegisterOrbisClass(TCheckTopolAreaInFather);
end.
