unit I_top_b;
{
********************************************************
**                                                    **
**                    ORBIS                           **
**     Skupina interpretr Topolovskch bod          **
**                                                    **
**                 Topol Pro 1996                    **
********************************************************
}

interface
uses
// KERNEL
   Elements,
   Tools,
   T_Recurs,
// GLIB
   g_Elems,
// DEVICE
   e_Device,
// SYMBOL
   e_PSymb,
// TOPOL   
   I_Top;

type

TInterpretTopBodu = class(TInterpretTopObject)
 protected
    Symbols: TTopoLSymbols;
    //Rect: TDoubleRect;
    function  IsItsClass(AObject: TObject): boolean; override;
    function  QGoInside(Element: TElement): boolean; override;
    function  QProcessBefore(Element: TElement): boolean; override;
    procedure Process(Element: TElement); override;
 public
   procedure  Reset(aDevice: TDevice); override;
   procedure  Close; override;
end;



implementation

uses
   WinProcs,
   Controls,
   Forms,
   Graphics,
   SysUtils,
// KERNEL
   e_Class,
// GLIB
   e_Color,
// SPACE
   e_Geometry,
   e_GeometryElement,
   //E_Space,
// SYMBOL
   u_Symbol,
// TOPOL
   e_TopoLElements;
   //E_TplPrp;

function  TInterpretTopBodu.IsItsClass(AObject: TObject): boolean;
begin
   result := (AObject is TTopolPointElement) or (AObject is TPointCollection);
end;


function  TInterpretTopBodu.QGoInside(Element: TElement): boolean;
begin
   Result:= Element is TPointCollection;
end;

function  TInterpretTopBodu.QProcessBefore(Element: TElement): boolean;
begin
  result:= false;
  if (Element is TPointCollection) then
  begin
     //OwnerProps:= TPointString(Element).Properties;
     UseColor := TPointCollection(Element).UseColor;
     Color := TPointCollection(Element).Color;
     UseSymbol:= TPointCollection(Element).UseSymbol;
     Symbol := TPointCollection(Element).Symbol;
{
     UseColor := TTopolBody(Element).UseColor;
     Color := TTopolBody(Element).Color;
     UseSymbol:= TTopolBody(Element).UseSymbol;
     Symbol := TTopolBody(Element).Symbol;
}
     exit;
  end;

  Result:= Element is TTopoLPointElement;
end;



procedure TInterpretTopBodu.Process(Element: TElement);
var
  IX, IY: double;
  iiX, iiY: integer;
//  I: longInt;
  Bod: TTopoLPointElement;
  //BP: TTopolProps;
  aZnacka: integer;
  IsInside: boolean;
  R: TDoubleRect;
  TP: TTopolPointELement;
  G: TGeometry;
begin
  IsInside := false;
  if (Element is TTopoLPointElement) then
  begin
     TP := TTopolPointElement(Element);
     G := TP.Geometry;
     if G = nil then exit;
     if StrictRects and (Symbols <> nil) and (TP.Znacka > 999 )then
     begin
        Symbols.OpsanyObdelnik(TP.Geometry,TP.Znacka,R);
        iX := G.X;
        iY := G.Y;
        G.MinX := R.MinX;
        G.MinY := R.MinY;
        G.MaxX := R.MaxX;
        G.MaxY := R.MaxY;
        G.AbsRefX := iX;
        G.AbsRefY := iY;
        IsInside := NoRect or G.IsOverRegionEx(Rect.MinX,Rect.MinY,Rect.MaxX,Rect.MaxY);
     end
     else
        IsInside :=  NoRect or TP.IsInsideRegion(Rect.MinX,Rect.MinY,Rect.MaxX,Rect.MaxY);
     if IsInside then
     begin
       Bod:= TP;
       //BP:= TTopolProps(Bod.Properties);
       //if not (TElement(BP) is TTopolProps) then exit;
       aZnacka := Bod.Znacka;
       if UseSymbol then
       begin
         aZnacka:= Symbol;
       end;

      try
       if UseColor then
          Device.Pen.Color := Color
       else
          Device.Pen.Color := DejBarvicku(Bod.Barva);

       Device.Pen.Style := psSolid;
       if (Symbols <> nil) and (aZnacka > 999) then
       begin
          Symbols.InterpretSymbol(Bod.Geometry, aZnacka);
          exit;
       end;
       IX:= Bod.X;
       IY:= Bod.Y;
       iiX := Device.Projection.GetPageX(IX);
       iiY := Device.Projection.GetPageY(IY);
       Device.MoveToDevice(iiX-5, iiY);
       Device.LineToDevice(iiX+6, iiY);
       Device.MoveToDevice(iiX, iiY-5);
       Device.LineToDevice(iiX, iiY+6);
      except
         {
         MessageDlg(IntToStr(TTopoLLin(Element).Count) + ' Chyba interpretace linie . '+ IntToStr(TTopoLLin(Element).Cislo),
                             mtInformation, [mbOK], 0);
         }
//         MessageBeep(word(-1));
      end;

     end;
  end
  else inherited process(Element);
end;


procedure   TInterpretTopBodu.Reset(aDevice: TDevice);
begin
   inherited Reset(aDevice);
   //Rect := aDevice.Projection.ModelView;

   if fileExists(PathOfLibraries+'\Fonty.txt') then
   begin
     if Symbols <> nil then
        Symbols.Free;
     Symbols := TTopoLSymbols.CreateAll(PathOfLibraries+'\Fonty.txt');
     try
       Symbols.Device := Device
     except
       if Symbols <> nil then
          Symbols.Free;
       Symbols:= nil
     end;
   end
end;

procedure   TInterpretTopBodu.Close;
begin
  if Symbols <> nil then
  begin
     Symbols.Free;
     Symbols:= nil
  end;
  inherited Close
end;






BEGIN
   RegisterOrbisClass(TInterpretTopBodu);
END.
