unit I_top_p;
{
********************************************************
**                                                    **
**                    ORBIS                           **
**     Skupina interpretr Topolovskch ploch         **
**                                                    **
********************************************************
}

interface

uses
   Graphics,
// KERNEL
   Elements,
   Tools,
   T_Recurs,
// GLIB
   g_Elems,
// SPACE
   e_Geometry,
   //E_Space,
// DEVICE
   e_Device,
// SYMBOL
   e_PlZn,
// TOPOL
   I_Top;



type

TInterpretTopPloch = class(TInterpretTopObject)
private
   PlosneZnacky: TPlosneZnacky;
   //Rect: TDoubleRect;
 protected
   procedure Process(Element: TElement); override;
   function  IsItsClass(AObject: TObject): boolean; override;
   function  QGoInside(Element: TElement): boolean; override;
   function  QProcessBefore(Element: TElement): boolean; override;
   procedure ProcessAsUserDefinedPattern(aPlocha: TAreaElement; aZnacka,aColor: integer);
 public
   function   CanUniGoInside(Element: TElement): boolean; override;
   procedure  Reset(aDevice: TDevice); override;
   procedure  Close; override;
end;



implementation

uses
   WinTypes,
   WinProcs,
   Dialogs,
   SysUtils,
// KERNEL
   e_Class,
// GLIB
   ClipArea,
   E_Color,
// SYMBOL
   u_Symbol,
// SPACE
   e_GeometryElement,
// TOPOL
   e_TopoLElements;
   //E_TplPrp;



{ TInterpretTopPloch }

(*
procedure TInterpretTopPloch.
          ProcessAsUserDefinedPattern(aPlocha: TAreaElement; aProps: TElement);
var
  Srafa: TPlosnaZnacka;
  BB: TBorderBuffer;
  ClipModelReg: TDoubleRect;

begin
  //Srafa:= nil;
  if aPlocha.IsHole then exit;
  {P.K.31.3.98}
  {
  if not (aPlocha.Properties is TTopolAreaProps) then exit;
  Srafa := PlosneZnacky.VratZnackuDleKodu(TTopolAreaProps(aPlocha.Properties).Znacka);
  }
  if not (aProps is TTopolAreaProps) then exit;
  Srafa := PlosneZnacky.VratZnackuDleKodu(TTopolAreaProps(aProps).Znacka);

  if not assigned(Srafa) then exit;

  with Device.Page.ClipRegion do
  begin
    ClipModelReg:= Device.Projection.GetModelRect(Left, Top, Right, Bottom)
  end;

{   with Device.Projection.ModelView do }
  BB:= TBorderBuffer.Create;
  BB.Projection:= Device.Projection;
  BB.RectEntity:= aPlocha;
  BB.MinX:= ClipModelReg.MinX;
  BB.MinY:= ClipModelReg.MinY;
  BB.MaxX:= ClipModelReg.MaxX;
  BB.MaxY:= ClipModelReg.MaxY;
  BB.ClipRect:= Device.Page.ClipRegion;
  BB.ClipIt;

  if BB.Buffer <> nil then
  begin
     Srafa.VyplnPlochu(Device, BB.PointNo, BB.Buffer^);
     BB.Free
  end;
  {P.K.31.3.98}
  {
  if BB.Buffer <> nil then freeMem(BB.Buffer, BB.BufferSize);
  BB.Free
  }
end;
*)

procedure TInterpretTopPloch.
          ProcessAsUserDefinedPattern(aPlocha: TAreaElement; aZnacka,aColor: integer);
var
  Srafa: TPlosnaZnacka;
  Coords, Lengths: pointer;
  aSize, LNumber: integer;
begin
  if aPlocha.IsHole then exit;
  //if not (aProps is TTopolAreaProps) then exit;
  Srafa := PlosneZnacky.VratZnackuDleKodu(aZnacka);
  if not assigned(Srafa) then exit;

  Device.PrepareForPolyPolygon(aPlocha,Coords,Lengths,aSize,LNumber);
  Srafa.ExternalColor := aColor;
  Srafa.VyplnPlochu(Device, TByteArray(Coords^)[0], TLengthArray(Lengths^)[0], LNumber,aPlocha.MinX,aPlocha.MaxY);
  freeMem(Coords, aSize);
  freeMem(Lengths, LNumber*sizeOf(TLengthItem));
end;


procedure TInterpretTopPloch.Process(Element: TElement);
var
  PlochaBoundary: TAreaElement;
  NPlocha: TAreaElement;
  aTP: TTopoLAreaElement;
  //P: Wintypes.TPoint;
  Znacka, Barva: longInt;
  SimpleArea: boolean;
begin
  //NPlocha:= nil;
  try
    aTP := TTopoLAreaElement(Element);
    PlochaBoundary := TAreaElement(aTP.Geometry);
    (*
    if (aProps <> nil) then
    begin
      if aProps.HasPropertyByName('ZNACKA') then
         Znacka:= aProps.GetPropertyLongIntByName('ZNACKA')
      else
        Znacka:= 1;

      if aProps.HasPropertyByName('BARVA') then
         Barva:= aProps.GetPropertyLongIntByName('BARVA')
      else
        Barva:= 10
    end
    *)
     Znacka := aTP.Znacka;
     Barva := aTP.Barva;
    {
    if aProps is TTopolAreaProps then
    begin
        Znacka := TTopolAreaProps(aProps).Znacka;
        Barva := TTopolAreaProps(aProps).Barva;
    end
    else
    begin
      Znacka:= 1;
      Barva:= 10;
    end;
    }
    SimpleArea := true;
    NPlocha:= nil;
    if PlochaBoundary is TPolyLineAreaElement then
    begin
      NPlocha:= TPolyLineAreaElement(PlochaBoundary).CreateAreaElement;
      PlochaBoundary:= NPlocha;
      SimpleArea := false;
    end;

    Device.Brush.Style:= bsSolid;

    if UseSymbol then
    begin
      (*
      aProps.SetPropertyLongIntByName('ZNACKA', GetOwnerLongIntProp('SYMBOL'));
      { !!!!!!!!!!!! co je to za kravinu - tady se natvrdo pepisuje znacka }
      *)
       Znacka := Symbol;
    end;

    if UseColor then
    begin
      Device.Brush.Color:= Color;
      Device.Pen.Style:= psClear;
      Device.PolyPolygon(PlochaBoundary)
    end
    else
    if Znacka > 999 then
    begin
      ProcessAsUserDefinedPattern(PlochaBoundary,Znacka,DejBarvicku(Barva));
    end
    else
    if Znacka > 0 then
    begin
       Device.Brush.Color:= DejBarvicku(Barva);
       if SimpleArea then
       begin
          Device.Pen.Style:= psSolid;
          Device.Pen.Color:= 0;
          Device.Pen.Width:= 1;
       end
       else Device.Pen.Style:= psClear;

       Device.PolyPolygon(PlochaBoundary)

    end;
{ Kek ? }

    if (NPlocha <> nil) then
    begin
    { POZOR ! nerusit souradnice !}
{      NPlocha.Clear; }
      NPlocha.Free
    end

  except
//      MessageBeep(Word(-1));
  end;
end;



function  TInterpretTopPloch.IsItsClass(AObject: TObject): boolean;
begin
   result := (AObject is TAreaCollection) or (AObject is TTopoLAreaElement);
end;



function  TInterpretTopPloch.QGoInside(Element: TElement): boolean;
begin
  Result:= false;//((Element is TTopoLAreaElement) and ScaleOK(Element))
end;



function  TInterpretTopPloch.QProcessBefore(Element: TElement): boolean;
var
  ModelLength: double;
begin
  result:= false;
  if (Element is TAreaCollection) then
  begin
    //OwnerProps:= TAreaString(Element).Properties;
     UseColor := TAreaCollection(Element).UseColor;
     Color :=    TAreaCollection(Element).Color;
     UseSymbol:= TAreaCollection(Element).UseSymbol;
     Symbol := TAreaCollection(Element).Symbol;
     exit;
  end;

  if not (Element is TTopoLAreaElement) then exit;
  if TTopoLAreaElement(Element).NoGeometry then exit;
  try
    ModelLength:= Device.Projection.GetModelLength(3);

    if TAreaElement(TTopoLAreaElement(Element).Geometry).GetMaxLength < ModelLength then exit;
    result := NoRect;
    if not TTopoLAreaElement(Element).IsOverRegion
            (Rect.MinX,Rect.MinY,Rect.MaxX,Rect.MaxY) then exit;
    Result:= true

  except
  end;
end;


procedure   TInterpretTopPloch.Reset(aDevice: TDevice);
begin
   inherited Reset(aDevice);
   //Rect := Device.Projection.ClipModelView;
   PlosneZnacky := TPlosneZnacky.CreateAll(PathOfLibraries+'\Srafy.txt');
   PlosneZnacky.Device := Device;
end;

procedure   TInterpretTopPloch.Close;
begin
   if PlosneZnacky <> nil then
   begin
      PlosneZnacky.Free;
      PlosneZnacky := nil;
   end;
   inherited Close;
end;


function  TInterpretTopPloch.CanUniGoInside(Element: TElement): boolean;
begin
   result := (Element is TAreaCollection) and
      ( NoRect or TAreaCollection(Element).IsOverRegion
               (Rect.MinX,Rect.MinY,Rect.MaxX,Rect.MaxY));
end;


BEGIN
   RegisterOrbisClass(TInterpretTopPloch);
END.