{
*************************************************************************
*                                                                       *
*  Jednotka pokousejici se resit univerzalni databazove, uzivatelske a  *
*  pambuhvi jake jeste INFO                                             *
*                                                                       *
*                       Shumperck(Schneberg) 1994                      *
*                                                                       *
*************************************************************************
}

unit DINosaur;

{============================================================================}

                                  INTERFACE

{============================================================================}

uses Objects,
     CtiRadek;

{============================================================================}

const

  { Funkce bloku }
  { ************ }

  { Zarovnani }
  { ********* }
  zarVlevo  = 1;
  zarVpravo = 2;
  zarStred  = 3;

  { Ridici kody DIN }
  { *************** }
  rcdIgnore = 0;
  rcdConst  = 1;
  rcdEval   = 2;
  rcdParam  = 3;
  rcdInfo   = 4;
  rcdUserBlk= 5;
  rcdEndBlk = 6;

  rcdFOR    =11;
  rcdIF     =12;
  rcdELSE   =13;
  rcdSEQ    =14;
  rcdSORT   =15;


  { Typy promennych }
  { *************** }
  vartNoTyp   = 0;
  vartBoolean = 1;
  vartLongInt = 2;
  vartDouble  = 3;
  vartString  = 4;
  vartObject  = 9;


  { Chybove kody }
  { ************ }
  erOK                = 0;
  erChybnyRCDVBloku   = 1;
  erNeznamyPrikaz     = 2;
  erChybnyRCDVPolozce = 3;
  erChybnyFORpredpis  = 4;
  erNevhodnyELSE      = 5;

type


   PVar = ^TVar;
   TVar = object(TObject)
      Nazev  : PString;
      Hodnota: Pointer;
      Delka  : longInt;
      constructor Init;
      Destructor  Done; virtual;
      procedure   VlozHodnotu(ATyp: byte; var AHodnota);
      procedure   VlozNazev(ANazev: string);
      procedure   VratHodnotu(ATyp: byte; var AHodnota);
      function    DejNazev: string;
      function    DejTyp  : byte;
      procedure   IncO(ADelta: longInt);

      function    DejDouble: double;
      function    DejLongInt: longInt;
      function    DejString: string;
      function    DejChar: char;
      procedure   UvolniHodnotu;
      procedure   UvolniNazev;

      private
      Typ    : byte;
   end;




   { Jednoduchy drzak (cesky collection) Promennych }
   { ********************************************** }
   PVars = ^TVars;
   TVars = object(Tcollection)
      constructor Init;
{
      procedure   FreeItem(Item: Pointer); virtual;
}
      procedure   PridejVar(AVar: PVar);
      function    DejVar(Jmeno: string): PVar;
      procedure   VypustVar(Posledni: integer);
   end;


   { Drzak drzaku  (collection collectionu)promennych }
   { ************************************************ }
   PMultiVars = ^TMultiVars;
   TMultiVars = object(Tcollection)
      constructor Init;
      procedure   FreeItem(Item: Pointer); virtual;
      procedure   PridejVar(AVar: PVar);
      procedure   BlkInit;
      procedure   BLKDone;
   end;


   { Predek vsech svetovych ukladacu, vyznacuje se tim, ze nic nedela }
   { **************************************************************** }

   PUkladacDIN = ^TUkladacDIN;
   TUkladacDIN = object(TObject)
      procedure Uloz(ID: word; Cosi: PVar); virtual;
   end;



   { Predek vsech svetovych Provadecu, vyznacuje se tim, ze taky nic nedela }
   { ********************************************************************** }

   PProvadecDIN = ^TProvadecDIN;


   { Polozka Dinu ...tedy hodnota nebo vyraz vyzbrojeny identifikatory }
   { ***************************************************************** }
   PPolozkaDIN =^TPolozkaDIN;
   TPolozkaDIN = object(TObject)
      IDuser: word;            { Uzivatelsky identifikator pro                }
      IDdin : word;            { Interni identifikator pro                    }
      Zneni : TVar;            { Vlastni zneni vyrazu                         }
      KodChyby: byte;

      constructor Init;
      destructor  Done; virtual;
      procedure   PridejPolozku
                  (AIdUser, AIdDIN: word; ANazev, AHodnota: string;
                   var Konec: boolean); virtual;

      procedure   NastavIDUser(aID: word);
      procedure   NastavIDDin(aID: word);
      procedure   NastavZneni(ANazev, AHodnota: string);

      procedure   Zpracuj(var Provadec: PProvadecDIN; var Ukladac: PUkladacDIN); virtual;
      private
      procedure   UvolniZneni;
   end;



   { Predek vsech svetovych Provadecu, vyznacuje se tim, ze taky nic nedela }
   { ********************************************************************** }


   TProvadecDIN = object(TObject)
      Promenne: TVars;

      constructor Init;
      destructor  Done; virtual;
      procedure   PridejVar(AVar: PVar);
      function    OKVypocti(const Vyraz: string; var Vysledek: double): boolean; virtual;
      function    OKProved(VstPol, VystPol: PVar): boolean; virtual;
      function    DejCisloPosledniVar: integer;
      procedure   SmazVarOd(Posledni: integer);

      procedure   NastavDoubleVar(Jmeno: string; Hodnota: double);
      function    UpravVyraz(Vyraz: string): string;
   end;


   { Kolekce polozek Dinu ... muze obsahovat i Bloky a janevimco }
   { *********************************************************** }
   PPolozkyDIN = ^TPolozkyDIN;
   TPolozkyDIN = object(TCollection)
      procedure  FreeItem(Item: Pointer); virtual;
   end;






   { Blok DIN muze byt nositelem nejake funkce nebo taky ne }
   { ****************************************************** }
   PBlokDIN = ^TBlokDIN;
   TBlokDIN = object(TPolozkaDIN)
      IdEndBlk  : word;
      ELSEZa    : integer;

      Polozky   : PPolozkyDin;   { Kolekce polozek (Bloku) }
      AktBlokDIN: PBlokDIN;      { aktualni blok, do ktereho se posila }

      CtiR      : TCtiRadek;     { vykonny objekt, ktery je k dispozici vsem
                                   potomkum } 

      constructor Init;
      destructor  Done; virtual;
      procedure   PridejPolozku
                  (AIdUser, AIdDIN: word; ANazev, AHodnota: string;
                   var Konec: boolean); virtual;

      procedure   Zpracuj(var Provadec: PProvadecDIN; var Ukladac: PUkladacDIN); virtual;

    private

      function    OKRozeberHodnotuNaKody
                  (var AHodnota: string; var Kod: word): boolean; virtual;


   end;



   { Blok FOR }
   { ******** }
   PBlokFOR = ^TBlokFOR;
   TBlokFOR = object(TBlokDIN)

     procedure Zpracuj(var Provadec: PProvadecDIN; var Ukladac: PUkladacDIN); virtual;
   end;

   { Blok IF }
   { ******** }
   PBlokIF = ^TBlokIF;
   TBlokIF = object(TBlokDIN)
     procedure Zpracuj(var Provadec: PProvadecDIN; var Ukladac: PUkladacDIN); virtual;
   end;


   { Blok SORT }
   { ******** }
   PBlokSORT = ^TBlokSORT;
   TBlokSORT = object(TBlokDIN)

     procedure Zpracuj(var Provadec: PProvadecDIN; var Ukladac: PUkladacDIN); virtual;
   end;



  TObjectDINPtr = ^TObjectDIN;

  TObjectDIN = object(TObject)
    constructor Init;
    destructor  Done; virtual;
    function    OKNastavProperty(IProperty: string; VstPol: PVar): boolean; virtual;
    function    OKProvedDoubleFunkci
                (Funkce: string; var Hodnota: double): boolean; virtual;

  end;



var
  PPromenne: PVars;


{============================================================================}

                                IMPLEMENTATION

{============================================================================}

uses
   StrProc, Kalk1;

{============================================================================}




constructor TObjectDIN.Init;
begin
  inherited Init
end;

destructor  TObjectDIN.Done;
begin
  inherited Done
end;

function    TObjectDIN.OKNastavProperty(IProperty: string; VstPol: PVar): boolean;
begin
  abstract
end;

function    TObjectDIN.OKProvedDoubleFunkci
              (Funkce: string; var Hodnota: double): boolean;
begin
  abstract
end;




procedure VratCisloDIN(nazevProm: openString; Var Hodnota: double;
                       Var Nalezl: boolean);
var
  PomVar: PVar;

begin
  PomVar:= PPromenne^.DejVar(NazevProm);
  if assigned(PomVar) then
  begin
    Hodnota:= PomVar^.DejDouble;
    Nalezl:= true
  end
  else
  begin
    Hodnota:= 0;
    Nalezl:= false
  end
end;





{ Ukazatele na pouzivane typy promennych }
{ ************************************** }

type
  PPlongInt = ^longInt;
  PPDouble  = ^double;
  PPBoolean = ^boolean;



{ Metody TVar }
{ *********** }

constructor TVar.Init;
begin
  inherited Init;
  Typ    := vartNoTyp;
  Nazev  := nil;
  Hodnota:= nil;
end;



Destructor  TVar.Done;
begin
  UvolniNazev;
  UvolniHodnotu;
end;



procedure   TVar.VlozHodnotu(ATyp: byte; var AHodnota);
begin
  UvolniHodnotu;
  Typ := ATyp;
  case Typ of
     vartBoolean:
     begin
        GetMem(Hodnota, sizeOf(Boolean));
        PPBoolean(Hodnota)^ := boolean(AHodnota);
        Delka:= sizeOf(boolean)
     end;
     vartLongInt:
     begin
        GetMem(Hodnota, sizeOf(longInt));
        PPLongInt(Hodnota)^ := longInt(AHodnota);
        Delka:= sizeOf(longInt);
     end;
     vartDouble :
     begin
        GetMem(Hodnota, sizeOf(Double));
        PPDouble(Hodnota)^ := double(AHodnota);
        Delka:= sizeOf(double);
     end;
     vartString :
     begin
        Hodnota := NewStr(string(AHodnota));
        Delka:= sizeOf(string);
     end;
     vartObject :
     begin
        Hodnota:= pointer(AHodnota)
     end
  end;
end;









procedure   TVar.VlozNazev(ANazev: string);
begin
  UvolniNazev;
  Nazev := NewStr(ANazev);
end;




procedure   TVar.VratHodnotu(ATyp: byte; var AHodnota);
begin
  if Typ = ATyp then
  case Typ of
     vartBoolean: begin
                    if assigned(Hodnota) then
                       move(Hodnota^, AHodnota, sizeOf(Boolean))
                  end;

     vartLongInt: begin
                    if assigned(Hodnota) then
                       move(Hodnota^, AHodnota, sizeOf(longInt));
                  end;

     vartDouble : begin
                    if assigned(Hodnota) then
                       move(Hodnota^, AHodnota, sizeOf(Double));
                  end;

     vartString : begin
                    if assigned(Hodnota) then
                       move(Hodnota^, AHodnota, length(PString(Hodnota)^)+1)
                    else
                       string(AHodnota):= ''
                  end
  end
  else
  begin

  end;
end;




function    TVar.DejNazev: string;
begin
  if assigned(Nazev) then
     DejNazev := Nazev^
  else
     DejNazev:= ''
end;



function    TVar.DejTyp: byte;
begin
  DejTyp := Typ;
end;




procedure   TVar.UvolniHodnotu;
begin
  if Assigned(Hodnota) then
  begin
    case Typ of
       vartBoolean: FreeMem(Hodnota, sizeOf(Boolean));
       vartLongInt: FreeMem(Hodnota, sizeOf(longInt));
       vartDouble : FreeMem(Hodnota, sizeOf(Double));
       vartString : DisposeStr(PString(Hodnota));
       vartObject : PObject(Hodnota)^.Free
    end

  end;

  Hodnota := nil;
end;



procedure   TVar.UvolniNazev;
begin
  if Assigned(Nazev) then DisposeStr(Nazev);
  Nazev := nil;
end;



procedure TVar.IncO(ADelta: longInt);
begin
  case Typ of
  vartBoolean: boolean(Hodnota^):= not boolean(Hodnota^);
  vartLongInt: longInt(Hodnota^):= longInt(Hodnota^) + ADelta;
  vartDouble : double(Hodnota^) :=  double(Hodnota^) + ADelta;
  vartString : begin end
  end
end;




function  TVar.DejDouble: double;
var
  PomDouble: double;
  Code: integer;

begin
  if Hodnota = nil then
  begin
    DejDouble:= 0;
    exit
  end;

  case Typ of
  vartBoolean: if boolean(Hodnota^) then DejDouble:= 1
               else DejDouble:= 0;

  vartLongInt: DejDouble:= longInt(Hodnota^);

  vartDouble : DejDouble:= double(Hodnota^);
  vartString : begin
                 val(BezVnejsichMezer(string(Hodnota^)), PomDouble, Code);
                 if Code = 0 then DejDouble:= PomDouble
                 else DejDouble:= 0
               end
  end
end;





function TVar.DejLongInt: longInt;
var
  PomDouble: double;
  Code: integer;

begin
  if Hodnota = nil then
  begin
    DejLongInt:= 0;
    exit
  end;

  case Typ of
  vartBoolean: if boolean(Hodnota^) then DejLongInt:= 1
               else DejLongInt:= 0;
  vartLongInt: DejLongInt:= longInt(Hodnota^);

  vartDouble : DejLongInt:= round(double(Hodnota^));

  vartString : begin
                 val(BezVnejsichMezer(string(Hodnota^)), PomDouble, Code);
                 if Code = 0 then DejLongInt:= round(PomDouble)
                 else DejLongInt:= 0
               end
  end
end;






function  TVar.DejString: string;
begin
  if Hodnota = nil then
  begin
    DejString:= '';
    exit
  end;

  case Typ of
  vartBoolean: if boolean(Hodnota^) then
                  DejString:= 'T'
               else DejString:= 'F';

  vartLongInt: DejString:= LStr(longInt(Hodnota^));

  vartDouble : DejString:= RStr(double(Hodnota^),6);
  vartString : DejString:= string(Hodnota^)
  end
end;




function  TVar.DejChar: char;
begin
  if Hodnota = nil then
  begin
    DejChar:= #0;
    exit
  end;

  case Typ of
  vartBoolean: if boolean(Hodnota^) then
                  DejChar:= 'T'
               else DejChar:= 'F';

  vartLongInt: DejChar:= #0;

  vartDouble : DejChar:= #0;
  vartString : DejChar:= string(Hodnota^)[1]
  end
end;






{ Metody TVars }
{ ************ }

constructor TVars.Init;
begin
  inherited Init(1,1);
end;




{
procedure   TVars.FreeItem(Item: Pointer);
begin
   if Assigned(Item) then PVar(Item)^.Free;
end;
}




procedure   TVars.PridejVar(AVar: PVar);
begin
   Insert(AVar);
end;





function TVars.DejVar(Jmeno: string): PVar;
var
  I: integer;
  Nasel: boolean;

begin
  DejVar:= nil;
  I:= Count-1;
  Nasel:= false;

  while (I >= 0) and not Nasel do
  begin
    if (PVar(At(I))^.Nazev^ = Jmeno) then
    begin
      Nasel:= true;
      DejVar:= At(I)
    end
    else
      dec(I)
  end
end;





procedure TVars.VypustVar(Posledni: integer);
var
  I: integer;

begin
  for I:= Count-1 downto Posledni+1 do
  begin
    Free(At(I))
  end
end;




{ Metody TMultiVars }
{ ***************** }

constructor TMultiVars.Init;
begin
  inherited Init(1,1);
end;


procedure   TMultiVars.FreeItem(Item: Pointer);
begin
  if Assigned(Item) then PVars(Item)^.FreeAll;
end;


procedure   TMultiVars.PridejVar(AVar: PVar);
begin
   PVars(At(0))^.Insert(AVar);
end;


procedure   TMultiVars.BlkInit;
begin
   AtInsert(0,New(PVars, Init));
end;


procedure   TMultiVars.BLKDone;
begin
   if Count > 0 then FreeItem(At(0));
end;



{ Polozka Dinu ...tedy hodnota nebo vyraz vyzbrojeny identifikatory }
{ ***************************************************************** }

constructor TPolozkaDIN.Init;
begin
  inherited Init;
  IDuser := 0;
  IDdin  := 0;
  Zneni.Init;
  KodChyby:= erOK;
end;


destructor  TPolozkaDIN.Done;
begin
  Zneni.Done
end;


procedure   TPolozkaDIN.PridejPolozku
            (AIdUser, AIdDIN: word; ANazev, AHodnota: string;
             var Konec: boolean);

begin
  Abstract;
end;


procedure   TPolozkaDIN.NastavIDUser(aID: word);
begin
  IDuser := aID;
end;


procedure   TPolozkaDIN.NastavIDDin(aID: word);
begin
  IDdin := aID;
end;


procedure   TPolozkaDIN.NastavZneni(ANazev, AHodnota: string);
begin
  UvolniZneni;
  Zneni.VlozNazev(ANazev);
  Zneni.VlozHodnotu(vartString, AHodnota)
end;




procedure   TPolozkaDIN.Zpracuj
            (var Provadec: PProvadecDIN; var Ukladac: PUkladacDIN);
var
  LVar: TVar;
  NazevPolozky: string;

begin
  LVar.Init;

  case IDdin of
    rcdConst: begin
                Ukladac^.Uloz(IDUser, addr(Zneni))
              end;

    rcdEval : begin
              { necha provest vyhodnoceni vyrazu Zneni a ulozit do LVar }
                if Provadec^.OKProved(addr(Zneni), addr(LVar)) then
                   Ukladac^.Uloz(IDUser, addr(LVar))
                   { ulozi vysledek pripadnym uzivatelskym ukladacem }
              end;

    rcdParam: begin
                if Provadec^.OKProved(addr(Zneni), addr(LVar)) then
                begin
                  NazevPolozky:= Zneni.DejNazev;
                  if NazevPolozky[1] <> '!' then
                     Provadec^.NastavDoubleVar
                       (NazevPolozky, LVar.DejDouble);

                  { LVar.VlozNazev('VAR: '+LVar.DejNazev); }
                  Ukladac^.Uloz(IDUser, addr(LVar))
                end
              end
    else KodChyby:= erChybnyRCDVPolozce
  end;

  LVar.Done
end;




procedure   TPolozkaDIN.UvolniZneni;
begin
  Zneni.UvolniNazev;
  Zneni.UvolniHodnotu
end;




{ Metody TPolozkyDin }
{ ****************** }
procedure   TPolozkyDIN.FreeItem(Item: Pointer);
begin
  if Assigned(PPolozkaDIN(Item)) then
     PPolozkaDIN(Item)^.Free;
end;





{ Metody TUkladacDIN }
{ ****************** }

procedure TUkladacDIN.Uloz(ID: word; Cosi: PVar);
begin
  Abstract;
end;





{ Metody TProvadecDIN }
{ ******************* }


constructor TProvadecDIN.Init;
begin
  Promenne.Init
end;


destructor TProvadecDIN.Done;
begin
  Promenne.Done
end;



procedure TProvadecDIN.PridejVar(AVar: PVar);
begin
  Promenne.PridejVar(AVar)
end;





function TProvadecDIN.OKVypocti(const Vyraz: string; var Vysledek: double): boolean;
var
  Chyba: string;
  PoziceChyby: word;

begin
  OKVypocti:= false;

  if VratCisloPtr <> nil then dispose(VratCisloPtr);

  new(VratCisloPtr);

  if VratCisloPtr <> nil then
  begin
    VratCisloPtr^:= VratCisloDIN;

    if Vyraz <> '' then
    begin
      PPromenne:= @Promenne;
      Vypocet(Vyraz, Vysledek, Chyba, PoziceChyby);

      if Chyba = '' then
      begin
        OKVypocti:= true
      end
    end;

    dispose(VratCisloPtr);
    VratCisloPtr:= nil
  end;

end;







function TProvadecDIN.OKProved(VstPol, VystPol: PVar): boolean;
var
  PomStr: string;
  Vysledek: double;

begin
  OKProved:= false;

  if VstPol^.DejTyp = vartString then
  begin
    VstPol^.VratHodnotu(vartString, PomStr);
    if pos('%', PomStr) > 0 then
       PomStr:= UpravVyraz(PomStr);

    if OKVypocti(PomStr, Vysledek) then
    begin
      VystPol^.VlozNazev(VstPol^.DejNazev);
      VystPol^.VlozHodnotu(vartDouble, Vysledek);
      OKProved:= true
    end

  end;

  VratCisloPtr:= nil
end;




function TProvadecDIN.UpravVyraz(Vyraz: string): string;
var
  CtiR: TCtiRadek;
  PomRet: string;
  Param:  string;
  Vysledek: double;

begin
  CtiR.Init(Vyraz);

  PomRet:= CtiR.DejStringPoZnak('%');
  CtiR.StepVp;

  while not CtiR.KonecRadku do
  begin
    Param:= CtiR.DejStringPoMnozinu(['[',']','.',' ','+','-','*','/','\']);

    if OKVypocti(Param, Vysledek) then
    begin
      PomRet:= PomRet + LStr(round(Vysledek))
    end;

    PomRet:= PomRet + CtiR.DejStringPoZnak('%')
  end;

  UpravVyraz:= PomRet;

  CtiR.Done;
end;





function  TProvadecDIN.DejCisloPosledniVar: integer;
begin
  DejCisloPosledniVar:= Promenne.Count-1
end;




procedure TProvadecDIN.SmazVarOd(Posledni: integer);
begin
  Promenne.VypustVar(Posledni)
end;






procedure TProvadecDIN.NastavDoubleVar(Jmeno: string; Hodnota: double);
var
  PomVar: PVar;

begin
  PomVar:= Promenne.DejVar(Jmeno);

  if not assigned(PomVar) then
  begin
    PomVar:= new(PVar, Init);
    Promenne.PridejVar(PomVar)
  end;

  if assigned (PomVar) then
  begin
    PomVar^.VlozHodnotu(vartDouble, Hodnota);
    PomVar^.VlozNazev(Jmeno)
  end
end;













{ Blok DIN muze byt nositelem nejake funkce nebo taky ne }
{ ****************************************************** }

constructor TBlokDIN.Init;
begin
  inherited Init;
  Polozky := nil;
  AktBlokDIN:= nil;
  ELSEZa:= -1;
  IdEndBLK:= 0
end;





destructor  TBlokDIN.Done;
begin
  if assigned(Polozky) then
     Dispose(Polozky, Done);

  Zneni.Done
end;




procedure   TBlokDIN.PridejPolozku
            (AIdUser, AIdDIN: word; ANazev, AHodnota: string;
             var Konec: boolean);
var
  LKonec: boolean;

begin
  Konec:= false;

  if KodChyby <> 0 then
  begin
    Konec:= true;
    exit
  end;

  if not Assigned(Polozky) and (AIdDIN <> rcdEndBLK) then
     Polozky := New(PPolozkyDIN, Init(1,1));

  case AIdDIN of
   rcdIgnore: begin end;

   rcdConst : begin
                if assigned(AktBlokDIN) then
                   AktBlokDIN^.PridejPolozku(AIdUser, AIdDIN, ANazev, AHodnota, LKonec)
                else
                begin
                  Polozky^.Insert(new(PPolozkaDIN, Init));
                  with PPolozkaDIN(Polozky^.At(Polozky^.Count-1))^ do
                  begin
                    NastavZneni(ANazev, AHodnota);
                    NastavIdUser(AIdUser);
                    NastavIdDIN(AIdDIN)
                  end
                end
              end;

   rcdEval  : begin
                if assigned(AktBlokDIN) then
                   AktBlokDIN^.PridejPolozku(AIdUser, AIdDIN, ANazev, AHodnota, LKonec)
                else
                begin
                  Polozky^.Insert(new(PPolozkaDIN, Init));
                  with PPolozkaDIN(Polozky^.At(Polozky^.Count-1))^ do
                  begin
                    NastavZneni(ANazev, AHodnota);
                    NastavIdUser(AIdUser);
                    NastavIdDIN(AIdDIN)
                  end
                end
              end;

   rcdParam : begin
                if assigned(AktBlokDIN) then
                   AktBlokDIN^.PridejPolozku(AIdUser, AIdDIN, ANazev, AHodnota, LKonec)
                else
                begin
                  Polozky^.Insert(new(PPolozkaDIN, Init));

                  with PPolozkaDIN(Polozky^.At(Polozky^.Count-1))^ do
                  begin
                    NastavZneni(ANazev, AHodnota);
                    NastavIdUser(AIdUser);
                    NastavIdDIN(AIdDIN)
                  end
                end
              end;

  rcdInfo   : begin
                if assigned(AktBlokDIN) then
                   AktBlokDIN^.PridejPolozku(AIdUser, AIdDIN, ANazev, AHodnota, LKonec)
                else
                begin
                  if OKRozeberHodnotuNaKody(AHodnota, AIdDIN) then
                  begin
                    case AIdDIN of
                      rcdFor:  Polozky^.Insert(new(PBlokFOR, Init));
                      rcdIF:   Polozky^.Insert(new(PBlokIF, Init));
                      rcdELSE: begin
                                 if IdDin = rcdIF then
                                    ELSEZa:= Polozky^.Count-1
                                 else
                                    KodChyby:= erNevhodnyELSE;
                               end;
                      rcdSEQ:  Polozky^.Insert(new(PBlokDIN, Init));
                      rcdSORT: Polozky^.Insert(new(PBlokSORT, Init));
                    end;

                    if (AIdDIN <> rcdELSE) and (KodChyby = erOK) then
                    begin
                      AktBlokDIN:= PBlokDIN(Polozky^.At(Polozky^.Count-1));
                      with AktBlokDIN^ do
                      begin
                        NastavZneni(ANazev, AHodnota);
                        NastavIdUser(AIdUser);
                        NastavIdDIN(AIdDIN)
                      end
                    end
                  end
                  else
                  begin
                    KodChyby:= erNeznamyPrikaz
                  end
                end
              end;

  rcdUserBlk: begin
                if assigned(AktBlokDIN) then
                   AktBlokDIN^.PridejPolozku(AIdUser, AIdDIN, ANazev, AHodnota, LKonec)
                else
                begin
                  Polozky^.Insert(new(PBlokDIN, Init));

                  AktBlokDIN:= PBlokDIN(Polozky^.At(Polozky^.Count-1));
                  with AktBlokDIN^ do
                  begin
                    NastavZneni(ANazev, AHodnota);
                    NastavIdUser(AIdUser);
                    NastavIdDIN(AIdDIN)
                  end
                end
              end;

  rcdEndBlk:  begin
                if assigned(AktBlokDIN) then
                begin
                  AktBlokDIN^.PridejPolozku(AIdUser, AIdDIN, ANazev, AHodnota, LKonec);
                  if LKonec then AktBlokDIN:= nil
                end
                else
                begin
                {
                  Polozky^.Insert(new(PPolozkaDIN, Init));
                  with PPolozkaDIN(Polozky^.At(Polozky^.Count-1))^ do
                  begin
                    NastavZneni(ANazev, AHodnota);
                    NastavIdUser(AIdUser);
                    NastavIdDIN(AIdDIN)
                  end;
                }
                  IdEndBLK:= AIdUser;
                  Konec:= true
                end
              end

  else        KodChyby:= erChybnyRCDVBloku

  end { case AIdDIN }

end;




function    TBlokDIN.OKRozeberHodnotuNaKody
            (var AHodnota: string; var Kod: word): boolean;
var
{  CtiR: TCtiRadek; }
  Funkce, Obsah: string;
  OKej: boolean;

begin
  OKej:= true;

  if AHodnota <> '' then
  begin
    CtiR.Init(AHodnota);
    CtiR.PreskocMezery;
    Funkce:= UpStr(CtiR.DejStringPoMnozinu([' ',']']));

    Obsah:= BezVnejsichMezer(CtiR.DejStringPoMnozinu([']']));
    if pos('[', Obsah) > 0 then
    begin
      CtiR.StepVp;
      Obsah:= Obsah + ']' +
               BezVnejsichMezer(UpStr(CtiR.DejStringPoMnozinu([']'])));
    end;

    CtiR.Done;

    if Funkce = 'FOR'  then Kod:= rcdFor
    else
    if Funkce = 'IF'   then Kod:= rcdIF
    else
    if Funkce = 'ELSE' then Kod:= rcdELSE
    else
    if Funkce = 'SORT' then Kod:= rcdSORT
    else
    if Funkce = 'SEQ'  then Kod:= rcdSEQ
    else
    begin
      Kod:= 0;
      OKej:= false
    end;

    if OKej then AHodnota:= Obsah
  end;

  OKRozeberHodnotuNaKody:= OKej;
end;




procedure   TBlokDIN.Zpracuj(var Provadec: PProvadecDIN; var Ukladac: PUkladacDIN);
var
  Posledni: integer;


  procedure ZpracujPolozku(Polozka: PPolozkaDIN); far;
  begin
    Polozka^.Zpracuj(Provadec, Ukladac)
  end;

begin
  Posledni:= Provadec^.DejCisloPosledniVar;

  if IdDIN = rcdUserBLK then
     Ukladac^.Uloz(IdUser, nil);

  if assigned(Polozky) then
  begin
    Polozky^.ForEach(@ZpracujPolozku)
  end;


  if IdDIN = rcdUserBLK then Ukladac^.Uloz(IdEndBLK, nil);

  Provadec^.SmazVarOd(Posledni)
end;






procedure TBlokFOR.Zpracuj(var Provadec: PProvadecDIN; var Ukladac: PUkladacDIN);
var
  Posledni: integer;
{  CtiR: TCtiRadek; }
  NazevProm, OdVyraz, DoVyraz: string;
  OdHodnota, DoHodnota, RidHodnota: double;
  Inkr: integer;

  procedure ZpracujPolozku(Polozka: PPolozkaDIN); far;
  begin
    Polozka^.Zpracuj(Provadec, Ukladac)
  end;

begin
  Posledni:= Provadec^.DejCisloPosledniVar;

  Zneni.VratHodnotu(vartString, NazevProm);

  { ocekava se predpis tvaru  "NazevProm  PocVyraz KoncVyraz" }
  CtiR.Init(NazevProm);
  CtiR.PreskocMezery;
  NazevProm:= UpStr(BezVnejsichMezer(CtiR.DejStringPoZnak(' ')));
  if not CtiR.DosloKChybe then
  begin
    CtiR.PreskocMezery;
    OdVyraz:= UpStr(BezVnejsichMezer(CtiR.DejStringPoZnak(' ')));

    if not CtiR.DosloKChybe then
    begin
      CtiR.PreskocMezery;
      DoVyraz:= UpStr(BezVnejsichMezer(CtiR.DejStringPoZnak(' ')));

      if Provadec^.OKVypocti(OdVyraz, OdHodnota) and
         Provadec^.OKVypocti(DoVyraz, DoHodnota) then
      begin
        RidHodnota:= OdHodnota;

        if OdHodnota < DoHodnota then
        while RidHodnota <= DoHodnota do
        begin
          Provadec^.NastavDoubleVar(NazevProm, RidHodnota);

          if assigned(Polozky) then
          begin
            Polozky^.ForEach(@ZpracujPolozku)
          end;

          RidHodnota:= RidHodnota + 1
        end
        else
        while RidHodnota >= DoHodnota do
        begin
          Provadec^.NastavDoubleVar(NazevProm, RidHodnota);

          if assigned(Polozky) then
          begin
            Polozky^.ForEach(@ZpracujPolozku)
          end;

          RidHodnota:= RidHodnota - 1
        end
      end
    end
    else
      KodChyby:= erChybnyFORpredpis
  end
  else
    KodChyby:= erChybnyFORpredpis;

  CtiR.Done;

  Provadec^.SmazVarOd(Posledni)
end;







procedure TBlokIF.Zpracuj(var Provadec: PProvadecDIN; var Ukladac: PUkladacDIN);
var
  Posledni: integer;
{  CtiR: TCtiRadek; }
  VyrazIF: string;
  HodnotaIF: double;
  I: integer;

  procedure ZpracujPolozku(Polozka: PPolozkaDIN); far;
  begin
    Polozka^.Zpracuj(Provadec, Ukladac)
  end;

begin
  Posledni:= Provadec^.DejCisloPosledniVar;

  Zneni.VratHodnotu(vartString, VyrazIF);

  { ocekava se vyraz }
  CtiR.Init(VyrazIF);
  CtiR.PreskocMezery;
  VyrazIF:= UpStr(BezVnejsichMezer(CtiR.DejStringPoZnak(' ')));

  if not CtiR.DosloKChybe then
  begin
    if Provadec^.OKVypocti(VyrazIF, HodnotaIF) then
    begin
      if assigned(Polozky) then
      begin
        if (HodnotaIF >= 0) then
        begin
          if ELSEZa < 0 then
             Polozky^.ForEach(@ZpracujPolozku)
          else
             for I:= 0 to ELSEZa do
                 ZpracujPolozku(PPolozkaDIN(Polozky^.At(I)));
        end
        else
        begin
          if ELSEZa > -1 then
          begin
             for I := ELSEZa+1 to Polozky^.Count-1 do
                 ZpracujPolozku(PPolozkaDIN(Polozky^.At(I)));
          end
        end
      end
    end
  end;

  CtiR.Done;

  Provadec^.SmazVarOd(Posledni)
end;







procedure TBlokSORT.Zpracuj(var Provadec: PProvadecDIN; var Ukladac: PUkladacDIN);
var
  Posledni: integer;


  procedure ZpracujPolozku(Polozka: PPolozkaDIN); far;
  begin
    Polozka^.Zpracuj(Provadec, Ukladac)
  end;

begin
  Posledni:= Provadec^.DejCisloPosledniVar;

  if assigned(Polozky) then
  begin
    Polozky^.ForEach(@ZpracujPolozku)
  end;

  Provadec^.SmazVarOd(Posledni)


end;




END.