{ D-}

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXX                                                             XXX}
{XXX    Copyright (c) - Help Service - Mapping, s.r.o.  1994     XXX}
{XXX                                                             XXX}
{XXX    Pouziti : - DosTopoL                                     XXX}
{XXX              - WinTopoL                                     XXX}
{XXX                                                             XXX}
{XXX                                                             XXX}
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}



unit Spline;


                        INTERFACE


uses
{$IFDEF WINDOWS}
  WinTypes, OWindows,
  BlokObj,
  BlokType,
  Krivky,
  MatProc,
  NadGraph,
  Objects;
{$ELSE}
  BlokObj,
  BlokType,
  Graph,
  MatProc,
  NadGraph,
  BPObject,
  PTranPov,
  Krivky;
{$ENDIF}

type

  PmsSpline = ^TmsSpline;
  TmsSpline = object(TKrivka)
     D2k,D1k,Dk,Dk1,Dk2,Dkn2  : Real;
     d,d2,d3 : Real;
     Ax,Bx,Cx: Real;
     Ay,By,Cy: Real;
     Mx2k,Mx1k,Mxk,Mxk1,Mxk2: Real;
     My2k,My1k,Myk,Myk1,Myk2: Real;
     txk,txk1 : Real;
     tyk,tyk1 : Real;
     dx2k,dy2k,dx1k,dy1k,dxk,dyk,dxk1,dyk1,dxk2,dyk2: Real;
     Poprve: Boolean;
     X,Y : Real;
     Gelp: LongInt;
     constructor Init;
     function    DelkaKrivky: Real; virtual;
     function    KrivkaVObdelniku(Obdelnik: TObdelnik): boolean; virtual;
{$IFNDEF WINDOWS}
     procedure   PrevedNaLinii(var Linie: TLin; PBlok: TBlokPtr;
                                   OtevreneSoub: boolean); virtual;
     procedure   VystupDoHPGL ( Vyrez: TObdelnik;
                                Meritko: real); virtual;
{$ENDIF}
     procedure   VratOpsanyObdelnik (var OpsObd: TObdelnik); virtual;
{$IFDEF WINDOWS}
     procedure   ZobrazRealne ( Orez: Boolean); virtual;
{$ELSE}
     procedure   ZobrazRealne ( Barva, Typ, ZobrMod: integer;
                                Nastavit: boolean;
                                Orez: Boolean); virtual;
{$ENDIF}
  private
     procedure   DejDkMat(k: integer);
     procedure   DejYXzF(k: integer);
     function    Delka(i: Integer; var ddx,ddy: Real): Real;
     function    Mx(i: Integer; DD: Real): Real;
     function    My(i: Integer; DD: Real): Real;
     function    tx: Real;
     function    ty: Real;
     function    tx1: Real;
     function    ty1: Real;
  end;

{$IFNDEF WINDOWS}
procedure msSplineInt(Pocet: Word; Uzly: PIntUzly);
{$ENDIF}

                       IMPLEMENTATION


uses
{$IFDEF WINDOWS}
   BPrevody,
   Chytani,
   MyStream,
   Strings,
   StrProc,
   VektoOkn,
   WinProcs;
{$ELSE}
   BPrevody,
   Crt,
   Chytani,
   Hlasky,
   HPGLBod,
   KeyProc,
   KurzObj,
   MyStream,
   PredmObj,
   StRadek,
   StrProc,
   UkazObj,
   VybUkaz,
   ZakNapov,
   ZobraObj,
   ZobrVyre,
   TxHlasky, TxBezNap;
{$ENDIF}





const
   Ano = True;
   Ne  = False;
   Sour00: TSour = (y: 0; x: 0);

   UnivDelitel  = 1000;             { Delitele pro zrychleny vyp. elipsy }
   UnivDelitel2 = 1000000;

type
  TPoloha = set of (Vlevo, VPravo, Nahore, Dole);



{================================================}


   { Tela metod TmsSpline }


{================================================}

{ Rychle se vykreslujici krivka pro potrebu editace }
{$IFNDEF WINDOWS}
procedure msSplineInt(Pocet: Word; Uzly: PIntUzly);
  const
     Kroku = 10;
  var
     D2k,D1k,Dk,Dk1,Dk2,Dkn2  : Real;
     d,d2,d3 : Real;
     Ax,Bx,Cx: Real;
     Ay,By,Cy: Real;
     Mx2k,Mx1k,Mxk,Mxk1,Mxk2: Real;
     My2k,My1k,Myk,Myk1,Myk2: Real;
     txk,txk1 : Real;
     tyk,tyk1 : Real;
     k  : Integer;
     dx2k,dy2k,dx1k,dy1k,dxk,dyk,dxk1,dyk1,dxk2,dyk2: real;
     Poprve: Boolean;
     X,Y: LongInt;
     Gelp: LongInt;
     Krok: Real;

  function Mx(i: Integer; D: Real): Real; near;
  begin
    Mx := (Uzly^[i+1].x - Uzly^[i].x) / D;
  end;

  function My(i: Integer; D: Real): Real; near;
  begin
    My := (Uzly^[i+1].y - Uzly^[i].y) / D;
  end;

  function Delka(i: Integer; var ddx,ddy: real): Real; near;
  var
     Pom: Real;
  begin
     ddX := (Uzly^[i+1].x - Uzly^[i].x);
     ddY := (Uzly^[i+1].y - Uzly^[i].y);
     Pom := SQRT(SQR(ddx)+SQR(ddy));
     if Pom < 1 then Pom := 1;
     Delka := Pom;
  end;

  function tx: Real; near;
  var
     Pom,Pom1,Pom2: Real;
  begin
     Pom1 := Abs(Mxk1-Mxk);
     Pom2 := Abs(Mx1k-Mx2k);
     Pom  := Pom1 + Pom2;
     If Pom <> 0 then tx := (Mx1k * Pom1 + Mxk * Pom2) / Pom
                 else tx := (Mxk1 + Mxk) / 2;
  end;

  function ty: Real; near;
  var
     Pom,Pom1,Pom2: Real;
  begin
     Pom1 := Abs(Myk1-Myk);
     Pom2 := Abs(My1k-My2k);
     Pom  := Pom1 + Pom2;
     If Pom <> 0 then ty := (My1k * Pom1 + Myk * Pom2) / Pom
                 else ty := (Myk1 + Myk) / 2;
  end;

  function tx1: Real; near;
  var
     Pom,Pom1,Pom2: Real;
  begin
     Pom1 := Abs(Mxk2-Mxk1);
     Pom2 := Abs(Mxk-Mx1k);
     Pom  := Pom1 + Pom2;
     If Pom <> 0 then tx1 := (Mxk * Pom1 + Mxk1 * Pom2) / Pom
                 else tx1 := (Mxk2 + Mxk1) / 2;
  end;

  function ty1: Real; near;
  var
     Pom,Pom1,Pom2: Real;
  begin
     Pom1 := Abs(Myk2-Myk1);
     Pom2 := Abs(Myk-My1k);
     Pom  := Pom1 + Pom2;
     If Pom <> 0 then ty1 := (Myk * Pom1 + Myk1 * Pom2) / Pom
                 else ty1 := (Myk2 + Myk1) / 2;
  end;

  begin
     Poprve := Ano;
     MoveTo(Uzly^[2].x,Uzly^[2].y);
     for k := 2 to Pocet - 4 do
     begin

        { 0 vypocet Delek segmentu Dk }
        { --------------------------- }
        { 1 vypocet M(k-2,k-1,k,k+1) .... dale uz jen posuny a (k+1) }
        { ---------------------------------------------------------- }
        { 2 vypocet t(k,k+1)
        { ------------------ }

        if Poprve then
        begin
           D2k    := Delka(k-2,dx2k,dy2k);
           D1k    := Delka(k-1,dx1k,dy1k);
           Dk     := Delka(k,dxk,dyk);
           Dk1    := Delka(k+1,dxk1,dyk1);

           Mx2k   := Mx(k-2,D2k);
           Mx1k   := Mx(k-1,D1k);
           Mxk    := Mx(k,Dk);
           Mxk1   := Mx(k+1,Dk1);
           txk    := tx;

           My2k   := My(k-2,D2k);
           My1k   := My(k-1,D1k);
           Myk    := My(k,Dk);
           Myk1   := My(k+1,Dk1);
           tyk    := ty;

           Poprve := Ne;
        end
        else begin
                D2k    := D1k;
                D1k    := Dk;
                Dk     := Dk1;
                Dk1    := Dk2;

                dx2k   := dx1k;
                dx1k   := dxk;
                dxk    := dxk1;
                dxk1   := dxk2;

                dy2k   := dy1k;
                dy1k   := dyk;
                dyk    := dyk1;
                dyk1   := dyk2;

                Mx2k   := Mx1k;
                Mx1k   := Mxk;
                Mxk    := Mxk1;
                Mxk1   := Mxk2;
                txk    := txk1;

                My2k   := My1k;
                My1k   := Myk;
                Myk    := Myk1;
                Myk1   := Myk2;
                tyk    := tyk1;
             end;
        Dkn2 := Dk * Dk;
        Dk2  := Delka(k+2,dxk2,dyk2);
        Mxk2 := Mx(k+2,Dk2);
        Myk2 := My(k+2,Dk2);
        txk1 := tx1;
        tyk1 := ty1;

        { ... cyklus d = 0 to Dk: }
        { ----------------------- }
        d    := 0;
        Krok := Dk/Kroku;
        while d <= Dk do
        begin
           d2 := d * d;
           d3 := d2 * d;

           { 3 vypocet a,b,c }
           { --------------- }
           Ax := ((txk + txk1 -(2*dxk) / Dk) / Dkn2);
           Bx := (((3*dxk) / Dk - 2*txk - txk1) / Dk);
           Cx := (txk);

           Ay := ((tyk + tyk1 -(2*dyk) / Dk) / Dkn2);
           By := (((3*dyk) / Dk - 2*tyk - tyk1) / Dk);
           Cy := (tyk);


           { 4 F }
           { --- }
           X := Round(Ax*d3 + Bx*d2 + Cx*d + Uzly^[k].x);
           Y := Round(Ay*d3 + By*d2 + Cy*d + Uzly^[k].y);
           {PutPixel(X,Y,GetColor);}
           LineTo(X,Y);
           LineTo(X,Y);
           d := d + Krok;
        end;{for d}
        LineTo(Uzly^[k+1].x,Uzly^[k+1].y);;
     end;{for k}
  end;
{$ENDIF}

{================================================}

constructor TMsSpline.Init;
  begin
     Inherited Init;
     MinimalniPocetUzlu := 6;
  end;
{------------------------------------------------}

function    TMsSpline.DelkaKrivky: Real;
  begin
     DelkaKrivky := 0;{ ?????????????? }
  end;

{------------------------------------------------}
function    TmsSpline.KrivkaVObdelniku(Obdelnik: TObdelnik): boolean;
  var
     k      : Integer;
     Nasel1,
     Nasel2 : Boolean;
     S1,S2: TSour;
     Poloha1,Poloha2: TPoloha;
     B1Jo,B2Jo: Boolean;
     AKrok: real;
     OS,NS: TSour;                { Stare a nove sour }

  begin
     KrivkaVObdelniku := Ne;
     if PocetUzlu < MinimalniPocetUzlu then exit;
     Poprve := Ano;
     Dk     := VzdalenostBodu(Uzly^[2],Uzly^[3]);

     for k := 2 to Pocetuzlu - 4 do
     begin
        { Preskoceni segmentu evidentne lezicich mimo vyrez ... }
        { ----------------------------------------------------- }
        B1Jo := BodVObdelniku(Uzly^[k],   Obdelnik, 0);
        B2Jo := BodVObdelniku(Uzly^[k+1], Obdelnik, 0);
        if (B1Jo or B2Jo) then
        begin
           KrivkaVObdelniku := Ano;
           exit;
        end
        else if not PrekryvObdelnikuSouradnicemi
                   (Uzly^[k],Uzly^[k+1], Obdelnik.PH,
                                         Obdelnik.LD,
                                        (Dk / 5)) then
        begin
           Poprve := Ano;
           Continue;
        end;

        if Poprve then OS := Uzly^[k];

        DejDkMat(k);

        { Nastaveni kroku }
        { --------------- }
        AKrok := Krok;
        if AKrok >= Dk then
        begin
           NS := Uzly^[k+1];
           if CaraVObdelniku(OS,NS,Obdelnik) then
           begin
              KrivkaVObdelniku := Ano;
              exit;
           end
           else begin
              OS := NS;
              Continue;
           end;
        end
        else begin
           Kroku := Round(Dk/AKrok);
           if Kroku < MinPocKroku then AKrok := Dk/MinPocKroku else
           if Kroku > MaxPocKroku then AKrok := Dk/MaxPocKroku;
        end;

        { ... cyklus d = 0 to Dk: }
        { ----------------------- }
        d := AKrok;
        while d <= Dk do
        begin
           DejYXzF(k);
           NS.y := Y;
           NS.x := X;
           if CaraVObdelniku(OS,NS,Obdelnik) then
           begin
              KrivkaVObdelniku := Ano;
              exit;
           end;
           OS := NS;
           d := d +AKrok;
        end;{for d}
        NS := Uzly^[k+1];
        if CaraVObdelniku(OS,NS,Obdelnik) then
        begin
           KrivkaVObdelniku := Ano;
           exit;
        end;
        OS := NS;
     end;{for k}

  end;

{$IFNDEF WINDOWS}
{------------------------------------------------}
procedure   TMsSpline.PrevedNaLinii(var Linie: TLin; PBlok: TBlokPtr;
                                        OtevreneSoub: boolean);
  type
     PProverovaneBody = ^TProverovaneBody;
     TProverovaneBody = record
       Dalsi: PProverovaneBody;
       Sour : TSour;
     end;
  var
     k: LongInt;
     AKrok: real;
     PredchBod, Bod: PProverovaneBody;
     KontrBody,KB: PProverovaneBody;
     PataKolmice,Sour: TSour;
     Chyba: real;
     ChybaPrekrocena: boolean;
     ProcNaUsek: real;
     OldProc, Proc: longInt;
     ProcK: real;
     Htx,Dtx: TTextNapovedy;
     ClinStr, ProcStr: String;
     MaxOdchylka: real;


  procedure ZrusKontrBody;
  var
    PPtr: PProverovaneBody;
  begin
     while KontrBody <> nil
     do begin
        PPtr:= KontrBody^.Dalsi;
        dispose (KontrBody);
        KontrBody := PPtr;
     end;
  end;


  begin
     if not OtevreneSoub then PBlok^.OtevriSoubory;
     if PresnostKrivek > 0 then AKrok := PresnostKrivek
                           else PrevodKrivekLomovymiBody := Ano;
     if not Assigned(Uzly) then if not NaplnPoleZDisku(Linie,PBlok) then
     begin
        if not OtevreneSoub then PBlok^.ZavriSoubory;
        exit;
     end;
     if PrevodKrivekLomovymiBody then with Linie do
     begin
        PrvniSour    := PrvniSour + 2;
        PosledniSour := PosledniSour - 2;
        Atributy     := Atributy - [lnKrivka];
        PBlok^.PisLinii(Cislo, Linie);
     end
     else with Linie do
     begin
        if PocetUzlu < MinimalniPocetUzlu then
        begin
           if not OtevreneSoub then PBlok^.ZavriSoubory;
           exit;
        end;
        Str(Cislo,CLinStr);
        CLinStr := hlKrivky101 + CLinStr;
        ProcNaUsek := 100/(PocetUzlu - 5);
        OldProc    := 0;
        UlozNapovedu(Htx,Dtx);
        PrvniSour    := FileSize(PBlok^.FSour);
        PosledniSour := PrvniSour;
        Poprve   := Ano;

        if PevnaDelkaVertexu then
        begin
           PBlok^.PridejSour(Uzly^[2]);
        end
        else begin
           New(Bod);
           KontrBody  := Bod;
           Bod^.Sour  := Uzly^[2];
           Bod^.Dalsi := nil;
           PredchBod  := Bod;
           PBlok^.PridejSour(Bod^.Sour);
        end;
        for k := 2 to PocetUzlu - 4 do
        begin

           ProcK := ((k-2)/(PocetUzlu-5)*100);

           DejDkMat(k);

           if AKrok >= Dk then
           begin
              Inc(PosledniSour);
              if PevnaDelkaVertexu then
              begin
                 PBlok^.PridejSour(Uzly^[k+1]);
              end
              else begin
                 { V Kontrolnich bodech zustava jen jeden B.}
                 Bod^.Sour  := Uzly^[k+1];
                 PBlok^.PridejSour(Bod^.Sour)
              end;
              Continue;
           end;
           if not PevnaDelkaVertexu then
           begin
              { Zjisteni kroku }
              { -------------- }
              AKrok := Dk/20;
              if AKrok = 0 then Continue;
              MaxOdchylka := 0;
              d := AKrok;
              while d <= Dk do
              begin
                 DejYXzF(k);
                 Sour.y := Y;
                 Sour.x := X;
                 DejPatuKolmice( Uzly^[k], Uzly^[k+1], Sour, PataKolmice);
                 Chyba := VzdalenostBodu(Sour,PataKolmice);
                 if Chyba > MaxOdchylka then MaxOdchylka := Chyba;
                 d := d +AKrok;
              end;{for d}

              if (MaxOdchylka <> 0) then
                 AKrok := (Dk * PresnostKrivek / MaxOdchylka)
              else
                 AKrok := Dk;

           end;
           { ... cyklus d = 0 to Dk: }
           { ----------------------- }
           d := AKrok;
           while d < Dk do
           begin
              Proc := Round(ProcK + d/Dk*ProcNaUsek);
              if Proc <> OldProc then
              begin
                 Str(Proc,ProcStr);
                 BeznaNapoveda(CLinStr, hlKrivky102+ProcStr+'%');
                 OldProc := Proc;
              end;
              DejYXzF(k);
              if PevnaDelkaVertexu then
              begin
                 Sour.y := Y;
                 Sour.x := X;
                 Inc(PosledniSour);
                 PBlok^.PridejSour(Sour);
              end
              else begin
                 New(Bod);
                 Bod^.Sour.y := Y;
                 Bod^.Sour.x := X;
                 Bod^.Dalsi  := nil;
                 KB := KontrBody;
                 ChybaPrekrocena := Ne;
                 while KB <> nil do
                 begin
                    DejPatuKolmice ( KontrBody^.Sour,
                                     Bod^.Sour,
                                     KB^.Sour,
                                     PataKolmice);
                    Chyba := VzdalenostBodu(KB^.Sour,PataKolmice);
                    ChybaPrekrocena := Chyba > PresnostKrivek ;
                    if ChybaPrekrocena then Break;
                    KB := KB^.Dalsi;
                 end;
                 if ChybaPrekrocena then
                 begin
                    Inc(PosledniSour);
                    PBlok^.PridejSour(PredchBod^.Sour);
                    ZrusKontrBody;
                    PredchBod := Bod;
                    KontrBody := Bod;
                 end
                 else
                 begin
                    PredchBod^.Dalsi := Bod;
                    PredchBod := Bod;
                 end;
              end;

              d := d +AKrok;
           end;{for d}
           Inc(PosledniSour);
           if PevnaDelkaVertexu then
           begin
              PBlok^.PridejSour(Uzly^[k+1]);
           end
           else begin
              ZrusKontrBody;
              New(Bod);
              Bod^.Sour  := Uzly^[k+1];
              Bod^.Dalsi := nil;
              KontrBody  := Bod;
              PredchBod  := Bod;
              PBlok^.PridejSour(Bod^.Sour)
           end;
        end;{for k}
        if not PevnaDelkaVertexu then ZrusKontrBody;
        Atributy := Atributy - [lnKrivka];
        PBlok^.PisLinii(Cislo, Linie);
        BeznaNapoveda(Htx,Dtx);
     end;
     if not OtevreneSoub then PBlok^.ZavriSoubory;
  end;
{$ENDIF}

{------------------------------------------------}
procedure   TMsSpline.VratOpsanyObdelnik (var OpsObd: TObdelnik);
  var
     k      : Integer;
     Nasel1,
     Nasel2 : Boolean;
     OrezPoUseckach: Boolean;
     S1,S2: TSour;
     Poloha1,Poloha2: TPoloha;
     B1Jo,B2Jo: Boolean;
     AKrok: real;

  begin
     Krok := VratKrok;
     if PocetUzlu < MinimalniPocetUzlu then
     begin
        {????????? chybova hlaska ???????}
        exit;
     end;
     Poprve := Ano;
     with OpsObd do
     begin
        PH.y := Uzly^[2].y;
        PH.x := Uzly^[2].x;
        LD.y := Uzly^[2].y;
        LD.x := Uzly^[2].x;
     end;

     for k := 2 to Pocetuzlu - 4 do
     begin
        {**********}
        DejDkMat(k);
        {**********}

        { Nastaveni kroku }
        { --------------- }
        AKrok := Krok;
        if AKrok >= Dk then
        begin
           with OpsObd do
             case SourSystem of
               JTSK       : begin
                              if Uzly^[k+1].y < PH.y then PH.y := Uzly^[k+1].y;
                              if Uzly^[k+1].x < PH.x then PH.x := Uzly^[k+1].x;
                              if Uzly^[k+1].y > LD.y then LD.y := Uzly^[k+1].y;
                              if Uzly^[k+1].x > LD.x then LD.x := Uzly^[k+1].x;
                            end;
               Matematicky,
               Gauss       : begin
                              if Uzly^[k+1].y > PH.y then PH.y := Uzly^[k+1].y;
                              if Uzly^[k+1].x > PH.x then PH.x := Uzly^[k+1].x;
                              if Uzly^[k+1].y < LD.y then LD.y := Uzly^[k+1].y;
                              if Uzly^[k+1].x < LD.x then LD.x := Uzly^[k+1].x;
                            end;
             end;
           Continue;
        end
        else begin
           Kroku := Round(Dk/AKrok);
           if Kroku < MinPocKroku then AKrok := Dk/MinPocKroku else
           if Kroku > MaxPocKroku then AKrok := Dk/MaxPocKroku;
        end;

        { ... cyklus d = 0 to Dk: }
        { ----------------------- }
        d := 0;
        while d <= Dk do
        begin
           {******}
           DejYXzF(k);
           {******}
           with OpsObd do
             case SourSystem of
               JTSK       : begin
                              if y < PH.y then PH.y := y;
                              if x < PH.x then PH.x := x;
                              if y > LD.y then LD.y := y;
                              if x > LD.x then LD.x := x;
                            end;
               Matematicky,
               Gauss      : begin
                              if y > PH.y then PH.y := y;
                              if x > PH.x then PH.x := x;
                              if y < LD.y then LD.y := y;
                              if x < LD.x then LD.x := x;
                            end;
             end;
           d := d +AKrok;
        end;{for d}
        with OpsObd do
          case SourSystem of
            JTSK       : begin
                           if Uzly^[k+1].y < PH.y then PH.y := Uzly^[k+1].y;
                           if Uzly^[k+1].x < PH.x then PH.x := Uzly^[k+1].x;
                           if Uzly^[k+1].y > LD.y then LD.y := Uzly^[k+1].y;
                           if Uzly^[k+1].x > LD.x then LD.x := Uzly^[k+1].x;
                         end;
            Matematicky,
            Gauss       : begin
                           if Uzly^[k+1].y > PH.y then PH.y := Uzly^[k+1].y;
                           if Uzly^[k+1].x > PH.x then PH.x := Uzly^[k+1].x;
                           if Uzly^[k+1].y < LD.y then LD.y := Uzly^[k+1].y;
                           if Uzly^[k+1].x < LD.x then LD.x := Uzly^[k+1].x;
                         end;
          end;
     end;{for k}

     { Trochu pridame, aby to nehaprovalo pri velkych zvetsenich }
     { ... Tomu se rika exaktni matematicka magie ...............}
     { --------------------------------------------------------- }
{$IFDEF WINDOWS}
     AKrok := 1/PVektorOkno(Okno)^.KVert;
{$ELSE}
     AKrok := 1/Zobrazovac.KVert;
{$ENDIF}
     with OpsObd do
       case SourSystem of
         JTSK        : begin
                         PH.y := PH.y - AKrok;
                         PH.x := PH.x - AKrok;
                         LD.y := LD.y + AKrok;
                         LD.x := LD.x + AKrok;
                       end;
         Matematicky,
         Gauss       : begin
                         PH.y := PH.y + AKrok;
                         PH.x := PH.x + AKrok;
                         LD.y := LD.y - AKrok;
                         LD.x := LD.x - AKrok;
                       end;
       end;
  end;

{$IFNDEF WINDOWS}
{------------------------------------------------}
procedure   TMsSpline.VystupDoHPGL ( Vyrez: TObdelnik;
                                     Meritko: real);

  var
     k      : Integer;
     B1Jo,B2Jo: Boolean;
     BezCarky: boolean;
     MaBytCarka: boolean;
     UplnePoprve: boolean;
     AKrok: real;
     PlotSour: TPlotSour;
     PomStr: String;
     PomSour: TSour;

  begin
     {
     NastavKrok;
     }
     Krok := 0.0005 * Meritko;
     if Krok = 0 then NastavKrok;
     if PocetUzlu < MinimalniPocetUzlu then exit;
     Poprve      := Ano;
     UplnePoprve := Ano;
     Dk          := VzdalenostBodu(Uzly^[2],Uzly^[3]);

     for k := 2 to Pocetuzlu - 4 do
     begin
        { Preskoceni segmentu evidentne lezicich mimo vyrez ... }
        { ----------------------------------------------------- }
        begin
           { Je segment ve vyrezu ?      }
           { --------------------------- }
           B1Jo := BodVObdelniku(Uzly^[k],   Vyrez, 0);
           B2Jo := BodVObdelniku(Uzly^[k+1], Vyrez, 0);
           if not (B1Jo or B2Jo) then
           if not PrekryvObdelnikuSouradnicemi
                  (Uzly^[k],Uzly^[k+1], Vyrez.PH,
                                        Vyrez.LD,
                                       (Dk / 5)) then
           begin
              Poprve := Ano;
              Continue;
           end;
        end;

        if Poprve then
        begin
           DejPlotSour (Uzly^[k], PlotSour);
           if not UplnePoprve then PomStr := ';'
           else begin
              PomStr      := '';
              UplnePoprve := Ne;
           end;
           PomStr := PomStr+'PU;PA'
                          +LStr (PlotSour.X)+ ','
                          +LStr (PlotSour.Y)+ ';'
                     +'PD;PA';
           HPGL( PomStr);
           BezCarky   := Ano;
           MaBytCarka := Ne;
        end;

        DejDkMat(k);

        { Nastaveni kroku }
        { --------------- }
        AKrok := Krok;
        if AKrok >= Dk then
        begin
           DejPlotSour (Uzly^[k+1], PlotSour);
           if BezCarky and MaBytCarka then PomStr := ','
                                      else PomStr := '';
           PomStr :=   PomStr + LStr (PlotSour.X)+ ','
                              + LStr (PlotSour.Y);
           HPGL( PomStr);
           BezCarky   := Ano;
           MaBytCarka := Ano;
           Continue;
        end
        else begin
           Kroku := Round(Dk/AKrok);
           if Kroku < MinPocKroku then AKrok := Dk/MinPocKroku else
           if Kroku > MaxPocKroku then AKrok := Dk/MaxPocKroku;
        end;

        { ... cyklus d = 0 to Dk: }
        { ----------------------- }
        d := AKrok;
        while d <= Dk do
        begin
           DejYXzF(k);

           PomSour.x := x;
           PomSour.y := y;

           DejPlotSour (PomSour, PlotSour);

           if BezCarky and MaBytCarka then PomStr := ','
                                      else PomStr := '';
           PomStr := PomStr + LStr (PlotSour.X)+','
                            + LStr (PlotSour.Y);
           HPGL( PomStr);
           BezCarky   := Ano;
           MaBytCarka := Ano;

           d := d +AKrok;
        end;{for d}

        DejPlotSour (Uzly^[k+1], PlotSour);
        if BezCarky and MaBytCarka then PomStr := ','
                                   else PomStr := '';
        PomStr :=   PomStr + LStr (PlotSour.X)+ ','
                           + LStr (PlotSour.Y);
        HPGL( PomStr);
        BezCarky   := Ano;
        MaBytCarka := Ano;

     end;{for k}
     PomStr := ';PU;';
     HPGL( PomStr);
  end;

{$ENDIF}

{------------------------------------------------}
{$IFDEF WINDOWS}
procedure   TMsSpline.ZobrazRealne ( Orez: Boolean);
{$ELSE}
procedure   TMsSpline.ZobrazRealne ( Barva, Typ, ZobrMod: integer;
                                     Nastavit: boolean;
                                     Orez: Boolean);
{$ENDIF}
  var
     k      : Integer;
     B1Jo,B2Jo: Boolean;
     AKrok: real;

  begin
     { Nastaveni barev a tak }
     { --------------------- }
     NastavKrok;

{$IFNDEF WINDOWS}
     if Nastavit then
     begin
        SetWriteMode(ZobrMod);
        SetColor(Barva);
        NastaveniTypuCary(Typ);
     end;
{$ENDIF}

     if PocetUzlu < MinimalniPocetUzlu then exit;
     Poprve := Ano;
     Dk     := VzdalenostBodu(Uzly^[2],Uzly^[3]);

     for k := 2 to Pocetuzlu - 4 do
     begin
        { Preskoceni segmentu evidentne lezicich mimo vyrez ... }
        { ----------------------------------------------------- }
        if Orez then
        begin
           { Je segment ve vyrezu ?      }
           { --------------------------- }
{$IFDEF WINDOWS}
           B1Jo := BodVObdelniku(Uzly^[k],   PVektorOkno(Okno)^.RozmerJTSK, 0);
           B2Jo := BodVObdelniku(Uzly^[k+1], PVektorOkno(Okno)^.RozmerJTSK, 0);
           if not (B1Jo or B2Jo) then
           if not PrekryvObdelnikuSouradnicemi
                  (Uzly^[k],Uzly^[k+1], PVektorOkno(Okno)^.RozmerJTSK.PH,
                                        PVektorOkno(Okno)^.RozmerJTSK.LD,
                                       (Dk / 5)) then
{$ELSE}
           B1Jo := BodVObdelniku(Uzly^[k],   Zobrazovac.RozmerVyrezu, 0);
           B2Jo := BodVObdelniku(Uzly^[k+1], Zobrazovac.RozmerVyrezu, 0);
           if not (B1Jo or B2Jo) then
           if not PrekryvObdelnikuSouradnicemi
                  (Uzly^[k],Uzly^[k+1], Zobrazovac.RozmerVyrezu.PH,
                                        Zobrazovac.RozmerVyrezu.LD,
                                       (Dk / 5)) then
{$ENDIF}
           begin
              Poprve := Ano;
              Continue;
           end;
        end;

{$IFDEF WINDOWS}
        if Poprve then
        begin
           if BMP then PVektorOkno(Okno)^.MoveSourPaint(DC, Uzly^[k])
                  else PVektorOkno(Okno)^.MoveSour(DC, Uzly^[k]);
        end;
{$ELSE}
        if Poprve then Zobrazovac.MoveSour(Uzly^[k]);
{$ENDIF}

        DejDkMat(k);

        { Nastaveni kroku }
        { --------------- }
        AKrok := Krok;
        if AKrok >= Dk then
        begin
{$IFDEF WINDOWS}
           if BMP then
              PVektorOkno(Okno)^.LineSourPaint(DC, Uzly^[k+1])
           else
              PVektorOkno(Okno)^.LineSour(DC, Uzly^[k+1]);
{$ELSE}
           Zobrazovac.LineSour(Uzly^[k+1]);
{$ENDIF}
           Continue;
        end
        else begin
           Kroku := Round(Dk/AKrok);
           if Kroku < MinPocKroku then AKrok := Dk/MinPocKroku else
           if Kroku > MaxPocKroku then AKrok := Dk/MaxPocKroku;
        end;

        { ... cyklus d = 0 to Dk: }
        { ----------------------- }
        d := AKrok;
        while d <= Dk do
        begin
           DejYXzF(k);
{$IFDEF WINDOWS}
           if BMP then
              PVektorOkno(Okno)^.LineYXPaint(DC, y, x)
           else
              PVektorOkno(Okno)^.LineYX(DC, y, x);
{$ELSE}
           Zobrazovac.LineYX(y,x);
{$ENDIF}
           d := d +AKrok;
        end;{for d}
{$IFDEF WINDOWS}
        if BMP then
           PVektorOkno(Okno)^.LineYXPaint(DC, Uzly^[k+1].y,Uzly^[k+1].x)
        else
           PVektorOkno(Okno)^.LineYX(DC, Uzly^[k+1].y,Uzly^[k+1].x);
{$ELSE}
        Zobrazovac.LineYX(Uzly^[k+1].y,Uzly^[k+1].x);
{$ENDIF}

     end;{for k}

{$IFNDEF WINDOWS}
     { Reset vykreslovacich parametru }
     SetWriteMode(NormalPut);
     NastaveniTypuCary(0);
{$ENDIF}
  end;


{------------------------------------------------}
procedure   TMsSpline.DejDkMat(k: integer);
begin
  { 0 vypocet Delek segmentu Dk }
  { --------------------------- }
  { 1 vypocet M(k-2,k-1,k,k+1) .... dale uz jen posuny a (k+1) }
  { ---------------------------------------------------------- }
  { 2 vypocet t(k,k+1)
  { ------------------ }
  if Poprve then
  begin
     D2k    := Delka(k-2,dx2k,dy2k);
     D1k    := Delka(k-1,dx1k,dy1k);
     Dk     := Delka(k,dxk,dyk);
     Dk1    := Delka(k+1,dxk1,dyk1);

     Mx2k   := Mx(k-2,D2k);
     Mx1k   := Mx(k-1,D1k);
     Mxk    := Mx(k,Dk);
     Mxk1   := Mx(k+1,Dk1);
     txk    := tx;

     My2k   := My(k-2,D2k);
     My1k   := My(k-1,D1k);
     Myk    := My(k,Dk);
     Myk1   := My(k+1,Dk1);
     tyk    := ty;

     Poprve := Ne;
  end
  else begin
          D2k    := D1k;
          D1k    := Dk;
          Dk     := Dk1;
          Dk1    := Dk2;

          dx2k   := dx1k;
          dx1k   := dxk;
          dxk    := dxk1;
          dxk1   := dxk2;

          dy2k   := dy1k;
          dy1k   := dyk;
          dyk    := dyk1;
          dyk1   := dyk2;

          Mx2k   := Mx1k;
          Mx1k   := Mxk;
          Mxk    := Mxk1;
          Mxk1   := Mxk2;
          txk    := txk1;

          My2k   := My1k;
          My1k   := Myk;
          Myk    := Myk1;
          Myk1   := Myk2;
          tyk    := tyk1;
       end;
  Dkn2 := SQR(Dk);
  Dk2  := Delka(k+2,dxk2,dyk2);
  Mxk2 := Mx(k+2,Dk2);
  Myk2 := My(k+2,Dk2);
  txk1 := tx1;
  tyk1 := ty1;
end;

{------------------------------------------------}
procedure   TMsSpline.DejYXzF(k: integer);
begin
  { Vypocet mocnin d }
  { ---------------- }
  d2 := sqr(d);
  d3 := d2 * d;

  { 3 vypocet a,b,c }
  { --------------- }
  Ax := ((txk + txk1 -(2*dxk) / Dk) / Dkn2);
  Bx := (((3*dxk) / Dk - 2*txk - txk1) / Dk);
  Cx := (txk);

  Ay := ((tyk + tyk1 -(2*dyk) / Dk) / Dkn2);
  By := (((3*dyk) / Dk - 2*tyk - tyk1) / Dk);
  Cy := (tyk);


  { 4 F }
  { --- }
  X := (Ax*d3 + Bx*d2 + Cx*d + Uzly^[k].x);
  Y := (Ay*d3 + By*d2 + Cy*d + Uzly^[k].y);
end;

{------------------------------------------------}
function TMsSpline.Delka(i: Integer; var ddx,ddy: Real): Real;
var
   Pom: Real;
begin
   ddX := Uzly^[i+1].x - Uzly^[i].x;
   ddY := Uzly^[i+1].y - Uzly^[i].y;
   Pom := SQRT(SQR(ddx)+SQR(ddy));
   if Pom < 1 then Pom := 1;
   Delka := Pom;
end;

{------------------------------------------------}
function TMsSpline.Mx(i: Integer; DD: Real): Real;
begin
  Mx := (Uzly^[i+1].x - Uzly^[i].x) / DD;
end;

{------------------------------------------------}
function TMsSpline.My(i: Integer; DD: Real): Real;
begin
  My := (Uzly^[i+1].y - Uzly^[i].y) / DD;
end;

{------------------------------------------------}
function TMsSpline.tx: Real;
var
   Pom,Pom1,Pom2: Real;
begin
   Pom1 := Abs(Mxk1-Mxk);
   Pom2 := Abs(Mx1k-Mx2k);
   Pom  := Pom1 + Pom2;
   If Pom <> 0 then tx := (Mx1k * Pom1 + Mxk * Pom2) / Pom
               else tx := (Mxk1 + Mxk) / 2;
end;

{------------------------------------------------}
function TMsSpline.ty: Real;
var
   Pom,Pom1,Pom2: Real;
begin
   Pom1 := Abs(Myk1-Myk);
   Pom2 := Abs(My1k-My2k);
   Pom  := Pom1 + Pom2;
   If Pom <> 0 then ty := (My1k * Pom1 + Myk * Pom2) / Pom
               else ty := (Myk1 + Myk) / 2;
end;

{------------------------------------------------}
function TMsSpline.tx1: Real;
var
   Pom,Pom1,Pom2: Real;
begin
   Pom1 := Abs(Mxk2-Mxk1);
   Pom2 := Abs(Mxk-Mx1k);
   Pom  := Pom1 + Pom2;
   If Pom <> 0 then tx1 := (Mxk * Pom1 + Mxk1 * Pom2) / Pom
               else tx1 := (Mxk2 + Mxk1) / 2;
end;

{------------------------------------------------}
function TMsSpline.ty1: Real;
var
   Pom,Pom1,Pom2: Real;
begin
   Pom1 := Abs(Myk2-Myk1);
   Pom2 := Abs(Myk-My1k);
   Pom  := Pom1 + Pom2;
   If Pom <> 0 then ty1 := (Myk * Pom1 + Myk1 * Pom2) / Pom
               else ty1 := (Myk2 + Myk1) / 2;
end;




end.







