{ Form Template - Source and Destination Choices Lists }
unit Fnastavp;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
     StdCtrls, DB, ExtCtrls, Tabs, TabNotBk, Spin, Wwdatsrc, DBTables,

     Wwtable, Dialogs, Grids, dbgrids, Wwquery, ComCtrls;

type
  TNastavP = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    TabbedNotebook1: TTabbedNotebook;
    IncludeBtn: TSpeedButton;
    IncAllBtn: TSpeedButton;
    ExcludeBtn: TSpeedButton;
    ExAllBtn: TSpeedButton;
    Panel1: TPanel;
    Label5: TLabel;
    Edit1: TEdit;
    Label6: TLabel;
    SpinEdit: TSpinEdit;
    Label7: TLabel;
    ComboBox1: TComboBox;
    GroupBox1: TGroupBox;
    LBpopisF: TListBox;
    Label1: TLabel;
    ComboBox2: TComboBox;
    GroupBox2: TGroupBox;
    LBZdrojP: TListBox;
    GroupBox3: TGroupBox;
    LBCilP: TListBox;
    InfoBar: TPanel;
    FontDialog1: TFontDialog;
    GroupBox4: TGroupBox;
    BitBtn2: TBitBtn;
    BitBtn1: TBitBtn;
    procedure IncludeBtnClick(Sender: TObject);
    procedure ExcludeBtnClick(Sender: TObject);
    procedure IncAllBtnClick(Sender: TObject);
    procedure ExcAllBtnClick(Sender: TObject);
    procedure MoveSelected(List: TCustomListBox; Items: TStrings);
    procedure SetItem(List: TListBox; Index: Integer);
    function GetFirstSelection(List: TCustomListBox): Integer;
    procedure SetButtons;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure LBCilPDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure LBCilPDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure LBZdrojPMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LBCilPMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LBZdrojPDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure LBZdrojPDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure LBpopisFClick(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure LBZdrojPMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure LBCilPMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure LBpopisFMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure LBZdrojPDblClick(Sender: TObject);
    procedure LBCilPDblClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    MyDataSource : TDataSource;
//    MyDBGrid : TwwDBGrid;
    MyDBGrid : TDBGrid;
    APointZdroj,APointCil,APointLBCil: TPoint;

    procedure NastavLBZdroj;
    procedure PresunRadek(Sender, Source: TObject; X, Y: Integer);
    procedure UlozZmenyDS(Sender: TObject);
    procedure NastavHint(X,Y : Integer; Sender : TObject);
    procedure NastavSel;
  public
    { Public declarations }
  end;

var
  NastavP: TNastavP;

//procedure NastavPole(Sender : TwwDBGrid);
procedure NastavPole(Sender : TDBGrid);
procedure ZapisNastaveni(NazevINI,Sekce : String; Sender : TDataSet);
procedure NactiNastaveni(NazevINI,Sekce : String; Sender : TDataSet);

procedure ProjedVseTable(Sender : TObject; Adresar : String; Zapis : Boolean);
procedure NactiPole(Sender : TDataSet);
procedure ZapisFont(NazevINI : String; Sender : TDBGrid);
procedure NactiFont(NazevINI : String; Sender : TDBGrid);

implementation

Uses IniFiles, SysUtils;

{$R *.DFM}




procedure TNastavP.IncludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(LBZdrojP);
  MoveSelected(LBZdrojP, LBCilP.Items);
  SetItem(LBZdrojP, Index);
end;



procedure TNastavP.ExcludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(LBCilP);
  MoveSelected(LBCilP, LBZdrojP.Items);
  SetItem(LBCilP, Index);
end;



procedure TNastavP.IncAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to LBZdrojP.Items.Count - 1 do
    begin
{      LBCilP.Items.AddObject(LBZdrojP.Items[I], LBZdrojP.Items.Objects[I]);}

      SetItem(LBZdrojP, 0);
      MoveSelected(LBZdrojP, LBCilP.Items);
    end;

  LBZdrojP.Items.Clear;
end;



procedure TNastavP.ExcAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to LBCilP.Items.Count - 1 do
    begin
{      LBZdrojP.Items.AddObject(LBCilP.Items[I], LBCilP.Items.Objects[I]);}

      SetItem(LBCilP, 0);
      MoveSelected(LBCilP, LBZdrojP.Items);
    end;

  LBCilP.Items.Clear;
end;



procedure TNastavP.MoveSelected(List: TCustomListBox; Items: TStrings);
var
  I: Integer;
  Radek : String;
  PomShow : Boolean;
begin
  for i := List.Items.Count - 1 downto 0 do
    if List.Selected[i] then
    begin
      Items.AddObject(List.Items[i], List.Items.Objects[i]);

      Radek := List.Items[I];
      if List.Name = 'LBZdrojP' then PomShow := true else PomShow := false;
      MyDataSource.DataSet.FieldByName(Radek).Index := LBCilP.Items.Count;
      MyDataSource.DataSet.FieldByName(Radek).Visible := PomShow;

      List.Items.Delete(i);

    end;
end;



procedure TNastavP.SetButtons;
var
  SrcEmpty, DstEmpty: Boolean;
begin
  SrcEmpty := LBZdrojP.Items.Count = 0;
  DstEmpty := LBCilP.Items.Count = 0;
  IncludeBtn.Enabled := not SrcEmpty;
  IncAllBtn.Enabled := not SrcEmpty;
  ExcludeBtn.Enabled := not DstEmpty;
  ExAllBtn.Enabled := not DstEmpty;
end;



function TNastavP.GetFirstSelection(List: TCustomListBox): Integer;
begin
  for Result := 0 to List.Items.Count - 1 do
    if List.Selected[Result] then Exit;
  Result := LB_ERR;
end;



procedure TNastavP.SetItem(List: TListBox; Index: Integer);
var
  MaxIndex: Integer;
begin
  with List do
  begin
    SetFocus;
    MaxIndex := List.Items.Count - 1;
    if Index = LB_ERR then Index := 0
    else if Index > MaxIndex then Index := MaxIndex;
    Selected[Index] := True;
  end;
  SetButtons;
end;



procedure NastavPole(Sender : TDBGrid);
var i : Integer;
begin
  NastavP := TNastavP.Create(Application);
  NastavP.MyDBGrid := Sender;
  NastavP.MyDataSource := Sender.DataSource;
  NastavP.MyDataSource.Dataset.DisableControls;

  for i := 0 to Sender.DataSource.DataSet.FieldCount - 1  do
    begin
{      NastavP.LBPopisF.Items.Add(Sender.DataSet.Fields[i].FieldName);}
      if not NastavP.MyDataSource.DataSet.Fields[i].visible then
         NastavP.LBZdrojP.Items.Add(NastavP.MyDataSource.DataSet.Fields[i].FieldName)
      else NastavP.LBCilP.Items.Add(NastavP.MyDataSource.DataSet.Fields[i].FieldName);
    end;

  NastavP.LBPopisF.Items := NastavP.LBCilP.Items; {???}

  NastavP.LBpopisFClick(NastavP.LBPopisF);
  NastavP.MyDataSource.DataSet.EnableControls;

  NastavP.SetButtons;
  NastavP.ShowModal;
end;



procedure TNastavP.NastavLBZdroj;
begin
end;



procedure TNastavP.FormCreate(Sender: TObject);
begin
  MyDataSource := TDataSource.create(Self);
end;

procedure TNastavP.FormActivate(Sender: TObject);
begin
  Screen.Cursor := crDefault;
end;



procedure TNastavP.LBCilPDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := (Source is TListBox);
  APointCil.X := X;
  APointCil.Y := Y;
  APointLBCil.X := X;
  APointLBCil.Y := Y;
end;



procedure TNastavP.LBCilPDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
 if (Source is TListBox) then
   begin
     {if (TListBox(Source).Name <> TListBox(Sender).Name) then }
     PresunRadek(Sender, Source, X, Y)
   end;
end;



procedure TNastavP.PresunRadek(Sender, Source: TObject; X, Y: Integer);
var CRadkuZdroj, CRadkuCil, pom, i, j, PoradiPole : Integer;
    Radek : string;
    PomShow : Boolean;
begin
 if (Source is TListBox) then
   begin
     CRadkuCil := TListBox(Sender).ItemAtPos(APointCil, False);
     CRadkuZdroj := TListBox(Source).ItemAtPos(APointZdroj, True);
     if CRadkuZdroj = -1 then exit;
     if CRadkuCil > CRadkuZdroj then PoradiPole := CRadkuCil-1 else PoradiPole := CRadkuCil;
     if (TListBox(Source).Name <> TListBox(Sender).Name) then
       begin
         j := 0;
         for i := TListBox(Source).Items.Count - 1 downto 0 do
           begin
             if TListBox(Source).Selected[i] then
               begin
                 inc(j);
                 Radek := (TListBox(Source).Items[i]);
                 TListBox(Sender).Items.Insert(CRadkuCil,Radek);
                 TListBox(Source).Items.Delete(i);

                 if TListBox(Sender).Name = 'LBCilP' then PomShow := true else PomShow := false;
                 MyDataSource.DataSet.FieldByName(Radek).Index := CRadkuCil;
                 MyDataSource.DataSet.FieldByName(Radek).Visible := PomShow;
               end;
           end;

         SetButtons;
       end
     else
       begin
         Radek := (TListBox(Source).Items[TListBox(Source).ItemIndex]);
         TListBox(Sender).Items.Insert(CRadkuCil,Radek);

         if CRadkuCil < CRadkuZdroj then Pom := 1 else Pom := 0;
         TListBox(Source).Items.Delete(CRadkuZdroj+Pom);

         MyDataSource.DataSet.FieldByName(Radek).Index := PoradiPole;
       end;
   end;
end;



procedure TNastavP.LBZdrojPMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  APointZdroj.X := X;
  APointZdroj.Y := Y;
end;



procedure TNastavP.LBCilPMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  APointZdroj.X := X;
  APointZdroj.Y := Y;
end;



procedure TNastavP.LBZdrojPDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
 if (Source is TListBox) and (TListBox(Source).Name <> TListBox(Sender).Name) then
   begin
     PresunRadek(Sender, Source, X, Y);
   end;
end;



procedure TNastavP.LBZdrojPDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := (Source is TListBox);
  APointCil.X := X;
  APointCil.Y := Y;
end;



procedure TNastavP.LBpopisFClick(Sender: TObject);
var Pole : String;
    Index : Integer;
begin
  Index := TListBox(Sender).ItemIndex;
  if (Index < 0) or (Index > TListBox(Sender).Items.Count) then Index := 0;
  try
    Pole := TListBox(Sender).Items[Index];
    Edit1.Text := MyDataSource.DataSet.FieldByName(Pole).DisplayLabel;

    case MyDataSource.DataSet.FieldByName(Pole).Alignment of
      taLeftJustify : ComboBox1.Text := 'Vlevo';
      taRightJustify : ComboBox1.Text := 'Vpravo';
      taCenter : ComboBox1.Text := 'Uprosted';
    end;

    if MyDataSource.DataSet.FieldByName(Pole).ReadOnly then ComboBox2.Text := 'Ano'
    else ComboBox2.Text := 'Ne';

    SpinEdit.Value := MyDataSource.DataSet.FieldByName(Pole).DisplayWidth;

  except
  end;
end;



procedure TNastavP.UlozZmenyDS(Sender: TObject);
var Pole : String;
begin
//   if LBPopisF.SelCount = 0 then LBPopisF.Selected[0] := true;
  NastavSel;

  Pole := LBPopisF.Items[LBPopisF.ItemIndex];

  MyDataSource.DataSet.FieldByName(Pole).DisplayLabel := Edit1.Text;

  if ComboBox1.Text = 'Vlevo' then MyDataSource.DataSet.FieldByName(Pole).Alignment := taLeftJustify;
  if ComboBox1.Text = 'Vpravo' then MyDataSource.DataSet.FieldByName(Pole).Alignment := taRightJustify;
  if ComboBox1.Text = 'Uprosted' then MyDataSource.DataSet.FieldByName(Pole).Alignment := taCenter;

  if ComboBox2.Text = 'Ano' then MyDataSource.DataSet.FieldByName(Pole).ReadOnly := true;
  if ComboBox2.Text = 'Ne' then MyDataSource.DataSet.FieldByName(Pole).ReadOnly := false;


  MyDataSource.DataSet.FieldByName(Pole).DisplayWidth := SpinEdit.Value;

end;



procedure TNastavP.Edit1Exit(Sender: TObject);
begin
  UlozZmenyDS(Sender);
end;



procedure TNastavP.NastavHint(X,Y : Integer; Sender : TObject);
var
  APoint: TPoint;
  Value : String;
  Index : Integer;
begin
  APoint.X := X;
  APoint.Y := Y;
  Index := TListBox(Sender).ItemAtPos(APoint, True);
  if (Index < 0) or (Index > TListBox(Sender).Items.Count - 1) then exit;
  Value := MyDataSource.DataSet.FieldByName(TListBox(Sender).Items[Index]).DisplayLabel;
  TListBox(Sender).Hint := value;
  InfoBar.Caption := Value;

end;



procedure TNastavP.LBZdrojPMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  NastavHint(X,Y,Sender);
end;



procedure TNastavP.LBCilPMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  NastavHint(X,Y,Sender);
end;



procedure TNastavP.LBpopisFMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  NastavHint(X,Y,Sender);
end;



procedure ZapisNastaveni(NazevINI,Sekce : String; Sender : TDataSet);
var
  i : Integer;
  MyINI : TIniFile;
  NazevPole : String;

begin
  MyINI := TIniFile.create(NazevINI);

  Sender.DisableControls;
  for i := 0 to Sender.FieldCount - 1 do
    begin
      NazevPole := Sender.Fields[i].FieldName;

      MyINI.WriteBool(Sekce,NazevPole+'_Zobrazit',Sender.Fields[i].Visible);
      MyINI.WriteInteger(Sekce,NazevPole+'_Poradi',Sender.Fields[i].Index);
      MyINI.WriteString(Sekce,NazevPole+'_Popis',Sender.Fields[i].DisplayLabel);
      MyINI.WriteInteger(Sekce,NazevPole+'_Sirka',Sender.Fields[i].DisplayWidth);
      MyINI.WriteInteger(Sekce,NazevPole+'_Zarovnani',Byte(Sender.Fields[i].Alignment));
      MyINI.WriteBool(Sekce,NazevPole+'_JenCteni',Sender.Fields[i].ReadOnly);

    end;
  Sender.EnableControls;

  MyINI.free;
end;



procedure NactiNastaveni(NazevINI,Sekce : String; Sender : TDataSet);
var
  i : Integer;
  MyINI : TIniFile;
  NazevPole : String;
  MyList : TStringList;

begin
//  if not FileExists(NazevINI) then exit;
  MyINI := TIniFile.create(NazevINI);
  MyList  := TstringList.create;
  MyList.Clear;

  Sender.DisableControls;
  for i := 0 to Sender.FieldCount - 1 do
    begin
      NazevPole := Sender.Fields[i].FieldName;

      Sender.Fields[i].Visible := MyINI.ReadBool(Sekce,NazevPole+'_Zobrazit',Sender.Fields[i].Visible);
      MyList.Add(NazevPole);
      Sender.Fields[i].DisplayLabel := MyINI.ReadString(Sekce,NazevPole+'_Popis',Sender.Fields[i].DisplayLabel);
      Sender.Fields[i].DisplayWidth := MyINI.ReadInteger(Sekce,NazevPole+'_Sirka',Sender.Fields[i].DisplayWidth);
      Sender.Fields[i].Alignment :=
             TAlignment(MyINI.ReadInteger(Sekce,NazevPole+'_Zarovnani',Byte(Sender.Fields[i].Alignment)));
      Sender.Fields[i].ReadOnly := MyINI.ReadBool(Sekce,NazevPole+'_JenCteni',Sender.Fields[i].ReadOnly);
    end;

  for i := 0 to MyList.Count - 1 do
    begin
      NazevPole := MyList[i];
      Sender.FieldByName(NazevPole).Index := MyINI.ReadInteger(Sekce,NazevPole+'_Poradi',
                                                               Sender.FieldByName(NazevPole).Index);
    end;

  Sender.EnableControls;
  MyList.free;
  MyINI.free;
end;



procedure TNastavP.TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
   AllowChange := True;
   if ((NewTab = 1) and (LBPopisF.Items.Count <> LBCilP.Items.Count)) then
   begin
      LBPopisF.Items := LBCilP.Items;
   end;

end;



procedure ProjedVseTable(Sender : TObject; Adresar : String; Zapis : Boolean);
var
  i : Integer;
  CestaKini : string;
  F : TForm;
begin
  Screen.Cursor := crHourGlass;

  F := TForm(Sender);
  CestaKIni  := Adresar + TForm(Sender).ClassName + '.INI';

  for i := 0 to F.ComponentCount - 1 do
    begin
      if (F.Components[i] is TDataSet) and ((F.Components[i] as TDataSet).Tag = 100) then
        begin
          if Zapis then ZapisNastaveni(CestaKIni,(F.Components[i] as TDataSet).Name,
                                                 (F.Components[i] as TDataSet))
          else NactiNastaveni(CestaKIni,(F.Components[i] as TDataSet).Name, (F.Components[i] as TDataSet));
        end;

      if F.Components[i] is TDBGrid then
        begin
          if Zapis then ZapisFont(CestaKIni,TDBGrid(F.Components[i]))
          else NactiFont(CestaKIni,TDBGrid(F.Components[i]));
        end;
    end;

  Screen.Cursor := crDefault;
end;



procedure NactiPole(Sender: TDataSet);
var
  i : Integer;
begin
  Sender.Close;
  for i := 0 to Sender.FieldDefs.Count - 1 do
    begin
      try
        Sender.FieldDefs[i].CreateField(Sender);
      except
      end;
    end;
  Sender.Open;
end;


procedure TNastavP.BitBtn2Click(Sender: TObject);
begin
  if MyDBGrid <> nil then
    FontDialog1.Font := MyDBGrid.Font
  else
    begin
      messagedlg('Fonty nelze nastavovat!',mtInformation,[mbOK],0);
      exit;
    end;
  if FontDialog1.execute then
    begin
      MyDBGrid.Font := FontDialog1.Font;
    end;
end;



procedure TNastavP.BitBtn1Click(Sender: TObject);
begin
  if MyDBGrid <> nil then
    FontDialog1.Font := MyDBGrid.TitleFont
  else
    begin
      messagedlg('Fonty nelze nastavovat!',mtInformation,[mbOK],0);
      exit;
    end;
  if FontDialog1.execute then
    begin
      MyDBGrid.TitleFont := FontDialog1.Font;
    end;
end;



procedure ZapisFont(NazevINI : String; Sender : TDBGrid);
var
  Sekce, Jmeno : String;
  Styl : Integer;
  MyINI : TIniFile;
  Pom : TFontStyles;

begin
  if not FileExists(NazevINI) then exit;
  MyINI := TIniFile.create(NazevINI);
  Sekce := Sender.Name;

  Pom := Sender.Font.Style;
  MyINI.WriteString(Sekce,'JmenoFontuT',Sender.Font.Name);
  MyINI.WriteInteger(Sekce,'BarvaFontuT',Sender.Font.Color);
  MyINI.WriteInteger(Sekce,'VelikostFontuT',Sender.Font.Size);
  MyINI.WriteInteger(Sekce,'StylFontuT',byte(Pom));

  Pom := Sender.TitleFont.Style;
  MyINI.WriteString(Sekce,'JmenoFontuN',Sender.TitleFont.Name);
  MyINI.WriteInteger(Sekce,'BarvaFontuN',Sender.TitleFont.Color);
  MyINI.WriteInteger(Sekce,'VelikostFontuN',Sender.TitleFont.Size);
  MyINI.WriteInteger(Sekce,'StylFontuN',byte(Pom));

  MyINI.free;
end;



procedure NactiFont(NazevINI : String; Sender : TDBGrid);
var
  Sekce, Jmeno : String;
  Barva, Velikost, Styl : Integer;
  MyINI : TIniFile;

begin
  if not FileExists(NazevINI) then exit;
  MyINI := TIniFile.create(NazevINI);
  Sekce := Sender.Name;

  Jmeno := MyINI.ReadString(Sekce,'JmenoFontuT','');
  Barva := MyINI.ReadInteger(Sekce,'BarvaFontuT',-1);
  Velikost := MyINI.ReadInteger(Sekce,'VelikostFontuT',-1);
  Styl := MyINI.ReadInteger(Sekce,'StylFontuT',-1);

  if Jmeno <> '' then Sender.Font.Name := Jmeno;
  if Barva <> -1 then Sender.Font.Color := Barva;
  if Velikost <> -1 then Sender.Font.Size := Velikost;
  if Styl <> -1 then Sender.Font.Style := TFontStyles(byte(Styl));;

  Jmeno := MyINI.ReadString(Sekce,'JmenoFontuN','');
  Barva := MyINI.ReadInteger(Sekce,'BarvaFontuN',-1);
  Velikost := MyINI.ReadInteger(Sekce,'VelikostFontuN',-1);
  Styl := MyINI.ReadInteger(Sekce,'StylFontuN',-1);

  if Jmeno <> '' then Sender.TitleFont.Name := Jmeno;
  if Barva <> -1 then Sender.TitleFont.Color := Barva;
  if Velikost <> -1 then Sender.TitleFont.Size := Velikost;
  if Styl <> -1 then Sender.TitleFont.Style := TFontStyles(byte(Styl));;

  MyINI.free;
end;



procedure TNastavP.LBZdrojPDblClick(Sender: TObject);
begin
  IncludeBtnClick(Sender);
end;



procedure TNastavP.LBCilPDblClick(Sender: TObject);
begin
  ExcludeBtnClick(Sender);
end;

procedure TNastavP.NastavSel;
var
   i: longInt;
   Sel: boolean;
begin
   if TabbedNotebook1.ActivePage='Popisy' then
   begin
      if LBPopisF.Items.Count = 0 then exit;
      Sel := false;
      for i := 0 to LBPopisF.Items.Count - 1 do
      begin
         Sel := LBPopisF.Selected[i];
         if Sel then break;
      end;
      if not Sel then
      begin
         LBPopisF.MultiSelect := True;
         LBPopisF.Selected[0] := True;
         LBPopisF.MultiSelect := False;
      end;
   end;
end;

procedure TNastavP.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Action := CaFree;
end;

end.
